/**
 * Central 部件模型
 *
 * @export
 * @class CentralModel
 */
export default class CentralModel {

    /**
     * 菜单项集合
     *
     * @private
     * @type {any[]}
     * @memberof CentralModel
     */
    private items: any[] = [
                {
        	id: 'd15157cb8d73af87f553f85887fdcbf8',
        	name: 'user_menus',
        	text: '用户菜单',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '用户菜单',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        	items: [
                		        {
                	id: '76d07a396b5ff6dfe8156b969ef9fb6a',
                	name: 'menuitem3',
                	text: '设置',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '设置',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-newspaper-o',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                }
                ,
                		        {
                	id: '150d5d0c57788f79b3a22edbea800198',
                	name: 'menuitem4',
                	text: '注销',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '注销',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-level-down',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                }
                ,
        	],
        }
        ,
                {
        	id: '4aea3655e93af303beba942116b04a31',
        	name: 'top_menus',
        	text: '顶部菜单',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '顶部菜单',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        	items: [
                		        {
                	id: 'B10BAEE7-D026-400F-8247-5E72D454AAF5',
                	name: 'menuitem17',
                	text: '主页',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '主页',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-home',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                }
                ,
                		        {
                	id: 'AD015F36-E901-472C-9A9E-06A6E53E908D',
                	name: 'menuitem18',
                	text: '最近',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '最近',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-clock-o',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                }
                ,
                		        {
                	id: '88544326-2CB2-404C-B5B7-87C29D4AAF3C',
                	name: 'menuitem19',
                	text: '固定',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '固定',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-thumb-tack',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                }
                ,
                		        {
                	id: '03DF4BF8-9F94-47B3-96B9-6F0AB66F9879',
                	name: 'menuitem16',
                	text: '我的工作',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '我的工作',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-legal',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: '9EFFF6D6-F677-49AD-9D16-6E27DB7B76FB',
                        	name: 'menuitem1',
                        	text: '仪表盘',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '仪表盘',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-line-chart',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: '1275FE7E-10AB-4891-B73C-9709A9148321',
                        	name: 'menuitem2',
                        	text: '活动',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '活动',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-file-o',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_10',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'activity-pointer-grid-view',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
                		        {
                	id: 'ACAE3951-50A4-4DDF-848F-37C77EC0F001',
                	name: 'menuitem20',
                	text: '客户',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '客户',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-sitemap',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: '9A80D149-E53A-4E3C-BFB9-E83CD67DD5A4',
                        	name: 'menuitem5',
                        	text: '客户',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '客户',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-users',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_5',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'account-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: 'C081966B-83AE-4959-A4F8-ED228A02B260',
                        	name: 'menuitem7',
                        	text: '联系人',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '联系人',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-user',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_8',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'contact-grid-view',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
                		        {
                	id: '548EC6CE-816B-4779-845D-34018E3DD5D9',
                	name: 'menuitem21',
                	text: '销售',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '销售',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-credit-card',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: '756C0CB9-B844-4C07-9803-7EB7DD7C6B80',
                        	name: 'menuitem8',
                        	text: '潜在客户',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '潜在客户',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-phone',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_15',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'lead-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: 'D2CF1FDD-9E56-4ED4-9070-9888EFEEC258',
                        	name: 'menuitem9',
                        	text: '商机',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '商机',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-envelope-o',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_11',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'opportunity-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: 'DBF0402C-8637-4C89-AA2B-20C5B5ED578D',
                        	name: 'menuitem10',
                        	text: '竞争对手',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '竞争对手',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-user-secret',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_13',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'competitor-grid-view',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
                		        {
                	id: '64D9336A-17E0-427B-92DE-24DFCBDD1638',
                	name: 'menuitem22',
                	text: '宣传资料',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '宣传资料',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-book',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: 'C2A47B4F-4E57-47D0-BE19-C5B47938C86B',
                        	name: 'menuitem11',
                        	text: '报价单',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '报价单',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-file-text-o',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_6',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'quote-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: 'C5289010-62B5-4B5C-B012-2AEF3ADFBF4D',
                        	name: 'menuitem12',
                        	text: '订单',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '订单',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-file-text-o',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_4',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'sales-order-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: '2DC7B936-91BE-4057-929E-DB3382E10452',
                        	name: 'menuitem13',
                        	text: '发票',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '发票',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-newspaper-o',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_7',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'invoice-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: 'eb55b353236f5f89b8ae1fada8f1c89d',
                        	name: 'menuitem6',
                        	text: '产品',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '产品',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-cube',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_12',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'product-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: '577FE224-E2CA-4A11-B94B-72F82F763735',
                        	name: 'menuitem14',
                        	text: '销售宣传资料',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '销售宣传资料',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-book',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_3',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'sales-literature-grid-view',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
                		        {
                	id: '2CF3C1E9-6668-4336-B51E-F7C92D442409',
                	name: 'menuitem23',
                	text: '市场营销',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '市场营销',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-shopping-cart',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: '9C9664DE-B9EA-48F6-8321-0A4D7EDBA5C9',
                        	name: 'menuitem15',
                        	text: '市场营销列表',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '市场营销列表',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-list',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_2',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'ibiz-list-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: '365014CC-1F6E-4D55-A0FD-CBF8063EC7A6',
                        	name: 'menuitem29',
                        	text: '快速市场活动',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '快速市场活动',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-list',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
                		        {
                	id: '31DA4E4A-EA7C-4388-915F-758858EA1797',
                	name: 'menuitem24',
                	text: '绩效',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '绩效',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-slack',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: 'FA9EC773-4AFF-4A10-BB19-948B33482E84',
                        	name: 'menuitem25',
                        	text: '目标',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '目标',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-flag-checkered',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_14',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'goal-grid-view',
                        	resourcetag: '',
                        }
                        ,
                        		        {
                        	id: '39BFFBD2-88B9-4071-A481-6B08BF9F8E7A',
                        	name: 'menuitem26',
                        	text: '预测',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '预测',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-dot-circle-o',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
                		        {
                	id: '37B31C69-6E3A-455B-854E-8AA299CEC61E',
                	name: 'menuitem27',
                	text: '服务',
                	type: 'MENUITEM',
                	counterid: '',
                	tooltip: '服务',
                	expanded: false,
                	separator: false,
                	hidden: false,
                	hidesidebar: false,
                	opendefault: false,
                	iconcls: 'fa fa-skyatlas',
                	icon: '',
                	textcls: '',
                	appfunctag: '',
                	resourcetag: '',
                	items: [
                        		        {
                        	id: 'CF922464-628E-4DC1-84E7-915A3314EB81',
                        	name: 'menuitem28',
                        	text: '服务案例',
                        	type: 'MENUITEM',
                        	counterid: '',
                        	tooltip: '服务案例',
                        	expanded: false,
                        	separator: false,
                        	hidden: false,
                        	hidesidebar: false,
                        	opendefault: false,
                        	iconcls: 'fa fa-list',
                        	icon: '',
                        	textcls: '',
                        	appfunctag: '_9',
                        	appfuncyype: 'APPVIEW',
                        	viewname: 'incident-grid-view',
                        	resourcetag: '',
                        }
                        ,
                	],
                }
                ,
        	],
        }
        ,
                {
        	id: 'e5dcbd32f6a4050109f54d97de44b715',
        	name: 'left_exp',
        	text: '左侧导航',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '左侧导航',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        }
        ,
                {
        	id: 'a204fcf70ab1a00c493e7128f2cfcd81',
        	name: 'bottom_exp',
        	text: '底部内容',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '底部内容',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        }
        ,
                {
        	id: '1c23002189e603110b9858de93d5a01d',
        	name: 'footer_left',
        	text: '底部左侧',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '底部左侧',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        }
        ,
                {
        	id: '28eaf24dc5f9fec02d69fc36e74b1713',
        	name: 'footer_center',
        	text: '底部中间',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '底部中间',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        }
        ,
                {
        	id: '908c555e923dbc2137a9998e1065a700',
        	name: 'footer_right',
        	text: '底部右侧',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '底部右侧',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: '',
        	icon: '',
        	textcls: '',
        	appfunctag: '',
        	resourcetag: '',
        }
        ,
    ];

	/**
	 * 应用功能集合
	 *
	 * @private
	 * @type {any[]}
	 * @memberof CentralModel
	 */
	private funcs: any[] = [
	];

    /**
     * 获取所有菜单项集合
     *
     * @returns {any[]}
     * @memberof CentralModel
     */
    public getAppMenuItems(): any[] {
        return this.items;
    }

	/**
	 * 根据名称获取菜单组
	 *
	 * @param {string} name
	 * @returns {*}
	 * @memberof CentralModel
	 */
	public getMenuGroup(name: string): any {
		return this.items.find((item: any) => Object.is(item.name, name));
	}

    /**
     * 获取所有应用功能集合
     *
     * @returns {any[]}
     * @memberof CentralModel
     */
    public getAppFuncs(): any[] {
        return this.funcs;
    }
}