package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[客户]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "ACCOUNT",resultMap = "AccountResultMap")
public class Account extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * Address1_PrimaryContactName
     */
    @DEField(name = "address1_primarycontactname")
    @TableField(value = "address1_primarycontactname")
    @JSONField(name = "address1_primarycontactname")
    @JsonProperty("address1_primarycontactname")
    private String address1Primarycontactname;
    /**
     * OpenRevenue_Date
     */
    @DEField(name = "openrevenue_date")
    @TableField(value = "openrevenue_date")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "openrevenue_date" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("openrevenue_date")
    private Timestamp openrevenueDate;
    /**
     * Address2_UTCOffset
     */
    @DEField(name = "address2_utcoffset")
    @TableField(value = "address2_utcoffset")
    @JSONField(name = "address2_utcoffset")
    @JsonProperty("address2_utcoffset")
    private Integer address2Utcoffset;
    /**
     * Fax
     */
    @TableField(value = "fax")
    @JSONField(name = "fax")
    @JsonProperty("fax")
    private String fax;
    /**
     * Address1_Composite
     */
    @DEField(name = "address1_composite")
    @TableField(value = "address1_composite")
    @JSONField(name = "address1_composite")
    @JsonProperty("address1_composite")
    private String address1Composite;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * EMailAddress1
     */
    @TableField(value = "emailaddress1")
    @JSONField(name = "emailaddress1")
    @JsonProperty("emailaddress1")
    private String emailaddress1;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * Address1_StateOrProvince
     */
    @DEField(name = "address1_stateorprovince")
    @TableField(value = "address1_stateorprovince")
    @JSONField(name = "address1_stateorprovince")
    @JsonProperty("address1_stateorprovince")
    private String address1Stateorprovince;
    /**
     * PrimaryContactIdYomiName
     */
    @TableField(value = "primarycontactidyominame")
    @JSONField(name = "primarycontactidyominame")
    @JsonProperty("primarycontactidyominame")
    private String primarycontactidyominame;
    /**
     * OpenRevenue
     */
    @TableField(value = "openrevenue")
    @JSONField(name = "openrevenue")
    @JsonProperty("openrevenue")
    private BigDecimal openrevenue;
    /**
     * Address1_UPSZone
     */
    @DEField(name = "address1_upszone")
    @TableField(value = "address1_upszone")
    @JSONField(name = "address1_upszone")
    @JsonProperty("address1_upszone")
    private String address1Upszone;
    /**
     * FollowEmail
     */
    @DEField(defaultValue = "True")
    @TableField(value = "followemail")
    @JSONField(name = "followemail")
    @JsonProperty("followemail")
    private Integer followemail;
    /**
     * MarketingOnly
     */
    @DEField(defaultValue = "False")
    @TableField(value = "marketingonly")
    @JSONField(name = "marketingonly")
    @JsonProperty("marketingonly")
    private Integer marketingonly;
    /**
     * NumberOfEmployees
     */
    @TableField(value = "numberofemployees")
    @JSONField(name = "numberofemployees")
    @JsonProperty("numberofemployees")
    private Integer numberofemployees;
    /**
     * Telephone1
     */
    @TableField(value = "telephone1")
    @JSONField(name = "telephone1")
    @JsonProperty("telephone1")
    private String telephone1;
    /**
     * Aging60
     */
    @TableField(value = "aging60")
    @JSONField(name = "aging60")
    @JsonProperty("aging60")
    private BigDecimal aging60;
    /**
     * SharesOutstanding
     */
    @TableField(value = "sharesoutstanding")
    @JSONField(name = "sharesoutstanding")
    @JsonProperty("sharesoutstanding")
    private Integer sharesoutstanding;
    /**
     * Address2_FreightTermsCode
     */
    @DEField(name = "address2_freighttermscode")
    @TableField(value = "address2_freighttermscode")
    @JSONField(name = "address2_freighttermscode")
    @JsonProperty("address2_freighttermscode")
    private String address2Freighttermscode;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * Revenue_Base
     */
    @DEField(name = "revenue_base")
    @TableField(value = "revenue_base")
    @JSONField(name = "revenue_base")
    @JsonProperty("revenue_base")
    private BigDecimal revenueBase;
    /**
     * AccountRatingCode
     */
    @TableField(value = "accountratingcode")
    @JSONField(name = "accountratingcode")
    @JsonProperty("accountratingcode")
    private String accountratingcode;
    /**
     * SLAName
     */
    @TableField(value = "slaname")
    @JSONField(name = "slaname")
    @JsonProperty("slaname")
    private String slaname;
    /**
     * DoNotBulkEMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotbulkemail")
    @JSONField(name = "donotbulkemail")
    @JsonProperty("donotbulkemail")
    private Integer donotbulkemail;
    /**
     * ParentAccountIdYomiName
     */
    @TableField(value = "parentaccountidyominame")
    @JSONField(name = "parentaccountidyominame")
    @JsonProperty("parentaccountidyominame")
    private String parentaccountidyominame;
    /**
     * Aging30
     */
    @TableField(value = "aging30")
    @JSONField(name = "aging30")
    @JsonProperty("aging30")
    private BigDecimal aging30;
    /**
     * DoNotBulkPostalMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotbulkpostalmail")
    @JSONField(name = "donotbulkpostalmail")
    @JsonProperty("donotbulkpostalmail")
    private Integer donotbulkpostalmail;
    /**
     * CreditLimit_Base
     */
    @DEField(name = "creditlimit_base")
    @TableField(value = "creditlimit_base")
    @JSONField(name = "creditlimit_base")
    @JsonProperty("creditlimit_base")
    private BigDecimal creditlimitBase;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * CustomerTypeCode
     */
    @TableField(value = "customertypecode")
    @JSONField(name = "customertypecode")
    @JsonProperty("customertypecode")
    private String customertypecode;
    /**
     * Address2_Longitude
     */
    @DEField(name = "address2_longitude")
    @TableField(value = "address2_longitude")
    @JSONField(name = "address2_longitude")
    @JsonProperty("address2_longitude")
    private Double address2Longitude;
    /**
     * accountName
     */
    @TableField(value = "accountname")
    @JSONField(name = "accountname")
    @JsonProperty("accountname")
    private String accountname;
    /**
     * ParticipatesInWorkflow
     */
    @DEField(defaultValue = "False")
    @TableField(value = "participatesinworkflow")
    @JSONField(name = "participatesinworkflow")
    @JsonProperty("participatesinworkflow")
    private Integer participatesinworkflow;
    /**
     * PreferredContactMethodCode
     */
    @TableField(value = "preferredcontactmethodcode")
    @JSONField(name = "preferredcontactmethodcode")
    @JsonProperty("preferredcontactmethodcode")
    private String preferredcontactmethodcode;
    /**
     * PreferredAppointmentDayCode
     */
    @TableField(value = "preferredappointmentdaycode")
    @JSONField(name = "preferredappointmentdaycode")
    @JsonProperty("preferredappointmentdaycode")
    private String preferredappointmentdaycode;
    /**
     * MarketCap
     */
    @TableField(value = "marketcap")
    @JSONField(name = "marketcap")
    @JsonProperty("marketcap")
    private BigDecimal marketcap;
    /**
     * Address2_Telephone1
     */
    @DEField(name = "address2_telephone1")
    @TableField(value = "address2_telephone1")
    @JSONField(name = "address2_telephone1")
    @JsonProperty("address2_telephone1")
    private String address2Telephone1;
    /**
     * BusinessTypeCode
     */
    @TableField(value = "businesstypecode")
    @JSONField(name = "businesstypecode")
    @JsonProperty("businesstypecode")
    private String businesstypecode;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * Address2_City
     */
    @DEField(name = "address2_city")
    @TableField(value = "address2_city")
    @JSONField(name = "address2_city")
    @JsonProperty("address2_city")
    private String address2City;
    /**
     * OwnershipCode
     */
    @TableField(value = "ownershipcode")
    @JSONField(name = "ownershipcode")
    @JsonProperty("ownershipcode")
    private String ownershipcode;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * AccountNumber
     */
    @TableField(value = "accountnumber")
    @JSONField(name = "accountnumber")
    @JsonProperty("accountnumber")
    private String accountnumber;
    /**
     * Address1_Telephone2
     */
    @DEField(name = "address1_telephone2")
    @TableField(value = "address1_telephone2")
    @JSONField(name = "address1_telephone2")
    @JsonProperty("address1_telephone2")
    private String address1Telephone2;
    /**
     * OriginatingLeadIdYomiName
     */
    @TableField(value = "originatingleadidyominame")
    @JSONField(name = "originatingleadidyominame")
    @JsonProperty("originatingleadidyominame")
    private String originatingleadidyominame;
    /**
     * Address1_Line1
     */
    @DEField(name = "address1_line1")
    @TableField(value = "address1_line1")
    @JSONField(name = "address1_line1")
    @JsonProperty("address1_line1")
    private String address1Line1;
    /**
     * DoNotPhone
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotphone")
    @JSONField(name = "donotphone")
    @JsonProperty("donotphone")
    private Integer donotphone;
    /**
     * Address1_Telephone3
     */
    @DEField(name = "address1_telephone3")
    @TableField(value = "address1_telephone3")
    @JSONField(name = "address1_telephone3")
    @JsonProperty("address1_telephone3")
    private String address1Telephone3;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * Address2_Line2
     */
    @DEField(name = "address2_line2")
    @TableField(value = "address2_line2")
    @JSONField(name = "address2_line2")
    @JsonProperty("address2_line2")
    private String address2Line2;
    /**
     * Address2_Telephone3
     */
    @DEField(name = "address2_telephone3")
    @TableField(value = "address2_telephone3")
    @JSONField(name = "address2_telephone3")
    @JsonProperty("address2_telephone3")
    private String address2Telephone3;
    /**
     * Address1_Telephone1
     */
    @DEField(name = "address1_telephone1")
    @TableField(value = "address1_telephone1")
    @JSONField(name = "address1_telephone1")
    @JsonProperty("address1_telephone1")
    private String address1Telephone1;
    /**
     * Address1_Fax
     */
    @DEField(name = "address1_fax")
    @TableField(value = "address1_fax")
    @JSONField(name = "address1_fax")
    @JsonProperty("address1_fax")
    private String address1Fax;
    /**
     * Address1_FreightTermsCode
     */
    @DEField(name = "address1_freighttermscode")
    @TableField(value = "address1_freighttermscode")
    @JSONField(name = "address1_freighttermscode")
    @JsonProperty("address1_freighttermscode")
    private String address1Freighttermscode;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * Merged
     */
    @DEField(defaultValue = "False")
    @TableField(value = "merged")
    @JSONField(name = "merged")
    @JsonProperty("merged")
    private Integer merged;
    /**
     * Address1_ShippingMethodCode
     */
    @DEField(name = "address1_shippingmethodcode")
    @TableField(value = "address1_shippingmethodcode")
    @JSONField(name = "address1_shippingmethodcode")
    @JsonProperty("address1_shippingmethodcode")
    private String address1Shippingmethodcode;
    /**
     * Address1_Name
     */
    @DEField(name = "address1_name")
    @TableField(value = "address1_name")
    @JSONField(name = "address1_name")
    @JsonProperty("address1_name")
    private String address1Name;
    /**
     * Aging30_Base
     */
    @DEField(name = "aging30_base")
    @TableField(value = "aging30_base")
    @JSONField(name = "aging30_base")
    @JsonProperty("aging30_base")
    private BigDecimal aging30Base;
    /**
     * Address2_Telephone2
     */
    @DEField(name = "address2_telephone2")
    @TableField(value = "address2_telephone2")
    @JSONField(name = "address2_telephone2")
    @JsonProperty("address2_telephone2")
    private String address2Telephone2;
    /**
     * AccountId
     */
    @DEField(isKeyField=true)
    @TableId(value= "accountid",type=IdType.UUID)
    @JSONField(name = "accountid")
    @JsonProperty("accountid")
    private String accountid;
    /**
     * PrimaryTwitterId
     */
    @TableField(value = "primarytwitterid")
    @JSONField(name = "primarytwitterid")
    @JsonProperty("primarytwitterid")
    private String primarytwitterid;
    /**
     * TickerSymbol
     */
    @TableField(value = "tickersymbol")
    @JSONField(name = "tickersymbol")
    @JsonProperty("tickersymbol")
    private String tickersymbol;
    /**
     * StockExchange
     */
    @TableField(value = "stockexchange")
    @JSONField(name = "stockexchange")
    @JsonProperty("stockexchange")
    private String stockexchange;
    /**
     * Address2_StateOrProvince
     */
    @DEField(name = "address2_stateorprovince")
    @TableField(value = "address2_stateorprovince")
    @JSONField(name = "address2_stateorprovince")
    @JsonProperty("address2_stateorprovince")
    private String address2Stateorprovince;
    /**
     * FtpSiteURL
     */
    @TableField(value = "ftpsiteurl")
    @JSONField(name = "ftpsiteurl")
    @JsonProperty("ftpsiteurl")
    private String ftpsiteurl;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * WebSiteURL
     */
    @TableField(value = "websiteurl")
    @JSONField(name = "websiteurl")
    @JsonProperty("websiteurl")
    private String websiteurl;
    /**
     * DoNotPostalMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotpostalmail")
    @JSONField(name = "donotpostalmail")
    @JsonProperty("donotpostalmail")
    private Integer donotpostalmail;
    /**
     * Address1_City
     */
    @DEField(name = "address1_city")
    @TableField(value = "address1_city")
    @JSONField(name = "address1_city")
    @JsonProperty("address1_city")
    private String address1City;
    /**
     * Address2_Fax
     */
    @DEField(name = "address2_fax")
    @TableField(value = "address2_fax")
    @JSONField(name = "address2_fax")
    @JsonProperty("address2_fax")
    private String address2Fax;
    /**
     * Aging90_Base
     */
    @DEField(name = "aging90_base")
    @TableField(value = "aging90_base")
    @JSONField(name = "aging90_base")
    @JsonProperty("aging90_base")
    private BigDecimal aging90Base;
    /**
     * OpenDeals_Date
     */
    @DEField(name = "opendeals_date")
    @TableField(value = "opendeals_date")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "opendeals_date" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("opendeals_date")
    private Timestamp opendealsDate;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * ShippingMethodCode
     */
    @TableField(value = "shippingmethodcode")
    @JSONField(name = "shippingmethodcode")
    @JsonProperty("shippingmethodcode")
    private String shippingmethodcode;
    /**
     * Address1_Line2
     */
    @DEField(name = "address1_line2")
    @TableField(value = "address1_line2")
    @JSONField(name = "address1_line2")
    @JsonProperty("address1_line2")
    private String address1Line2;
    /**
     * OpenRevenue_Base
     */
    @DEField(name = "openrevenue_base")
    @TableField(value = "openrevenue_base")
    @JSONField(name = "openrevenue_base")
    @JsonProperty("openrevenue_base")
    private BigDecimal openrevenueBase;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * PreferredSystemUserIdYomiName
     */
    @TableField(value = "preferredsystemuseridyominame")
    @JSONField(name = "preferredsystemuseridyominame")
    @JsonProperty("preferredsystemuseridyominame")
    private String preferredsystemuseridyominame;
    /**
     * Address2_Line3
     */
    @DEField(name = "address2_line3")
    @TableField(value = "address2_line3")
    @JSONField(name = "address2_line3")
    @JsonProperty("address2_line3")
    private String address2Line3;
    /**
     * Address1_PostalCode
     */
    @DEField(name = "address1_postalcode")
    @TableField(value = "address1_postalcode")
    @JSONField(name = "address1_postalcode")
    @JsonProperty("address1_postalcode")
    private String address1Postalcode;
    /**
     * Address2_Latitude
     */
    @DEField(name = "address2_latitude")
    @TableField(value = "address2_latitude")
    @JSONField(name = "address2_latitude")
    @JsonProperty("address2_latitude")
    private Double address2Latitude;
    /**
     * Private
     */
    @DEField(defaultValue = "False")
    @TableField(value = "private")
    @JSONField(name = "ibizprivate")
    @JsonProperty("ibizprivate")
    private Integer ibizprivate;
    /**
     * TerritoryCode
     */
    @TableField(value = "territorycode")
    @JSONField(name = "territorycode")
    @JsonProperty("territorycode")
    private String territorycode;
    /**
     * TeamsFollowed
     */
    @TableField(value = "teamsfollowed")
    @JSONField(name = "teamsfollowed")
    @JsonProperty("teamsfollowed")
    private Integer teamsfollowed;
    /**
     * YomiName
     */
    @TableField(value = "yominame")
    @JSONField(name = "yominame")
    @JsonProperty("yominame")
    private String yominame;
    /**
     * Address1_Latitude
     */
    @DEField(name = "address1_latitude")
    @TableField(value = "address1_latitude")
    @JSONField(name = "address1_latitude")
    @JsonProperty("address1_latitude")
    private Double address1Latitude;
    /**
     * Telephone3
     */
    @TableField(value = "telephone3")
    @JSONField(name = "telephone3")
    @JsonProperty("telephone3")
    private String telephone3;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * Address2_Country
     */
    @DEField(name = "address2_country")
    @TableField(value = "address2_country")
    @JSONField(name = "address2_country")
    @JsonProperty("address2_country")
    private String address2Country;
    /**
     * MasterAccountIdYomiName
     */
    @TableField(value = "masteraccountidyominame")
    @JSONField(name = "masteraccountidyominame")
    @JsonProperty("masteraccountidyominame")
    private String masteraccountidyominame;
    /**
     * IndustryCode
     */
    @TableField(value = "industrycode")
    @JSONField(name = "industrycode")
    @JsonProperty("industrycode")
    private String industrycode;
    /**
     * LastOnHoldTime
     */
    @TableField(value = "lastonholdtime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastonholdtime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastonholdtime")
    private Timestamp lastonholdtime;
    /**
     * Address2_AddressId
     */
    @DEField(name = "address2_addressid")
    @TableField(value = "address2_addressid")
    @JSONField(name = "address2_addressid")
    @JsonProperty("address2_addressid")
    private String address2Addressid;
    /**
     * OnHoldTime
     */
    @TableField(value = "onholdtime")
    @JSONField(name = "onholdtime")
    @JsonProperty("onholdtime")
    private Integer onholdtime;
    /**
     * AccountClassificationCode
     */
    @TableField(value = "accountclassificationcode")
    @JSONField(name = "accountclassificationcode")
    @JsonProperty("accountclassificationcode")
    private String accountclassificationcode;
    /**
     * Address1_Country
     */
    @DEField(name = "address1_country")
    @TableField(value = "address1_country")
    @JSONField(name = "address1_country")
    @JsonProperty("address1_country")
    private String address1Country;
    /**
     * Address1_AddressTypeCode
     */
    @DEField(name = "address1_addresstypecode")
    @TableField(value = "address1_addresstypecode")
    @JSONField(name = "address1_addresstypecode")
    @JsonProperty("address1_addresstypecode")
    private String address1Addresstypecode;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * Address2_AddressTypeCode
     */
    @DEField(name = "address2_addresstypecode")
    @TableField(value = "address2_addresstypecode")
    @JSONField(name = "address2_addresstypecode")
    @JsonProperty("address2_addresstypecode")
    private String address2Addresstypecode;
    /**
     * AccountCategoryCode
     */
    @TableField(value = "accountcategorycode")
    @JSONField(name = "accountcategorycode")
    @JsonProperty("accountcategorycode")
    private String accountcategorycode;
    /**
     * EMailAddress2
     */
    @TableField(value = "emailaddress2")
    @JSONField(name = "emailaddress2")
    @JsonProperty("emailaddress2")
    private String emailaddress2;
    /**
     * Address2_ShippingMethodCode
     */
    @DEField(name = "address2_shippingmethodcode")
    @TableField(value = "address2_shippingmethodcode")
    @JSONField(name = "address2_shippingmethodcode")
    @JsonProperty("address2_shippingmethodcode")
    private String address2Shippingmethodcode;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * PrimarySatoriId
     */
    @TableField(value = "primarysatoriid")
    @JSONField(name = "primarysatoriid")
    @JsonProperty("primarysatoriid")
    private String primarysatoriid;
    /**
     * CustomerSizeCode
     */
    @TableField(value = "customersizecode")
    @JSONField(name = "customersizecode")
    @JsonProperty("customersizecode")
    private String customersizecode;
    /**
     * OpenDeals
     */
    @TableField(value = "opendeals")
    @JSONField(name = "opendeals")
    @JsonProperty("opendeals")
    private Integer opendeals;
    /**
     * DoNotSendMM
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotsendmm")
    @JSONField(name = "donotsendmm")
    @JsonProperty("donotsendmm")
    private Integer donotsendmm;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * PaymentTermsCode
     */
    @TableField(value = "paymenttermscode")
    @JSONField(name = "paymenttermscode")
    @JsonProperty("paymenttermscode")
    private String paymenttermscode;
    /**
     * SIC
     */
    @TableField(value = "sic")
    @JSONField(name = "sic")
    @JsonProperty("sic")
    private String sic;
    /**
     * Address2_PrimaryContactName
     */
    @DEField(name = "address2_primarycontactname")
    @TableField(value = "address2_primarycontactname")
    @JSONField(name = "address2_primarycontactname")
    @JsonProperty("address2_primarycontactname")
    private String address2Primarycontactname;
    /**
     * Address1_UTCOffset
     */
    @DEField(name = "address1_utcoffset")
    @TableField(value = "address1_utcoffset")
    @JSONField(name = "address1_utcoffset")
    @JsonProperty("address1_utcoffset")
    private Integer address1Utcoffset;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * LastUsedInCampaign
     */
    @TableField(value = "lastusedincampaign")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastusedincampaign" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastusedincampaign")
    private Timestamp lastusedincampaign;
    /**
     * Aging60_Base
     */
    @DEField(name = "aging60_base")
    @TableField(value = "aging60_base")
    @JSONField(name = "aging60_base")
    @JsonProperty("aging60_base")
    private BigDecimal aging60Base;
    /**
     * DoNotFax
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotfax")
    @JSONField(name = "donotfax")
    @JsonProperty("donotfax")
    private Integer donotfax;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * OpenRevenue_State
     */
    @DEField(name = "openrevenue_state")
    @TableField(value = "openrevenue_state")
    @JSONField(name = "openrevenue_state")
    @JsonProperty("openrevenue_state")
    private Integer openrevenueState;
    /**
     * OpenDeals_State
     */
    @DEField(name = "opendeals_state")
    @TableField(value = "opendeals_state")
    @JSONField(name = "opendeals_state")
    @JsonProperty("opendeals_state")
    private Integer opendealsState;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * Address1_Longitude
     */
    @DEField(name = "address1_longitude")
    @TableField(value = "address1_longitude")
    @JSONField(name = "address1_longitude")
    @JsonProperty("address1_longitude")
    private Double address1Longitude;
    /**
     * Aging90
     */
    @TableField(value = "aging90")
    @JSONField(name = "aging90")
    @JsonProperty("aging90")
    private BigDecimal aging90;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * CreditLimit
     */
    @TableField(value = "creditlimit")
    @JSONField(name = "creditlimit")
    @JsonProperty("creditlimit")
    private BigDecimal creditlimit;
    /**
     * PreferredSystemUserId
     */
    @TableField(value = "preferredsystemuserid")
    @JSONField(name = "preferredsystemuserid")
    @JsonProperty("preferredsystemuserid")
    private String preferredsystemuserid;
    /**
     * Revenue
     */
    @TableField(value = "revenue")
    @JSONField(name = "revenue")
    @JsonProperty("revenue")
    private BigDecimal revenue;
    /**
     * Address1_County
     */
    @DEField(name = "address1_county")
    @TableField(value = "address1_county")
    @JSONField(name = "address1_county")
    @JsonProperty("address1_county")
    private String address1County;
    /**
     * Address1_Line3
     */
    @DEField(name = "address1_line3")
    @TableField(value = "address1_line3")
    @JSONField(name = "address1_line3")
    @JsonProperty("address1_line3")
    private String address1Line3;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * DoNotEMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotemail")
    @JSONField(name = "donotemail")
    @JsonProperty("donotemail")
    private Integer donotemail;
    /**
     * Address2_PostalCode
     */
    @DEField(name = "address2_postalcode")
    @TableField(value = "address2_postalcode")
    @JSONField(name = "address2_postalcode")
    @JsonProperty("address2_postalcode")
    private String address2Postalcode;
    /**
     * PreferredAppointmentTimeCode
     */
    @TableField(value = "preferredappointmenttimecode")
    @JSONField(name = "preferredappointmenttimecode")
    @JsonProperty("preferredappointmenttimecode")
    private String preferredappointmenttimecode;
    /**
     * Address2_UPSZone
     */
    @DEField(name = "address2_upszone")
    @TableField(value = "address2_upszone")
    @JSONField(name = "address2_upszone")
    @JsonProperty("address2_upszone")
    private String address2Upszone;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * Address2_County
     */
    @DEField(name = "address2_county")
    @TableField(value = "address2_county")
    @JSONField(name = "address2_county")
    @JsonProperty("address2_county")
    private String address2County;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * Address2_Composite
     */
    @DEField(name = "address2_composite")
    @TableField(value = "address2_composite")
    @JSONField(name = "address2_composite")
    @JsonProperty("address2_composite")
    private String address2Composite;
    /**
     * Address2_Name
     */
    @DEField(name = "address2_name")
    @TableField(value = "address2_name")
    @JSONField(name = "address2_name")
    @JsonProperty("address2_name")
    private String address2Name;
    /**
     * Address2_Line1
     */
    @DEField(name = "address2_line1")
    @TableField(value = "address2_line1")
    @JSONField(name = "address2_line1")
    @JsonProperty("address2_line1")
    private String address2Line1;
    /**
     * MarketCap_Base
     */
    @DEField(name = "marketcap_base")
    @TableField(value = "marketcap_base")
    @JSONField(name = "marketcap_base")
    @JsonProperty("marketcap_base")
    private BigDecimal marketcapBase;
    /**
     * EMailAddress3
     */
    @TableField(value = "emailaddress3")
    @JSONField(name = "emailaddress3")
    @JsonProperty("emailaddress3")
    private String emailaddress3;
    /**
     * Telephone2
     */
    @TableField(value = "telephone2")
    @JSONField(name = "telephone2")
    @JsonProperty("telephone2")
    private String telephone2;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * Address1_PostOfficeBox
     */
    @DEField(name = "address1_postofficebox")
    @TableField(value = "address1_postofficebox")
    @JSONField(name = "address1_postofficebox")
    @JsonProperty("address1_postofficebox")
    private String address1Postofficebox;
    /**
     * CreditOnHold
     */
    @DEField(defaultValue = "False")
    @TableField(value = "creditonhold")
    @JSONField(name = "creditonhold")
    @JsonProperty("creditonhold")
    private Integer creditonhold;
    /**
     * Address1_AddressId
     */
    @DEField(name = "address1_addressid")
    @TableField(value = "address1_addressid")
    @JSONField(name = "address1_addressid")
    @JsonProperty("address1_addressid")
    private String address1Addressid;
    /**
     * Address2_PostOfficeBox
     */
    @DEField(name = "address2_postofficebox")
    @TableField(value = "address2_postofficebox")
    @JSONField(name = "address2_postofficebox")
    @JsonProperty("address2_postofficebox")
    private String address2Postofficebox;
    /**
     * OriginatingLeadId
     */
    @TableField(value = "originatingleadid")
    @JSONField(name = "originatingleadid")
    @JsonProperty("originatingleadid")
    private String originatingleadid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;
    /**
     * DefaultPriceLevelId
     */
    @TableField(value = "defaultpricelevelid")
    @JSONField(name = "defaultpricelevelid")
    @JsonProperty("defaultpricelevelid")
    private String defaultpricelevelid;
    /**
     * ParentAccountId
     */
    @TableField(value = "parentaccountid")
    @JSONField(name = "parentaccountid")
    @JsonProperty("parentaccountid")
    private String parentaccountid;
    /**
     * PreferredEquipmentId
     */
    @TableField(value = "preferredequipmentid")
    @JSONField(name = "preferredequipmentid")
    @JsonProperty("preferredequipmentid")
    private String preferredequipmentid;
    /**
     * TerritoryId
     */
    @TableField(value = "territoryid")
    @JSONField(name = "territoryid")
    @JsonProperty("territoryid")
    private String territoryid;
    /**
     * PrimaryContactId
     */
    @TableField(value = "primarycontactid")
    @JSONField(name = "primarycontactid")
    @JsonProperty("primarycontactid")
    private String primarycontactid;
    /**
     * SLAId
     */
    @TableField(value = "slaid")
    @JSONField(name = "slaid")
    @JsonProperty("slaid")
    private String slaid;
    /**
     * PreferredServiceId
     */
    @TableField(value = "preferredserviceid")
    @JSONField(name = "preferredserviceid")
    @JsonProperty("preferredserviceid")
    private String preferredserviceid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Account parentaccount;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Contact primarycontact;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Equipment preferredequipment;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.Lead originatinglead;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.product.domain.PriceLevel defaultpricelevel;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.IBizService preferredservice;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Sla sla;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Territory territory;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [Address1_PrimaryContactName]
     */
    public void setAddress1Primarycontactname(String address1Primarycontactname){
        this.address1Primarycontactname = address1Primarycontactname ;
        this.modify("address1_primarycontactname",address1Primarycontactname);
    }
    /**
     * 设置 [OpenRevenue_Date]
     */
    public void setOpenrevenueDate(Timestamp openrevenueDate){
        this.openrevenueDate = openrevenueDate ;
        this.modify("openrevenue_date",openrevenueDate);
    }
    /**
     * 设置 [Address2_UTCOffset]
     */
    public void setAddress2Utcoffset(Integer address2Utcoffset){
        this.address2Utcoffset = address2Utcoffset ;
        this.modify("address2_utcoffset",address2Utcoffset);
    }
    /**
     * 设置 [Fax]
     */
    public void setFax(String fax){
        this.fax = fax ;
        this.modify("fax",fax);
    }
    /**
     * 设置 [Address1_Composite]
     */
    public void setAddress1Composite(String address1Composite){
        this.address1Composite = address1Composite ;
        this.modify("address1_composite",address1Composite);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [EMailAddress1]
     */
    public void setEmailaddress1(String emailaddress1){
        this.emailaddress1 = emailaddress1 ;
        this.modify("emailaddress1",emailaddress1);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [Address1_StateOrProvince]
     */
    public void setAddress1Stateorprovince(String address1Stateorprovince){
        this.address1Stateorprovince = address1Stateorprovince ;
        this.modify("address1_stateorprovince",address1Stateorprovince);
    }
    /**
     * 设置 [PrimaryContactIdYomiName]
     */
    public void setPrimarycontactidyominame(String primarycontactidyominame){
        this.primarycontactidyominame = primarycontactidyominame ;
        this.modify("primarycontactidyominame",primarycontactidyominame);
    }
    /**
     * 设置 [OpenRevenue]
     */
    public void setOpenrevenue(BigDecimal openrevenue){
        this.openrevenue = openrevenue ;
        this.modify("openrevenue",openrevenue);
    }
    /**
     * 设置 [Address1_UPSZone]
     */
    public void setAddress1Upszone(String address1Upszone){
        this.address1Upszone = address1Upszone ;
        this.modify("address1_upszone",address1Upszone);
    }
    /**
     * 设置 [FollowEmail]
     */
    public void setFollowemail(Integer followemail){
        this.followemail = followemail ;
        this.modify("followemail",followemail);
    }
    /**
     * 设置 [MarketingOnly]
     */
    public void setMarketingonly(Integer marketingonly){
        this.marketingonly = marketingonly ;
        this.modify("marketingonly",marketingonly);
    }
    /**
     * 设置 [NumberOfEmployees]
     */
    public void setNumberofemployees(Integer numberofemployees){
        this.numberofemployees = numberofemployees ;
        this.modify("numberofemployees",numberofemployees);
    }
    /**
     * 设置 [Telephone1]
     */
    public void setTelephone1(String telephone1){
        this.telephone1 = telephone1 ;
        this.modify("telephone1",telephone1);
    }
    /**
     * 设置 [Aging60]
     */
    public void setAging60(BigDecimal aging60){
        this.aging60 = aging60 ;
        this.modify("aging60",aging60);
    }
    /**
     * 设置 [SharesOutstanding]
     */
    public void setSharesoutstanding(Integer sharesoutstanding){
        this.sharesoutstanding = sharesoutstanding ;
        this.modify("sharesoutstanding",sharesoutstanding);
    }
    /**
     * 设置 [Address2_FreightTermsCode]
     */
    public void setAddress2Freighttermscode(String address2Freighttermscode){
        this.address2Freighttermscode = address2Freighttermscode ;
        this.modify("address2_freighttermscode",address2Freighttermscode);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [Revenue_Base]
     */
    public void setRevenueBase(BigDecimal revenueBase){
        this.revenueBase = revenueBase ;
        this.modify("revenue_base",revenueBase);
    }
    /**
     * 设置 [AccountRatingCode]
     */
    public void setAccountratingcode(String accountratingcode){
        this.accountratingcode = accountratingcode ;
        this.modify("accountratingcode",accountratingcode);
    }
    /**
     * 设置 [SLAName]
     */
    public void setSlaname(String slaname){
        this.slaname = slaname ;
        this.modify("slaname",slaname);
    }
    /**
     * 设置 [DoNotBulkEMail]
     */
    public void setDonotbulkemail(Integer donotbulkemail){
        this.donotbulkemail = donotbulkemail ;
        this.modify("donotbulkemail",donotbulkemail);
    }
    /**
     * 设置 [ParentAccountIdYomiName]
     */
    public void setParentaccountidyominame(String parentaccountidyominame){
        this.parentaccountidyominame = parentaccountidyominame ;
        this.modify("parentaccountidyominame",parentaccountidyominame);
    }
    /**
     * 设置 [Aging30]
     */
    public void setAging30(BigDecimal aging30){
        this.aging30 = aging30 ;
        this.modify("aging30",aging30);
    }
    /**
     * 设置 [DoNotBulkPostalMail]
     */
    public void setDonotbulkpostalmail(Integer donotbulkpostalmail){
        this.donotbulkpostalmail = donotbulkpostalmail ;
        this.modify("donotbulkpostalmail",donotbulkpostalmail);
    }
    /**
     * 设置 [CreditLimit_Base]
     */
    public void setCreditlimitBase(BigDecimal creditlimitBase){
        this.creditlimitBase = creditlimitBase ;
        this.modify("creditlimit_base",creditlimitBase);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [CustomerTypeCode]
     */
    public void setCustomertypecode(String customertypecode){
        this.customertypecode = customertypecode ;
        this.modify("customertypecode",customertypecode);
    }
    /**
     * 设置 [Address2_Longitude]
     */
    public void setAddress2Longitude(Double address2Longitude){
        this.address2Longitude = address2Longitude ;
        this.modify("address2_longitude",address2Longitude);
    }
    /**
     * 设置 [accountName]
     */
    public void setAccountname(String accountname){
        this.accountname = accountname ;
        this.modify("accountname",accountname);
    }
    /**
     * 设置 [ParticipatesInWorkflow]
     */
    public void setParticipatesinworkflow(Integer participatesinworkflow){
        this.participatesinworkflow = participatesinworkflow ;
        this.modify("participatesinworkflow",participatesinworkflow);
    }
    /**
     * 设置 [PreferredContactMethodCode]
     */
    public void setPreferredcontactmethodcode(String preferredcontactmethodcode){
        this.preferredcontactmethodcode = preferredcontactmethodcode ;
        this.modify("preferredcontactmethodcode",preferredcontactmethodcode);
    }
    /**
     * 设置 [PreferredAppointmentDayCode]
     */
    public void setPreferredappointmentdaycode(String preferredappointmentdaycode){
        this.preferredappointmentdaycode = preferredappointmentdaycode ;
        this.modify("preferredappointmentdaycode",preferredappointmentdaycode);
    }
    /**
     * 设置 [MarketCap]
     */
    public void setMarketcap(BigDecimal marketcap){
        this.marketcap = marketcap ;
        this.modify("marketcap",marketcap);
    }
    /**
     * 设置 [Address2_Telephone1]
     */
    public void setAddress2Telephone1(String address2Telephone1){
        this.address2Telephone1 = address2Telephone1 ;
        this.modify("address2_telephone1",address2Telephone1);
    }
    /**
     * 设置 [BusinessTypeCode]
     */
    public void setBusinesstypecode(String businesstypecode){
        this.businesstypecode = businesstypecode ;
        this.modify("businesstypecode",businesstypecode);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [Address2_City]
     */
    public void setAddress2City(String address2City){
        this.address2City = address2City ;
        this.modify("address2_city",address2City);
    }
    /**
     * 设置 [OwnershipCode]
     */
    public void setOwnershipcode(String ownershipcode){
        this.ownershipcode = ownershipcode ;
        this.modify("ownershipcode",ownershipcode);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [AccountNumber]
     */
    public void setAccountnumber(String accountnumber){
        this.accountnumber = accountnumber ;
        this.modify("accountnumber",accountnumber);
    }
    /**
     * 设置 [Address1_Telephone2]
     */
    public void setAddress1Telephone2(String address1Telephone2){
        this.address1Telephone2 = address1Telephone2 ;
        this.modify("address1_telephone2",address1Telephone2);
    }
    /**
     * 设置 [OriginatingLeadIdYomiName]
     */
    public void setOriginatingleadidyominame(String originatingleadidyominame){
        this.originatingleadidyominame = originatingleadidyominame ;
        this.modify("originatingleadidyominame",originatingleadidyominame);
    }
    /**
     * 设置 [Address1_Line1]
     */
    public void setAddress1Line1(String address1Line1){
        this.address1Line1 = address1Line1 ;
        this.modify("address1_line1",address1Line1);
    }
    /**
     * 设置 [DoNotPhone]
     */
    public void setDonotphone(Integer donotphone){
        this.donotphone = donotphone ;
        this.modify("donotphone",donotphone);
    }
    /**
     * 设置 [Address1_Telephone3]
     */
    public void setAddress1Telephone3(String address1Telephone3){
        this.address1Telephone3 = address1Telephone3 ;
        this.modify("address1_telephone3",address1Telephone3);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [Address2_Line2]
     */
    public void setAddress2Line2(String address2Line2){
        this.address2Line2 = address2Line2 ;
        this.modify("address2_line2",address2Line2);
    }
    /**
     * 设置 [Address2_Telephone3]
     */
    public void setAddress2Telephone3(String address2Telephone3){
        this.address2Telephone3 = address2Telephone3 ;
        this.modify("address2_telephone3",address2Telephone3);
    }
    /**
     * 设置 [Address1_Telephone1]
     */
    public void setAddress1Telephone1(String address1Telephone1){
        this.address1Telephone1 = address1Telephone1 ;
        this.modify("address1_telephone1",address1Telephone1);
    }
    /**
     * 设置 [Address1_Fax]
     */
    public void setAddress1Fax(String address1Fax){
        this.address1Fax = address1Fax ;
        this.modify("address1_fax",address1Fax);
    }
    /**
     * 设置 [Address1_FreightTermsCode]
     */
    public void setAddress1Freighttermscode(String address1Freighttermscode){
        this.address1Freighttermscode = address1Freighttermscode ;
        this.modify("address1_freighttermscode",address1Freighttermscode);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [Merged]
     */
    public void setMerged(Integer merged){
        this.merged = merged ;
        this.modify("merged",merged);
    }
    /**
     * 设置 [Address1_ShippingMethodCode]
     */
    public void setAddress1Shippingmethodcode(String address1Shippingmethodcode){
        this.address1Shippingmethodcode = address1Shippingmethodcode ;
        this.modify("address1_shippingmethodcode",address1Shippingmethodcode);
    }
    /**
     * 设置 [Address1_Name]
     */
    public void setAddress1Name(String address1Name){
        this.address1Name = address1Name ;
        this.modify("address1_name",address1Name);
    }
    /**
     * 设置 [Aging30_Base]
     */
    public void setAging30Base(BigDecimal aging30Base){
        this.aging30Base = aging30Base ;
        this.modify("aging30_base",aging30Base);
    }
    /**
     * 设置 [Address2_Telephone2]
     */
    public void setAddress2Telephone2(String address2Telephone2){
        this.address2Telephone2 = address2Telephone2 ;
        this.modify("address2_telephone2",address2Telephone2);
    }
    /**
     * 设置 [PrimaryTwitterId]
     */
    public void setPrimarytwitterid(String primarytwitterid){
        this.primarytwitterid = primarytwitterid ;
        this.modify("primarytwitterid",primarytwitterid);
    }
    /**
     * 设置 [TickerSymbol]
     */
    public void setTickersymbol(String tickersymbol){
        this.tickersymbol = tickersymbol ;
        this.modify("tickersymbol",tickersymbol);
    }
    /**
     * 设置 [StockExchange]
     */
    public void setStockexchange(String stockexchange){
        this.stockexchange = stockexchange ;
        this.modify("stockexchange",stockexchange);
    }
    /**
     * 设置 [Address2_StateOrProvince]
     */
    public void setAddress2Stateorprovince(String address2Stateorprovince){
        this.address2Stateorprovince = address2Stateorprovince ;
        this.modify("address2_stateorprovince",address2Stateorprovince);
    }
    /**
     * 设置 [FtpSiteURL]
     */
    public void setFtpsiteurl(String ftpsiteurl){
        this.ftpsiteurl = ftpsiteurl ;
        this.modify("ftpsiteurl",ftpsiteurl);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [WebSiteURL]
     */
    public void setWebsiteurl(String websiteurl){
        this.websiteurl = websiteurl ;
        this.modify("websiteurl",websiteurl);
    }
    /**
     * 设置 [DoNotPostalMail]
     */
    public void setDonotpostalmail(Integer donotpostalmail){
        this.donotpostalmail = donotpostalmail ;
        this.modify("donotpostalmail",donotpostalmail);
    }
    /**
     * 设置 [Address1_City]
     */
    public void setAddress1City(String address1City){
        this.address1City = address1City ;
        this.modify("address1_city",address1City);
    }
    /**
     * 设置 [Address2_Fax]
     */
    public void setAddress2Fax(String address2Fax){
        this.address2Fax = address2Fax ;
        this.modify("address2_fax",address2Fax);
    }
    /**
     * 设置 [Aging90_Base]
     */
    public void setAging90Base(BigDecimal aging90Base){
        this.aging90Base = aging90Base ;
        this.modify("aging90_base",aging90Base);
    }
    /**
     * 设置 [OpenDeals_Date]
     */
    public void setOpendealsDate(Timestamp opendealsDate){
        this.opendealsDate = opendealsDate ;
        this.modify("opendeals_date",opendealsDate);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [ShippingMethodCode]
     */
    public void setShippingmethodcode(String shippingmethodcode){
        this.shippingmethodcode = shippingmethodcode ;
        this.modify("shippingmethodcode",shippingmethodcode);
    }
    /**
     * 设置 [Address1_Line2]
     */
    public void setAddress1Line2(String address1Line2){
        this.address1Line2 = address1Line2 ;
        this.modify("address1_line2",address1Line2);
    }
    /**
     * 设置 [OpenRevenue_Base]
     */
    public void setOpenrevenueBase(BigDecimal openrevenueBase){
        this.openrevenueBase = openrevenueBase ;
        this.modify("openrevenue_base",openrevenueBase);
    }
    /**
     * 设置 [PreferredSystemUserIdYomiName]
     */
    public void setPreferredsystemuseridyominame(String preferredsystemuseridyominame){
        this.preferredsystemuseridyominame = preferredsystemuseridyominame ;
        this.modify("preferredsystemuseridyominame",preferredsystemuseridyominame);
    }
    /**
     * 设置 [Address2_Line3]
     */
    public void setAddress2Line3(String address2Line3){
        this.address2Line3 = address2Line3 ;
        this.modify("address2_line3",address2Line3);
    }
    /**
     * 设置 [Address1_PostalCode]
     */
    public void setAddress1Postalcode(String address1Postalcode){
        this.address1Postalcode = address1Postalcode ;
        this.modify("address1_postalcode",address1Postalcode);
    }
    /**
     * 设置 [Address2_Latitude]
     */
    public void setAddress2Latitude(Double address2Latitude){
        this.address2Latitude = address2Latitude ;
        this.modify("address2_latitude",address2Latitude);
    }
    /**
     * 设置 [Private]
     */
    public void setIbizprivate(Integer ibizprivate){
        this.ibizprivate = ibizprivate ;
        this.modify("private",ibizprivate);
    }
    /**
     * 设置 [TerritoryCode]
     */
    public void setTerritorycode(String territorycode){
        this.territorycode = territorycode ;
        this.modify("territorycode",territorycode);
    }
    /**
     * 设置 [TeamsFollowed]
     */
    public void setTeamsfollowed(Integer teamsfollowed){
        this.teamsfollowed = teamsfollowed ;
        this.modify("teamsfollowed",teamsfollowed);
    }
    /**
     * 设置 [YomiName]
     */
    public void setYominame(String yominame){
        this.yominame = yominame ;
        this.modify("yominame",yominame);
    }
    /**
     * 设置 [Address1_Latitude]
     */
    public void setAddress1Latitude(Double address1Latitude){
        this.address1Latitude = address1Latitude ;
        this.modify("address1_latitude",address1Latitude);
    }
    /**
     * 设置 [Telephone3]
     */
    public void setTelephone3(String telephone3){
        this.telephone3 = telephone3 ;
        this.modify("telephone3",telephone3);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [Address2_Country]
     */
    public void setAddress2Country(String address2Country){
        this.address2Country = address2Country ;
        this.modify("address2_country",address2Country);
    }
    /**
     * 设置 [MasterAccountIdYomiName]
     */
    public void setMasteraccountidyominame(String masteraccountidyominame){
        this.masteraccountidyominame = masteraccountidyominame ;
        this.modify("masteraccountidyominame",masteraccountidyominame);
    }
    /**
     * 设置 [IndustryCode]
     */
    public void setIndustrycode(String industrycode){
        this.industrycode = industrycode ;
        this.modify("industrycode",industrycode);
    }
    /**
     * 设置 [LastOnHoldTime]
     */
    public void setLastonholdtime(Timestamp lastonholdtime){
        this.lastonholdtime = lastonholdtime ;
        this.modify("lastonholdtime",lastonholdtime);
    }
    /**
     * 设置 [Address2_AddressId]
     */
    public void setAddress2Addressid(String address2Addressid){
        this.address2Addressid = address2Addressid ;
        this.modify("address2_addressid",address2Addressid);
    }
    /**
     * 设置 [OnHoldTime]
     */
    public void setOnholdtime(Integer onholdtime){
        this.onholdtime = onholdtime ;
        this.modify("onholdtime",onholdtime);
    }
    /**
     * 设置 [AccountClassificationCode]
     */
    public void setAccountclassificationcode(String accountclassificationcode){
        this.accountclassificationcode = accountclassificationcode ;
        this.modify("accountclassificationcode",accountclassificationcode);
    }
    /**
     * 设置 [Address1_Country]
     */
    public void setAddress1Country(String address1Country){
        this.address1Country = address1Country ;
        this.modify("address1_country",address1Country);
    }
    /**
     * 设置 [Address1_AddressTypeCode]
     */
    public void setAddress1Addresstypecode(String address1Addresstypecode){
        this.address1Addresstypecode = address1Addresstypecode ;
        this.modify("address1_addresstypecode",address1Addresstypecode);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [Address2_AddressTypeCode]
     */
    public void setAddress2Addresstypecode(String address2Addresstypecode){
        this.address2Addresstypecode = address2Addresstypecode ;
        this.modify("address2_addresstypecode",address2Addresstypecode);
    }
    /**
     * 设置 [AccountCategoryCode]
     */
    public void setAccountcategorycode(String accountcategorycode){
        this.accountcategorycode = accountcategorycode ;
        this.modify("accountcategorycode",accountcategorycode);
    }
    /**
     * 设置 [EMailAddress2]
     */
    public void setEmailaddress2(String emailaddress2){
        this.emailaddress2 = emailaddress2 ;
        this.modify("emailaddress2",emailaddress2);
    }
    /**
     * 设置 [Address2_ShippingMethodCode]
     */
    public void setAddress2Shippingmethodcode(String address2Shippingmethodcode){
        this.address2Shippingmethodcode = address2Shippingmethodcode ;
        this.modify("address2_shippingmethodcode",address2Shippingmethodcode);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [PrimarySatoriId]
     */
    public void setPrimarysatoriid(String primarysatoriid){
        this.primarysatoriid = primarysatoriid ;
        this.modify("primarysatoriid",primarysatoriid);
    }
    /**
     * 设置 [CustomerSizeCode]
     */
    public void setCustomersizecode(String customersizecode){
        this.customersizecode = customersizecode ;
        this.modify("customersizecode",customersizecode);
    }
    /**
     * 设置 [OpenDeals]
     */
    public void setOpendeals(Integer opendeals){
        this.opendeals = opendeals ;
        this.modify("opendeals",opendeals);
    }
    /**
     * 设置 [DoNotSendMM]
     */
    public void setDonotsendmm(Integer donotsendmm){
        this.donotsendmm = donotsendmm ;
        this.modify("donotsendmm",donotsendmm);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [PaymentTermsCode]
     */
    public void setPaymenttermscode(String paymenttermscode){
        this.paymenttermscode = paymenttermscode ;
        this.modify("paymenttermscode",paymenttermscode);
    }
    /**
     * 设置 [SIC]
     */
    public void setSic(String sic){
        this.sic = sic ;
        this.modify("sic",sic);
    }
    /**
     * 设置 [Address2_PrimaryContactName]
     */
    public void setAddress2Primarycontactname(String address2Primarycontactname){
        this.address2Primarycontactname = address2Primarycontactname ;
        this.modify("address2_primarycontactname",address2Primarycontactname);
    }
    /**
     * 设置 [Address1_UTCOffset]
     */
    public void setAddress1Utcoffset(Integer address1Utcoffset){
        this.address1Utcoffset = address1Utcoffset ;
        this.modify("address1_utcoffset",address1Utcoffset);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [LastUsedInCampaign]
     */
    public void setLastusedincampaign(Timestamp lastusedincampaign){
        this.lastusedincampaign = lastusedincampaign ;
        this.modify("lastusedincampaign",lastusedincampaign);
    }
    /**
     * 设置 [Aging60_Base]
     */
    public void setAging60Base(BigDecimal aging60Base){
        this.aging60Base = aging60Base ;
        this.modify("aging60_base",aging60Base);
    }
    /**
     * 设置 [DoNotFax]
     */
    public void setDonotfax(Integer donotfax){
        this.donotfax = donotfax ;
        this.modify("donotfax",donotfax);
    }
    /**
     * 设置 [OpenRevenue_State]
     */
    public void setOpenrevenueState(Integer openrevenueState){
        this.openrevenueState = openrevenueState ;
        this.modify("openrevenue_state",openrevenueState);
    }
    /**
     * 设置 [OpenDeals_State]
     */
    public void setOpendealsState(Integer opendealsState){
        this.opendealsState = opendealsState ;
        this.modify("opendeals_state",opendealsState);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [Address1_Longitude]
     */
    public void setAddress1Longitude(Double address1Longitude){
        this.address1Longitude = address1Longitude ;
        this.modify("address1_longitude",address1Longitude);
    }
    /**
     * 设置 [Aging90]
     */
    public void setAging90(BigDecimal aging90){
        this.aging90 = aging90 ;
        this.modify("aging90",aging90);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [CreditLimit]
     */
    public void setCreditlimit(BigDecimal creditlimit){
        this.creditlimit = creditlimit ;
        this.modify("creditlimit",creditlimit);
    }
    /**
     * 设置 [PreferredSystemUserId]
     */
    public void setPreferredsystemuserid(String preferredsystemuserid){
        this.preferredsystemuserid = preferredsystemuserid ;
        this.modify("preferredsystemuserid",preferredsystemuserid);
    }
    /**
     * 设置 [Revenue]
     */
    public void setRevenue(BigDecimal revenue){
        this.revenue = revenue ;
        this.modify("revenue",revenue);
    }
    /**
     * 设置 [Address1_County]
     */
    public void setAddress1County(String address1County){
        this.address1County = address1County ;
        this.modify("address1_county",address1County);
    }
    /**
     * 设置 [Address1_Line3]
     */
    public void setAddress1Line3(String address1Line3){
        this.address1Line3 = address1Line3 ;
        this.modify("address1_line3",address1Line3);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [DoNotEMail]
     */
    public void setDonotemail(Integer donotemail){
        this.donotemail = donotemail ;
        this.modify("donotemail",donotemail);
    }
    /**
     * 设置 [Address2_PostalCode]
     */
    public void setAddress2Postalcode(String address2Postalcode){
        this.address2Postalcode = address2Postalcode ;
        this.modify("address2_postalcode",address2Postalcode);
    }
    /**
     * 设置 [PreferredAppointmentTimeCode]
     */
    public void setPreferredappointmenttimecode(String preferredappointmenttimecode){
        this.preferredappointmenttimecode = preferredappointmenttimecode ;
        this.modify("preferredappointmenttimecode",preferredappointmenttimecode);
    }
    /**
     * 设置 [Address2_UPSZone]
     */
    public void setAddress2Upszone(String address2Upszone){
        this.address2Upszone = address2Upszone ;
        this.modify("address2_upszone",address2Upszone);
    }
    /**
     * 设置 [Address2_County]
     */
    public void setAddress2County(String address2County){
        this.address2County = address2County ;
        this.modify("address2_county",address2County);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [Address2_Composite]
     */
    public void setAddress2Composite(String address2Composite){
        this.address2Composite = address2Composite ;
        this.modify("address2_composite",address2Composite);
    }
    /**
     * 设置 [Address2_Name]
     */
    public void setAddress2Name(String address2Name){
        this.address2Name = address2Name ;
        this.modify("address2_name",address2Name);
    }
    /**
     * 设置 [Address2_Line1]
     */
    public void setAddress2Line1(String address2Line1){
        this.address2Line1 = address2Line1 ;
        this.modify("address2_line1",address2Line1);
    }
    /**
     * 设置 [MarketCap_Base]
     */
    public void setMarketcapBase(BigDecimal marketcapBase){
        this.marketcapBase = marketcapBase ;
        this.modify("marketcap_base",marketcapBase);
    }
    /**
     * 设置 [EMailAddress3]
     */
    public void setEmailaddress3(String emailaddress3){
        this.emailaddress3 = emailaddress3 ;
        this.modify("emailaddress3",emailaddress3);
    }
    /**
     * 设置 [Telephone2]
     */
    public void setTelephone2(String telephone2){
        this.telephone2 = telephone2 ;
        this.modify("telephone2",telephone2);
    }
    /**
     * 设置 [Address1_PostOfficeBox]
     */
    public void setAddress1Postofficebox(String address1Postofficebox){
        this.address1Postofficebox = address1Postofficebox ;
        this.modify("address1_postofficebox",address1Postofficebox);
    }
    /**
     * 设置 [CreditOnHold]
     */
    public void setCreditonhold(Integer creditonhold){
        this.creditonhold = creditonhold ;
        this.modify("creditonhold",creditonhold);
    }
    /**
     * 设置 [Address1_AddressId]
     */
    public void setAddress1Addressid(String address1Addressid){
        this.address1Addressid = address1Addressid ;
        this.modify("address1_addressid",address1Addressid);
    }
    /**
     * 设置 [Address2_PostOfficeBox]
     */
    public void setAddress2Postofficebox(String address2Postofficebox){
        this.address2Postofficebox = address2Postofficebox ;
        this.modify("address2_postofficebox",address2Postofficebox);
    }
    /**
     * 设置 [OriginatingLeadId]
     */
    public void setOriginatingleadid(String originatingleadid){
        this.originatingleadid = originatingleadid ;
        this.modify("originatingleadid",originatingleadid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }
    /**
     * 设置 [DefaultPriceLevelId]
     */
    public void setDefaultpricelevelid(String defaultpricelevelid){
        this.defaultpricelevelid = defaultpricelevelid ;
        this.modify("defaultpricelevelid",defaultpricelevelid);
    }
    /**
     * 设置 [ParentAccountId]
     */
    public void setParentaccountid(String parentaccountid){
        this.parentaccountid = parentaccountid ;
        this.modify("parentaccountid",parentaccountid);
    }
    /**
     * 设置 [PreferredEquipmentId]
     */
    public void setPreferredequipmentid(String preferredequipmentid){
        this.preferredequipmentid = preferredequipmentid ;
        this.modify("preferredequipmentid",preferredequipmentid);
    }
    /**
     * 设置 [TerritoryId]
     */
    public void setTerritoryid(String territoryid){
        this.territoryid = territoryid ;
        this.modify("territoryid",territoryid);
    }
    /**
     * 设置 [PrimaryContactId]
     */
    public void setPrimarycontactid(String primarycontactid){
        this.primarycontactid = primarycontactid ;
        this.modify("primarycontactid",primarycontactid);
    }
    /**
     * 设置 [SLAId]
     */
    public void setSlaid(String slaid){
        this.slaid = slaid ;
        this.modify("slaid",slaid);
    }
    /**
     * 设置 [PreferredServiceId]
     */
    public void setPreferredserviceid(String preferredserviceid){
        this.preferredserviceid = preferredserviceid ;
        this.modify("preferredserviceid",preferredserviceid);
    }

}


