package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[活动合作]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "ACTIVITYPARTY",resultMap = "ActivityPartyResultMap")
public class ActivityParty extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * AddressUsedEmailColumnNumber
     */
    @TableField(value = "addressusedemailcolumnnumber")
    @JSONField(name = "addressusedemailcolumnnumber")
    @JsonProperty("addressusedemailcolumnnumber")
    private Integer addressusedemailcolumnnumber;
    /**
     * DoNotEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotemail")
    @JSONField(name = "donotemail")
    @JsonProperty("donotemail")
    private Integer donotemail;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * InstanceTypeCode
     */
    @TableField(value = "instancetypecode")
    @JSONField(name = "instancetypecode")
    @JsonProperty("instancetypecode")
    private String instancetypecode;
    /**
     * ActivityPartyId
     */
    @DEField(isKeyField=true)
    @TableId(value= "activitypartyid",type=IdType.UUID)
    @JSONField(name = "activitypartyid")
    @JsonProperty("activitypartyid")
    private String activitypartyid;
    /**
     * DoNotPostalMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotpostalmail")
    @JSONField(name = "donotpostalmail")
    @JsonProperty("donotpostalmail")
    private Integer donotpostalmail;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * DoNotFax
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotfax")
    @JSONField(name = "donotfax")
    @JsonProperty("donotfax")
    private Integer donotfax;
    /**
     * PartyId
     */
    @TableField(value = "partyid")
    @JSONField(name = "partyid")
    @JsonProperty("partyid")
    private String partyid;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * DoNotPhone
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotphone")
    @JSONField(name = "donotphone")
    @JsonProperty("donotphone")
    private Integer donotphone;
    /**
     * Effort
     */
    @TableField(value = "effort")
    @JSONField(name = "effort")
    @JsonProperty("effort")
    private Double effort;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * PartyIdName
     */
    @TableField(value = "partyidname")
    @JSONField(name = "partyidname")
    @JsonProperty("partyidname")
    private String partyidname;
    /**
     * PartyObjectTypeCode
     */
    @TableField(value = "partyobjecttypecode")
    @JSONField(name = "partyobjecttypecode")
    @JsonProperty("partyobjecttypecode")
    private String partyobjecttypecode;
    /**
     * ScheduledEnd
     */
    @TableField(value = "scheduledend")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "scheduledend" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("scheduledend")
    private Timestamp scheduledend;
    /**
     * ScheduledStart
     */
    @TableField(value = "scheduledstart")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "scheduledstart" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("scheduledstart")
    private Timestamp scheduledstart;
    /**
     * ParticipationTypeMask
     */
    @TableField(value = "participationtypemask")
    @JSONField(name = "participationtypemask")
    @JsonProperty("participationtypemask")
    private String participationtypemask;
    /**
     * OwningUser
     */
    @TableField(value = "owninguser")
    @JSONField(name = "owninguser")
    @JsonProperty("owninguser")
    private String owninguser;
    /**
     * ExchangeEntryId
     */
    @TableField(value = "exchangeentryid")
    @JSONField(name = "exchangeentryid")
    @JsonProperty("exchangeentryid")
    private String exchangeentryid;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * AddressUsed
     */
    @TableField(value = "addressused")
    @JSONField(name = "addressused")
    @JsonProperty("addressused")
    private String addressused;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * OwningBusinessUnit
     */
    @TableField(value = "owningbusinessunit")
    @JSONField(name = "owningbusinessunit")
    @JsonProperty("owningbusinessunit")
    private String owningbusinessunit;
    /**
     * PartyDeleted
     */
    @DEField(defaultValue = "False")
    @TableField(value = "partydeleted")
    @JSONField(name = "partydeleted")
    @JsonProperty("partydeleted")
    private Integer partydeleted;
    /**
     * ResourceSpecId
     */
    @TableField(value = "resourcespecid")
    @JSONField(name = "resourcespecid")
    @JsonProperty("resourcespecid")
    private String resourcespecid;
    /**
     * ActivityId
     */
    @TableField(value = "activityid")
    @JSONField(name = "activityid")
    @JsonProperty("activityid")
    private String activityid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.ActivityPointer activity;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.ResourceSpec resourcespec;



    /**
     * 设置 [AddressUsedEmailColumnNumber]
     */
    public void setAddressusedemailcolumnnumber(Integer addressusedemailcolumnnumber){
        this.addressusedemailcolumnnumber = addressusedemailcolumnnumber ;
        this.modify("addressusedemailcolumnnumber",addressusedemailcolumnnumber);
    }
    /**
     * 设置 [DoNotEmail]
     */
    public void setDonotemail(Integer donotemail){
        this.donotemail = donotemail ;
        this.modify("donotemail",donotemail);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [InstanceTypeCode]
     */
    public void setInstancetypecode(String instancetypecode){
        this.instancetypecode = instancetypecode ;
        this.modify("instancetypecode",instancetypecode);
    }
    /**
     * 设置 [DoNotPostalMail]
     */
    public void setDonotpostalmail(Integer donotpostalmail){
        this.donotpostalmail = donotpostalmail ;
        this.modify("donotpostalmail",donotpostalmail);
    }
    /**
     * 设置 [DoNotFax]
     */
    public void setDonotfax(Integer donotfax){
        this.donotfax = donotfax ;
        this.modify("donotfax",donotfax);
    }
    /**
     * 设置 [PartyId]
     */
    public void setPartyid(String partyid){
        this.partyid = partyid ;
        this.modify("partyid",partyid);
    }
    /**
     * 设置 [DoNotPhone]
     */
    public void setDonotphone(Integer donotphone){
        this.donotphone = donotphone ;
        this.modify("donotphone",donotphone);
    }
    /**
     * 设置 [Effort]
     */
    public void setEffort(Double effort){
        this.effort = effort ;
        this.modify("effort",effort);
    }
    /**
     * 设置 [PartyIdName]
     */
    public void setPartyidname(String partyidname){
        this.partyidname = partyidname ;
        this.modify("partyidname",partyidname);
    }
    /**
     * 设置 [PartyObjectTypeCode]
     */
    public void setPartyobjecttypecode(String partyobjecttypecode){
        this.partyobjecttypecode = partyobjecttypecode ;
        this.modify("partyobjecttypecode",partyobjecttypecode);
    }
    /**
     * 设置 [ScheduledEnd]
     */
    public void setScheduledend(Timestamp scheduledend){
        this.scheduledend = scheduledend ;
        this.modify("scheduledend",scheduledend);
    }
    /**
     * 设置 [ScheduledStart]
     */
    public void setScheduledstart(Timestamp scheduledstart){
        this.scheduledstart = scheduledstart ;
        this.modify("scheduledstart",scheduledstart);
    }
    /**
     * 设置 [ParticipationTypeMask]
     */
    public void setParticipationtypemask(String participationtypemask){
        this.participationtypemask = participationtypemask ;
        this.modify("participationtypemask",participationtypemask);
    }
    /**
     * 设置 [OwningUser]
     */
    public void setOwninguser(String owninguser){
        this.owninguser = owninguser ;
        this.modify("owninguser",owninguser);
    }
    /**
     * 设置 [ExchangeEntryId]
     */
    public void setExchangeentryid(String exchangeentryid){
        this.exchangeentryid = exchangeentryid ;
        this.modify("exchangeentryid",exchangeentryid);
    }
    /**
     * 设置 [AddressUsed]
     */
    public void setAddressused(String addressused){
        this.addressused = addressused ;
        this.modify("addressused",addressused);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [OwningBusinessUnit]
     */
    public void setOwningbusinessunit(String owningbusinessunit){
        this.owningbusinessunit = owningbusinessunit ;
        this.modify("owningbusinessunit",owningbusinessunit);
    }
    /**
     * 设置 [PartyDeleted]
     */
    public void setPartydeleted(Integer partydeleted){
        this.partydeleted = partydeleted ;
        this.modify("partydeleted",partydeleted);
    }
    /**
     * 设置 [ResourceSpecId]
     */
    public void setResourcespecid(String resourcespecid){
        this.resourcespecid = resourcespecid ;
        this.modify("resourcespecid",resourcespecid);
    }
    /**
     * 设置 [ActivityId]
     */
    public void setActivityid(String activityid){
        this.activityid = activityid ;
        this.modify("activityid",activityid);
    }

}


