package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[审计]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "AUDIT",resultMap = "AuditResultMap")
public class Audit extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * RegardingObjectIdName
     */
    @TableField(value = "regardingobjectidname")
    @JSONField(name = "regardingobjectidname")
    @JsonProperty("regardingobjectidname")
    private String regardingobjectidname;
    /**
     * AttributeMask
     */
    @TableField(value = "attributemask")
    @JSONField(name = "attributemask")
    @JsonProperty("attributemask")
    private String attributemask;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * RegardingObjectId
     */
    @TableField(value = "regardingobjectid")
    @JSONField(name = "regardingobjectid")
    @JsonProperty("regardingobjectid")
    private String regardingobjectid;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * AuditId
     */
    @DEField(isKeyField=true)
    @TableId(value= "auditid",type=IdType.UUID)
    @JSONField(name = "auditid")
    @JsonProperty("auditid")
    private String auditid;
    /**
     * TransactionId
     */
    @TableField(value = "transactionid")
    @JSONField(name = "transactionid")
    @JsonProperty("transactionid")
    private String transactionid;
    /**
     * UserAdditionalInfo
     */
    @TableField(value = "useradditionalinfo")
    @JSONField(name = "useradditionalinfo")
    @JsonProperty("useradditionalinfo")
    private String useradditionalinfo;
    /**
     * Action
     */
    @TableField(value = "action")
    @JSONField(name = "action")
    @JsonProperty("action")
    private String action;
    /**
     * Operation
     */
    @TableField(value = "operation")
    @JSONField(name = "operation")
    @JsonProperty("operation")
    private String operation;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * ChangeData
     */
    @TableField(value = "changedata")
    @JSONField(name = "changedata")
    @JsonProperty("changedata")
    private String changedata;
    /**
     * ObjectTypeCode
     */
    @TableField(value = "objecttypecode")
    @JSONField(name = "objecttypecode")
    @JsonProperty("objecttypecode")
    private String objecttypecode;



    /**
     * 设置 [RegardingObjectIdName]
     */
    public void setRegardingobjectidname(String regardingobjectidname){
        this.regardingobjectidname = regardingobjectidname ;
        this.modify("regardingobjectidname",regardingobjectidname);
    }
    /**
     * 设置 [AttributeMask]
     */
    public void setAttributemask(String attributemask){
        this.attributemask = attributemask ;
        this.modify("attributemask",attributemask);
    }
    /**
     * 设置 [RegardingObjectId]
     */
    public void setRegardingobjectid(String regardingobjectid){
        this.regardingobjectid = regardingobjectid ;
        this.modify("regardingobjectid",regardingobjectid);
    }
    /**
     * 设置 [TransactionId]
     */
    public void setTransactionid(String transactionid){
        this.transactionid = transactionid ;
        this.modify("transactionid",transactionid);
    }
    /**
     * 设置 [UserAdditionalInfo]
     */
    public void setUseradditionalinfo(String useradditionalinfo){
        this.useradditionalinfo = useradditionalinfo ;
        this.modify("useradditionalinfo",useradditionalinfo);
    }
    /**
     * 设置 [Action]
     */
    public void setAction(String action){
        this.action = action ;
        this.modify("action",action);
    }
    /**
     * 设置 [Operation]
     */
    public void setOperation(String operation){
        this.operation = operation ;
        this.modify("operation",operation);
    }
    /**
     * 设置 [ChangeData]
     */
    public void setChangedata(String changedata){
        this.changedata = changedata ;
        this.modify("changedata",changedata);
    }
    /**
     * 设置 [ObjectTypeCode]
     */
    public void setObjecttypecode(String objecttypecode){
        this.objecttypecode = objecttypecode ;
        this.modify("objecttypecode",objecttypecode);
    }

}


