package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[业务部门新闻文章]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "BUSINESSUNITNEWSARTICLE",resultMap = "BusinessUnitNewsArticleResultMap")
public class BusinessUnitNewsArticle extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * BusinessUnitNewsArticleId
     */
    @DEField(isKeyField=true)
    @TableId(value= "businessunitnewsarticleid",type=IdType.UUID)
    @JSONField(name = "businessunitnewsarticleid")
    @JsonProperty("businessunitnewsarticleid")
    private String businessunitnewsarticleid;
    /**
     * ArticleUrl
     */
    @TableField(value = "articleurl")
    @JSONField(name = "articleurl")
    @JsonProperty("articleurl")
    private String articleurl;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * NewsArticle
     */
    @TableField(value = "newsarticle")
    @JSONField(name = "newsarticle")
    @JsonProperty("newsarticle")
    private String newsarticle;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * ShowOnHomepage
     */
    @DEField(defaultValue = "False")
    @TableField(value = "showonhomepage")
    @JSONField(name = "showonhomepage")
    @JsonProperty("showonhomepage")
    private Integer showonhomepage;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * ActiveUntil
     */
    @TableField(value = "activeuntil")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "activeuntil" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("activeuntil")
    private Timestamp activeuntil;
    /**
     * ArticleTitle
     */
    @TableField(value = "articletitle")
    @JSONField(name = "articletitle")
    @JsonProperty("articletitle")
    private String articletitle;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * ArticleTypeCode
     */
    @TableField(value = "articletypecode")
    @JSONField(name = "articletypecode")
    @JsonProperty("articletypecode")
    private String articletypecode;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * ActiveOn
     */
    @TableField(value = "activeon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "activeon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("activeon")
    private Timestamp activeon;



    /**
     * 设置 [ArticleUrl]
     */
    public void setArticleurl(String articleurl){
        this.articleurl = articleurl ;
        this.modify("articleurl",articleurl);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [NewsArticle]
     */
    public void setNewsarticle(String newsarticle){
        this.newsarticle = newsarticle ;
        this.modify("newsarticle",newsarticle);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [ShowOnHomepage]
     */
    public void setShowonhomepage(Integer showonhomepage){
        this.showonhomepage = showonhomepage ;
        this.modify("showonhomepage",showonhomepage);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [ActiveUntil]
     */
    public void setActiveuntil(Timestamp activeuntil){
        this.activeuntil = activeuntil ;
        this.modify("activeuntil",activeuntil);
    }
    /**
     * 设置 [ArticleTitle]
     */
    public void setArticletitle(String articletitle){
        this.articletitle = articletitle ;
        this.modify("articletitle",articletitle);
    }
    /**
     * 设置 [ArticleTypeCode]
     */
    public void setArticletypecode(String articletypecode){
        this.articletypecode = articletypecode ;
        this.modify("articletypecode",articletypecode);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [ActiveOn]
     */
    public void setActiveon(Timestamp activeon){
        this.activeon = activeon ;
        this.modify("activeon",activeon);
    }

}


