package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[知识文章]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "KNOWLEDGEARTICLE",resultMap = "KnowledgeArticleResultMap")
public class KnowledgeArticle extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * KnowledgeArticleViews_Date
     */
    @DEField(name = "knowledgearticleviews_date")
    @TableField(value = "knowledgearticleviews_date")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "knowledgearticleviews_date" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("knowledgearticleviews_date")
    private Timestamp knowledgearticleviewsDate;
    /**
     * Keywords
     */
    @TableField(value = "keywords")
    @JSONField(name = "keywords")
    @JsonProperty("keywords")
    private String keywords;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * Primary
     */
    @DEField(defaultValue = "False")
    @TableField(value = "primary")
    @JSONField(name = "primary")
    @JsonProperty("primary")
    private Integer primary;
    /**
     * ExpirationStateId
     */
    @TableField(value = "expirationstateid")
    @JSONField(name = "expirationstateid")
    @JsonProperty("expirationstateid")
    private Integer expirationstateid;
    /**
     * Rating_Count
     */
    @DEField(name = "rating_count")
    @TableField(value = "rating_count")
    @JSONField(name = "rating_count")
    @JsonProperty("rating_count")
    private Integer ratingCount;
    /**
     * Content
     */
    @TableField(value = "content")
    @JSONField(name = "content")
    @JsonProperty("content")
    private String content;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * RootArticle
     */
    @DEField(defaultValue = "False")
    @TableField(value = "rootarticle")
    @JSONField(name = "rootarticled")
    @JsonProperty("rootarticled")
    private Integer rootarticled;
    /**
     * KnowledgeArticleViews_State
     */
    @DEField(name = "knowledgearticleviews_state")
    @TableField(value = "knowledgearticleviews_state")
    @JSONField(name = "knowledgearticleviews_state")
    @JsonProperty("knowledgearticleviews_state")
    private Integer knowledgearticleviewsState;
    /**
     * Rating_Sum
     */
    @DEField(name = "rating_sum")
    @TableField(value = "rating_sum")
    @JSONField(name = "rating_sum")
    @JsonProperty("rating_sum")
    private BigDecimal ratingSum;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * traversedpath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * PublishStatusId
     */
    @TableField(value = "publishstatusid")
    @JSONField(name = "publishstatusid")
    @JsonProperty("publishstatusid")
    private Integer publishstatusid;
    /**
     * ArticlePublicNumber
     */
    @TableField(value = "articlepublicnumber")
    @JSONField(name = "articlepublicnumber")
    @JsonProperty("articlepublicnumber")
    private String articlepublicnumber;
    /**
     * primaryauthoridName
     */
    @TableField(value = "primaryauthoridname")
    @JSONField(name = "primaryauthoridname")
    @JsonProperty("primaryauthoridname")
    private String primaryauthoridname;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * primaryauthorid
     */
    @TableField(value = "primaryauthorid")
    @JSONField(name = "primaryauthorid")
    @JsonProperty("primaryauthorid")
    private String primaryauthorid;
    /**
     * LatestVersion
     */
    @DEField(defaultValue = "False")
    @TableField(value = "latestversion")
    @JSONField(name = "latestversion")
    @JsonProperty("latestversion")
    private Integer latestversion;
    /**
     * Rating_State
     */
    @DEField(name = "rating_state")
    @TableField(value = "rating_state")
    @JSONField(name = "rating_state")
    @JsonProperty("rating_state")
    private Integer ratingState;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * ExpirationStatusId
     */
    @TableField(value = "expirationstatusid")
    @JSONField(name = "expirationstatusid")
    @JsonProperty("expirationstatusid")
    private Integer expirationstatusid;
    /**
     * knowledgearticleId
     */
    @DEField(isKeyField=true)
    @TableId(value= "knowledgearticleid",type=IdType.UUID)
    @JSONField(name = "knowledgearticleid")
    @JsonProperty("knowledgearticleid")
    private String knowledgearticleid;
    /**
     * SetCategoryAssociations
     */
    @DEField(defaultValue = "False")
    @TableField(value = "setcategoryassociations")
    @JSONField(name = "setcategoryassociations")
    @JsonProperty("setcategoryassociations")
    private Integer setcategoryassociations;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * SetProductAssociations
     */
    @DEField(defaultValue = "False")
    @TableField(value = "setproductassociations")
    @JSONField(name = "setproductassociations")
    @JsonProperty("setproductassociations")
    private Integer setproductassociations;
    /**
     * MinorVersionNumber
     */
    @TableField(value = "minorversionnumber")
    @JSONField(name = "minorversionnumber")
    @JsonProperty("minorversionnumber")
    private Integer minorversionnumber;
    /**
     * stageid
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * processid
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * MajorVersionNumber
     */
    @TableField(value = "majorversionnumber")
    @JSONField(name = "majorversionnumber")
    @JsonProperty("majorversionnumber")
    private Integer majorversionnumber;
    /**
     * Rating
     */
    @TableField(value = "rating")
    @JSONField(name = "rating")
    @JsonProperty("rating")
    private BigDecimal rating;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * PublishOn
     */
    @TableField(value = "publishon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "publishon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("publishon")
    private Timestamp publishon;
    /**
     * KnowledgeArticleViews
     */
    @TableField(value = "knowledgearticleviews")
    @JSONField(name = "knowledgearticleviews")
    @JsonProperty("knowledgearticleviews")
    private Integer knowledgearticleviews;
    /**
     * Rating_Date
     */
    @DEField(name = "rating_date")
    @TableField(value = "rating_date")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "rating_date" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("rating_date")
    private Timestamp ratingDate;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * ReadyForReview
     */
    @DEField(defaultValue = "False")
    @TableField(value = "readyforreview")
    @JSONField(name = "readyforreview")
    @JsonProperty("readyforreview")
    private Integer readyforreview;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * SubjectIdDsc
     */
    @TableField(value = "subjectiddsc")
    @JSONField(name = "subjectiddsc")
    @JsonProperty("subjectiddsc")
    private Integer subjectiddsc;
    /**
     * Review
     */
    @TableField(value = "review")
    @JSONField(name = "review")
    @JsonProperty("review")
    private String review;
    /**
     * LanguageLocaleIdLocaleId
     */
    @TableField(value = "languagelocaleidlocaleid")
    @JSONField(name = "languagelocaleidlocaleid")
    @JsonProperty("languagelocaleidlocaleid")
    private Integer languagelocaleidlocaleid;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * ScheduledStatusId
     */
    @TableField(value = "scheduledstatusid")
    @JSONField(name = "scheduledstatusid")
    @JsonProperty("scheduledstatusid")
    private Integer scheduledstatusid;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * Internal
     */
    @DEField(defaultValue = "False")
    @TableField(value = "internal")
    @JSONField(name = "internal")
    @JsonProperty("internal")
    private Integer internal;
    /**
     * Title
     */
    @TableField(value = "title")
    @JSONField(name = "title")
    @JsonProperty("title")
    private String title;
    /**
     * UpdateContent
     */
    @DEField(defaultValue = "False")
    @TableField(value = "updatecontent")
    @JSONField(name = "updatecontent")
    @JsonProperty("updatecontent")
    private Integer updatecontent;
    /**
     * ExpirationDate
     */
    @TableField(value = "expirationdate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "expirationdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("expirationdate")
    private Timestamp expirationdate;
    /**
     * ExpiredReviewOptions
     */
    @TableField(value = "expiredreviewoptions")
    @JSONField(name = "expiredreviewoptions")
    @JsonProperty("expiredreviewoptions")
    private String expiredreviewoptions;
    /**
     * ParentArticleContentId
     */
    @TableField(value = "parentarticlecontentid")
    @JSONField(name = "parentarticlecontentid")
    @JsonProperty("parentarticlecontentid")
    private String parentarticlecontentid;
    /**
     * PreviousArticleContentId
     */
    @TableField(value = "previousarticlecontentid")
    @JSONField(name = "previousarticlecontentid")
    @JsonProperty("previousarticlecontentid")
    private String previousarticlecontentid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;
    /**
     * RootArticleId
     */
    @TableField(value = "rootarticleid")
    @JSONField(name = "rootarticleid")
    @JsonProperty("rootarticleid")
    private String rootarticleid;
    /**
     * SubjectId
     */
    @TableField(value = "subjectid")
    @JSONField(name = "subjectid")
    @JsonProperty("subjectid")
    private String subjectid;
    /**
     * LanguageLocaleId
     */
    @TableField(value = "languagelocaleid")
    @JSONField(name = "languagelocaleid")
    @JsonProperty("languagelocaleid")
    private String languagelocaleid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.KnowledgeArticle parentarticlecontent;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.KnowledgeArticle previousarticlecontent;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.KnowledgeArticle rootarticle;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.LanguageLocale languagelocale;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Subject subject;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [KnowledgeArticleViews_Date]
     */
    public void setKnowledgearticleviewsDate(Timestamp knowledgearticleviewsDate){
        this.knowledgearticleviewsDate = knowledgearticleviewsDate ;
        this.modify("knowledgearticleviews_date",knowledgearticleviewsDate);
    }
    /**
     * 设置 [Keywords]
     */
    public void setKeywords(String keywords){
        this.keywords = keywords ;
        this.modify("keywords",keywords);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [Primary]
     */
    public void setPrimary(Integer primary){
        this.primary = primary ;
        this.modify("primary",primary);
    }
    /**
     * 设置 [ExpirationStateId]
     */
    public void setExpirationstateid(Integer expirationstateid){
        this.expirationstateid = expirationstateid ;
        this.modify("expirationstateid",expirationstateid);
    }
    /**
     * 设置 [Rating_Count]
     */
    public void setRatingCount(Integer ratingCount){
        this.ratingCount = ratingCount ;
        this.modify("rating_count",ratingCount);
    }
    /**
     * 设置 [Content]
     */
    public void setContent(String content){
        this.content = content ;
        this.modify("content",content);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [RootArticle]
     */
    public void setRootarticled(Integer rootarticled){
        this.rootarticled = rootarticled ;
        this.modify("rootarticle",rootarticled);
    }
    /**
     * 设置 [KnowledgeArticleViews_State]
     */
    public void setKnowledgearticleviewsState(Integer knowledgearticleviewsState){
        this.knowledgearticleviewsState = knowledgearticleviewsState ;
        this.modify("knowledgearticleviews_state",knowledgearticleviewsState);
    }
    /**
     * 设置 [Rating_Sum]
     */
    public void setRatingSum(BigDecimal ratingSum){
        this.ratingSum = ratingSum ;
        this.modify("rating_sum",ratingSum);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [traversedpath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [PublishStatusId]
     */
    public void setPublishstatusid(Integer publishstatusid){
        this.publishstatusid = publishstatusid ;
        this.modify("publishstatusid",publishstatusid);
    }
    /**
     * 设置 [ArticlePublicNumber]
     */
    public void setArticlepublicnumber(String articlepublicnumber){
        this.articlepublicnumber = articlepublicnumber ;
        this.modify("articlepublicnumber",articlepublicnumber);
    }
    /**
     * 设置 [primaryauthoridName]
     */
    public void setPrimaryauthoridname(String primaryauthoridname){
        this.primaryauthoridname = primaryauthoridname ;
        this.modify("primaryauthoridname",primaryauthoridname);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [primaryauthorid]
     */
    public void setPrimaryauthorid(String primaryauthorid){
        this.primaryauthorid = primaryauthorid ;
        this.modify("primaryauthorid",primaryauthorid);
    }
    /**
     * 设置 [LatestVersion]
     */
    public void setLatestversion(Integer latestversion){
        this.latestversion = latestversion ;
        this.modify("latestversion",latestversion);
    }
    /**
     * 设置 [Rating_State]
     */
    public void setRatingState(Integer ratingState){
        this.ratingState = ratingState ;
        this.modify("rating_state",ratingState);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [ExpirationStatusId]
     */
    public void setExpirationstatusid(Integer expirationstatusid){
        this.expirationstatusid = expirationstatusid ;
        this.modify("expirationstatusid",expirationstatusid);
    }
    /**
     * 设置 [SetCategoryAssociations]
     */
    public void setSetcategoryassociations(Integer setcategoryassociations){
        this.setcategoryassociations = setcategoryassociations ;
        this.modify("setcategoryassociations",setcategoryassociations);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [SetProductAssociations]
     */
    public void setSetproductassociations(Integer setproductassociations){
        this.setproductassociations = setproductassociations ;
        this.modify("setproductassociations",setproductassociations);
    }
    /**
     * 设置 [MinorVersionNumber]
     */
    public void setMinorversionnumber(Integer minorversionnumber){
        this.minorversionnumber = minorversionnumber ;
        this.modify("minorversionnumber",minorversionnumber);
    }
    /**
     * 设置 [stageid]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [processid]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [MajorVersionNumber]
     */
    public void setMajorversionnumber(Integer majorversionnumber){
        this.majorversionnumber = majorversionnumber ;
        this.modify("majorversionnumber",majorversionnumber);
    }
    /**
     * 设置 [Rating]
     */
    public void setRating(BigDecimal rating){
        this.rating = rating ;
        this.modify("rating",rating);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [PublishOn]
     */
    public void setPublishon(Timestamp publishon){
        this.publishon = publishon ;
        this.modify("publishon",publishon);
    }
    /**
     * 设置 [KnowledgeArticleViews]
     */
    public void setKnowledgearticleviews(Integer knowledgearticleviews){
        this.knowledgearticleviews = knowledgearticleviews ;
        this.modify("knowledgearticleviews",knowledgearticleviews);
    }
    /**
     * 设置 [Rating_Date]
     */
    public void setRatingDate(Timestamp ratingDate){
        this.ratingDate = ratingDate ;
        this.modify("rating_date",ratingDate);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [ReadyForReview]
     */
    public void setReadyforreview(Integer readyforreview){
        this.readyforreview = readyforreview ;
        this.modify("readyforreview",readyforreview);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [SubjectIdDsc]
     */
    public void setSubjectiddsc(Integer subjectiddsc){
        this.subjectiddsc = subjectiddsc ;
        this.modify("subjectiddsc",subjectiddsc);
    }
    /**
     * 设置 [Review]
     */
    public void setReview(String review){
        this.review = review ;
        this.modify("review",review);
    }
    /**
     * 设置 [LanguageLocaleIdLocaleId]
     */
    public void setLanguagelocaleidlocaleid(Integer languagelocaleidlocaleid){
        this.languagelocaleidlocaleid = languagelocaleidlocaleid ;
        this.modify("languagelocaleidlocaleid",languagelocaleidlocaleid);
    }
    /**
     * 设置 [ScheduledStatusId]
     */
    public void setScheduledstatusid(Integer scheduledstatusid){
        this.scheduledstatusid = scheduledstatusid ;
        this.modify("scheduledstatusid",scheduledstatusid);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [Internal]
     */
    public void setInternal(Integer internal){
        this.internal = internal ;
        this.modify("internal",internal);
    }
    /**
     * 设置 [Title]
     */
    public void setTitle(String title){
        this.title = title ;
        this.modify("title",title);
    }
    /**
     * 设置 [UpdateContent]
     */
    public void setUpdatecontent(Integer updatecontent){
        this.updatecontent = updatecontent ;
        this.modify("updatecontent",updatecontent);
    }
    /**
     * 设置 [ExpirationDate]
     */
    public void setExpirationdate(Timestamp expirationdate){
        this.expirationdate = expirationdate ;
        this.modify("expirationdate",expirationdate);
    }
    /**
     * 设置 [ExpiredReviewOptions]
     */
    public void setExpiredreviewoptions(String expiredreviewoptions){
        this.expiredreviewoptions = expiredreviewoptions ;
        this.modify("expiredreviewoptions",expiredreviewoptions);
    }
    /**
     * 设置 [ParentArticleContentId]
     */
    public void setParentarticlecontentid(String parentarticlecontentid){
        this.parentarticlecontentid = parentarticlecontentid ;
        this.modify("parentarticlecontentid",parentarticlecontentid);
    }
    /**
     * 设置 [PreviousArticleContentId]
     */
    public void setPreviousarticlecontentid(String previousarticlecontentid){
        this.previousarticlecontentid = previousarticlecontentid ;
        this.modify("previousarticlecontentid",previousarticlecontentid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }
    /**
     * 设置 [RootArticleId]
     */
    public void setRootarticleid(String rootarticleid){
        this.rootarticleid = rootarticleid ;
        this.modify("rootarticleid",rootarticleid);
    }
    /**
     * 设置 [SubjectId]
     */
    public void setSubjectid(String subjectid){
        this.subjectid = subjectid ;
        this.modify("subjectid",subjectid);
    }
    /**
     * 设置 [LanguageLocaleId]
     */
    public void setLanguagelocaleid(String languagelocaleid){
        this.languagelocaleid = languagelocaleid ;
        this.modify("languagelocaleid",languagelocaleid);
    }

}


