package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[组织]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "ORGANIZATION",resultMap = "OrganizationResultMap")
public class Organization extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * EnableLivePersonaCardUCI
     */
    @DEField(defaultValue = "False")
    @TableField(value = "enablelivepersonacarduci")
    @JSONField(name = "enablelivepersonacarduci")
    @JsonProperty("enablelivepersonacarduci")
    private Integer enablelivepersonacarduci;
    /**
     * AutoDataCaptureEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "autodatacaptureenabled")
    @JSONField(name = "autodatacaptureenabled")
    @JsonProperty("autodatacaptureenabled")
    private Integer autodatacaptureenabled;
    /**
     * AllowClientMessageBarAd
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowclientmessagebarad")
    @JSONField(name = "allowclientmessagebarad")
    @JsonProperty("allowclientmessagebarad")
    private Integer allowclientmessagebarad;
    /**
     * YammerGroupId
     */
    @TableField(value = "yammergroupid")
    @JSONField(name = "yammergroupid")
    @JsonProperty("yammergroupid")
    private Integer yammergroupid;
    /**
     * GoalRollupFrequency
     */
    @TableField(value = "goalrollupfrequency")
    @JSONField(name = "goalrollupfrequency")
    @JsonProperty("goalrollupfrequency")
    private Integer goalrollupfrequency;
    /**
     * YearStartWeekCode
     */
    @TableField(value = "yearstartweekcode")
    @JSONField(name = "yearstartweekcode")
    @JsonProperty("yearstartweekcode")
    private Integer yearstartweekcode;
    /**
     * OOBPriceCalculationEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "oobpricecalculationenabled")
    @JSONField(name = "oobpricecalculationenabled")
    @JsonProperty("oobpricecalculationenabled")
    private Integer oobpricecalculationenabled;
    /**
     * AppDesignerExperienceEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "appdesignerexperienceenabled")
    @JSONField(name = "appdesignerexperienceenabled")
    @JsonProperty("appdesignerexperienceenabled")
    private Integer appdesignerexperienceenabled;
    /**
     * UseLegacyRendering
     */
    @DEField(defaultValue = "False")
    @TableField(value = "uselegacyrendering")
    @JSONField(name = "uselegacyrendering")
    @JsonProperty("uselegacyrendering")
    private Integer uselegacyrendering;
    /**
     * WebResourceHash
     */
    @TableField(value = "webresourcehash")
    @JSONField(name = "webresourcehash")
    @JsonProperty("webresourcehash")
    private String webresourcehash;
    /**
     * UseSkypeProtocol
     */
    @DEField(defaultValue = "True")
    @TableField(value = "useskypeprotocol")
    @JSONField(name = "useskypeprotocol")
    @JsonProperty("useskypeprotocol")
    private Integer useskypeprotocol;
    /**
     * NotesAnalysisEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "notesanalysisenabled")
    @JSONField(name = "notesanalysisenabled")
    @JsonProperty("notesanalysisenabled")
    private Integer notesanalysisenabled;
    /**
     * BaseISOCurrencyCode
     */
    @TableField(value = "baseisocurrencycode")
    @JSONField(name = "baseisocurrencycode")
    @JsonProperty("baseisocurrencycode")
    private String baseisocurrencycode;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * LocaleId
     */
    @TableField(value = "localeid")
    @JSONField(name = "localeid")
    @JsonProperty("localeid")
    private Integer localeid;
    /**
     * ExternalPartyEntitySettings
     */
    @TableField(value = "externalpartyentitysettings")
    @JSONField(name = "externalpartyentitysettings")
    @JsonProperty("externalpartyentitysettings")
    private String externalpartyentitysettings;
    /**
     * EnableMicrosoftFlowIntegration
     */
    @DEField(defaultValue = "False")
    @TableField(value = "enablemicrosoftflowintegration")
    @JSONField(name = "enablemicrosoftflowintegration")
    @JsonProperty("enablemicrosoftflowintegration")
    private Integer enablemicrosoftflowintegration;
    /**
     * Disabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "disabled")
    @JSONField(name = "disabled")
    @JsonProperty("disabled")
    private Integer disabled;
    /**
     * MinOfflineSyncInterval
     */
    @TableField(value = "minofflinesyncinterval")
    @JSONField(name = "minofflinesyncinterval")
    @JsonProperty("minofflinesyncinterval")
    private Integer minofflinesyncinterval;
    /**
     * AllowEntityOnlyAudit
     */
    @DEField(defaultValue = "True")
    @TableField(value = "allowentityonlyaudit")
    @JSONField(name = "allowentityonlyaudit")
    @JsonProperty("allowentityonlyaudit")
    private Integer allowentityonlyaudit;
    /**
     * AllowAddressBookSyncs
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowaddressbooksyncs")
    @JSONField(name = "allowaddressbooksyncs")
    @JsonProperty("allowaddressbooksyncs")
    private Integer allowaddressbooksyncs;
    /**
     * FiscalYearFormatSuffix
     */
    @TableField(value = "fiscalyearformatsuffix")
    @JSONField(name = "fiscalyearformatsuffix")
    @JsonProperty("fiscalyearformatsuffix")
    private String fiscalyearformatsuffix;
    /**
     * TaskBasedFlowEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "taskbasedflowenabled")
    @JSONField(name = "taskbasedflowenabled")
    @JsonProperty("taskbasedflowenabled")
    private Integer taskbasedflowenabled;
    /**
     * MobileOfflineMinLicenseProd
     */
    @TableField(value = "mobileofflineminlicenseprod")
    @JSONField(name = "mobileofflineminlicenseprod")
    @JsonProperty("mobileofflineminlicenseprod")
    private Integer mobileofflineminlicenseprod;
    /**
     * NextTrackingNumber
     */
    @TableField(value = "nexttrackingnumber")
    @JSONField(name = "nexttrackingnumber")
    @JsonProperty("nexttrackingnumber")
    private Integer nexttrackingnumber;
    /**
     * ReportingGroupId
     */
    @TableField(value = "reportinggroupid")
    @JSONField(name = "reportinggroupid")
    @JsonProperty("reportinggroupid")
    private String reportinggroupid;
    /**
     * NextCustomObjectTypeCode
     */
    @TableField(value = "nextcustomobjecttypecode")
    @JSONField(name = "nextcustomobjecttypecode")
    @JsonProperty("nextcustomobjecttypecode")
    private Integer nextcustomobjecttypecode;
    /**
     * CurrentCategoryNumber
     */
    @TableField(value = "currentcategorynumber")
    @JSONField(name = "currentcategorynumber")
    @JsonProperty("currentcategorynumber")
    private Integer currentcategorynumber;
    /**
     * SupportUserId
     */
    @TableField(value = "supportuserid")
    @JSONField(name = "supportuserid")
    @JsonProperty("supportuserid")
    private String supportuserid;
    /**
     * AllowLegacyDialogsEmbedding
     */
    @DEField(defaultValue = "True")
    @TableField(value = "allowlegacydialogsembedding")
    @JSONField(name = "allowlegacydialogsembedding")
    @JsonProperty("allowlegacydialogsembedding")
    private Integer allowlegacydialogsembedding;
    /**
     * ExternalBaseUrl
     */
    @TableField(value = "externalbaseurl")
    @JSONField(name = "externalbaseurl")
    @JsonProperty("externalbaseurl")
    private String externalbaseurl;
    /**
     * ActionSupportFeatureEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "actionsupportfeatureenabled")
    @JSONField(name = "actionsupportfeatureenabled")
    @JsonProperty("actionsupportfeatureenabled")
    private Integer actionsupportfeatureenabled;
    /**
     * GenerateAlertsForErrors
     */
    @DEField(defaultValue = "True")
    @TableField(value = "generatealertsforerrors")
    @JSONField(name = "generatealertsforerrors")
    @JsonProperty("generatealertsforerrors")
    private Integer generatealertsforerrors;
    /**
     * RenderSecureIFrameForEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "rendersecureiframeforemail")
    @JSONField(name = "rendersecureiframeforemail")
    @JsonProperty("rendersecureiframeforemail")
    private Integer rendersecureiframeforemail;
    /**
     * TokenExpiry
     */
    @TableField(value = "tokenexpiry")
    @JSONField(name = "tokenexpiry")
    @JsonProperty("tokenexpiry")
    private Integer tokenexpiry;
    /**
     * PricingDecimalPrecision
     */
    @TableField(value = "pricingdecimalprecision")
    @JSONField(name = "pricingdecimalprecision")
    @JsonProperty("pricingdecimalprecision")
    private Integer pricingdecimalprecision;
    /**
     * ManualSalesForecastingEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "manualsalesforecastingenabled")
    @JSONField(name = "manualsalesforecastingenabled")
    @JsonProperty("manualsalesforecastingenabled")
    private Integer manualsalesforecastingenabled;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * EnableLPAuthoring
     */
    @DEField(defaultValue = "False")
    @TableField(value = "enablelpauthoring")
    @JSONField(name = "enablelpauthoring")
    @JsonProperty("enablelpauthoring")
    private Integer enablelpauthoring;
    /**
     * UserGroupId
     */
    @TableField(value = "usergroupid")
    @JSONField(name = "usergroupid")
    @JsonProperty("usergroupid")
    private String usergroupid;
    /**
     * PowerBiFeatureEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "powerbifeatureenabled")
    @JSONField(name = "powerbifeatureenabled")
    @JsonProperty("powerbifeatureenabled")
    private Integer powerbifeatureenabled;
    /**
     * MailboxPermanentIssueMinRange
     */
    @TableField(value = "mailboxpermanentissueminrange")
    @JSONField(name = "mailboxpermanentissueminrange")
    @JsonProperty("mailboxpermanentissueminrange")
    private Integer mailboxpermanentissueminrange;
    /**
     * SocialInsightsTermsAccepted
     */
    @DEField(defaultValue = "False")
    @TableField(value = "socialinsightstermsaccepted")
    @JSONField(name = "socialinsightstermsaccepted")
    @JsonProperty("socialinsightstermsaccepted")
    private Integer socialinsightstermsaccepted;
    /**
     * ReadAuditEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "readauditenabled")
    @JSONField(name = "readauditenabled")
    @JsonProperty("readauditenabled")
    private Integer readauditenabled;
    /**
     * MaxRecordsForLookupFilters
     */
    @TableField(value = "maxrecordsforlookupfilters")
    @JSONField(name = "maxrecordsforlookupfilters")
    @JsonProperty("maxrecordsforlookupfilters")
    private Integer maxrecordsforlookupfilters;
    /**
     * MaxFolderBasedTrackingMappings
     */
    @TableField(value = "maxfolderbasedtrackingmappings")
    @JSONField(name = "maxfolderbasedtrackingmappings")
    @JsonProperty("maxfolderbasedtrackingmappings")
    private Integer maxfolderbasedtrackingmappings;
    /**
     * BaseCurrencySymbol
     */
    @TableField(value = "basecurrencysymbol")
    @JSONField(name = "basecurrencysymbol")
    @JsonProperty("basecurrencysymbol")
    private String basecurrencysymbol;
    /**
     * MobileOfflineEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "mobileofflineenabled")
    @JSONField(name = "mobileofflineenabled")
    @JsonProperty("mobileofflineenabled")
    private Integer mobileofflineenabled;
    /**
     * DefaultEmailSettings
     */
    @TableField(value = "defaultemailsettings")
    @JSONField(name = "defaultemailsettings")
    @JsonProperty("defaultemailsettings")
    private String defaultemailsettings;
    /**
     * RequireApprovalForUserEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "requireapprovalforuseremail")
    @JSONField(name = "requireapprovalforuseremail")
    @JsonProperty("requireapprovalforuseremail")
    private Integer requireapprovalforuseremail;
    /**
     * MobileOfflineMinLicenseTrial
     */
    @TableField(value = "mobileofflineminlicensetrial")
    @JSONField(name = "mobileofflineminlicensetrial")
    @JsonProperty("mobileofflineminlicensetrial")
    private Integer mobileofflineminlicensetrial;
    /**
     * PrivacyStatementUrl
     */
    @TableField(value = "privacystatementurl")
    @JSONField(name = "privacystatementurl")
    @JsonProperty("privacystatementurl")
    private String privacystatementurl;
    /**
     * HashMinAddressCount
     */
    @TableField(value = "hashminaddresscount")
    @JSONField(name = "hashminaddresscount")
    @JsonProperty("hashminaddresscount")
    private Integer hashminaddresscount;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * CalendarType
     */
    @TableField(value = "calendartype")
    @JSONField(name = "calendartype")
    @JsonProperty("calendartype")
    private Integer calendartype;
    /**
     * ShareToPreviousOwnerOnAssign
     */
    @DEField(defaultValue = "False")
    @TableField(value = "sharetopreviousowneronassign")
    @JSONField(name = "sharetopreviousowneronassign")
    @JsonProperty("sharetopreviousowneronassign")
    private Integer sharetopreviousowneronassign;
    /**
     * CurrentBulkOperationNumber
     */
    @TableField(value = "currentbulkoperationnumber")
    @JSONField(name = "currentbulkoperationnumber")
    @JsonProperty("currentbulkoperationnumber")
    private Integer currentbulkoperationnumber;
    /**
     * RiErrorStatus
     */
    @TableField(value = "rierrorstatus")
    @JSONField(name = "rierrorstatus")
    @JsonProperty("rierrorstatus")
    private Integer rierrorstatus;
    /**
     * EmailConnectionChannel
     */
    @TableField(value = "emailconnectionchannel")
    @JSONField(name = "emailconnectionchannel")
    @JsonProperty("emailconnectionchannel")
    private String emailconnectionchannel;
    /**
     * AllowAutoResponseCreation
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowautoresponsecreation")
    @JSONField(name = "allowautoresponsecreation")
    @JsonProperty("allowautoresponsecreation")
    private Integer allowautoresponsecreation;
    /**
     * AssignedTasksSyncEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "assignedtaskssyncenabled")
    @JSONField(name = "assignedtaskssyncenabled")
    @JsonProperty("assignedtaskssyncenabled")
    private Integer assignedtaskssyncenabled;
    /**
     * UniqueSpecifierLength
     */
    @TableField(value = "uniquespecifierlength")
    @JSONField(name = "uniquespecifierlength")
    @JsonProperty("uniquespecifierlength")
    private Integer uniquespecifierlength;
    /**
     * PostMessageWhitelistDomains
     */
    @TableField(value = "postmessagewhitelistdomains")
    @JSONField(name = "postmessagewhitelistdomains")
    @JsonProperty("postmessagewhitelistdomains")
    private String postmessagewhitelistdomains;
    /**
     * AutoSaveEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "autosaveenabled")
    @JSONField(name = "autosaveenabled")
    @JsonProperty("autosaveenabled")
    private Integer autosaveenabled;
    /**
     * CurrencySymbol
     */
    @TableField(value = "currencysymbol")
    @JSONField(name = "currencysymbol")
    @JsonProperty("currencysymbol")
    private String currencysymbol;
    /**
     * SOPIntegrationEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "sopintegrationenabled")
    @JSONField(name = "sopintegrationenabled")
    @JsonProperty("sopintegrationenabled")
    private Integer sopintegrationenabled;
    /**
     * FiscalPeriodMonthBased
     */
    @DEField(defaultValue = "False")
    @TableField(value = "fiscalperiodmonthbased")
    @JSONField(name = "fiscalperiodmonthbased")
    @JsonProperty("fiscalperiodmonthbased")
    private Integer fiscalperiodmonthbased;
    /**
     * AppMode
     */
    @DEField(defaultValue = "False")
    @TableField(value = "appmode")
    @JSONField(name = "appmode")
    @JsonProperty("appmode")
    private Integer appmode;
    /**
     * FullNameConventionCode
     */
    @TableField(value = "fullnameconventioncode")
    @JSONField(name = "fullnameconventioncode")
    @JsonProperty("fullnameconventioncode")
    private String fullnameconventioncode;
    /**
     * CurrentQuoteNumber
     */
    @TableField(value = "currentquotenumber")
    @JSONField(name = "currentquotenumber")
    @JsonProperty("currentquotenumber")
    private Integer currentquotenumber;
    /**
     * EmailSendPollingPeriod
     */
    @TableField(value = "emailsendpollingperiod")
    @JSONField(name = "emailsendpollingperiod")
    @JsonProperty("emailsendpollingperiod")
    private Integer emailsendpollingperiod;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * MSTeamsUserSyncEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "msteamsusersyncenabled")
    @JSONField(name = "msteamsusersyncenabled")
    @JsonProperty("msteamsusersyncenabled")
    private Integer msteamsusersyncenabled;
    /**
     * MaxAppointmentDurationDays
     */
    @TableField(value = "maxappointmentdurationdays")
    @JSONField(name = "maxappointmentdurationdays")
    @JsonProperty("maxappointmentdurationdays")
    private Integer maxappointmentdurationdays;
    /**
     * DiscountCalculationMethod
     */
    @TableField(value = "discountcalculationmethod")
    @JSONField(name = "discountcalculationmethod")
    @JsonProperty("discountcalculationmethod")
    private String discountcalculationmethod;
    /**
     * GenerateAlertsForInformation
     */
    @DEField(defaultValue = "True")
    @TableField(value = "generatealertsforinformation")
    @JSONField(name = "generatealertsforinformation")
    @JsonProperty("generatealertsforinformation")
    private Integer generatealertsforinformation;
    /**
     * DelegateAccessEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "delegateaccessenabled")
    @JSONField(name = "delegateaccessenabled")
    @JsonProperty("delegateaccessenabled")
    private Integer delegateaccessenabled;
    /**
     * TextAnalyticsEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "textanalyticsenabled")
    @JSONField(name = "textanalyticsenabled")
    @JsonProperty("textanalyticsenabled")
    private Integer textanalyticsenabled;
    /**
     * HashDeltaSubjectCount
     */
    @TableField(value = "hashdeltasubjectcount")
    @JSONField(name = "hashdeltasubjectcount")
    @JsonProperty("hashdeltasubjectcount")
    private Integer hashdeltasubjectcount;
    /**
     * ExpireSubscriptionsInDays
     */
    @TableField(value = "expiresubscriptionsindays")
    @JSONField(name = "expiresubscriptionsindays")
    @JsonProperty("expiresubscriptionsindays")
    private Integer expiresubscriptionsindays;
    /**
     * KMSettings
     */
    @TableField(value = "kmsettings")
    @JSONField(name = "kmsettings")
    @JsonProperty("kmsettings")
    private String kmsettings;
    /**
     * PastExpansionWindow
     */
    @TableField(value = "pastexpansionwindow")
    @JSONField(name = "pastexpansionwindow")
    @JsonProperty("pastexpansionwindow")
    private Integer pastexpansionwindow;
    /**
     * YammerOAuthAccessTokenExpired
     */
    @DEField(defaultValue = "False")
    @TableField(value = "yammeroauthaccesstokenexpired")
    @JSONField(name = "yammeroauthaccesstokenexpired")
    @JsonProperty("yammeroauthaccesstokenexpired")
    private Integer yammeroauthaccesstokenexpired;
    /**
     * OfficeGraphDelveUrl
     */
    @TableField(value = "officegraphdelveurl")
    @JSONField(name = "officegraphdelveurl")
    @JsonProperty("officegraphdelveurl")
    private String officegraphdelveurl;
    /**
     * HighContrastThemeData
     */
    @TableField(value = "highcontrastthemedata")
    @JSONField(name = "highcontrastthemedata")
    @JsonProperty("highcontrastthemedata")
    private String highcontrastthemedata;
    /**
     * DefaultEmailServerProfileId
     */
    @TableField(value = "defaultemailserverprofileid")
    @JSONField(name = "defaultemailserverprofileid")
    @JsonProperty("defaultemailserverprofileid")
    private String defaultemailserverprofileid;
    /**
     * TimeFormatCode
     */
    @TableField(value = "timeformatcode")
    @JSONField(name = "timeformatcode")
    @JsonProperty("timeformatcode")
    private String timeformatcode;
    /**
     * DecimalSymbol
     */
    @TableField(value = "decimalsymbol")
    @JSONField(name = "decimalsymbol")
    @JsonProperty("decimalsymbol")
    private String decimalsymbol;
    /**
     * MaxRecordsForExportToExcel
     */
    @TableField(value = "maxrecordsforexporttoexcel")
    @JSONField(name = "maxrecordsforexporttoexcel")
    @JsonProperty("maxrecordsforexporttoexcel")
    private Integer maxrecordsforexporttoexcel;
    /**
     * MaxVerboseLoggingSyncCycles
     */
    @TableField(value = "maxverboseloggingsynccycles")
    @JSONField(name = "maxverboseloggingsynccycles")
    @JsonProperty("maxverboseloggingsynccycles")
    private Integer maxverboseloggingsynccycles;
    /**
     * SchemaNamePrefix
     */
    @TableField(value = "schemanameprefix")
    @JSONField(name = "schemanameprefix")
    @JsonProperty("schemanameprefix")
    private String schemanameprefix;
    /**
     * RequireApprovalForQueueEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "requireapprovalforqueueemail")
    @JSONField(name = "requireapprovalforqueueemail")
    @JsonProperty("requireapprovalforqueueemail")
    private Integer requireapprovalforqueueemail;
    /**
     * ACIWebEndpointUrl
     */
    @TableField(value = "aciwebendpointurl")
    @JSONField(name = "aciwebendpointurl")
    @JsonProperty("aciwebendpointurl")
    private String aciwebendpointurl;
    /**
     * CurrentCampaignNumber
     */
    @TableField(value = "currentcampaignnumber")
    @JSONField(name = "currentcampaignnumber")
    @JsonProperty("currentcampaignnumber")
    private Integer currentcampaignnumber;
    /**
     * CurrentKbNumber
     */
    @TableField(value = "currentkbnumber")
    @JSONField(name = "currentkbnumber")
    @JsonProperty("currentkbnumber")
    private Integer currentkbnumber;
    /**
     * InactivityTimeoutEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "inactivitytimeoutenabled")
    @JSONField(name = "inactivitytimeoutenabled")
    @JsonProperty("inactivitytimeoutenabled")
    private Integer inactivitytimeoutenabled;
    /**
     * YammerNetworkPermalink
     */
    @TableField(value = "yammernetworkpermalink")
    @JSONField(name = "yammernetworkpermalink")
    @JsonProperty("yammernetworkpermalink")
    private String yammernetworkpermalink;
    /**
     * FiscalPeriodType
     */
    @TableField(value = "fiscalperiodtype")
    @JSONField(name = "fiscalperiodtype")
    @JsonProperty("fiscalperiodtype")
    private Integer fiscalperiodtype;
    /**
     * CurrentOrderNumber
     */
    @TableField(value = "currentordernumber")
    @JSONField(name = "currentordernumber")
    @JsonProperty("currentordernumber")
    private Integer currentordernumber;
    /**
     * CurrentCaseNumber
     */
    @TableField(value = "currentcasenumber")
    @JSONField(name = "currentcasenumber")
    @JsonProperty("currentcasenumber")
    private Integer currentcasenumber;
    /**
     * ExternalPartyCorrelationKeys
     */
    @TableField(value = "externalpartycorrelationkeys")
    @JSONField(name = "externalpartycorrelationkeys")
    @JsonProperty("externalpartycorrelationkeys")
    private String externalpartycorrelationkeys;
    /**
     * SignupOutlookDownloadFWLink
     */
    @TableField(value = "signupoutlookdownloadfwlink")
    @JSONField(name = "signupoutlookdownloadfwlink")
    @JsonProperty("signupoutlookdownloadfwlink")
    private String signupoutlookdownloadfwlink;
    /**
     * FiscalPeriodFormat
     */
    @TableField(value = "fiscalperiodformat")
    @JSONField(name = "fiscalperiodformat")
    @JsonProperty("fiscalperiodformat")
    private String fiscalperiodformat;
    /**
     * AllowMarketingEmailExecution
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowmarketingemailexecution")
    @JSONField(name = "allowmarketingemailexecution")
    @JsonProperty("allowmarketingemailexecution")
    private Integer allowmarketingemailexecution;
    /**
     * PrivReportingGroupName
     */
    @TableField(value = "privreportinggroupname")
    @JSONField(name = "privreportinggroupname")
    @JsonProperty("privreportinggroupname")
    private String privreportinggroupname;
    /**
     * FolderAutoCreatedonSP
     */
    @DEField(defaultValue = "False")
    @TableField(value = "folderautocreatedonsp")
    @JSONField(name = "folderautocreatedonsp")
    @JsonProperty("folderautocreatedonsp")
    private Integer folderautocreatedonsp;
    /**
     * UserAccessAuditEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "useraccessauditenabled")
    @JSONField(name = "useraccessauditenabled")
    @JsonProperty("useraccessauditenabled")
    private Integer useraccessauditenabled;
    /**
     * SqlAccessGroupId
     */
    @TableField(value = "sqlaccessgroupid")
    @JSONField(name = "sqlaccessgroupid")
    @JsonProperty("sqlaccessgroupid")
    private String sqlaccessgroupid;
    /**
     * TrackingTokenIdBase
     */
    @TableField(value = "trackingtokenidbase")
    @JSONField(name = "trackingtokenidbase")
    @JsonProperty("trackingtokenidbase")
    private Integer trackingtokenidbase;
    /**
     * ContractPrefix
     */
    @TableField(value = "contractprefix")
    @JSONField(name = "contractprefix")
    @JsonProperty("contractprefix")
    private String contractprefix;
    /**
     * MaxActionStepsInBPF
     */
    @TableField(value = "maxactionstepsinbpf")
    @JSONField(name = "maxactionstepsinbpf")
    @JsonProperty("maxactionstepsinbpf")
    private Integer maxactionstepsinbpf;
    /**
     * ActivityAnalysisEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "activityanalysisenabled")
    @JSONField(name = "activityanalysisenabled")
    @JsonProperty("activityanalysisenabled")
    private Integer activityanalysisenabled;
    /**
     * CategoryPrefix
     */
    @TableField(value = "categoryprefix")
    @JSONField(name = "categoryprefix")
    @JsonProperty("categoryprefix")
    private String categoryprefix;
    /**
     * SlaPauseStates
     */
    @TableField(value = "slapausestates")
    @JSONField(name = "slapausestates")
    @JsonProperty("slapausestates")
    private String slapausestates;
    /**
     * OrgDbOrgSettings
     */
    @TableField(value = "orgdborgsettings")
    @JSONField(name = "orgdborgsettings")
    @JsonProperty("orgdborgsettings")
    private String orgdborgsettings;
    /**
     * ExternalSearchIndexEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "externalsearchindexenabled")
    @JSONField(name = "externalsearchindexenabled")
    @JsonProperty("externalsearchindexenabled")
    private Integer externalsearchindexenabled;
    /**
     * OrganizationState
     */
    @TableField(value = "organizationstate")
    @JSONField(name = "organizationstate")
    @JsonProperty("organizationstate")
    private String organizationstate;
    /**
     * BlockedAttachments
     */
    @TableField(value = "blockedattachments")
    @JSONField(name = "blockedattachments")
    @JsonProperty("blockedattachments")
    private String blockedattachments;
    /**
     * ParsedTablePrefix
     */
    @TableField(value = "parsedtableprefix")
    @JSONField(name = "parsedtableprefix")
    @JsonProperty("parsedtableprefix")
    private String parsedtableprefix;
    /**
     * LanguageCode
     */
    @TableField(value = "languagecode")
    @JSONField(name = "languagecode")
    @JsonProperty("languagecode")
    private Integer languagecode;
    /**
     * TimeSeparator
     */
    @TableField(value = "timeseparator")
    @JSONField(name = "timeseparator")
    @JsonProperty("timeseparator")
    private String timeseparator;
    /**
     * MinOutlookSyncInterval
     */
    @TableField(value = "minoutlooksyncinterval")
    @JSONField(name = "minoutlooksyncinterval")
    @JsonProperty("minoutlooksyncinterval")
    private Integer minoutlooksyncinterval;
    /**
     * SQMEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "sqmenabled")
    @JSONField(name = "sqmenabled")
    @JsonProperty("sqmenabled")
    private Integer sqmenabled;
    /**
     * MicrosoftFlowEnvironment
     */
    @TableField(value = "microsoftflowenvironment")
    @JSONField(name = "microsoftflowenvironment")
    @JsonProperty("microsoftflowenvironment")
    private String microsoftflowenvironment;
    /**
     * SharePointDeploymentType
     */
    @TableField(value = "sharepointdeploymenttype")
    @JSONField(name = "sharepointdeploymenttype")
    @JsonProperty("sharepointdeploymenttype")
    private String sharepointdeploymenttype;
    /**
     * AutoApplyDefaultonCaseUpdate
     */
    @DEField(defaultValue = "False")
    @TableField(value = "autoapplydefaultoncaseupdate")
    @JSONField(name = "autoapplydefaultoncaseupdate")
    @JsonProperty("autoapplydefaultoncaseupdate")
    private Integer autoapplydefaultoncaseupdate;
    /**
     * PresenceEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "presenceenabled")
    @JSONField(name = "presenceenabled")
    @JsonProperty("presenceenabled")
    private Integer presenceenabled;
    /**
     * OrgInsightsEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "orginsightsenabled")
    @JSONField(name = "orginsightsenabled")
    @JsonProperty("orginsightsenabled")
    private Integer orginsightsenabled;
    /**
     * SystemUserId
     */
    @TableField(value = "systemuserid")
    @JSONField(name = "systemuserid")
    @JsonProperty("systemuserid")
    private String systemuserid;
    /**
     * MetadataSyncTimestamp
     */
    @TableField(value = "metadatasynctimestamp")
    @JSONField(name = "metadatasynctimestamp")
    @JsonProperty("metadatasynctimestamp")
    private BigInteger metadatasynctimestamp;
    /**
     * ReportingGroupName
     */
    @TableField(value = "reportinggroupname")
    @JSONField(name = "reportinggroupname")
    @JsonProperty("reportinggroupname")
    private String reportinggroupname;
    /**
     * GlobalHelpUrlEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "globalhelpurlenabled")
    @JSONField(name = "globalhelpurlenabled")
    @JsonProperty("globalhelpurlenabled")
    private Integer globalhelpurlenabled;
    /**
     * ClientFeatureSet
     */
    @TableField(value = "clientfeatureset")
    @JSONField(name = "clientfeatureset")
    @JsonProperty("clientfeatureset")
    private String clientfeatureset;
    /**
     * DelegatedAdminUserId
     */
    @TableField(value = "delegatedadminuserid")
    @JSONField(name = "delegatedadminuserid")
    @JsonProperty("delegatedadminuserid")
    private String delegatedadminuserid;
    /**
     * PluginTraceLogSetting
     */
    @TableField(value = "plugintracelogsetting")
    @JSONField(name = "plugintracelogsetting")
    @JsonProperty("plugintracelogsetting")
    private String plugintracelogsetting;
    /**
     * GoalRollupExpiryTime
     */
    @TableField(value = "goalrollupexpirytime")
    @JSONField(name = "goalrollupexpirytime")
    @JsonProperty("goalrollupexpirytime")
    private Integer goalrollupexpirytime;
    /**
     * DisplayNavigationTour
     */
    @DEField(defaultValue = "True")
    @TableField(value = "displaynavigationtour")
    @JSONField(name = "displaynavigationtour")
    @JsonProperty("displaynavigationtour")
    private Integer displaynavigationtour;
    /**
     * MaxProductsInBundle
     */
    @TableField(value = "maxproductsinbundle")
    @JSONField(name = "maxproductsinbundle")
    @JsonProperty("maxproductsinbundle")
    private Integer maxproductsinbundle;
    /**
     * ISVIntegrationCode
     */
    @TableField(value = "isvintegrationcode")
    @JSONField(name = "isvintegrationcode")
    @JsonProperty("isvintegrationcode")
    private String isvintegrationcode;
    /**
     * SyncOptInSelectionStatus
     */
    @TableField(value = "syncoptinselectionstatus")
    @JSONField(name = "syncoptinselectionstatus")
    @JsonProperty("syncoptinselectionstatus")
    private String syncoptinselectionstatus;
    /**
     * EnablePricingOnCreate
     */
    @DEField(defaultValue = "True")
    @TableField(value = "enablepricingoncreate")
    @JSONField(name = "enablepricingoncreate")
    @JsonProperty("enablepricingoncreate")
    private Integer enablepricingoncreate;
    /**
     * HashFilterKeywords
     */
    @TableField(value = "hashfilterkeywords")
    @JSONField(name = "hashfilterkeywords")
    @JsonProperty("hashfilterkeywords")
    private String hashfilterkeywords;
    /**
     * AMDesignator
     */
    @TableField(value = "amdesignator")
    @JSONField(name = "amdesignator")
    @JsonProperty("amdesignator")
    private String amdesignator;
    /**
     * AllowOfflineScheduledSyncs
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowofflinescheduledsyncs")
    @JSONField(name = "allowofflinescheduledsyncs")
    @JsonProperty("allowofflinescheduledsyncs")
    private Integer allowofflinescheduledsyncs;
    /**
     * DefaultMobileOfflineProfileId
     */
    @TableField(value = "defaultmobileofflineprofileid")
    @JSONField(name = "defaultmobileofflineprofileid")
    @JsonProperty("defaultmobileofflineprofileid")
    private String defaultmobileofflineprofileid;
    /**
     * NegativeFormatCode
     */
    @TableField(value = "negativeformatcode")
    @JSONField(name = "negativeformatcode")
    @JsonProperty("negativeformatcode")
    private String negativeformatcode;
    /**
     * BulkOperationPrefix
     */
    @TableField(value = "bulkoperationprefix")
    @JSONField(name = "bulkoperationprefix")
    @JsonProperty("bulkoperationprefix")
    private String bulkoperationprefix;
    /**
     * CurrentContractNumber
     */
    @TableField(value = "currentcontractnumber")
    @JSONField(name = "currentcontractnumber")
    @JsonProperty("currentcontractnumber")
    private Integer currentcontractnumber;
    /**
     * MSTeamsCollaborationEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "msteamscollaborationenabled")
    @JSONField(name = "msteamscollaborationenabled")
    @JsonProperty("msteamscollaborationenabled")
    private Integer msteamscollaborationenabled;
    /**
     * ExternalFileStorageEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "externalfilestorageenabled")
    @JSONField(name = "externalfilestorageenabled")
    @JsonProperty("externalfilestorageenabled")
    private Integer externalfilestorageenabled;
    /**
     * TokenKey
     */
    @TableField(value = "tokenkey")
    @JSONField(name = "tokenkey")
    @JsonProperty("tokenkey")
    private String tokenkey;
    /**
     * CurrentInvoiceNumber
     */
    @TableField(value = "currentinvoicenumber")
    @JSONField(name = "currentinvoicenumber")
    @JsonProperty("currentinvoicenumber")
    private Integer currentinvoicenumber;
    /**
     * SqlAccessGroupName
     */
    @TableField(value = "sqlaccessgroupname")
    @JSONField(name = "sqlaccessgroupname")
    @JsonProperty("sqlaccessgroupname")
    private String sqlaccessgroupname;
    /**
     * CurrencyDecimalPrecision
     */
    @TableField(value = "currencydecimalprecision")
    @JSONField(name = "currencydecimalprecision")
    @JsonProperty("currencydecimalprecision")
    private Integer currencydecimalprecision;
    /**
     * SessionTimeoutReminderInMins
     */
    @TableField(value = "sessiontimeoutreminderinmins")
    @JSONField(name = "sessiontimeoutreminderinmins")
    @JsonProperty("sessiontimeoutreminderinmins")
    private Integer sessiontimeoutreminderinmins;
    /**
     * MaximumEntitiesWithActiveSLA
     */
    @TableField(value = "maximumentitieswithactivesla")
    @JSONField(name = "maximumentitieswithactivesla")
    @JsonProperty("maximumentitieswithactivesla")
    private Integer maximumentitieswithactivesla;
    /**
     * AutoApplySLA
     */
    @DEField(defaultValue = "False")
    @TableField(value = "autoapplysla")
    @JSONField(name = "autoapplysla")
    @JsonProperty("autoapplysla")
    private Integer autoapplysla;
    /**
     * BusinessClosureCalendarId
     */
    @TableField(value = "businessclosurecalendarid")
    @JSONField(name = "businessclosurecalendarid")
    @JsonProperty("businessclosurecalendarid")
    private String businessclosurecalendarid;
    /**
     * OneDriveEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "onedriveenabled")
    @JSONField(name = "onedriveenabled")
    @JsonProperty("onedriveenabled")
    private Integer onedriveenabled;
    /**
     * FiscalYearFormat
     */
    @TableField(value = "fiscalyearformat")
    @JSONField(name = "fiscalyearformat")
    @JsonProperty("fiscalyearformat")
    private String fiscalyearformat;
    /**
     * MobileOfflineSyncInterval
     */
    @TableField(value = "mobileofflinesyncinterval")
    @JSONField(name = "mobileofflinesyncinterval")
    @JsonProperty("mobileofflinesyncinterval")
    private Integer mobileofflinesyncinterval;
    /**
     * ReferenceSiteMapXml
     */
    @TableField(value = "referencesitemapxml")
    @JSONField(name = "referencesitemapxml")
    @JsonProperty("referencesitemapxml")
    private String referencesitemapxml;
    /**
     * SessionTimeoutEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "sessiontimeoutenabled")
    @JSONField(name = "sessiontimeoutenabled")
    @JsonProperty("sessiontimeoutenabled")
    private Integer sessiontimeoutenabled;
    /**
     * CurrentParsedTableNumber
     */
    @TableField(value = "currentparsedtablenumber")
    @JSONField(name = "currentparsedtablenumber")
    @JsonProperty("currentparsedtablenumber")
    private Integer currentparsedtablenumber;
    /**
     * organizationName
     */
    @TableField(value = "organizationname")
    @JSONField(name = "organizationname")
    @JsonProperty("organizationname")
    private String organizationname;
    /**
     * NumberGroupFormat
     */
    @TableField(value = "numbergroupformat")
    @JSONField(name = "numbergroupformat")
    @JsonProperty("numbergroupformat")
    private String numbergroupformat;
    /**
     * FeatureSet
     */
    @TableField(value = "featureset")
    @JSONField(name = "featureset")
    @JsonProperty("featureset")
    private String featureset;
    /**
     * FiscalCalendarStart
     */
    @TableField(value = "fiscalcalendarstart")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "fiscalcalendarstart" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("fiscalcalendarstart")
    private Timestamp fiscalcalendarstart;
    /**
     * NumberFormat
     */
    @TableField(value = "numberformat")
    @JSONField(name = "numberformat")
    @JsonProperty("numberformat")
    private String numberformat;
    /**
     * InactivityTimeoutInMins
     */
    @TableField(value = "inactivitytimeoutinmins")
    @JSONField(name = "inactivitytimeoutinmins")
    @JsonProperty("inactivitytimeoutinmins")
    private Integer inactivitytimeoutinmins;
    /**
     * EmailMonitoringAllowed
     */
    @DEField(defaultValue = "True")
    @TableField(value = "emailmonitoringallowed")
    @JSONField(name = "emailmonitoringallowed")
    @JsonProperty("emailmonitoringallowed")
    private Integer emailmonitoringallowed;
    /**
     * FiscalYearPeriodConnect
     */
    @TableField(value = "fiscalyearperiodconnect")
    @JSONField(name = "fiscalyearperiodconnect")
    @JsonProperty("fiscalyearperiodconnect")
    private String fiscalyearperiodconnect;
    /**
     * DuplicateDetectionEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "duplicatedetectionenabled")
    @JSONField(name = "duplicatedetectionenabled")
    @JsonProperty("duplicatedetectionenabled")
    private Integer duplicatedetectionenabled;
    /**
     * SocialInsightsEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "socialinsightsenabled")
    @JSONField(name = "socialinsightsenabled")
    @JsonProperty("socialinsightsenabled")
    private Integer socialinsightsenabled;
    /**
     * DefaultRecurrenceEndRangeType
     */
    @TableField(value = "defaultrecurrenceendrangetype")
    @JSONField(name = "defaultrecurrenceendrangetype")
    @JsonProperty("defaultrecurrenceendrangetype")
    private String defaultrecurrenceendrangetype;
    /**
     * DefaultCountryCode
     */
    @TableField(value = "defaultcountrycode")
    @JSONField(name = "defaultcountrycode")
    @JsonProperty("defaultcountrycode")
    private String defaultcountrycode;
    /**
     * PreviewEnabledForActionCard
     */
    @DEField(defaultValue = "False")
    @TableField(value = "previewenabledforactioncard")
    @JSONField(name = "previewenabledforactioncard")
    @JsonProperty("previewenabledforactioncard")
    private Integer previewenabledforactioncard;
    /**
     * FiscalYearFormatYear
     */
    @TableField(value = "fiscalyearformatyear")
    @JSONField(name = "fiscalyearformatyear")
    @JsonProperty("fiscalyearformatyear")
    private String fiscalyearformatyear;
    /**
     * DefaultCountryCodeCheckEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "defaultcountrycodecheckenabled")
    @JSONField(name = "defaultcountrycodecheckenabled")
    @JsonProperty("defaultcountrycodecheckenabled")
    private Integer defaultcountrycodecheckenabled;
    /**
     * FutureExpansionWindow
     */
    @TableField(value = "futureexpansionwindow")
    @JSONField(name = "futureexpansionwindow")
    @JsonProperty("futureexpansionwindow")
    private Integer futureexpansionwindow;
    /**
     * RestrictStatusUpdate
     */
    @DEField(defaultValue = "False")
    @TableField(value = "restrictstatusupdate")
    @JSONField(name = "restrictstatusupdate")
    @JsonProperty("restrictstatusupdate")
    private Integer restrictstatusupdate;
    /**
     * CurrentImportSequenceNumber
     */
    @TableField(value = "currentimportsequencenumber")
    @JSONField(name = "currentimportsequencenumber")
    @JsonProperty("currentimportsequencenumber")
    private Integer currentimportsequencenumber;
    /**
     * SampleDataImportId
     */
    @TableField(value = "sampledataimportid")
    @JSONField(name = "sampledataimportid")
    @JsonProperty("sampledataimportid")
    private String sampledataimportid;
    /**
     * AuditEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "auditenabled")
    @JSONField(name = "auditenabled")
    @JsonProperty("auditenabled")
    private Integer auditenabled;
    /**
     * AllowAutoUnsubscribe
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowautounsubscribe")
    @JSONField(name = "allowautounsubscribe")
    @JsonProperty("allowautounsubscribe")
    private Integer allowautounsubscribe;
    /**
     * SchedulingEngine
     */
    @TableField(value = "schedulingengine")
    @JSONField(name = "schedulingengine")
    @JsonProperty("schedulingengine")
    private String schedulingengine;
    /**
     * MSTeamsEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "msteamsenabled")
    @JSONField(name = "msteamsenabled")
    @JsonProperty("msteamsenabled")
    private Integer msteamsenabled;
    /**
     * EnableSmartMatching
     */
    @DEField(defaultValue = "False")
    @TableField(value = "enablesmartmatching")
    @JSONField(name = "enablesmartmatching")
    @JsonProperty("enablesmartmatching")
    private Integer enablesmartmatching;
    /**
     * OrderPrefix
     */
    @TableField(value = "orderprefix")
    @JSONField(name = "orderprefix")
    @JsonProperty("orderprefix")
    private String orderprefix;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * PreviewForAutoCaptureEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "previewforautocaptureenabled")
    @JSONField(name = "previewforautocaptureenabled")
    @JsonProperty("previewforautocaptureenabled")
    private Integer previewforautocaptureenabled;
    /**
     * DefaultCrmCustomName
     */
    @TableField(value = "defaultcrmcustomname")
    @JSONField(name = "defaultcrmcustomname")
    @JsonProperty("defaultcrmcustomname")
    private String defaultcrmcustomname;
    /**
     * DateFormatCode
     */
    @TableField(value = "dateformatcode")
    @JSONField(name = "dateformatcode")
    @JsonProperty("dateformatcode")
    private String dateformatcode;
    /**
     * ReportScriptErrors
     */
    @TableField(value = "reportscripterrors")
    @JSONField(name = "reportscripterrors")
    @JsonProperty("reportscripterrors")
    private String reportscripterrors;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * OfficeGraphEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "officegraphenabled")
    @JSONField(name = "officegraphenabled")
    @JsonProperty("officegraphenabled")
    private Integer officegraphenabled;
    /**
     * OrganizationId
     */
    @DEField(isKeyField=true)
    @TableId(value= "organizationid",type=IdType.UUID)
    @JSONField(name = "organizationid")
    @JsonProperty("organizationid")
    private String organizationid;
    /**
     * EnabledForAllRoles
     */
    @DEField(defaultValue = "True")
    @TableField(value = "enabledforallroles")
    @JSONField(name = "enabledforallroles")
    @JsonProperty("enabledforallroles")
    private Integer enabledforallroles;
    /**
     * TrackingTokenIdDigits
     */
    @TableField(value = "trackingtokeniddigits")
    @JSONField(name = "trackingtokeniddigits")
    @JsonProperty("trackingtokeniddigits")
    private Integer trackingtokeniddigits;
    /**
     * DisableSocialCare
     */
    @DEField(defaultValue = "False")
    @TableField(value = "disablesocialcare")
    @JSONField(name = "disablesocialcare")
    @JsonProperty("disablesocialcare")
    private Integer disablesocialcare;
    /**
     * EnforceReadOnlyPlugins
     */
    @DEField(defaultValue = "False")
    @TableField(value = "enforcereadonlyplugins")
    @JSONField(name = "enforcereadonlyplugins")
    @JsonProperty("enforcereadonlyplugins")
    private Integer enforcereadonlyplugins;
    /**
     * DateSeparator
     */
    @TableField(value = "dateseparator")
    @JSONField(name = "dateseparator")
    @JsonProperty("dateseparator")
    private String dateseparator;
    /**
     * SuppressSLA
     */
    @DEField(defaultValue = "False")
    @TableField(value = "suppresssla")
    @JSONField(name = "suppresssla")
    @JsonProperty("suppresssla")
    private Integer suppresssla;
    /**
     * UserAccessAuditingInterval
     */
    @TableField(value = "useraccessauditinginterval")
    @JSONField(name = "useraccessauditinginterval")
    @JsonProperty("useraccessauditinginterval")
    private Integer useraccessauditinginterval;
    /**
     * LongDateFormatCode
     */
    @TableField(value = "longdateformatcode")
    @JSONField(name = "longdateformatcode")
    @JsonProperty("longdateformatcode")
    private Integer longdateformatcode;
    /**
     * UseReadForm
     */
    @DEField(defaultValue = "False")
    @TableField(value = "usereadform")
    @JSONField(name = "usereadform")
    @JsonProperty("usereadform")
    private Integer usereadform;
    /**
     * AllowLegacyClientExperience
     */
    @DEField(defaultValue = "True")
    @TableField(value = "allowlegacyclientexperience")
    @JSONField(name = "allowlegacyclientexperience")
    @JsonProperty("allowlegacyclientexperience")
    private Integer allowlegacyclientexperience;
    /**
     * SyncOptInSelection
     */
    @DEField(defaultValue = "False")
    @TableField(value = "syncoptinselection")
    @JSONField(name = "syncoptinselection")
    @JsonProperty("syncoptinselection")
    private Integer syncoptinselection;
    /**
     * MSTeamsSettingChangedByUser
     */
    @DEField(defaultValue = "False")
    @TableField(value = "msteamssettingchangedbyuser")
    @JSONField(name = "msteamssettingchangedbyuser")
    @JsonProperty("msteamssettingchangedbyuser")
    private Integer msteamssettingchangedbyuser;
    /**
     * AllowOutlookScheduledSyncs
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowoutlookscheduledsyncs")
    @JSONField(name = "allowoutlookscheduledsyncs")
    @JsonProperty("allowoutlookscheduledsyncs")
    private Integer allowoutlookscheduledsyncs;
    /**
     * CurrencyFormatCode
     */
    @TableField(value = "currencyformatcode")
    @JSONField(name = "currencyformatcode")
    @JsonProperty("currencyformatcode")
    private String currencyformatcode;
    /**
     * SiteMapXml
     */
    @TableField(value = "sitemapxml")
    @JSONField(name = "sitemapxml")
    @JsonProperty("sitemapxml")
    private String sitemapxml;
    /**
     * V3CalloutConfigHash
     */
    @TableField(value = "v3calloutconfighash")
    @JSONField(name = "v3calloutconfighash")
    @JsonProperty("v3calloutconfighash")
    private String v3calloutconfighash;
    /**
     * YammerPostMethod
     */
    @TableField(value = "yammerpostmethod")
    @JSONField(name = "yammerpostmethod")
    @JsonProperty("yammerpostmethod")
    private String yammerpostmethod;
    /**
     * CampaignPrefix
     */
    @TableField(value = "campaignprefix")
    @JSONField(name = "campaignprefix")
    @JsonProperty("campaignprefix")
    private String campaignprefix;
    /**
     * UsePositionHierarchy
     */
    @DEField(defaultValue = "False")
    @TableField(value = "usepositionhierarchy")
    @JSONField(name = "usepositionhierarchy")
    @JsonProperty("usepositionhierarchy")
    private Integer usepositionhierarchy;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * AllowUserFormModePreference
     */
    @DEField(defaultValue = "True")
    @TableField(value = "allowuserformmodepreference")
    @JSONField(name = "allowuserformmodepreference")
    @JsonProperty("allowuserformmodepreference")
    private Integer allowuserformmodepreference;
    /**
     * FolderBasedTrackingEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "folderbasedtrackingenabled")
    @JSONField(name = "folderbasedtrackingenabled")
    @JsonProperty("folderbasedtrackingenabled")
    private Integer folderbasedtrackingenabled;
    /**
     * FiscalSettingsUpdated
     */
    @DEField(defaultValue = "False")
    @TableField(value = "fiscalsettingsupdated")
    @JSONField(name = "fiscalsettingsupdated")
    @JsonProperty("fiscalsettingsupdated")
    private Integer fiscalsettingsupdated;
    /**
     * GrantAccessToNetworkService
     */
    @DEField(defaultValue = "False")
    @TableField(value = "grantaccesstonetworkservice")
    @JSONField(name = "grantaccesstonetworkservice")
    @JsonProperty("grantaccesstonetworkservice")
    private Integer grantaccesstonetworkservice;
    /**
     * RelationshipInsightsEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "relationshipinsightsenabled")
    @JSONField(name = "relationshipinsightsenabled")
    @JsonProperty("relationshipinsightsenabled")
    private Integer relationshipinsightsenabled;
    /**
     * AllowWebExcelExport
     */
    @DEField(defaultValue = "True")
    @TableField(value = "allowwebexcelexport")
    @JSONField(name = "allowwebexcelexport")
    @JsonProperty("allowwebexcelexport")
    private Integer allowwebexcelexport;
    /**
     * WeekStartDayCode
     */
    @TableField(value = "weekstartdaycode")
    @JSONField(name = "weekstartdaycode")
    @JsonProperty("weekstartdaycode")
    private String weekstartdaycode;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * SyncBulkOperationBatchSize
     */
    @TableField(value = "syncbulkoperationbatchsize")
    @JSONField(name = "syncbulkoperationbatchsize")
    @JsonProperty("syncbulkoperationbatchsize")
    private Integer syncbulkoperationbatchsize;
    /**
     * SocialInsightsInstance
     */
    @TableField(value = "socialinsightsinstance")
    @JSONField(name = "socialinsightsinstance")
    @JsonProperty("socialinsightsinstance")
    private String socialinsightsinstance;
    /**
     * FullTextSearchEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "fulltextsearchenabled")
    @JSONField(name = "fulltextsearchenabled")
    @JsonProperty("fulltextsearchenabled")
    private Integer fulltextsearchenabled;
    /**
     * MaxVerboseLoggingMailbox
     */
    @TableField(value = "maxverboseloggingmailbox")
    @JSONField(name = "maxverboseloggingmailbox")
    @JsonProperty("maxverboseloggingmailbox")
    private Integer maxverboseloggingmailbox;
    /**
     * PrivReportingGroupId
     */
    @TableField(value = "privreportinggroupid")
    @JSONField(name = "privreportinggroupid")
    @JsonProperty("privreportinggroupid")
    private String privreportinggroupid;
    /**
     * TextWrapEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "textwrapenabled")
    @JSONField(name = "textwrapenabled")
    @JsonProperty("textwrapenabled")
    private Integer textwrapenabled;
    /**
     * DisabledReason
     */
    @TableField(value = "disabledreason")
    @JSONField(name = "disabledreason")
    @JsonProperty("disabledreason")
    private String disabledreason;
    /**
     * TagMaxAggressiveCycles
     */
    @TableField(value = "tagmaxaggressivecycles")
    @JSONField(name = "tagmaxaggressivecycles")
    @JsonProperty("tagmaxaggressivecycles")
    private Integer tagmaxaggressivecycles;
    /**
     * GenerateAlertsForWarnings
     */
    @DEField(defaultValue = "True")
    @TableField(value = "generatealertsforwarnings")
    @JSONField(name = "generatealertsforwarnings")
    @JsonProperty("generatealertsforwarnings")
    private Integer generatealertsforwarnings;
    /**
     * KaPrefix
     */
    @TableField(value = "kaprefix")
    @JSONField(name = "kaprefix")
    @JsonProperty("kaprefix")
    private String kaprefix;
    /**
     * InitialVersion
     */
    @TableField(value = "initialversion")
    @JSONField(name = "initialversion")
    @JsonProperty("initialversion")
    private String initialversion;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * ParsedTableColumnPrefix
     */
    @TableField(value = "parsedtablecolumnprefix")
    @JSONField(name = "parsedtablecolumnprefix")
    @JsonProperty("parsedtablecolumnprefix")
    private String parsedtablecolumnprefix;
    /**
     * ShowWeekNumber
     */
    @DEField(defaultValue = "False")
    @TableField(value = "showweeknumber")
    @JSONField(name = "showweeknumber")
    @JsonProperty("showweeknumber")
    private Integer showweeknumber;
    /**
     * ProductRecommendationsEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "productrecommendationsenabled")
    @JSONField(name = "productrecommendationsenabled")
    @JsonProperty("productrecommendationsenabled")
    private Integer productrecommendationsenabled;
    /**
     * EmailCorrelationEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "emailcorrelationenabled")
    @JSONField(name = "emailcorrelationenabled")
    @JsonProperty("emailcorrelationenabled")
    private Integer emailcorrelationenabled;
    /**
     * IntegrationUserId
     */
    @TableField(value = "integrationuserid")
    @JSONField(name = "integrationuserid")
    @JsonProperty("integrationuserid")
    private String integrationuserid;
    /**
     * HashMaxCount
     */
    @TableField(value = "hashmaxcount")
    @JSONField(name = "hashmaxcount")
    @JsonProperty("hashmaxcount")
    private Integer hashmaxcount;
    /**
     * QuotePrefix
     */
    @TableField(value = "quoteprefix")
    @JSONField(name = "quoteprefix")
    @JsonProperty("quoteprefix")
    private String quoteprefix;
    /**
     * CasePrefix
     */
    @TableField(value = "caseprefix")
    @JSONField(name = "caseprefix")
    @JsonProperty("caseprefix")
    private String caseprefix;
    /**
     * PinpointLanguageCode
     */
    @TableField(value = "pinpointlanguagecode")
    @JSONField(name = "pinpointlanguagecode")
    @JsonProperty("pinpointlanguagecode")
    private Integer pinpointlanguagecode;
    /**
     * NegativeCurrencyFormatCode
     */
    @TableField(value = "negativecurrencyformatcode")
    @JSONField(name = "negativecurrencyformatcode")
    @JsonProperty("negativecurrencyformatcode")
    private Integer negativecurrencyformatcode;
    /**
     * GetStartedPaneContentEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "getstartedpanecontentenabled")
    @JSONField(name = "getstartedpanecontentenabled")
    @JsonProperty("getstartedpanecontentenabled")
    private Integer getstartedpanecontentenabled;
    /**
     * MaximumTrackingNumber
     */
    @TableField(value = "maximumtrackingnumber")
    @JSONField(name = "maximumtrackingnumber")
    @JsonProperty("maximumtrackingnumber")
    private Integer maximumtrackingnumber;
    /**
     * FiscalYearFormatPrefix
     */
    @TableField(value = "fiscalyearformatprefix")
    @JSONField(name = "fiscalyearformatprefix")
    @JsonProperty("fiscalyearformatprefix")
    private String fiscalyearformatprefix;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * NumberSeparator
     */
    @TableField(value = "numberseparator")
    @JSONField(name = "numberseparator")
    @JsonProperty("numberseparator")
    private String numberseparator;
    /**
     * InvoicePrefix
     */
    @TableField(value = "invoiceprefix")
    @JSONField(name = "invoiceprefix")
    @JsonProperty("invoiceprefix")
    private String invoiceprefix;
    /**
     * AutoApplyDefaultonCaseCreate
     */
    @DEField(defaultValue = "False")
    @TableField(value = "autoapplydefaultoncasecreate")
    @JSONField(name = "autoapplydefaultoncasecreate")
    @JsonProperty("autoapplydefaultoncasecreate")
    private Integer autoapplydefaultoncasecreate;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * PrivilegeUserGroupId
     */
    @TableField(value = "privilegeusergroupid")
    @JSONField(name = "privilegeusergroupid")
    @JsonProperty("privilegeusergroupid")
    private String privilegeusergroupid;
    /**
     * IgnoreInternalEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "ignoreinternalemail")
    @JSONField(name = "ignoreinternalemail")
    @JsonProperty("ignoreinternalemail")
    private Integer ignoreinternalemail;
    /**
     * CurrencyDisplayOption
     */
    @TableField(value = "currencydisplayoption")
    @JSONField(name = "currencydisplayoption")
    @JsonProperty("currencydisplayoption")
    private String currencydisplayoption;
    /**
     * DefaultThemeData
     */
    @TableField(value = "defaultthemedata")
    @JSONField(name = "defaultthemedata")
    @JsonProperty("defaultthemedata")
    private String defaultthemedata;
    /**
     * CurrentKaNumber
     */
    @TableField(value = "currentkanumber")
    @JSONField(name = "currentkanumber")
    @JsonProperty("currentkanumber")
    private Integer currentkanumber;
    /**
     * SortId
     */
    @TableField(value = "sortid")
    @JSONField(name = "sortid")
    @JsonProperty("sortid")
    private Integer sortid;
    /**
     * BingMapsApiKey
     */
    @TableField(value = "bingmapsapikey")
    @JSONField(name = "bingmapsapikey")
    @JsonProperty("bingmapsapikey")
    private String bingmapsapikey;
    /**
     * GlobalHelpUrl
     */
    @TableField(value = "globalhelpurl")
    @JSONField(name = "globalhelpurl")
    @JsonProperty("globalhelpurl")
    private String globalhelpurl;
    /**
     * CascadeStatusUpdate
     */
    @DEField(defaultValue = "False")
    @TableField(value = "cascadestatusupdate")
    @JSONField(name = "cascadestatusupdate")
    @JsonProperty("cascadestatusupdate")
    private Integer cascadestatusupdate;
    /**
     * Picture
     */
    @TableField(value = "picture")
    @JSONField(name = "picture")
    @JsonProperty("picture")
    private String picture;
    /**
     * TagPollingPeriod
     */
    @TableField(value = "tagpollingperiod")
    @JSONField(name = "tagpollingperiod")
    @JsonProperty("tagpollingperiod")
    private Integer tagpollingperiod;
    /**
     * ExpireChangeTrackingInDays
     */
    @TableField(value = "expirechangetrackingindays")
    @JSONField(name = "expirechangetrackingindays")
    @JsonProperty("expirechangetrackingindays")
    private Integer expirechangetrackingindays;
    /**
     * TrackingPrefix
     */
    @TableField(value = "trackingprefix")
    @JSONField(name = "trackingprefix")
    @JsonProperty("trackingprefix")
    private String trackingprefix;
    /**
     * FiscalYearDisplayCode
     */
    @TableField(value = "fiscalyeardisplaycode")
    @JSONField(name = "fiscalyeardisplaycode")
    @JsonProperty("fiscalyeardisplaycode")
    private Integer fiscalyeardisplaycode;
    /**
     * MaxUploadFileSize
     */
    @TableField(value = "maxuploadfilesize")
    @JSONField(name = "maxuploadfilesize")
    @JsonProperty("maxuploadfilesize")
    private Integer maxuploadfilesize;
    /**
     * ActionCardEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "actioncardenabled")
    @JSONField(name = "actioncardenabled")
    @JsonProperty("actioncardenabled")
    private Integer actioncardenabled;
    /**
     * SessionTimeoutInMins
     */
    @TableField(value = "sessiontimeoutinmins")
    @JSONField(name = "sessiontimeoutinmins")
    @JsonProperty("sessiontimeoutinmins")
    private Integer sessiontimeoutinmins;
    /**
     * SyncBulkOperationMaxLimit
     */
    @TableField(value = "syncbulkoperationmaxlimit")
    @JSONField(name = "syncbulkoperationmaxlimit")
    @JsonProperty("syncbulkoperationmaxlimit")
    private Integer syncbulkoperationmaxlimit;
    /**
     * MailboxForcedUnlockingEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "mailboxforcedunlockingenabled")
    @JSONField(name = "mailboxforcedunlockingenabled")
    @JsonProperty("mailboxforcedunlockingenabled")
    private Integer mailboxforcedunlockingenabled;
    /**
     * BaseCurrencyPrecision
     */
    @TableField(value = "basecurrencyprecision")
    @JSONField(name = "basecurrencyprecision")
    @JsonProperty("basecurrencyprecision")
    private Integer basecurrencyprecision;
    /**
     * MinAddressBookSyncInterval
     */
    @TableField(value = "minaddressbooksyncinterval")
    @JSONField(name = "minaddressbooksyncinterval")
    @JsonProperty("minaddressbooksyncinterval")
    private Integer minaddressbooksyncinterval;
    /**
     * EnableBingMapsIntegration
     */
    @DEField(defaultValue = "True")
    @TableField(value = "enablebingmapsintegration")
    @JSONField(name = "enablebingmapsintegration")
    @JsonProperty("enablebingmapsintegration")
    private Integer enablebingmapsintegration;
    /**
     * MailboxInactiveBackoffEnabled
     */
    @DEField(defaultValue = "False")
    @TableField(value = "mailboxinactivebackoffenabled")
    @JSONField(name = "mailboxinactivebackoffenabled")
    @JsonProperty("mailboxinactivebackoffenabled")
    private Integer mailboxinactivebackoffenabled;
    /**
     * QuickFindRecordLimitEnabled
     */
    @DEField(defaultValue = "True")
    @TableField(value = "quickfindrecordlimitenabled")
    @JSONField(name = "quickfindrecordlimitenabled")
    @JsonProperty("quickfindrecordlimitenabled")
    private Integer quickfindrecordlimitenabled;
    /**
     * FiscalPeriodFormatPeriod
     */
    @TableField(value = "fiscalperiodformatperiod")
    @JSONField(name = "fiscalperiodformatperiod")
    @JsonProperty("fiscalperiodformatperiod")
    private String fiscalperiodformatperiod;
    /**
     * KbPrefix
     */
    @TableField(value = "kbprefix")
    @JSONField(name = "kbprefix")
    @JsonProperty("kbprefix")
    private String kbprefix;
    /**
     * PMDesignator
     */
    @TableField(value = "pmdesignator")
    @JSONField(name = "pmdesignator")
    @JsonProperty("pmdesignator")
    private String pmdesignator;
    /**
     * AcknowledgementTemplateId
     */
    @TableField(value = "acknowledgementtemplateid")
    @JSONField(name = "acknowledgementtemplateid")
    @JsonProperty("acknowledgementtemplateid")
    private String acknowledgementtemplateid;
    /**
     * BaseCurrencyId
     */
    @TableField(value = "basecurrencyid")
    @JSONField(name = "basecurrencyid")
    @JsonProperty("basecurrencyid")
    private String basecurrencyid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Template acknowledgementtemplate;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency basecurrency;



    /**
     * 设置 [EnableLivePersonaCardUCI]
     */
    public void setEnablelivepersonacarduci(Integer enablelivepersonacarduci){
        this.enablelivepersonacarduci = enablelivepersonacarduci ;
        this.modify("enablelivepersonacarduci",enablelivepersonacarduci);
    }
    /**
     * 设置 [AutoDataCaptureEnabled]
     */
    public void setAutodatacaptureenabled(Integer autodatacaptureenabled){
        this.autodatacaptureenabled = autodatacaptureenabled ;
        this.modify("autodatacaptureenabled",autodatacaptureenabled);
    }
    /**
     * 设置 [AllowClientMessageBarAd]
     */
    public void setAllowclientmessagebarad(Integer allowclientmessagebarad){
        this.allowclientmessagebarad = allowclientmessagebarad ;
        this.modify("allowclientmessagebarad",allowclientmessagebarad);
    }
    /**
     * 设置 [YammerGroupId]
     */
    public void setYammergroupid(Integer yammergroupid){
        this.yammergroupid = yammergroupid ;
        this.modify("yammergroupid",yammergroupid);
    }
    /**
     * 设置 [GoalRollupFrequency]
     */
    public void setGoalrollupfrequency(Integer goalrollupfrequency){
        this.goalrollupfrequency = goalrollupfrequency ;
        this.modify("goalrollupfrequency",goalrollupfrequency);
    }
    /**
     * 设置 [YearStartWeekCode]
     */
    public void setYearstartweekcode(Integer yearstartweekcode){
        this.yearstartweekcode = yearstartweekcode ;
        this.modify("yearstartweekcode",yearstartweekcode);
    }
    /**
     * 设置 [OOBPriceCalculationEnabled]
     */
    public void setOobpricecalculationenabled(Integer oobpricecalculationenabled){
        this.oobpricecalculationenabled = oobpricecalculationenabled ;
        this.modify("oobpricecalculationenabled",oobpricecalculationenabled);
    }
    /**
     * 设置 [AppDesignerExperienceEnabled]
     */
    public void setAppdesignerexperienceenabled(Integer appdesignerexperienceenabled){
        this.appdesignerexperienceenabled = appdesignerexperienceenabled ;
        this.modify("appdesignerexperienceenabled",appdesignerexperienceenabled);
    }
    /**
     * 设置 [UseLegacyRendering]
     */
    public void setUselegacyrendering(Integer uselegacyrendering){
        this.uselegacyrendering = uselegacyrendering ;
        this.modify("uselegacyrendering",uselegacyrendering);
    }
    /**
     * 设置 [WebResourceHash]
     */
    public void setWebresourcehash(String webresourcehash){
        this.webresourcehash = webresourcehash ;
        this.modify("webresourcehash",webresourcehash);
    }
    /**
     * 设置 [UseSkypeProtocol]
     */
    public void setUseskypeprotocol(Integer useskypeprotocol){
        this.useskypeprotocol = useskypeprotocol ;
        this.modify("useskypeprotocol",useskypeprotocol);
    }
    /**
     * 设置 [NotesAnalysisEnabled]
     */
    public void setNotesanalysisenabled(Integer notesanalysisenabled){
        this.notesanalysisenabled = notesanalysisenabled ;
        this.modify("notesanalysisenabled",notesanalysisenabled);
    }
    /**
     * 设置 [BaseISOCurrencyCode]
     */
    public void setBaseisocurrencycode(String baseisocurrencycode){
        this.baseisocurrencycode = baseisocurrencycode ;
        this.modify("baseisocurrencycode",baseisocurrencycode);
    }
    /**
     * 设置 [LocaleId]
     */
    public void setLocaleid(Integer localeid){
        this.localeid = localeid ;
        this.modify("localeid",localeid);
    }
    /**
     * 设置 [ExternalPartyEntitySettings]
     */
    public void setExternalpartyentitysettings(String externalpartyentitysettings){
        this.externalpartyentitysettings = externalpartyentitysettings ;
        this.modify("externalpartyentitysettings",externalpartyentitysettings);
    }
    /**
     * 设置 [EnableMicrosoftFlowIntegration]
     */
    public void setEnablemicrosoftflowintegration(Integer enablemicrosoftflowintegration){
        this.enablemicrosoftflowintegration = enablemicrosoftflowintegration ;
        this.modify("enablemicrosoftflowintegration",enablemicrosoftflowintegration);
    }
    /**
     * 设置 [Disabled]
     */
    public void setDisabled(Integer disabled){
        this.disabled = disabled ;
        this.modify("disabled",disabled);
    }
    /**
     * 设置 [MinOfflineSyncInterval]
     */
    public void setMinofflinesyncinterval(Integer minofflinesyncinterval){
        this.minofflinesyncinterval = minofflinesyncinterval ;
        this.modify("minofflinesyncinterval",minofflinesyncinterval);
    }
    /**
     * 设置 [AllowEntityOnlyAudit]
     */
    public void setAllowentityonlyaudit(Integer allowentityonlyaudit){
        this.allowentityonlyaudit = allowentityonlyaudit ;
        this.modify("allowentityonlyaudit",allowentityonlyaudit);
    }
    /**
     * 设置 [AllowAddressBookSyncs]
     */
    public void setAllowaddressbooksyncs(Integer allowaddressbooksyncs){
        this.allowaddressbooksyncs = allowaddressbooksyncs ;
        this.modify("allowaddressbooksyncs",allowaddressbooksyncs);
    }
    /**
     * 设置 [FiscalYearFormatSuffix]
     */
    public void setFiscalyearformatsuffix(String fiscalyearformatsuffix){
        this.fiscalyearformatsuffix = fiscalyearformatsuffix ;
        this.modify("fiscalyearformatsuffix",fiscalyearformatsuffix);
    }
    /**
     * 设置 [TaskBasedFlowEnabled]
     */
    public void setTaskbasedflowenabled(Integer taskbasedflowenabled){
        this.taskbasedflowenabled = taskbasedflowenabled ;
        this.modify("taskbasedflowenabled",taskbasedflowenabled);
    }
    /**
     * 设置 [MobileOfflineMinLicenseProd]
     */
    public void setMobileofflineminlicenseprod(Integer mobileofflineminlicenseprod){
        this.mobileofflineminlicenseprod = mobileofflineminlicenseprod ;
        this.modify("mobileofflineminlicenseprod",mobileofflineminlicenseprod);
    }
    /**
     * 设置 [NextTrackingNumber]
     */
    public void setNexttrackingnumber(Integer nexttrackingnumber){
        this.nexttrackingnumber = nexttrackingnumber ;
        this.modify("nexttrackingnumber",nexttrackingnumber);
    }
    /**
     * 设置 [ReportingGroupId]
     */
    public void setReportinggroupid(String reportinggroupid){
        this.reportinggroupid = reportinggroupid ;
        this.modify("reportinggroupid",reportinggroupid);
    }
    /**
     * 设置 [NextCustomObjectTypeCode]
     */
    public void setNextcustomobjecttypecode(Integer nextcustomobjecttypecode){
        this.nextcustomobjecttypecode = nextcustomobjecttypecode ;
        this.modify("nextcustomobjecttypecode",nextcustomobjecttypecode);
    }
    /**
     * 设置 [CurrentCategoryNumber]
     */
    public void setCurrentcategorynumber(Integer currentcategorynumber){
        this.currentcategorynumber = currentcategorynumber ;
        this.modify("currentcategorynumber",currentcategorynumber);
    }
    /**
     * 设置 [SupportUserId]
     */
    public void setSupportuserid(String supportuserid){
        this.supportuserid = supportuserid ;
        this.modify("supportuserid",supportuserid);
    }
    /**
     * 设置 [AllowLegacyDialogsEmbedding]
     */
    public void setAllowlegacydialogsembedding(Integer allowlegacydialogsembedding){
        this.allowlegacydialogsembedding = allowlegacydialogsembedding ;
        this.modify("allowlegacydialogsembedding",allowlegacydialogsembedding);
    }
    /**
     * 设置 [ExternalBaseUrl]
     */
    public void setExternalbaseurl(String externalbaseurl){
        this.externalbaseurl = externalbaseurl ;
        this.modify("externalbaseurl",externalbaseurl);
    }
    /**
     * 设置 [ActionSupportFeatureEnabled]
     */
    public void setActionsupportfeatureenabled(Integer actionsupportfeatureenabled){
        this.actionsupportfeatureenabled = actionsupportfeatureenabled ;
        this.modify("actionsupportfeatureenabled",actionsupportfeatureenabled);
    }
    /**
     * 设置 [GenerateAlertsForErrors]
     */
    public void setGeneratealertsforerrors(Integer generatealertsforerrors){
        this.generatealertsforerrors = generatealertsforerrors ;
        this.modify("generatealertsforerrors",generatealertsforerrors);
    }
    /**
     * 设置 [RenderSecureIFrameForEmail]
     */
    public void setRendersecureiframeforemail(Integer rendersecureiframeforemail){
        this.rendersecureiframeforemail = rendersecureiframeforemail ;
        this.modify("rendersecureiframeforemail",rendersecureiframeforemail);
    }
    /**
     * 设置 [TokenExpiry]
     */
    public void setTokenexpiry(Integer tokenexpiry){
        this.tokenexpiry = tokenexpiry ;
        this.modify("tokenexpiry",tokenexpiry);
    }
    /**
     * 设置 [PricingDecimalPrecision]
     */
    public void setPricingdecimalprecision(Integer pricingdecimalprecision){
        this.pricingdecimalprecision = pricingdecimalprecision ;
        this.modify("pricingdecimalprecision",pricingdecimalprecision);
    }
    /**
     * 设置 [ManualSalesForecastingEnabled]
     */
    public void setManualsalesforecastingenabled(Integer manualsalesforecastingenabled){
        this.manualsalesforecastingenabled = manualsalesforecastingenabled ;
        this.modify("manualsalesforecastingenabled",manualsalesforecastingenabled);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [EnableLPAuthoring]
     */
    public void setEnablelpauthoring(Integer enablelpauthoring){
        this.enablelpauthoring = enablelpauthoring ;
        this.modify("enablelpauthoring",enablelpauthoring);
    }
    /**
     * 设置 [UserGroupId]
     */
    public void setUsergroupid(String usergroupid){
        this.usergroupid = usergroupid ;
        this.modify("usergroupid",usergroupid);
    }
    /**
     * 设置 [PowerBiFeatureEnabled]
     */
    public void setPowerbifeatureenabled(Integer powerbifeatureenabled){
        this.powerbifeatureenabled = powerbifeatureenabled ;
        this.modify("powerbifeatureenabled",powerbifeatureenabled);
    }
    /**
     * 设置 [MailboxPermanentIssueMinRange]
     */
    public void setMailboxpermanentissueminrange(Integer mailboxpermanentissueminrange){
        this.mailboxpermanentissueminrange = mailboxpermanentissueminrange ;
        this.modify("mailboxpermanentissueminrange",mailboxpermanentissueminrange);
    }
    /**
     * 设置 [SocialInsightsTermsAccepted]
     */
    public void setSocialinsightstermsaccepted(Integer socialinsightstermsaccepted){
        this.socialinsightstermsaccepted = socialinsightstermsaccepted ;
        this.modify("socialinsightstermsaccepted",socialinsightstermsaccepted);
    }
    /**
     * 设置 [ReadAuditEnabled]
     */
    public void setReadauditenabled(Integer readauditenabled){
        this.readauditenabled = readauditenabled ;
        this.modify("readauditenabled",readauditenabled);
    }
    /**
     * 设置 [MaxRecordsForLookupFilters]
     */
    public void setMaxrecordsforlookupfilters(Integer maxrecordsforlookupfilters){
        this.maxrecordsforlookupfilters = maxrecordsforlookupfilters ;
        this.modify("maxrecordsforlookupfilters",maxrecordsforlookupfilters);
    }
    /**
     * 设置 [MaxFolderBasedTrackingMappings]
     */
    public void setMaxfolderbasedtrackingmappings(Integer maxfolderbasedtrackingmappings){
        this.maxfolderbasedtrackingmappings = maxfolderbasedtrackingmappings ;
        this.modify("maxfolderbasedtrackingmappings",maxfolderbasedtrackingmappings);
    }
    /**
     * 设置 [BaseCurrencySymbol]
     */
    public void setBasecurrencysymbol(String basecurrencysymbol){
        this.basecurrencysymbol = basecurrencysymbol ;
        this.modify("basecurrencysymbol",basecurrencysymbol);
    }
    /**
     * 设置 [MobileOfflineEnabled]
     */
    public void setMobileofflineenabled(Integer mobileofflineenabled){
        this.mobileofflineenabled = mobileofflineenabled ;
        this.modify("mobileofflineenabled",mobileofflineenabled);
    }
    /**
     * 设置 [DefaultEmailSettings]
     */
    public void setDefaultemailsettings(String defaultemailsettings){
        this.defaultemailsettings = defaultemailsettings ;
        this.modify("defaultemailsettings",defaultemailsettings);
    }
    /**
     * 设置 [RequireApprovalForUserEmail]
     */
    public void setRequireapprovalforuseremail(Integer requireapprovalforuseremail){
        this.requireapprovalforuseremail = requireapprovalforuseremail ;
        this.modify("requireapprovalforuseremail",requireapprovalforuseremail);
    }
    /**
     * 设置 [MobileOfflineMinLicenseTrial]
     */
    public void setMobileofflineminlicensetrial(Integer mobileofflineminlicensetrial){
        this.mobileofflineminlicensetrial = mobileofflineminlicensetrial ;
        this.modify("mobileofflineminlicensetrial",mobileofflineminlicensetrial);
    }
    /**
     * 设置 [PrivacyStatementUrl]
     */
    public void setPrivacystatementurl(String privacystatementurl){
        this.privacystatementurl = privacystatementurl ;
        this.modify("privacystatementurl",privacystatementurl);
    }
    /**
     * 设置 [HashMinAddressCount]
     */
    public void setHashminaddresscount(Integer hashminaddresscount){
        this.hashminaddresscount = hashminaddresscount ;
        this.modify("hashminaddresscount",hashminaddresscount);
    }
    /**
     * 设置 [CalendarType]
     */
    public void setCalendartype(Integer calendartype){
        this.calendartype = calendartype ;
        this.modify("calendartype",calendartype);
    }
    /**
     * 设置 [ShareToPreviousOwnerOnAssign]
     */
    public void setSharetopreviousowneronassign(Integer sharetopreviousowneronassign){
        this.sharetopreviousowneronassign = sharetopreviousowneronassign ;
        this.modify("sharetopreviousowneronassign",sharetopreviousowneronassign);
    }
    /**
     * 设置 [CurrentBulkOperationNumber]
     */
    public void setCurrentbulkoperationnumber(Integer currentbulkoperationnumber){
        this.currentbulkoperationnumber = currentbulkoperationnumber ;
        this.modify("currentbulkoperationnumber",currentbulkoperationnumber);
    }
    /**
     * 设置 [RiErrorStatus]
     */
    public void setRierrorstatus(Integer rierrorstatus){
        this.rierrorstatus = rierrorstatus ;
        this.modify("rierrorstatus",rierrorstatus);
    }
    /**
     * 设置 [EmailConnectionChannel]
     */
    public void setEmailconnectionchannel(String emailconnectionchannel){
        this.emailconnectionchannel = emailconnectionchannel ;
        this.modify("emailconnectionchannel",emailconnectionchannel);
    }
    /**
     * 设置 [AllowAutoResponseCreation]
     */
    public void setAllowautoresponsecreation(Integer allowautoresponsecreation){
        this.allowautoresponsecreation = allowautoresponsecreation ;
        this.modify("allowautoresponsecreation",allowautoresponsecreation);
    }
    /**
     * 设置 [AssignedTasksSyncEnabled]
     */
    public void setAssignedtaskssyncenabled(Integer assignedtaskssyncenabled){
        this.assignedtaskssyncenabled = assignedtaskssyncenabled ;
        this.modify("assignedtaskssyncenabled",assignedtaskssyncenabled);
    }
    /**
     * 设置 [UniqueSpecifierLength]
     */
    public void setUniquespecifierlength(Integer uniquespecifierlength){
        this.uniquespecifierlength = uniquespecifierlength ;
        this.modify("uniquespecifierlength",uniquespecifierlength);
    }
    /**
     * 设置 [PostMessageWhitelistDomains]
     */
    public void setPostmessagewhitelistdomains(String postmessagewhitelistdomains){
        this.postmessagewhitelistdomains = postmessagewhitelistdomains ;
        this.modify("postmessagewhitelistdomains",postmessagewhitelistdomains);
    }
    /**
     * 设置 [AutoSaveEnabled]
     */
    public void setAutosaveenabled(Integer autosaveenabled){
        this.autosaveenabled = autosaveenabled ;
        this.modify("autosaveenabled",autosaveenabled);
    }
    /**
     * 设置 [CurrencySymbol]
     */
    public void setCurrencysymbol(String currencysymbol){
        this.currencysymbol = currencysymbol ;
        this.modify("currencysymbol",currencysymbol);
    }
    /**
     * 设置 [SOPIntegrationEnabled]
     */
    public void setSopintegrationenabled(Integer sopintegrationenabled){
        this.sopintegrationenabled = sopintegrationenabled ;
        this.modify("sopintegrationenabled",sopintegrationenabled);
    }
    /**
     * 设置 [FiscalPeriodMonthBased]
     */
    public void setFiscalperiodmonthbased(Integer fiscalperiodmonthbased){
        this.fiscalperiodmonthbased = fiscalperiodmonthbased ;
        this.modify("fiscalperiodmonthbased",fiscalperiodmonthbased);
    }
    /**
     * 设置 [AppMode]
     */
    public void setAppmode(Integer appmode){
        this.appmode = appmode ;
        this.modify("appmode",appmode);
    }
    /**
     * 设置 [FullNameConventionCode]
     */
    public void setFullnameconventioncode(String fullnameconventioncode){
        this.fullnameconventioncode = fullnameconventioncode ;
        this.modify("fullnameconventioncode",fullnameconventioncode);
    }
    /**
     * 设置 [CurrentQuoteNumber]
     */
    public void setCurrentquotenumber(Integer currentquotenumber){
        this.currentquotenumber = currentquotenumber ;
        this.modify("currentquotenumber",currentquotenumber);
    }
    /**
     * 设置 [EmailSendPollingPeriod]
     */
    public void setEmailsendpollingperiod(Integer emailsendpollingperiod){
        this.emailsendpollingperiod = emailsendpollingperiod ;
        this.modify("emailsendpollingperiod",emailsendpollingperiod);
    }
    /**
     * 设置 [MSTeamsUserSyncEnabled]
     */
    public void setMsteamsusersyncenabled(Integer msteamsusersyncenabled){
        this.msteamsusersyncenabled = msteamsusersyncenabled ;
        this.modify("msteamsusersyncenabled",msteamsusersyncenabled);
    }
    /**
     * 设置 [MaxAppointmentDurationDays]
     */
    public void setMaxappointmentdurationdays(Integer maxappointmentdurationdays){
        this.maxappointmentdurationdays = maxappointmentdurationdays ;
        this.modify("maxappointmentdurationdays",maxappointmentdurationdays);
    }
    /**
     * 设置 [DiscountCalculationMethod]
     */
    public void setDiscountcalculationmethod(String discountcalculationmethod){
        this.discountcalculationmethod = discountcalculationmethod ;
        this.modify("discountcalculationmethod",discountcalculationmethod);
    }
    /**
     * 设置 [GenerateAlertsForInformation]
     */
    public void setGeneratealertsforinformation(Integer generatealertsforinformation){
        this.generatealertsforinformation = generatealertsforinformation ;
        this.modify("generatealertsforinformation",generatealertsforinformation);
    }
    /**
     * 设置 [DelegateAccessEnabled]
     */
    public void setDelegateaccessenabled(Integer delegateaccessenabled){
        this.delegateaccessenabled = delegateaccessenabled ;
        this.modify("delegateaccessenabled",delegateaccessenabled);
    }
    /**
     * 设置 [TextAnalyticsEnabled]
     */
    public void setTextanalyticsenabled(Integer textanalyticsenabled){
        this.textanalyticsenabled = textanalyticsenabled ;
        this.modify("textanalyticsenabled",textanalyticsenabled);
    }
    /**
     * 设置 [HashDeltaSubjectCount]
     */
    public void setHashdeltasubjectcount(Integer hashdeltasubjectcount){
        this.hashdeltasubjectcount = hashdeltasubjectcount ;
        this.modify("hashdeltasubjectcount",hashdeltasubjectcount);
    }
    /**
     * 设置 [ExpireSubscriptionsInDays]
     */
    public void setExpiresubscriptionsindays(Integer expiresubscriptionsindays){
        this.expiresubscriptionsindays = expiresubscriptionsindays ;
        this.modify("expiresubscriptionsindays",expiresubscriptionsindays);
    }
    /**
     * 设置 [KMSettings]
     */
    public void setKmsettings(String kmsettings){
        this.kmsettings = kmsettings ;
        this.modify("kmsettings",kmsettings);
    }
    /**
     * 设置 [PastExpansionWindow]
     */
    public void setPastexpansionwindow(Integer pastexpansionwindow){
        this.pastexpansionwindow = pastexpansionwindow ;
        this.modify("pastexpansionwindow",pastexpansionwindow);
    }
    /**
     * 设置 [YammerOAuthAccessTokenExpired]
     */
    public void setYammeroauthaccesstokenexpired(Integer yammeroauthaccesstokenexpired){
        this.yammeroauthaccesstokenexpired = yammeroauthaccesstokenexpired ;
        this.modify("yammeroauthaccesstokenexpired",yammeroauthaccesstokenexpired);
    }
    /**
     * 设置 [OfficeGraphDelveUrl]
     */
    public void setOfficegraphdelveurl(String officegraphdelveurl){
        this.officegraphdelveurl = officegraphdelveurl ;
        this.modify("officegraphdelveurl",officegraphdelveurl);
    }
    /**
     * 设置 [HighContrastThemeData]
     */
    public void setHighcontrastthemedata(String highcontrastthemedata){
        this.highcontrastthemedata = highcontrastthemedata ;
        this.modify("highcontrastthemedata",highcontrastthemedata);
    }
    /**
     * 设置 [DefaultEmailServerProfileId]
     */
    public void setDefaultemailserverprofileid(String defaultemailserverprofileid){
        this.defaultemailserverprofileid = defaultemailserverprofileid ;
        this.modify("defaultemailserverprofileid",defaultemailserverprofileid);
    }
    /**
     * 设置 [TimeFormatCode]
     */
    public void setTimeformatcode(String timeformatcode){
        this.timeformatcode = timeformatcode ;
        this.modify("timeformatcode",timeformatcode);
    }
    /**
     * 设置 [DecimalSymbol]
     */
    public void setDecimalsymbol(String decimalsymbol){
        this.decimalsymbol = decimalsymbol ;
        this.modify("decimalsymbol",decimalsymbol);
    }
    /**
     * 设置 [MaxRecordsForExportToExcel]
     */
    public void setMaxrecordsforexporttoexcel(Integer maxrecordsforexporttoexcel){
        this.maxrecordsforexporttoexcel = maxrecordsforexporttoexcel ;
        this.modify("maxrecordsforexporttoexcel",maxrecordsforexporttoexcel);
    }
    /**
     * 设置 [MaxVerboseLoggingSyncCycles]
     */
    public void setMaxverboseloggingsynccycles(Integer maxverboseloggingsynccycles){
        this.maxverboseloggingsynccycles = maxverboseloggingsynccycles ;
        this.modify("maxverboseloggingsynccycles",maxverboseloggingsynccycles);
    }
    /**
     * 设置 [SchemaNamePrefix]
     */
    public void setSchemanameprefix(String schemanameprefix){
        this.schemanameprefix = schemanameprefix ;
        this.modify("schemanameprefix",schemanameprefix);
    }
    /**
     * 设置 [RequireApprovalForQueueEmail]
     */
    public void setRequireapprovalforqueueemail(Integer requireapprovalforqueueemail){
        this.requireapprovalforqueueemail = requireapprovalforqueueemail ;
        this.modify("requireapprovalforqueueemail",requireapprovalforqueueemail);
    }
    /**
     * 设置 [ACIWebEndpointUrl]
     */
    public void setAciwebendpointurl(String aciwebendpointurl){
        this.aciwebendpointurl = aciwebendpointurl ;
        this.modify("aciwebendpointurl",aciwebendpointurl);
    }
    /**
     * 设置 [CurrentCampaignNumber]
     */
    public void setCurrentcampaignnumber(Integer currentcampaignnumber){
        this.currentcampaignnumber = currentcampaignnumber ;
        this.modify("currentcampaignnumber",currentcampaignnumber);
    }
    /**
     * 设置 [CurrentKbNumber]
     */
    public void setCurrentkbnumber(Integer currentkbnumber){
        this.currentkbnumber = currentkbnumber ;
        this.modify("currentkbnumber",currentkbnumber);
    }
    /**
     * 设置 [InactivityTimeoutEnabled]
     */
    public void setInactivitytimeoutenabled(Integer inactivitytimeoutenabled){
        this.inactivitytimeoutenabled = inactivitytimeoutenabled ;
        this.modify("inactivitytimeoutenabled",inactivitytimeoutenabled);
    }
    /**
     * 设置 [YammerNetworkPermalink]
     */
    public void setYammernetworkpermalink(String yammernetworkpermalink){
        this.yammernetworkpermalink = yammernetworkpermalink ;
        this.modify("yammernetworkpermalink",yammernetworkpermalink);
    }
    /**
     * 设置 [FiscalPeriodType]
     */
    public void setFiscalperiodtype(Integer fiscalperiodtype){
        this.fiscalperiodtype = fiscalperiodtype ;
        this.modify("fiscalperiodtype",fiscalperiodtype);
    }
    /**
     * 设置 [CurrentOrderNumber]
     */
    public void setCurrentordernumber(Integer currentordernumber){
        this.currentordernumber = currentordernumber ;
        this.modify("currentordernumber",currentordernumber);
    }
    /**
     * 设置 [CurrentCaseNumber]
     */
    public void setCurrentcasenumber(Integer currentcasenumber){
        this.currentcasenumber = currentcasenumber ;
        this.modify("currentcasenumber",currentcasenumber);
    }
    /**
     * 设置 [ExternalPartyCorrelationKeys]
     */
    public void setExternalpartycorrelationkeys(String externalpartycorrelationkeys){
        this.externalpartycorrelationkeys = externalpartycorrelationkeys ;
        this.modify("externalpartycorrelationkeys",externalpartycorrelationkeys);
    }
    /**
     * 设置 [SignupOutlookDownloadFWLink]
     */
    public void setSignupoutlookdownloadfwlink(String signupoutlookdownloadfwlink){
        this.signupoutlookdownloadfwlink = signupoutlookdownloadfwlink ;
        this.modify("signupoutlookdownloadfwlink",signupoutlookdownloadfwlink);
    }
    /**
     * 设置 [FiscalPeriodFormat]
     */
    public void setFiscalperiodformat(String fiscalperiodformat){
        this.fiscalperiodformat = fiscalperiodformat ;
        this.modify("fiscalperiodformat",fiscalperiodformat);
    }
    /**
     * 设置 [AllowMarketingEmailExecution]
     */
    public void setAllowmarketingemailexecution(Integer allowmarketingemailexecution){
        this.allowmarketingemailexecution = allowmarketingemailexecution ;
        this.modify("allowmarketingemailexecution",allowmarketingemailexecution);
    }
    /**
     * 设置 [PrivReportingGroupName]
     */
    public void setPrivreportinggroupname(String privreportinggroupname){
        this.privreportinggroupname = privreportinggroupname ;
        this.modify("privreportinggroupname",privreportinggroupname);
    }
    /**
     * 设置 [FolderAutoCreatedonSP]
     */
    public void setFolderautocreatedonsp(Integer folderautocreatedonsp){
        this.folderautocreatedonsp = folderautocreatedonsp ;
        this.modify("folderautocreatedonsp",folderautocreatedonsp);
    }
    /**
     * 设置 [UserAccessAuditEnabled]
     */
    public void setUseraccessauditenabled(Integer useraccessauditenabled){
        this.useraccessauditenabled = useraccessauditenabled ;
        this.modify("useraccessauditenabled",useraccessauditenabled);
    }
    /**
     * 设置 [SqlAccessGroupId]
     */
    public void setSqlaccessgroupid(String sqlaccessgroupid){
        this.sqlaccessgroupid = sqlaccessgroupid ;
        this.modify("sqlaccessgroupid",sqlaccessgroupid);
    }
    /**
     * 设置 [TrackingTokenIdBase]
     */
    public void setTrackingtokenidbase(Integer trackingtokenidbase){
        this.trackingtokenidbase = trackingtokenidbase ;
        this.modify("trackingtokenidbase",trackingtokenidbase);
    }
    /**
     * 设置 [ContractPrefix]
     */
    public void setContractprefix(String contractprefix){
        this.contractprefix = contractprefix ;
        this.modify("contractprefix",contractprefix);
    }
    /**
     * 设置 [MaxActionStepsInBPF]
     */
    public void setMaxactionstepsinbpf(Integer maxactionstepsinbpf){
        this.maxactionstepsinbpf = maxactionstepsinbpf ;
        this.modify("maxactionstepsinbpf",maxactionstepsinbpf);
    }
    /**
     * 设置 [ActivityAnalysisEnabled]
     */
    public void setActivityanalysisenabled(Integer activityanalysisenabled){
        this.activityanalysisenabled = activityanalysisenabled ;
        this.modify("activityanalysisenabled",activityanalysisenabled);
    }
    /**
     * 设置 [CategoryPrefix]
     */
    public void setCategoryprefix(String categoryprefix){
        this.categoryprefix = categoryprefix ;
        this.modify("categoryprefix",categoryprefix);
    }
    /**
     * 设置 [SlaPauseStates]
     */
    public void setSlapausestates(String slapausestates){
        this.slapausestates = slapausestates ;
        this.modify("slapausestates",slapausestates);
    }
    /**
     * 设置 [OrgDbOrgSettings]
     */
    public void setOrgdborgsettings(String orgdborgsettings){
        this.orgdborgsettings = orgdborgsettings ;
        this.modify("orgdborgsettings",orgdborgsettings);
    }
    /**
     * 设置 [ExternalSearchIndexEnabled]
     */
    public void setExternalsearchindexenabled(Integer externalsearchindexenabled){
        this.externalsearchindexenabled = externalsearchindexenabled ;
        this.modify("externalsearchindexenabled",externalsearchindexenabled);
    }
    /**
     * 设置 [OrganizationState]
     */
    public void setOrganizationstate(String organizationstate){
        this.organizationstate = organizationstate ;
        this.modify("organizationstate",organizationstate);
    }
    /**
     * 设置 [BlockedAttachments]
     */
    public void setBlockedattachments(String blockedattachments){
        this.blockedattachments = blockedattachments ;
        this.modify("blockedattachments",blockedattachments);
    }
    /**
     * 设置 [ParsedTablePrefix]
     */
    public void setParsedtableprefix(String parsedtableprefix){
        this.parsedtableprefix = parsedtableprefix ;
        this.modify("parsedtableprefix",parsedtableprefix);
    }
    /**
     * 设置 [LanguageCode]
     */
    public void setLanguagecode(Integer languagecode){
        this.languagecode = languagecode ;
        this.modify("languagecode",languagecode);
    }
    /**
     * 设置 [TimeSeparator]
     */
    public void setTimeseparator(String timeseparator){
        this.timeseparator = timeseparator ;
        this.modify("timeseparator",timeseparator);
    }
    /**
     * 设置 [MinOutlookSyncInterval]
     */
    public void setMinoutlooksyncinterval(Integer minoutlooksyncinterval){
        this.minoutlooksyncinterval = minoutlooksyncinterval ;
        this.modify("minoutlooksyncinterval",minoutlooksyncinterval);
    }
    /**
     * 设置 [SQMEnabled]
     */
    public void setSqmenabled(Integer sqmenabled){
        this.sqmenabled = sqmenabled ;
        this.modify("sqmenabled",sqmenabled);
    }
    /**
     * 设置 [MicrosoftFlowEnvironment]
     */
    public void setMicrosoftflowenvironment(String microsoftflowenvironment){
        this.microsoftflowenvironment = microsoftflowenvironment ;
        this.modify("microsoftflowenvironment",microsoftflowenvironment);
    }
    /**
     * 设置 [SharePointDeploymentType]
     */
    public void setSharepointdeploymenttype(String sharepointdeploymenttype){
        this.sharepointdeploymenttype = sharepointdeploymenttype ;
        this.modify("sharepointdeploymenttype",sharepointdeploymenttype);
    }
    /**
     * 设置 [AutoApplyDefaultonCaseUpdate]
     */
    public void setAutoapplydefaultoncaseupdate(Integer autoapplydefaultoncaseupdate){
        this.autoapplydefaultoncaseupdate = autoapplydefaultoncaseupdate ;
        this.modify("autoapplydefaultoncaseupdate",autoapplydefaultoncaseupdate);
    }
    /**
     * 设置 [PresenceEnabled]
     */
    public void setPresenceenabled(Integer presenceenabled){
        this.presenceenabled = presenceenabled ;
        this.modify("presenceenabled",presenceenabled);
    }
    /**
     * 设置 [OrgInsightsEnabled]
     */
    public void setOrginsightsenabled(Integer orginsightsenabled){
        this.orginsightsenabled = orginsightsenabled ;
        this.modify("orginsightsenabled",orginsightsenabled);
    }
    /**
     * 设置 [SystemUserId]
     */
    public void setSystemuserid(String systemuserid){
        this.systemuserid = systemuserid ;
        this.modify("systemuserid",systemuserid);
    }
    /**
     * 设置 [MetadataSyncTimestamp]
     */
    public void setMetadatasynctimestamp(BigInteger metadatasynctimestamp){
        this.metadatasynctimestamp = metadatasynctimestamp ;
        this.modify("metadatasynctimestamp",metadatasynctimestamp);
    }
    /**
     * 设置 [ReportingGroupName]
     */
    public void setReportinggroupname(String reportinggroupname){
        this.reportinggroupname = reportinggroupname ;
        this.modify("reportinggroupname",reportinggroupname);
    }
    /**
     * 设置 [GlobalHelpUrlEnabled]
     */
    public void setGlobalhelpurlenabled(Integer globalhelpurlenabled){
        this.globalhelpurlenabled = globalhelpurlenabled ;
        this.modify("globalhelpurlenabled",globalhelpurlenabled);
    }
    /**
     * 设置 [ClientFeatureSet]
     */
    public void setClientfeatureset(String clientfeatureset){
        this.clientfeatureset = clientfeatureset ;
        this.modify("clientfeatureset",clientfeatureset);
    }
    /**
     * 设置 [DelegatedAdminUserId]
     */
    public void setDelegatedadminuserid(String delegatedadminuserid){
        this.delegatedadminuserid = delegatedadminuserid ;
        this.modify("delegatedadminuserid",delegatedadminuserid);
    }
    /**
     * 设置 [PluginTraceLogSetting]
     */
    public void setPlugintracelogsetting(String plugintracelogsetting){
        this.plugintracelogsetting = plugintracelogsetting ;
        this.modify("plugintracelogsetting",plugintracelogsetting);
    }
    /**
     * 设置 [GoalRollupExpiryTime]
     */
    public void setGoalrollupexpirytime(Integer goalrollupexpirytime){
        this.goalrollupexpirytime = goalrollupexpirytime ;
        this.modify("goalrollupexpirytime",goalrollupexpirytime);
    }
    /**
     * 设置 [DisplayNavigationTour]
     */
    public void setDisplaynavigationtour(Integer displaynavigationtour){
        this.displaynavigationtour = displaynavigationtour ;
        this.modify("displaynavigationtour",displaynavigationtour);
    }
    /**
     * 设置 [MaxProductsInBundle]
     */
    public void setMaxproductsinbundle(Integer maxproductsinbundle){
        this.maxproductsinbundle = maxproductsinbundle ;
        this.modify("maxproductsinbundle",maxproductsinbundle);
    }
    /**
     * 设置 [ISVIntegrationCode]
     */
    public void setIsvintegrationcode(String isvintegrationcode){
        this.isvintegrationcode = isvintegrationcode ;
        this.modify("isvintegrationcode",isvintegrationcode);
    }
    /**
     * 设置 [SyncOptInSelectionStatus]
     */
    public void setSyncoptinselectionstatus(String syncoptinselectionstatus){
        this.syncoptinselectionstatus = syncoptinselectionstatus ;
        this.modify("syncoptinselectionstatus",syncoptinselectionstatus);
    }
    /**
     * 设置 [EnablePricingOnCreate]
     */
    public void setEnablepricingoncreate(Integer enablepricingoncreate){
        this.enablepricingoncreate = enablepricingoncreate ;
        this.modify("enablepricingoncreate",enablepricingoncreate);
    }
    /**
     * 设置 [HashFilterKeywords]
     */
    public void setHashfilterkeywords(String hashfilterkeywords){
        this.hashfilterkeywords = hashfilterkeywords ;
        this.modify("hashfilterkeywords",hashfilterkeywords);
    }
    /**
     * 设置 [AMDesignator]
     */
    public void setAmdesignator(String amdesignator){
        this.amdesignator = amdesignator ;
        this.modify("amdesignator",amdesignator);
    }
    /**
     * 设置 [AllowOfflineScheduledSyncs]
     */
    public void setAllowofflinescheduledsyncs(Integer allowofflinescheduledsyncs){
        this.allowofflinescheduledsyncs = allowofflinescheduledsyncs ;
        this.modify("allowofflinescheduledsyncs",allowofflinescheduledsyncs);
    }
    /**
     * 设置 [DefaultMobileOfflineProfileId]
     */
    public void setDefaultmobileofflineprofileid(String defaultmobileofflineprofileid){
        this.defaultmobileofflineprofileid = defaultmobileofflineprofileid ;
        this.modify("defaultmobileofflineprofileid",defaultmobileofflineprofileid);
    }
    /**
     * 设置 [NegativeFormatCode]
     */
    public void setNegativeformatcode(String negativeformatcode){
        this.negativeformatcode = negativeformatcode ;
        this.modify("negativeformatcode",negativeformatcode);
    }
    /**
     * 设置 [BulkOperationPrefix]
     */
    public void setBulkoperationprefix(String bulkoperationprefix){
        this.bulkoperationprefix = bulkoperationprefix ;
        this.modify("bulkoperationprefix",bulkoperationprefix);
    }
    /**
     * 设置 [CurrentContractNumber]
     */
    public void setCurrentcontractnumber(Integer currentcontractnumber){
        this.currentcontractnumber = currentcontractnumber ;
        this.modify("currentcontractnumber",currentcontractnumber);
    }
    /**
     * 设置 [MSTeamsCollaborationEnabled]
     */
    public void setMsteamscollaborationenabled(Integer msteamscollaborationenabled){
        this.msteamscollaborationenabled = msteamscollaborationenabled ;
        this.modify("msteamscollaborationenabled",msteamscollaborationenabled);
    }
    /**
     * 设置 [ExternalFileStorageEnabled]
     */
    public void setExternalfilestorageenabled(Integer externalfilestorageenabled){
        this.externalfilestorageenabled = externalfilestorageenabled ;
        this.modify("externalfilestorageenabled",externalfilestorageenabled);
    }
    /**
     * 设置 [TokenKey]
     */
    public void setTokenkey(String tokenkey){
        this.tokenkey = tokenkey ;
        this.modify("tokenkey",tokenkey);
    }
    /**
     * 设置 [CurrentInvoiceNumber]
     */
    public void setCurrentinvoicenumber(Integer currentinvoicenumber){
        this.currentinvoicenumber = currentinvoicenumber ;
        this.modify("currentinvoicenumber",currentinvoicenumber);
    }
    /**
     * 设置 [SqlAccessGroupName]
     */
    public void setSqlaccessgroupname(String sqlaccessgroupname){
        this.sqlaccessgroupname = sqlaccessgroupname ;
        this.modify("sqlaccessgroupname",sqlaccessgroupname);
    }
    /**
     * 设置 [CurrencyDecimalPrecision]
     */
    public void setCurrencydecimalprecision(Integer currencydecimalprecision){
        this.currencydecimalprecision = currencydecimalprecision ;
        this.modify("currencydecimalprecision",currencydecimalprecision);
    }
    /**
     * 设置 [SessionTimeoutReminderInMins]
     */
    public void setSessiontimeoutreminderinmins(Integer sessiontimeoutreminderinmins){
        this.sessiontimeoutreminderinmins = sessiontimeoutreminderinmins ;
        this.modify("sessiontimeoutreminderinmins",sessiontimeoutreminderinmins);
    }
    /**
     * 设置 [MaximumEntitiesWithActiveSLA]
     */
    public void setMaximumentitieswithactivesla(Integer maximumentitieswithactivesla){
        this.maximumentitieswithactivesla = maximumentitieswithactivesla ;
        this.modify("maximumentitieswithactivesla",maximumentitieswithactivesla);
    }
    /**
     * 设置 [AutoApplySLA]
     */
    public void setAutoapplysla(Integer autoapplysla){
        this.autoapplysla = autoapplysla ;
        this.modify("autoapplysla",autoapplysla);
    }
    /**
     * 设置 [BusinessClosureCalendarId]
     */
    public void setBusinessclosurecalendarid(String businessclosurecalendarid){
        this.businessclosurecalendarid = businessclosurecalendarid ;
        this.modify("businessclosurecalendarid",businessclosurecalendarid);
    }
    /**
     * 设置 [OneDriveEnabled]
     */
    public void setOnedriveenabled(Integer onedriveenabled){
        this.onedriveenabled = onedriveenabled ;
        this.modify("onedriveenabled",onedriveenabled);
    }
    /**
     * 设置 [FiscalYearFormat]
     */
    public void setFiscalyearformat(String fiscalyearformat){
        this.fiscalyearformat = fiscalyearformat ;
        this.modify("fiscalyearformat",fiscalyearformat);
    }
    /**
     * 设置 [MobileOfflineSyncInterval]
     */
    public void setMobileofflinesyncinterval(Integer mobileofflinesyncinterval){
        this.mobileofflinesyncinterval = mobileofflinesyncinterval ;
        this.modify("mobileofflinesyncinterval",mobileofflinesyncinterval);
    }
    /**
     * 设置 [ReferenceSiteMapXml]
     */
    public void setReferencesitemapxml(String referencesitemapxml){
        this.referencesitemapxml = referencesitemapxml ;
        this.modify("referencesitemapxml",referencesitemapxml);
    }
    /**
     * 设置 [SessionTimeoutEnabled]
     */
    public void setSessiontimeoutenabled(Integer sessiontimeoutenabled){
        this.sessiontimeoutenabled = sessiontimeoutenabled ;
        this.modify("sessiontimeoutenabled",sessiontimeoutenabled);
    }
    /**
     * 设置 [CurrentParsedTableNumber]
     */
    public void setCurrentparsedtablenumber(Integer currentparsedtablenumber){
        this.currentparsedtablenumber = currentparsedtablenumber ;
        this.modify("currentparsedtablenumber",currentparsedtablenumber);
    }
    /**
     * 设置 [organizationName]
     */
    public void setOrganizationname(String organizationname){
        this.organizationname = organizationname ;
        this.modify("organizationname",organizationname);
    }
    /**
     * 设置 [NumberGroupFormat]
     */
    public void setNumbergroupformat(String numbergroupformat){
        this.numbergroupformat = numbergroupformat ;
        this.modify("numbergroupformat",numbergroupformat);
    }
    /**
     * 设置 [FeatureSet]
     */
    public void setFeatureset(String featureset){
        this.featureset = featureset ;
        this.modify("featureset",featureset);
    }
    /**
     * 设置 [FiscalCalendarStart]
     */
    public void setFiscalcalendarstart(Timestamp fiscalcalendarstart){
        this.fiscalcalendarstart = fiscalcalendarstart ;
        this.modify("fiscalcalendarstart",fiscalcalendarstart);
    }
    /**
     * 设置 [NumberFormat]
     */
    public void setNumberformat(String numberformat){
        this.numberformat = numberformat ;
        this.modify("numberformat",numberformat);
    }
    /**
     * 设置 [InactivityTimeoutInMins]
     */
    public void setInactivitytimeoutinmins(Integer inactivitytimeoutinmins){
        this.inactivitytimeoutinmins = inactivitytimeoutinmins ;
        this.modify("inactivitytimeoutinmins",inactivitytimeoutinmins);
    }
    /**
     * 设置 [EmailMonitoringAllowed]
     */
    public void setEmailmonitoringallowed(Integer emailmonitoringallowed){
        this.emailmonitoringallowed = emailmonitoringallowed ;
        this.modify("emailmonitoringallowed",emailmonitoringallowed);
    }
    /**
     * 设置 [FiscalYearPeriodConnect]
     */
    public void setFiscalyearperiodconnect(String fiscalyearperiodconnect){
        this.fiscalyearperiodconnect = fiscalyearperiodconnect ;
        this.modify("fiscalyearperiodconnect",fiscalyearperiodconnect);
    }
    /**
     * 设置 [DuplicateDetectionEnabled]
     */
    public void setDuplicatedetectionenabled(Integer duplicatedetectionenabled){
        this.duplicatedetectionenabled = duplicatedetectionenabled ;
        this.modify("duplicatedetectionenabled",duplicatedetectionenabled);
    }
    /**
     * 设置 [SocialInsightsEnabled]
     */
    public void setSocialinsightsenabled(Integer socialinsightsenabled){
        this.socialinsightsenabled = socialinsightsenabled ;
        this.modify("socialinsightsenabled",socialinsightsenabled);
    }
    /**
     * 设置 [DefaultRecurrenceEndRangeType]
     */
    public void setDefaultrecurrenceendrangetype(String defaultrecurrenceendrangetype){
        this.defaultrecurrenceendrangetype = defaultrecurrenceendrangetype ;
        this.modify("defaultrecurrenceendrangetype",defaultrecurrenceendrangetype);
    }
    /**
     * 设置 [DefaultCountryCode]
     */
    public void setDefaultcountrycode(String defaultcountrycode){
        this.defaultcountrycode = defaultcountrycode ;
        this.modify("defaultcountrycode",defaultcountrycode);
    }
    /**
     * 设置 [PreviewEnabledForActionCard]
     */
    public void setPreviewenabledforactioncard(Integer previewenabledforactioncard){
        this.previewenabledforactioncard = previewenabledforactioncard ;
        this.modify("previewenabledforactioncard",previewenabledforactioncard);
    }
    /**
     * 设置 [FiscalYearFormatYear]
     */
    public void setFiscalyearformatyear(String fiscalyearformatyear){
        this.fiscalyearformatyear = fiscalyearformatyear ;
        this.modify("fiscalyearformatyear",fiscalyearformatyear);
    }
    /**
     * 设置 [DefaultCountryCodeCheckEnabled]
     */
    public void setDefaultcountrycodecheckenabled(Integer defaultcountrycodecheckenabled){
        this.defaultcountrycodecheckenabled = defaultcountrycodecheckenabled ;
        this.modify("defaultcountrycodecheckenabled",defaultcountrycodecheckenabled);
    }
    /**
     * 设置 [FutureExpansionWindow]
     */
    public void setFutureexpansionwindow(Integer futureexpansionwindow){
        this.futureexpansionwindow = futureexpansionwindow ;
        this.modify("futureexpansionwindow",futureexpansionwindow);
    }
    /**
     * 设置 [RestrictStatusUpdate]
     */
    public void setRestrictstatusupdate(Integer restrictstatusupdate){
        this.restrictstatusupdate = restrictstatusupdate ;
        this.modify("restrictstatusupdate",restrictstatusupdate);
    }
    /**
     * 设置 [CurrentImportSequenceNumber]
     */
    public void setCurrentimportsequencenumber(Integer currentimportsequencenumber){
        this.currentimportsequencenumber = currentimportsequencenumber ;
        this.modify("currentimportsequencenumber",currentimportsequencenumber);
    }
    /**
     * 设置 [SampleDataImportId]
     */
    public void setSampledataimportid(String sampledataimportid){
        this.sampledataimportid = sampledataimportid ;
        this.modify("sampledataimportid",sampledataimportid);
    }
    /**
     * 设置 [AuditEnabled]
     */
    public void setAuditenabled(Integer auditenabled){
        this.auditenabled = auditenabled ;
        this.modify("auditenabled",auditenabled);
    }
    /**
     * 设置 [AllowAutoUnsubscribe]
     */
    public void setAllowautounsubscribe(Integer allowautounsubscribe){
        this.allowautounsubscribe = allowautounsubscribe ;
        this.modify("allowautounsubscribe",allowautounsubscribe);
    }
    /**
     * 设置 [SchedulingEngine]
     */
    public void setSchedulingengine(String schedulingengine){
        this.schedulingengine = schedulingengine ;
        this.modify("schedulingengine",schedulingengine);
    }
    /**
     * 设置 [MSTeamsEnabled]
     */
    public void setMsteamsenabled(Integer msteamsenabled){
        this.msteamsenabled = msteamsenabled ;
        this.modify("msteamsenabled",msteamsenabled);
    }
    /**
     * 设置 [EnableSmartMatching]
     */
    public void setEnablesmartmatching(Integer enablesmartmatching){
        this.enablesmartmatching = enablesmartmatching ;
        this.modify("enablesmartmatching",enablesmartmatching);
    }
    /**
     * 设置 [OrderPrefix]
     */
    public void setOrderprefix(String orderprefix){
        this.orderprefix = orderprefix ;
        this.modify("orderprefix",orderprefix);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [PreviewForAutoCaptureEnabled]
     */
    public void setPreviewforautocaptureenabled(Integer previewforautocaptureenabled){
        this.previewforautocaptureenabled = previewforautocaptureenabled ;
        this.modify("previewforautocaptureenabled",previewforautocaptureenabled);
    }
    /**
     * 设置 [DefaultCrmCustomName]
     */
    public void setDefaultcrmcustomname(String defaultcrmcustomname){
        this.defaultcrmcustomname = defaultcrmcustomname ;
        this.modify("defaultcrmcustomname",defaultcrmcustomname);
    }
    /**
     * 设置 [DateFormatCode]
     */
    public void setDateformatcode(String dateformatcode){
        this.dateformatcode = dateformatcode ;
        this.modify("dateformatcode",dateformatcode);
    }
    /**
     * 设置 [ReportScriptErrors]
     */
    public void setReportscripterrors(String reportscripterrors){
        this.reportscripterrors = reportscripterrors ;
        this.modify("reportscripterrors",reportscripterrors);
    }
    /**
     * 设置 [OfficeGraphEnabled]
     */
    public void setOfficegraphenabled(Integer officegraphenabled){
        this.officegraphenabled = officegraphenabled ;
        this.modify("officegraphenabled",officegraphenabled);
    }
    /**
     * 设置 [EnabledForAllRoles]
     */
    public void setEnabledforallroles(Integer enabledforallroles){
        this.enabledforallroles = enabledforallroles ;
        this.modify("enabledforallroles",enabledforallroles);
    }
    /**
     * 设置 [TrackingTokenIdDigits]
     */
    public void setTrackingtokeniddigits(Integer trackingtokeniddigits){
        this.trackingtokeniddigits = trackingtokeniddigits ;
        this.modify("trackingtokeniddigits",trackingtokeniddigits);
    }
    /**
     * 设置 [DisableSocialCare]
     */
    public void setDisablesocialcare(Integer disablesocialcare){
        this.disablesocialcare = disablesocialcare ;
        this.modify("disablesocialcare",disablesocialcare);
    }
    /**
     * 设置 [EnforceReadOnlyPlugins]
     */
    public void setEnforcereadonlyplugins(Integer enforcereadonlyplugins){
        this.enforcereadonlyplugins = enforcereadonlyplugins ;
        this.modify("enforcereadonlyplugins",enforcereadonlyplugins);
    }
    /**
     * 设置 [DateSeparator]
     */
    public void setDateseparator(String dateseparator){
        this.dateseparator = dateseparator ;
        this.modify("dateseparator",dateseparator);
    }
    /**
     * 设置 [SuppressSLA]
     */
    public void setSuppresssla(Integer suppresssla){
        this.suppresssla = suppresssla ;
        this.modify("suppresssla",suppresssla);
    }
    /**
     * 设置 [UserAccessAuditingInterval]
     */
    public void setUseraccessauditinginterval(Integer useraccessauditinginterval){
        this.useraccessauditinginterval = useraccessauditinginterval ;
        this.modify("useraccessauditinginterval",useraccessauditinginterval);
    }
    /**
     * 设置 [LongDateFormatCode]
     */
    public void setLongdateformatcode(Integer longdateformatcode){
        this.longdateformatcode = longdateformatcode ;
        this.modify("longdateformatcode",longdateformatcode);
    }
    /**
     * 设置 [UseReadForm]
     */
    public void setUsereadform(Integer usereadform){
        this.usereadform = usereadform ;
        this.modify("usereadform",usereadform);
    }
    /**
     * 设置 [AllowLegacyClientExperience]
     */
    public void setAllowlegacyclientexperience(Integer allowlegacyclientexperience){
        this.allowlegacyclientexperience = allowlegacyclientexperience ;
        this.modify("allowlegacyclientexperience",allowlegacyclientexperience);
    }
    /**
     * 设置 [SyncOptInSelection]
     */
    public void setSyncoptinselection(Integer syncoptinselection){
        this.syncoptinselection = syncoptinselection ;
        this.modify("syncoptinselection",syncoptinselection);
    }
    /**
     * 设置 [MSTeamsSettingChangedByUser]
     */
    public void setMsteamssettingchangedbyuser(Integer msteamssettingchangedbyuser){
        this.msteamssettingchangedbyuser = msteamssettingchangedbyuser ;
        this.modify("msteamssettingchangedbyuser",msteamssettingchangedbyuser);
    }
    /**
     * 设置 [AllowOutlookScheduledSyncs]
     */
    public void setAllowoutlookscheduledsyncs(Integer allowoutlookscheduledsyncs){
        this.allowoutlookscheduledsyncs = allowoutlookscheduledsyncs ;
        this.modify("allowoutlookscheduledsyncs",allowoutlookscheduledsyncs);
    }
    /**
     * 设置 [CurrencyFormatCode]
     */
    public void setCurrencyformatcode(String currencyformatcode){
        this.currencyformatcode = currencyformatcode ;
        this.modify("currencyformatcode",currencyformatcode);
    }
    /**
     * 设置 [SiteMapXml]
     */
    public void setSitemapxml(String sitemapxml){
        this.sitemapxml = sitemapxml ;
        this.modify("sitemapxml",sitemapxml);
    }
    /**
     * 设置 [V3CalloutConfigHash]
     */
    public void setV3calloutconfighash(String v3calloutconfighash){
        this.v3calloutconfighash = v3calloutconfighash ;
        this.modify("v3calloutconfighash",v3calloutconfighash);
    }
    /**
     * 设置 [YammerPostMethod]
     */
    public void setYammerpostmethod(String yammerpostmethod){
        this.yammerpostmethod = yammerpostmethod ;
        this.modify("yammerpostmethod",yammerpostmethod);
    }
    /**
     * 设置 [CampaignPrefix]
     */
    public void setCampaignprefix(String campaignprefix){
        this.campaignprefix = campaignprefix ;
        this.modify("campaignprefix",campaignprefix);
    }
    /**
     * 设置 [UsePositionHierarchy]
     */
    public void setUsepositionhierarchy(Integer usepositionhierarchy){
        this.usepositionhierarchy = usepositionhierarchy ;
        this.modify("usepositionhierarchy",usepositionhierarchy);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [AllowUserFormModePreference]
     */
    public void setAllowuserformmodepreference(Integer allowuserformmodepreference){
        this.allowuserformmodepreference = allowuserformmodepreference ;
        this.modify("allowuserformmodepreference",allowuserformmodepreference);
    }
    /**
     * 设置 [FolderBasedTrackingEnabled]
     */
    public void setFolderbasedtrackingenabled(Integer folderbasedtrackingenabled){
        this.folderbasedtrackingenabled = folderbasedtrackingenabled ;
        this.modify("folderbasedtrackingenabled",folderbasedtrackingenabled);
    }
    /**
     * 设置 [FiscalSettingsUpdated]
     */
    public void setFiscalsettingsupdated(Integer fiscalsettingsupdated){
        this.fiscalsettingsupdated = fiscalsettingsupdated ;
        this.modify("fiscalsettingsupdated",fiscalsettingsupdated);
    }
    /**
     * 设置 [GrantAccessToNetworkService]
     */
    public void setGrantaccesstonetworkservice(Integer grantaccesstonetworkservice){
        this.grantaccesstonetworkservice = grantaccesstonetworkservice ;
        this.modify("grantaccesstonetworkservice",grantaccesstonetworkservice);
    }
    /**
     * 设置 [RelationshipInsightsEnabled]
     */
    public void setRelationshipinsightsenabled(Integer relationshipinsightsenabled){
        this.relationshipinsightsenabled = relationshipinsightsenabled ;
        this.modify("relationshipinsightsenabled",relationshipinsightsenabled);
    }
    /**
     * 设置 [AllowWebExcelExport]
     */
    public void setAllowwebexcelexport(Integer allowwebexcelexport){
        this.allowwebexcelexport = allowwebexcelexport ;
        this.modify("allowwebexcelexport",allowwebexcelexport);
    }
    /**
     * 设置 [WeekStartDayCode]
     */
    public void setWeekstartdaycode(String weekstartdaycode){
        this.weekstartdaycode = weekstartdaycode ;
        this.modify("weekstartdaycode",weekstartdaycode);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [SyncBulkOperationBatchSize]
     */
    public void setSyncbulkoperationbatchsize(Integer syncbulkoperationbatchsize){
        this.syncbulkoperationbatchsize = syncbulkoperationbatchsize ;
        this.modify("syncbulkoperationbatchsize",syncbulkoperationbatchsize);
    }
    /**
     * 设置 [SocialInsightsInstance]
     */
    public void setSocialinsightsinstance(String socialinsightsinstance){
        this.socialinsightsinstance = socialinsightsinstance ;
        this.modify("socialinsightsinstance",socialinsightsinstance);
    }
    /**
     * 设置 [FullTextSearchEnabled]
     */
    public void setFulltextsearchenabled(Integer fulltextsearchenabled){
        this.fulltextsearchenabled = fulltextsearchenabled ;
        this.modify("fulltextsearchenabled",fulltextsearchenabled);
    }
    /**
     * 设置 [MaxVerboseLoggingMailbox]
     */
    public void setMaxverboseloggingmailbox(Integer maxverboseloggingmailbox){
        this.maxverboseloggingmailbox = maxverboseloggingmailbox ;
        this.modify("maxverboseloggingmailbox",maxverboseloggingmailbox);
    }
    /**
     * 设置 [PrivReportingGroupId]
     */
    public void setPrivreportinggroupid(String privreportinggroupid){
        this.privreportinggroupid = privreportinggroupid ;
        this.modify("privreportinggroupid",privreportinggroupid);
    }
    /**
     * 设置 [TextWrapEnabled]
     */
    public void setTextwrapenabled(Integer textwrapenabled){
        this.textwrapenabled = textwrapenabled ;
        this.modify("textwrapenabled",textwrapenabled);
    }
    /**
     * 设置 [DisabledReason]
     */
    public void setDisabledreason(String disabledreason){
        this.disabledreason = disabledreason ;
        this.modify("disabledreason",disabledreason);
    }
    /**
     * 设置 [TagMaxAggressiveCycles]
     */
    public void setTagmaxaggressivecycles(Integer tagmaxaggressivecycles){
        this.tagmaxaggressivecycles = tagmaxaggressivecycles ;
        this.modify("tagmaxaggressivecycles",tagmaxaggressivecycles);
    }
    /**
     * 设置 [GenerateAlertsForWarnings]
     */
    public void setGeneratealertsforwarnings(Integer generatealertsforwarnings){
        this.generatealertsforwarnings = generatealertsforwarnings ;
        this.modify("generatealertsforwarnings",generatealertsforwarnings);
    }
    /**
     * 设置 [KaPrefix]
     */
    public void setKaprefix(String kaprefix){
        this.kaprefix = kaprefix ;
        this.modify("kaprefix",kaprefix);
    }
    /**
     * 设置 [InitialVersion]
     */
    public void setInitialversion(String initialversion){
        this.initialversion = initialversion ;
        this.modify("initialversion",initialversion);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [ParsedTableColumnPrefix]
     */
    public void setParsedtablecolumnprefix(String parsedtablecolumnprefix){
        this.parsedtablecolumnprefix = parsedtablecolumnprefix ;
        this.modify("parsedtablecolumnprefix",parsedtablecolumnprefix);
    }
    /**
     * 设置 [ShowWeekNumber]
     */
    public void setShowweeknumber(Integer showweeknumber){
        this.showweeknumber = showweeknumber ;
        this.modify("showweeknumber",showweeknumber);
    }
    /**
     * 设置 [ProductRecommendationsEnabled]
     */
    public void setProductrecommendationsenabled(Integer productrecommendationsenabled){
        this.productrecommendationsenabled = productrecommendationsenabled ;
        this.modify("productrecommendationsenabled",productrecommendationsenabled);
    }
    /**
     * 设置 [EmailCorrelationEnabled]
     */
    public void setEmailcorrelationenabled(Integer emailcorrelationenabled){
        this.emailcorrelationenabled = emailcorrelationenabled ;
        this.modify("emailcorrelationenabled",emailcorrelationenabled);
    }
    /**
     * 设置 [IntegrationUserId]
     */
    public void setIntegrationuserid(String integrationuserid){
        this.integrationuserid = integrationuserid ;
        this.modify("integrationuserid",integrationuserid);
    }
    /**
     * 设置 [HashMaxCount]
     */
    public void setHashmaxcount(Integer hashmaxcount){
        this.hashmaxcount = hashmaxcount ;
        this.modify("hashmaxcount",hashmaxcount);
    }
    /**
     * 设置 [QuotePrefix]
     */
    public void setQuoteprefix(String quoteprefix){
        this.quoteprefix = quoteprefix ;
        this.modify("quoteprefix",quoteprefix);
    }
    /**
     * 设置 [CasePrefix]
     */
    public void setCaseprefix(String caseprefix){
        this.caseprefix = caseprefix ;
        this.modify("caseprefix",caseprefix);
    }
    /**
     * 设置 [PinpointLanguageCode]
     */
    public void setPinpointlanguagecode(Integer pinpointlanguagecode){
        this.pinpointlanguagecode = pinpointlanguagecode ;
        this.modify("pinpointlanguagecode",pinpointlanguagecode);
    }
    /**
     * 设置 [NegativeCurrencyFormatCode]
     */
    public void setNegativecurrencyformatcode(Integer negativecurrencyformatcode){
        this.negativecurrencyformatcode = negativecurrencyformatcode ;
        this.modify("negativecurrencyformatcode",negativecurrencyformatcode);
    }
    /**
     * 设置 [GetStartedPaneContentEnabled]
     */
    public void setGetstartedpanecontentenabled(Integer getstartedpanecontentenabled){
        this.getstartedpanecontentenabled = getstartedpanecontentenabled ;
        this.modify("getstartedpanecontentenabled",getstartedpanecontentenabled);
    }
    /**
     * 设置 [MaximumTrackingNumber]
     */
    public void setMaximumtrackingnumber(Integer maximumtrackingnumber){
        this.maximumtrackingnumber = maximumtrackingnumber ;
        this.modify("maximumtrackingnumber",maximumtrackingnumber);
    }
    /**
     * 设置 [FiscalYearFormatPrefix]
     */
    public void setFiscalyearformatprefix(String fiscalyearformatprefix){
        this.fiscalyearformatprefix = fiscalyearformatprefix ;
        this.modify("fiscalyearformatprefix",fiscalyearformatprefix);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [NumberSeparator]
     */
    public void setNumberseparator(String numberseparator){
        this.numberseparator = numberseparator ;
        this.modify("numberseparator",numberseparator);
    }
    /**
     * 设置 [InvoicePrefix]
     */
    public void setInvoiceprefix(String invoiceprefix){
        this.invoiceprefix = invoiceprefix ;
        this.modify("invoiceprefix",invoiceprefix);
    }
    /**
     * 设置 [AutoApplyDefaultonCaseCreate]
     */
    public void setAutoapplydefaultoncasecreate(Integer autoapplydefaultoncasecreate){
        this.autoapplydefaultoncasecreate = autoapplydefaultoncasecreate ;
        this.modify("autoapplydefaultoncasecreate",autoapplydefaultoncasecreate);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [PrivilegeUserGroupId]
     */
    public void setPrivilegeusergroupid(String privilegeusergroupid){
        this.privilegeusergroupid = privilegeusergroupid ;
        this.modify("privilegeusergroupid",privilegeusergroupid);
    }
    /**
     * 设置 [IgnoreInternalEmail]
     */
    public void setIgnoreinternalemail(Integer ignoreinternalemail){
        this.ignoreinternalemail = ignoreinternalemail ;
        this.modify("ignoreinternalemail",ignoreinternalemail);
    }
    /**
     * 设置 [CurrencyDisplayOption]
     */
    public void setCurrencydisplayoption(String currencydisplayoption){
        this.currencydisplayoption = currencydisplayoption ;
        this.modify("currencydisplayoption",currencydisplayoption);
    }
    /**
     * 设置 [DefaultThemeData]
     */
    public void setDefaultthemedata(String defaultthemedata){
        this.defaultthemedata = defaultthemedata ;
        this.modify("defaultthemedata",defaultthemedata);
    }
    /**
     * 设置 [CurrentKaNumber]
     */
    public void setCurrentkanumber(Integer currentkanumber){
        this.currentkanumber = currentkanumber ;
        this.modify("currentkanumber",currentkanumber);
    }
    /**
     * 设置 [SortId]
     */
    public void setSortid(Integer sortid){
        this.sortid = sortid ;
        this.modify("sortid",sortid);
    }
    /**
     * 设置 [BingMapsApiKey]
     */
    public void setBingmapsapikey(String bingmapsapikey){
        this.bingmapsapikey = bingmapsapikey ;
        this.modify("bingmapsapikey",bingmapsapikey);
    }
    /**
     * 设置 [GlobalHelpUrl]
     */
    public void setGlobalhelpurl(String globalhelpurl){
        this.globalhelpurl = globalhelpurl ;
        this.modify("globalhelpurl",globalhelpurl);
    }
    /**
     * 设置 [CascadeStatusUpdate]
     */
    public void setCascadestatusupdate(Integer cascadestatusupdate){
        this.cascadestatusupdate = cascadestatusupdate ;
        this.modify("cascadestatusupdate",cascadestatusupdate);
    }
    /**
     * 设置 [Picture]
     */
    public void setPicture(String picture){
        this.picture = picture ;
        this.modify("picture",picture);
    }
    /**
     * 设置 [TagPollingPeriod]
     */
    public void setTagpollingperiod(Integer tagpollingperiod){
        this.tagpollingperiod = tagpollingperiod ;
        this.modify("tagpollingperiod",tagpollingperiod);
    }
    /**
     * 设置 [ExpireChangeTrackingInDays]
     */
    public void setExpirechangetrackingindays(Integer expirechangetrackingindays){
        this.expirechangetrackingindays = expirechangetrackingindays ;
        this.modify("expirechangetrackingindays",expirechangetrackingindays);
    }
    /**
     * 设置 [TrackingPrefix]
     */
    public void setTrackingprefix(String trackingprefix){
        this.trackingprefix = trackingprefix ;
        this.modify("trackingprefix",trackingprefix);
    }
    /**
     * 设置 [FiscalYearDisplayCode]
     */
    public void setFiscalyeardisplaycode(Integer fiscalyeardisplaycode){
        this.fiscalyeardisplaycode = fiscalyeardisplaycode ;
        this.modify("fiscalyeardisplaycode",fiscalyeardisplaycode);
    }
    /**
     * 设置 [MaxUploadFileSize]
     */
    public void setMaxuploadfilesize(Integer maxuploadfilesize){
        this.maxuploadfilesize = maxuploadfilesize ;
        this.modify("maxuploadfilesize",maxuploadfilesize);
    }
    /**
     * 设置 [ActionCardEnabled]
     */
    public void setActioncardenabled(Integer actioncardenabled){
        this.actioncardenabled = actioncardenabled ;
        this.modify("actioncardenabled",actioncardenabled);
    }
    /**
     * 设置 [SessionTimeoutInMins]
     */
    public void setSessiontimeoutinmins(Integer sessiontimeoutinmins){
        this.sessiontimeoutinmins = sessiontimeoutinmins ;
        this.modify("sessiontimeoutinmins",sessiontimeoutinmins);
    }
    /**
     * 设置 [SyncBulkOperationMaxLimit]
     */
    public void setSyncbulkoperationmaxlimit(Integer syncbulkoperationmaxlimit){
        this.syncbulkoperationmaxlimit = syncbulkoperationmaxlimit ;
        this.modify("syncbulkoperationmaxlimit",syncbulkoperationmaxlimit);
    }
    /**
     * 设置 [MailboxForcedUnlockingEnabled]
     */
    public void setMailboxforcedunlockingenabled(Integer mailboxforcedunlockingenabled){
        this.mailboxforcedunlockingenabled = mailboxforcedunlockingenabled ;
        this.modify("mailboxforcedunlockingenabled",mailboxforcedunlockingenabled);
    }
    /**
     * 设置 [BaseCurrencyPrecision]
     */
    public void setBasecurrencyprecision(Integer basecurrencyprecision){
        this.basecurrencyprecision = basecurrencyprecision ;
        this.modify("basecurrencyprecision",basecurrencyprecision);
    }
    /**
     * 设置 [MinAddressBookSyncInterval]
     */
    public void setMinaddressbooksyncinterval(Integer minaddressbooksyncinterval){
        this.minaddressbooksyncinterval = minaddressbooksyncinterval ;
        this.modify("minaddressbooksyncinterval",minaddressbooksyncinterval);
    }
    /**
     * 设置 [EnableBingMapsIntegration]
     */
    public void setEnablebingmapsintegration(Integer enablebingmapsintegration){
        this.enablebingmapsintegration = enablebingmapsintegration ;
        this.modify("enablebingmapsintegration",enablebingmapsintegration);
    }
    /**
     * 设置 [MailboxInactiveBackoffEnabled]
     */
    public void setMailboxinactivebackoffenabled(Integer mailboxinactivebackoffenabled){
        this.mailboxinactivebackoffenabled = mailboxinactivebackoffenabled ;
        this.modify("mailboxinactivebackoffenabled",mailboxinactivebackoffenabled);
    }
    /**
     * 设置 [QuickFindRecordLimitEnabled]
     */
    public void setQuickfindrecordlimitenabled(Integer quickfindrecordlimitenabled){
        this.quickfindrecordlimitenabled = quickfindrecordlimitenabled ;
        this.modify("quickfindrecordlimitenabled",quickfindrecordlimitenabled);
    }
    /**
     * 设置 [FiscalPeriodFormatPeriod]
     */
    public void setFiscalperiodformatperiod(String fiscalperiodformatperiod){
        this.fiscalperiodformatperiod = fiscalperiodformatperiod ;
        this.modify("fiscalperiodformatperiod",fiscalperiodformatperiod);
    }
    /**
     * 设置 [KbPrefix]
     */
    public void setKbprefix(String kbprefix){
        this.kbprefix = kbprefix ;
        this.modify("kbprefix",kbprefix);
    }
    /**
     * 设置 [PMDesignator]
     */
    public void setPmdesignator(String pmdesignator){
        this.pmdesignator = pmdesignator ;
        this.modify("pmdesignator",pmdesignator);
    }
    /**
     * 设置 [AcknowledgementTemplateId]
     */
    public void setAcknowledgementtemplateid(String acknowledgementtemplateid){
        this.acknowledgementtemplateid = acknowledgementtemplateid ;
        this.modify("acknowledgementtemplateid",acknowledgementtemplateid);
    }
    /**
     * 设置 [BaseCurrencyId]
     */
    public void setBasecurrencyid(String basecurrencyid){
        this.basecurrencyid = basecurrencyid ;
        this.modify("basecurrencyid",basecurrencyid);
    }

}


