package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[个人文档模板]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "PERSONALDOCUMENTTEMPLATE",resultMap = "PersonalDocumentTemplateResultMap")
public class PersonalDocumentTemplate extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * LanguageCode
     */
    @TableField(value = "languagecode")
    @JSONField(name = "languagecode")
    @JsonProperty("languagecode")
    private Integer languagecode;
    /**
     * Content
     */
    @TableField(value = "content")
    @JSONField(name = "content")
    @JsonProperty("content")
    private String content;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * ClientData
     */
    @TableField(value = "clientdata")
    @JSONField(name = "clientdata")
    @JsonProperty("clientdata")
    private String clientdata;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * DocumentType
     */
    @TableField(value = "documenttype")
    @JSONField(name = "documenttype")
    @JsonProperty("documenttype")
    private String documenttype;
    /**
     * AssociatedEntityTypeCode
     */
    @TableField(value = "associatedentitytypecode")
    @JSONField(name = "associatedentitytypecode")
    @JsonProperty("associatedentitytypecode")
    private String associatedentitytypecode;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * personaldocumenttemplateName
     */
    @TableField(value = "personaldocumenttemplatename")
    @JSONField(name = "personaldocumenttemplatename")
    @JsonProperty("personaldocumenttemplatename")
    private String personaldocumenttemplatename;
    /**
     * PersonalDocumentTemplateId
     */
    @DEField(isKeyField=true)
    @TableId(value= "personaldocumenttemplateid",type=IdType.UUID)
    @JSONField(name = "personaldocumenttemplateid")
    @JsonProperty("personaldocumenttemplateid")
    private String personaldocumenttemplateid;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * Status
     */
    @DEField(defaultValue = "False")
    @TableField(value = "status")
    @JSONField(name = "status")
    @JsonProperty("status")
    private Integer status;



    /**
     * 设置 [LanguageCode]
     */
    public void setLanguagecode(Integer languagecode){
        this.languagecode = languagecode ;
        this.modify("languagecode",languagecode);
    }
    /**
     * 设置 [Content]
     */
    public void setContent(String content){
        this.content = content ;
        this.modify("content",content);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [ClientData]
     */
    public void setClientdata(String clientdata){
        this.clientdata = clientdata ;
        this.modify("clientdata",clientdata);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [DocumentType]
     */
    public void setDocumenttype(String documenttype){
        this.documenttype = documenttype ;
        this.modify("documenttype",documenttype);
    }
    /**
     * 设置 [AssociatedEntityTypeCode]
     */
    public void setAssociatedentitytypecode(String associatedentitytypecode){
        this.associatedentitytypecode = associatedentitytypecode ;
        this.modify("associatedentitytypecode",associatedentitytypecode);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [personaldocumenttemplateName]
     */
    public void setPersonaldocumenttemplatename(String personaldocumenttemplatename){
        this.personaldocumenttemplatename = personaldocumenttemplatename ;
        this.modify("personaldocumenttemplatename",personaldocumenttemplatename);
    }
    /**
     * 设置 [Status]
     */
    public void setStatus(Integer status){
        this.status = status ;
        this.modify("status",status);
    }

}


