package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[邮件]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "POST",resultMap = "PostResultMap")
public class Post extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * Type
     */
    @TableField(value = "type")
    @JSONField(name = "type")
    @JsonProperty("type")
    private String type;
    /**
     * RegardingObjectIdYomiName
     */
    @TableField(value = "regardingobjectidyominame")
    @JSONField(name = "regardingobjectidyominame")
    @JsonProperty("regardingobjectidyominame")
    private String regardingobjectidyominame;
    /**
     * RegardingObjectOwnerId
     */
    @TableField(value = "regardingobjectownerid")
    @JSONField(name = "regardingobjectownerid")
    @JsonProperty("regardingobjectownerid")
    private String regardingobjectownerid;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * RegardingObjectIdName
     */
    @TableField(value = "regardingobjectidname")
    @JSONField(name = "regardingobjectidname")
    @JsonProperty("regardingobjectidname")
    private String regardingobjectidname;
    /**
     * PostId
     */
    @DEField(isKeyField=true)
    @TableId(value= "postid",type=IdType.UUID)
    @JSONField(name = "postid")
    @JsonProperty("postid")
    private String postid;
    /**
     * PostToYammer
     */
    @DEField(defaultValue = "False")
    @TableField(value = "posttoyammer")
    @JSONField(name = "posttoyammer")
    @JsonProperty("posttoyammer")
    private Integer posttoyammer;
    /**
     * RegardingObjectTypeCode
     */
    @TableField(value = "regardingobjecttypecode")
    @JSONField(name = "regardingobjecttypecode")
    @JsonProperty("regardingobjecttypecode")
    private String regardingobjecttypecode;
    /**
     * RegardingObjectId
     */
    @TableField(value = "regardingobjectid")
    @JSONField(name = "regardingobjectid")
    @JsonProperty("regardingobjectid")
    private String regardingobjectid;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * Text
     */
    @TableField(value = "text")
    @JSONField(name = "text")
    @JsonProperty("text")
    private String text;
    /**
     * RegardingObjectOwnerIdType
     */
    @TableField(value = "regardingobjectowneridtype")
    @JSONField(name = "regardingobjectowneridtype")
    @JsonProperty("regardingobjectowneridtype")
    private String regardingobjectowneridtype;
    /**
     * YammerRetryCount
     */
    @TableField(value = "yammerretrycount")
    @JSONField(name = "yammerretrycount")
    @JsonProperty("yammerretrycount")
    private Integer yammerretrycount;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * YammerPostState
     */
    @TableField(value = "yammerpoststate")
    @JSONField(name = "yammerpoststate")
    @JsonProperty("yammerpoststate")
    private Integer yammerpoststate;
    /**
     * Source
     */
    @TableField(value = "source")
    @JSONField(name = "source")
    @JsonProperty("source")
    private String source;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;



    /**
     * 设置 [Type]
     */
    public void setType(String type){
        this.type = type ;
        this.modify("type",type);
    }
    /**
     * 设置 [RegardingObjectIdYomiName]
     */
    public void setRegardingobjectidyominame(String regardingobjectidyominame){
        this.regardingobjectidyominame = regardingobjectidyominame ;
        this.modify("regardingobjectidyominame",regardingobjectidyominame);
    }
    /**
     * 设置 [RegardingObjectOwnerId]
     */
    public void setRegardingobjectownerid(String regardingobjectownerid){
        this.regardingobjectownerid = regardingobjectownerid ;
        this.modify("regardingobjectownerid",regardingobjectownerid);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [RegardingObjectIdName]
     */
    public void setRegardingobjectidname(String regardingobjectidname){
        this.regardingobjectidname = regardingobjectidname ;
        this.modify("regardingobjectidname",regardingobjectidname);
    }
    /**
     * 设置 [PostToYammer]
     */
    public void setPosttoyammer(Integer posttoyammer){
        this.posttoyammer = posttoyammer ;
        this.modify("posttoyammer",posttoyammer);
    }
    /**
     * 设置 [RegardingObjectTypeCode]
     */
    public void setRegardingobjecttypecode(String regardingobjecttypecode){
        this.regardingobjecttypecode = regardingobjecttypecode ;
        this.modify("regardingobjecttypecode",regardingobjecttypecode);
    }
    /**
     * 设置 [RegardingObjectId]
     */
    public void setRegardingobjectid(String regardingobjectid){
        this.regardingobjectid = regardingobjectid ;
        this.modify("regardingobjectid",regardingobjectid);
    }
    /**
     * 设置 [Text]
     */
    public void setText(String text){
        this.text = text ;
        this.modify("text",text);
    }
    /**
     * 设置 [RegardingObjectOwnerIdType]
     */
    public void setRegardingobjectowneridtype(String regardingobjectowneridtype){
        this.regardingobjectowneridtype = regardingobjectowneridtype ;
        this.modify("regardingobjectowneridtype",regardingobjectowneridtype);
    }
    /**
     * 设置 [YammerRetryCount]
     */
    public void setYammerretrycount(Integer yammerretrycount){
        this.yammerretrycount = yammerretrycount ;
        this.modify("yammerretrycount",yammerretrycount);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [YammerPostState]
     */
    public void setYammerpoststate(Integer yammerpoststate){
        this.yammerpoststate = yammerpoststate ;
        this.modify("yammerpoststate",yammerpoststate);
    }
    /**
     * 设置 [Source]
     */
    public void setSource(String source){
        this.source = source ;
        this.modify("source",source);
    }

}


