package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[服务协议]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "SLA",resultMap = "SlaResultMap")
public class Sla extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * WorkflowId
     */
    @TableField(value = "workflowid")
    @JSONField(name = "workflowid")
    @JsonProperty("workflowid")
    private String workflowid;
    /**
     * SLAId
     */
    @DEField(isKeyField=true)
    @TableId(value= "slaid",type=IdType.UUID)
    @JSONField(name = "slaid")
    @JsonProperty("slaid")
    private String slaid;
    /**
     * ComponentState
     */
    @TableField(value = "componentstate")
    @JSONField(name = "componentstate")
    @JsonProperty("componentstate")
    private String componentstate;
    /**
     * ApplicableFrom
     */
    @TableField(value = "applicablefrom")
    @JSONField(name = "applicablefrom")
    @JsonProperty("applicablefrom")
    private String applicablefrom;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * Default
     */
    @DEField(defaultValue = "False")
    @TableField(value = "default")
    @JSONField(name = "ibizdefault")
    @JsonProperty("ibizdefault")
    private Integer ibizdefault;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * ApplicableFromPickList
     */
    @TableField(value = "applicablefrompicklist")
    @JSONField(name = "applicablefrompicklist")
    @JsonProperty("applicablefrompicklist")
    private String applicablefrompicklist;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * SLAType
     */
    @TableField(value = "slatype")
    @JSONField(name = "slatype")
    @JsonProperty("slatype")
    private String slatype;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * WorkflowIdName
     */
    @TableField(value = "workflowidname")
    @JSONField(name = "workflowidname")
    @JsonProperty("workflowidname")
    private String workflowidname;
    /**
     * SupportingSolutionId
     */
    @TableField(value = "supportingsolutionid")
    @JSONField(name = "supportingsolutionid")
    @JsonProperty("supportingsolutionid")
    private String supportingsolutionid;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * ChangedAttributeList
     */
    @TableField(value = "changedattributelist")
    @JSONField(name = "changedattributelist")
    @JsonProperty("changedattributelist")
    private String changedattributelist;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * SolutionId
     */
    @TableField(value = "solutionid")
    @JSONField(name = "solutionid")
    @JsonProperty("solutionid")
    private String solutionid;
    /**
     * Managed
     */
    @DEField(defaultValue = "False")
    @TableField(value = "managed")
    @JSONField(name = "managed")
    @JsonProperty("managed")
    private Integer managed;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * AllowPauseResume
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowpauseresume")
    @JSONField(name = "allowpauseresume")
    @JsonProperty("allowpauseresume")
    private Integer allowpauseresume;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * PrimaryEntityOTC
     */
    @TableField(value = "primaryentityotc")
    @JSONField(name = "primaryentityotc")
    @JsonProperty("primaryentityotc")
    private Integer primaryentityotc;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * ObjectTypeCode
     */
    @TableField(value = "objecttypecode")
    @JSONField(name = "objecttypecode")
    @JsonProperty("objecttypecode")
    private String objecttypecode;
    /**
     * slaName
     */
    @TableField(value = "slaname")
    @JSONField(name = "slaname")
    @JsonProperty("slaname")
    private String slaname;
    /**
     * OverwriteTime
     */
    @TableField(value = "overwritetime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overwritetime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overwritetime")
    private Timestamp overwritetime;
    /**
     * OwningUser
     */
    @TableField(value = "owninguser")
    @JSONField(name = "owninguser")
    @JsonProperty("owninguser")
    private String owninguser;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * SLAIdUnique
     */
    @TableField(value = "slaidunique")
    @JSONField(name = "slaidunique")
    @JsonProperty("slaidunique")
    private String slaidunique;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * OwningTeam
     */
    @TableField(value = "owningteam")
    @JSONField(name = "owningteam")
    @JsonProperty("owningteam")
    private String owningteam;
    /**
     * OwningBusinessUnit
     */
    @TableField(value = "owningbusinessunit")
    @JSONField(name = "owningbusinessunit")
    @JsonProperty("owningbusinessunit")
    private String owningbusinessunit;
    /**
     * BusinessHoursId
     */
    @TableField(value = "businesshoursid")
    @JSONField(name = "businesshoursid")
    @JsonProperty("businesshoursid")
    private String businesshoursid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.BusinessUnit owningbusinessun;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Calendar businesshours;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Team owningte;



    /**
     * 设置 [WorkflowId]
     */
    public void setWorkflowid(String workflowid){
        this.workflowid = workflowid ;
        this.modify("workflowid",workflowid);
    }
    /**
     * 设置 [ComponentState]
     */
    public void setComponentstate(String componentstate){
        this.componentstate = componentstate ;
        this.modify("componentstate",componentstate);
    }
    /**
     * 设置 [ApplicableFrom]
     */
    public void setApplicablefrom(String applicablefrom){
        this.applicablefrom = applicablefrom ;
        this.modify("applicablefrom",applicablefrom);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [Default]
     */
    public void setIbizdefault(Integer ibizdefault){
        this.ibizdefault = ibizdefault ;
        this.modify("default",ibizdefault);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [ApplicableFromPickList]
     */
    public void setApplicablefrompicklist(String applicablefrompicklist){
        this.applicablefrompicklist = applicablefrompicklist ;
        this.modify("applicablefrompicklist",applicablefrompicklist);
    }
    /**
     * 设置 [SLAType]
     */
    public void setSlatype(String slatype){
        this.slatype = slatype ;
        this.modify("slatype",slatype);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [WorkflowIdName]
     */
    public void setWorkflowidname(String workflowidname){
        this.workflowidname = workflowidname ;
        this.modify("workflowidname",workflowidname);
    }
    /**
     * 设置 [SupportingSolutionId]
     */
    public void setSupportingsolutionid(String supportingsolutionid){
        this.supportingsolutionid = supportingsolutionid ;
        this.modify("supportingsolutionid",supportingsolutionid);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [ChangedAttributeList]
     */
    public void setChangedattributelist(String changedattributelist){
        this.changedattributelist = changedattributelist ;
        this.modify("changedattributelist",changedattributelist);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [SolutionId]
     */
    public void setSolutionid(String solutionid){
        this.solutionid = solutionid ;
        this.modify("solutionid",solutionid);
    }
    /**
     * 设置 [Managed]
     */
    public void setManaged(Integer managed){
        this.managed = managed ;
        this.modify("managed",managed);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [AllowPauseResume]
     */
    public void setAllowpauseresume(Integer allowpauseresume){
        this.allowpauseresume = allowpauseresume ;
        this.modify("allowpauseresume",allowpauseresume);
    }
    /**
     * 设置 [PrimaryEntityOTC]
     */
    public void setPrimaryentityotc(Integer primaryentityotc){
        this.primaryentityotc = primaryentityotc ;
        this.modify("primaryentityotc",primaryentityotc);
    }
    /**
     * 设置 [ObjectTypeCode]
     */
    public void setObjecttypecode(String objecttypecode){
        this.objecttypecode = objecttypecode ;
        this.modify("objecttypecode",objecttypecode);
    }
    /**
     * 设置 [slaName]
     */
    public void setSlaname(String slaname){
        this.slaname = slaname ;
        this.modify("slaname",slaname);
    }
    /**
     * 设置 [OverwriteTime]
     */
    public void setOverwritetime(Timestamp overwritetime){
        this.overwritetime = overwritetime ;
        this.modify("overwritetime",overwritetime);
    }
    /**
     * 设置 [OwningUser]
     */
    public void setOwninguser(String owninguser){
        this.owninguser = owninguser ;
        this.modify("owninguser",owninguser);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [SLAIdUnique]
     */
    public void setSlaidunique(String slaidunique){
        this.slaidunique = slaidunique ;
        this.modify("slaidunique",slaidunique);
    }
    /**
     * 设置 [OwningTeam]
     */
    public void setOwningteam(String owningteam){
        this.owningteam = owningteam ;
        this.modify("owningteam",owningteam);
    }
    /**
     * 设置 [OwningBusinessUnit]
     */
    public void setOwningbusinessunit(String owningbusinessunit){
        this.owningbusinessunit = owningbusinessunit ;
        this.modify("owningbusinessunit",owningbusinessunit);
    }
    /**
     * 设置 [BusinessHoursId]
     */
    public void setBusinesshoursid(String businesshoursid){
        this.businesshoursid = businesshoursid ;
        this.modify("businesshoursid",businesshoursid);
    }

}


