package cn.ibizlab.businesscentral.core.base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[模板]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "TEMPLATE",resultMap = "TemplateResultMap")
public class Template extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * SolutionId
     */
    @TableField(value = "solutionid")
    @JSONField(name = "solutionid")
    @JsonProperty("solutionid")
    private String solutionid;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * ReplyRate
     */
    @TableField(value = "replyrate")
    @JSONField(name = "replyrate")
    @JsonProperty("replyrate")
    private Integer replyrate;
    /**
     * Personal
     */
    @DEField(defaultValue = "True")
    @TableField(value = "personal")
    @JSONField(name = "personal")
    @JsonProperty("personal")
    private Integer personal;
    /**
     * TemplateTypeCode
     */
    @TableField(value = "templatetypecode")
    @JSONField(name = "templatetypecode")
    @JsonProperty("templatetypecode")
    private String templatetypecode;
    /**
     * Managed
     */
    @DEField(defaultValue = "False")
    @TableField(value = "managed")
    @JSONField(name = "managed")
    @JsonProperty("managed")
    private Integer managed;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * ReplyCount
     */
    @TableField(value = "replycount")
    @JSONField(name = "replycount")
    @JsonProperty("replycount")
    private Integer replycount;
    /**
     * Title
     */
    @TableField(value = "title")
    @JSONField(name = "title")
    @JsonProperty("title")
    private String title;
    /**
     * OpenCount
     */
    @TableField(value = "opencount")
    @JSONField(name = "opencount")
    @JsonProperty("opencount")
    private Integer opencount;
    /**
     * IntroducedVersion
     */
    @TableField(value = "introducedversion")
    @JSONField(name = "introducedversion")
    @JsonProperty("introducedversion")
    private String introducedversion;
    /**
     * MimeType
     */
    @TableField(value = "mimetype")
    @JSONField(name = "mimetype")
    @JsonProperty("mimetype")
    private String mimetype;
    /**
     * TemplateId
     */
    @DEField(isKeyField=true)
    @TableId(value= "templateid",type=IdType.UUID)
    @JSONField(name = "templateid")
    @JsonProperty("templateid")
    private String templateid;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * Recommended
     */
    @DEField(defaultValue = "False")
    @TableField(value = "recommended")
    @JSONField(name = "recommended")
    @JsonProperty("recommended")
    private Integer recommended;
    /**
     * PresentationXml
     */
    @TableField(value = "presentationxml")
    @JSONField(name = "presentationxml")
    @JsonProperty("presentationxml")
    private String presentationxml;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * OverwriteTime
     */
    @TableField(value = "overwritetime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overwritetime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overwritetime")
    private Timestamp overwritetime;
    /**
     * Customizable
     */
    @TableField(value = "customizable")
    @JSONField(name = "customizable")
    @JsonProperty("customizable")
    private String customizable;
    /**
     * ComponentState
     */
    @TableField(value = "componentstate")
    @JSONField(name = "componentstate")
    @JsonProperty("componentstate")
    private String componentstate;
    /**
     * Body
     */
    @TableField(value = "body")
    @JSONField(name = "body")
    @JsonProperty("body")
    private String body;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * SubjectPresentationXml
     */
    @TableField(value = "subjectpresentationxml")
    @JSONField(name = "subjectpresentationxml")
    @JsonProperty("subjectpresentationxml")
    private String subjectpresentationxml;
    /**
     * SupportingSolutionId
     */
    @TableField(value = "supportingsolutionid")
    @JSONField(name = "supportingsolutionid")
    @JsonProperty("supportingsolutionid")
    private String supportingsolutionid;
    /**
     * GenerationTypeCode
     */
    @TableField(value = "generationtypecode")
    @JSONField(name = "generationtypecode")
    @JsonProperty("generationtypecode")
    private Integer generationtypecode;
    /**
     * OpenRate
     */
    @TableField(value = "openrate")
    @JSONField(name = "openrate")
    @JsonProperty("openrate")
    private Integer openrate;
    /**
     * TemplateIdUnique
     */
    @TableField(value = "templateidunique")
    @JSONField(name = "templateidunique")
    @JsonProperty("templateidunique")
    private String templateidunique;
    /**
     * LanguageCode
     */
    @TableField(value = "languagecode")
    @JSONField(name = "languagecode")
    @JsonProperty("languagecode")
    private Integer languagecode;
    /**
     * UsedCount
     */
    @TableField(value = "usedcount")
    @JSONField(name = "usedcount")
    @JsonProperty("usedcount")
    private Integer usedcount;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * Subject
     */
    @TableField(value = "subject")
    @JSONField(name = "subject")
    @JsonProperty("subject")
    private String subject;



    /**
     * 设置 [SolutionId]
     */
    public void setSolutionid(String solutionid){
        this.solutionid = solutionid ;
        this.modify("solutionid",solutionid);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [ReplyRate]
     */
    public void setReplyrate(Integer replyrate){
        this.replyrate = replyrate ;
        this.modify("replyrate",replyrate);
    }
    /**
     * 设置 [Personal]
     */
    public void setPersonal(Integer personal){
        this.personal = personal ;
        this.modify("personal",personal);
    }
    /**
     * 设置 [TemplateTypeCode]
     */
    public void setTemplatetypecode(String templatetypecode){
        this.templatetypecode = templatetypecode ;
        this.modify("templatetypecode",templatetypecode);
    }
    /**
     * 设置 [Managed]
     */
    public void setManaged(Integer managed){
        this.managed = managed ;
        this.modify("managed",managed);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [ReplyCount]
     */
    public void setReplycount(Integer replycount){
        this.replycount = replycount ;
        this.modify("replycount",replycount);
    }
    /**
     * 设置 [Title]
     */
    public void setTitle(String title){
        this.title = title ;
        this.modify("title",title);
    }
    /**
     * 设置 [OpenCount]
     */
    public void setOpencount(Integer opencount){
        this.opencount = opencount ;
        this.modify("opencount",opencount);
    }
    /**
     * 设置 [IntroducedVersion]
     */
    public void setIntroducedversion(String introducedversion){
        this.introducedversion = introducedversion ;
        this.modify("introducedversion",introducedversion);
    }
    /**
     * 设置 [MimeType]
     */
    public void setMimetype(String mimetype){
        this.mimetype = mimetype ;
        this.modify("mimetype",mimetype);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [Recommended]
     */
    public void setRecommended(Integer recommended){
        this.recommended = recommended ;
        this.modify("recommended",recommended);
    }
    /**
     * 设置 [PresentationXml]
     */
    public void setPresentationxml(String presentationxml){
        this.presentationxml = presentationxml ;
        this.modify("presentationxml",presentationxml);
    }
    /**
     * 设置 [OverwriteTime]
     */
    public void setOverwritetime(Timestamp overwritetime){
        this.overwritetime = overwritetime ;
        this.modify("overwritetime",overwritetime);
    }
    /**
     * 设置 [Customizable]
     */
    public void setCustomizable(String customizable){
        this.customizable = customizable ;
        this.modify("customizable",customizable);
    }
    /**
     * 设置 [ComponentState]
     */
    public void setComponentstate(String componentstate){
        this.componentstate = componentstate ;
        this.modify("componentstate",componentstate);
    }
    /**
     * 设置 [Body]
     */
    public void setBody(String body){
        this.body = body ;
        this.modify("body",body);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [SubjectPresentationXml]
     */
    public void setSubjectpresentationxml(String subjectpresentationxml){
        this.subjectpresentationxml = subjectpresentationxml ;
        this.modify("subjectpresentationxml",subjectpresentationxml);
    }
    /**
     * 设置 [SupportingSolutionId]
     */
    public void setSupportingsolutionid(String supportingsolutionid){
        this.supportingsolutionid = supportingsolutionid ;
        this.modify("supportingsolutionid",supportingsolutionid);
    }
    /**
     * 设置 [GenerationTypeCode]
     */
    public void setGenerationtypecode(Integer generationtypecode){
        this.generationtypecode = generationtypecode ;
        this.modify("generationtypecode",generationtypecode);
    }
    /**
     * 设置 [OpenRate]
     */
    public void setOpenrate(Integer openrate){
        this.openrate = openrate ;
        this.modify("openrate",openrate);
    }
    /**
     * 设置 [TemplateIdUnique]
     */
    public void setTemplateidunique(String templateidunique){
        this.templateidunique = templateidunique ;
        this.modify("templateidunique",templateidunique);
    }
    /**
     * 设置 [LanguageCode]
     */
    public void setLanguagecode(Integer languagecode){
        this.languagecode = languagecode ;
        this.modify("languagecode",languagecode);
    }
    /**
     * 设置 [UsedCount]
     */
    public void setUsedcount(Integer usedcount){
        this.usedcount = usedcount ;
        this.modify("usedcount",usedcount);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [Subject]
     */
    public void setSubject(String subject){
        this.subject = subject ;
        this.modify("subject",subject);
    }

}


