package cn.ibizlab.businesscentral.core.base.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.businesscentral.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.businesscentral.core.base.domain.Account;
/**
 * 关系型数据实体[Account] 查询条件对象
 */
@Slf4j
@Data
public class AccountSearchContext extends QueryWrapperContext<Account> {

	private String n_address2_freighttermscode_eq;//[Address2_FreightTermsCode]
	public void setN_address2_freighttermscode_eq(String n_address2_freighttermscode_eq) {
        this.n_address2_freighttermscode_eq = n_address2_freighttermscode_eq;
        if(!ObjectUtils.isEmpty(this.n_address2_freighttermscode_eq)){
            this.getSearchCond().eq("address2_freighttermscode", n_address2_freighttermscode_eq);
        }
    }
	private String n_accountratingcode_eq;//[AccountRatingCode]
	public void setN_accountratingcode_eq(String n_accountratingcode_eq) {
        this.n_accountratingcode_eq = n_accountratingcode_eq;
        if(!ObjectUtils.isEmpty(this.n_accountratingcode_eq)){
            this.getSearchCond().eq("accountratingcode", n_accountratingcode_eq);
        }
    }
	private String n_customertypecode_eq;//[CustomerTypeCode]
	public void setN_customertypecode_eq(String n_customertypecode_eq) {
        this.n_customertypecode_eq = n_customertypecode_eq;
        if(!ObjectUtils.isEmpty(this.n_customertypecode_eq)){
            this.getSearchCond().eq("customertypecode", n_customertypecode_eq);
        }
    }
	private String n_accountname_like;//[accountName]
	public void setN_accountname_like(String n_accountname_like) {
        this.n_accountname_like = n_accountname_like;
        if(!ObjectUtils.isEmpty(this.n_accountname_like)){
            this.getSearchCond().like("accountname", n_accountname_like);
        }
    }
	private String n_preferredcontactmethodcode_eq;//[PreferredContactMethodCode]
	public void setN_preferredcontactmethodcode_eq(String n_preferredcontactmethodcode_eq) {
        this.n_preferredcontactmethodcode_eq = n_preferredcontactmethodcode_eq;
        if(!ObjectUtils.isEmpty(this.n_preferredcontactmethodcode_eq)){
            this.getSearchCond().eq("preferredcontactmethodcode", n_preferredcontactmethodcode_eq);
        }
    }
	private String n_preferredappointmentdaycode_eq;//[PreferredAppointmentDayCode]
	public void setN_preferredappointmentdaycode_eq(String n_preferredappointmentdaycode_eq) {
        this.n_preferredappointmentdaycode_eq = n_preferredappointmentdaycode_eq;
        if(!ObjectUtils.isEmpty(this.n_preferredappointmentdaycode_eq)){
            this.getSearchCond().eq("preferredappointmentdaycode", n_preferredappointmentdaycode_eq);
        }
    }
	private String n_businesstypecode_eq;//[BusinessTypeCode]
	public void setN_businesstypecode_eq(String n_businesstypecode_eq) {
        this.n_businesstypecode_eq = n_businesstypecode_eq;
        if(!ObjectUtils.isEmpty(this.n_businesstypecode_eq)){
            this.getSearchCond().eq("businesstypecode", n_businesstypecode_eq);
        }
    }
	private String n_ownershipcode_eq;//[OwnershipCode]
	public void setN_ownershipcode_eq(String n_ownershipcode_eq) {
        this.n_ownershipcode_eq = n_ownershipcode_eq;
        if(!ObjectUtils.isEmpty(this.n_ownershipcode_eq)){
            this.getSearchCond().eq("ownershipcode", n_ownershipcode_eq);
        }
    }
	private String n_address1_freighttermscode_eq;//[Address1_FreightTermsCode]
	public void setN_address1_freighttermscode_eq(String n_address1_freighttermscode_eq) {
        this.n_address1_freighttermscode_eq = n_address1_freighttermscode_eq;
        if(!ObjectUtils.isEmpty(this.n_address1_freighttermscode_eq)){
            this.getSearchCond().eq("address1_freighttermscode", n_address1_freighttermscode_eq);
        }
    }
	private String n_address1_shippingmethodcode_eq;//[Address1_ShippingMethodCode]
	public void setN_address1_shippingmethodcode_eq(String n_address1_shippingmethodcode_eq) {
        this.n_address1_shippingmethodcode_eq = n_address1_shippingmethodcode_eq;
        if(!ObjectUtils.isEmpty(this.n_address1_shippingmethodcode_eq)){
            this.getSearchCond().eq("address1_shippingmethodcode", n_address1_shippingmethodcode_eq);
        }
    }
	private Integer n_statuscode_eq;//[StatusCode]
	public void setN_statuscode_eq(Integer n_statuscode_eq) {
        this.n_statuscode_eq = n_statuscode_eq;
        if(!ObjectUtils.isEmpty(this.n_statuscode_eq)){
            this.getSearchCond().eq("statuscode", n_statuscode_eq);
        }
    }
	private String n_shippingmethodcode_eq;//[ShippingMethodCode]
	public void setN_shippingmethodcode_eq(String n_shippingmethodcode_eq) {
        this.n_shippingmethodcode_eq = n_shippingmethodcode_eq;
        if(!ObjectUtils.isEmpty(this.n_shippingmethodcode_eq)){
            this.getSearchCond().eq("shippingmethodcode", n_shippingmethodcode_eq);
        }
    }
	private String n_territorycode_eq;//[TerritoryCode]
	public void setN_territorycode_eq(String n_territorycode_eq) {
        this.n_territorycode_eq = n_territorycode_eq;
        if(!ObjectUtils.isEmpty(this.n_territorycode_eq)){
            this.getSearchCond().eq("territorycode", n_territorycode_eq);
        }
    }
	private String n_industrycode_eq;//[IndustryCode]
	public void setN_industrycode_eq(String n_industrycode_eq) {
        this.n_industrycode_eq = n_industrycode_eq;
        if(!ObjectUtils.isEmpty(this.n_industrycode_eq)){
            this.getSearchCond().eq("industrycode", n_industrycode_eq);
        }
    }
	private String n_accountclassificationcode_eq;//[AccountClassificationCode]
	public void setN_accountclassificationcode_eq(String n_accountclassificationcode_eq) {
        this.n_accountclassificationcode_eq = n_accountclassificationcode_eq;
        if(!ObjectUtils.isEmpty(this.n_accountclassificationcode_eq)){
            this.getSearchCond().eq("accountclassificationcode", n_accountclassificationcode_eq);
        }
    }
	private String n_address1_addresstypecode_eq;//[Address1_AddressTypeCode]
	public void setN_address1_addresstypecode_eq(String n_address1_addresstypecode_eq) {
        this.n_address1_addresstypecode_eq = n_address1_addresstypecode_eq;
        if(!ObjectUtils.isEmpty(this.n_address1_addresstypecode_eq)){
            this.getSearchCond().eq("address1_addresstypecode", n_address1_addresstypecode_eq);
        }
    }
	private Integer n_statecode_eq;//[StateCode]
	public void setN_statecode_eq(Integer n_statecode_eq) {
        this.n_statecode_eq = n_statecode_eq;
        if(!ObjectUtils.isEmpty(this.n_statecode_eq)){
            this.getSearchCond().eq("statecode", n_statecode_eq);
        }
    }
	private String n_address2_addresstypecode_eq;//[Address2_AddressTypeCode]
	public void setN_address2_addresstypecode_eq(String n_address2_addresstypecode_eq) {
        this.n_address2_addresstypecode_eq = n_address2_addresstypecode_eq;
        if(!ObjectUtils.isEmpty(this.n_address2_addresstypecode_eq)){
            this.getSearchCond().eq("address2_addresstypecode", n_address2_addresstypecode_eq);
        }
    }
	private String n_accountcategorycode_eq;//[AccountCategoryCode]
	public void setN_accountcategorycode_eq(String n_accountcategorycode_eq) {
        this.n_accountcategorycode_eq = n_accountcategorycode_eq;
        if(!ObjectUtils.isEmpty(this.n_accountcategorycode_eq)){
            this.getSearchCond().eq("accountcategorycode", n_accountcategorycode_eq);
        }
    }
	private String n_address2_shippingmethodcode_eq;//[Address2_ShippingMethodCode]
	public void setN_address2_shippingmethodcode_eq(String n_address2_shippingmethodcode_eq) {
        this.n_address2_shippingmethodcode_eq = n_address2_shippingmethodcode_eq;
        if(!ObjectUtils.isEmpty(this.n_address2_shippingmethodcode_eq)){
            this.getSearchCond().eq("address2_shippingmethodcode", n_address2_shippingmethodcode_eq);
        }
    }
	private String n_customersizecode_eq;//[CustomerSizeCode]
	public void setN_customersizecode_eq(String n_customersizecode_eq) {
        this.n_customersizecode_eq = n_customersizecode_eq;
        if(!ObjectUtils.isEmpty(this.n_customersizecode_eq)){
            this.getSearchCond().eq("customersizecode", n_customersizecode_eq);
        }
    }
	private String n_paymenttermscode_eq;//[PaymentTermsCode]
	public void setN_paymenttermscode_eq(String n_paymenttermscode_eq) {
        this.n_paymenttermscode_eq = n_paymenttermscode_eq;
        if(!ObjectUtils.isEmpty(this.n_paymenttermscode_eq)){
            this.getSearchCond().eq("paymenttermscode", n_paymenttermscode_eq);
        }
    }
	private String n_preferredappointmenttimecode_eq;//[PreferredAppointmentTimeCode]
	public void setN_preferredappointmenttimecode_eq(String n_preferredappointmenttimecode_eq) {
        this.n_preferredappointmenttimecode_eq = n_preferredappointmenttimecode_eq;
        if(!ObjectUtils.isEmpty(this.n_preferredappointmenttimecode_eq)){
            this.getSearchCond().eq("preferredappointmenttimecode", n_preferredappointmenttimecode_eq);
        }
    }
	private String n_originatingleadid_eq;//[OriginatingLeadId]
	public void setN_originatingleadid_eq(String n_originatingleadid_eq) {
        this.n_originatingleadid_eq = n_originatingleadid_eq;
        if(!ObjectUtils.isEmpty(this.n_originatingleadid_eq)){
            this.getSearchCond().eq("originatingleadid", n_originatingleadid_eq);
        }
    }
	private String n_transactioncurrencyid_eq;//[TransactionCurrencyId]
	public void setN_transactioncurrencyid_eq(String n_transactioncurrencyid_eq) {
        this.n_transactioncurrencyid_eq = n_transactioncurrencyid_eq;
        if(!ObjectUtils.isEmpty(this.n_transactioncurrencyid_eq)){
            this.getSearchCond().eq("transactioncurrencyid", n_transactioncurrencyid_eq);
        }
    }
	private String n_defaultpricelevelid_eq;//[DefaultPriceLevelId]
	public void setN_defaultpricelevelid_eq(String n_defaultpricelevelid_eq) {
        this.n_defaultpricelevelid_eq = n_defaultpricelevelid_eq;
        if(!ObjectUtils.isEmpty(this.n_defaultpricelevelid_eq)){
            this.getSearchCond().eq("defaultpricelevelid", n_defaultpricelevelid_eq);
        }
    }
	private String n_parentaccountid_eq;//[ParentAccountId]
	public void setN_parentaccountid_eq(String n_parentaccountid_eq) {
        this.n_parentaccountid_eq = n_parentaccountid_eq;
        if(!ObjectUtils.isEmpty(this.n_parentaccountid_eq)){
            this.getSearchCond().eq("parentaccountid", n_parentaccountid_eq);
        }
    }
	private String n_preferredequipmentid_eq;//[PreferredEquipmentId]
	public void setN_preferredequipmentid_eq(String n_preferredequipmentid_eq) {
        this.n_preferredequipmentid_eq = n_preferredequipmentid_eq;
        if(!ObjectUtils.isEmpty(this.n_preferredequipmentid_eq)){
            this.getSearchCond().eq("preferredequipmentid", n_preferredequipmentid_eq);
        }
    }
	private String n_territoryid_eq;//[TerritoryId]
	public void setN_territoryid_eq(String n_territoryid_eq) {
        this.n_territoryid_eq = n_territoryid_eq;
        if(!ObjectUtils.isEmpty(this.n_territoryid_eq)){
            this.getSearchCond().eq("territoryid", n_territoryid_eq);
        }
    }
	private String n_primarycontactid_eq;//[PrimaryContactId]
	public void setN_primarycontactid_eq(String n_primarycontactid_eq) {
        this.n_primarycontactid_eq = n_primarycontactid_eq;
        if(!ObjectUtils.isEmpty(this.n_primarycontactid_eq)){
            this.getSearchCond().eq("primarycontactid", n_primarycontactid_eq);
        }
    }
	private String n_slaid_eq;//[SLAId]
	public void setN_slaid_eq(String n_slaid_eq) {
        this.n_slaid_eq = n_slaid_eq;
        if(!ObjectUtils.isEmpty(this.n_slaid_eq)){
            this.getSearchCond().eq("slaid", n_slaid_eq);
        }
    }
	private String n_preferredserviceid_eq;//[PreferredServiceId]
	public void setN_preferredserviceid_eq(String n_preferredserviceid_eq) {
        this.n_preferredserviceid_eq = n_preferredserviceid_eq;
        if(!ObjectUtils.isEmpty(this.n_preferredserviceid_eq)){
            this.getSearchCond().eq("preferredserviceid", n_preferredserviceid_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("accountname", query)   
            );
		 }
	}
}




