package cn.ibizlab.businesscentral.core.marketing.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[活动]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "CAMPAIGN",resultMap = "CampaignResultMap")
public class Campaign extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * ExpectedResponse
     */
    @TableField(value = "expectedresponse")
    @JSONField(name = "expectedresponse")
    @JsonProperty("expectedresponse")
    private Integer expectedresponse;
    /**
     * TypeCode
     */
    @TableField(value = "typecode")
    @JSONField(name = "typecode")
    @JsonProperty("typecode")
    private String typecode;
    /**
     * BudgetedCost
     */
    @TableField(value = "budgetedcost")
    @JSONField(name = "budgetedcost")
    @JsonProperty("budgetedcost")
    private BigDecimal budgetedcost;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * TotalActualCost
     */
    @TableField(value = "totalactualcost")
    @JSONField(name = "totalactualcost")
    @JsonProperty("totalactualcost")
    private BigDecimal totalactualcost;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * OtherCost
     */
    @TableField(value = "othercost")
    @JSONField(name = "othercost")
    @JsonProperty("othercost")
    private BigDecimal othercost;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * campaignName
     */
    @TableField(value = "campaignname")
    @JSONField(name = "campaignname")
    @JsonProperty("campaignname")
    private String campaignname;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * Template
     */
    @DEField(defaultValue = "False")
    @TableField(value = "template")
    @JSONField(name = "template")
    @JsonProperty("template")
    private Integer template;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * CampaignId
     */
    @DEField(isKeyField=true)
    @TableId(value= "campaignid",type=IdType.UUID)
    @JSONField(name = "campaignid")
    @JsonProperty("campaignid")
    private String campaignid;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * Objective
     */
    @TableField(value = "objective")
    @JSONField(name = "objective")
    @JsonProperty("objective")
    private String objective;
    /**
     * BudgetedCost_Base
     */
    @DEField(name = "budgetedcost_base")
    @TableField(value = "budgetedcost_base")
    @JSONField(name = "budgetedcost_base")
    @JsonProperty("budgetedcost_base")
    private BigDecimal budgetedcostBase;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * ExpectedRevenue_Base
     */
    @DEField(name = "expectedrevenue_base")
    @TableField(value = "expectedrevenue_base")
    @JSONField(name = "expectedrevenue_base")
    @JsonProperty("expectedrevenue_base")
    private BigDecimal expectedrevenueBase;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * OtherCost_Base
     */
    @DEField(name = "othercost_base")
    @TableField(value = "othercost_base")
    @JSONField(name = "othercost_base")
    @JsonProperty("othercost_base")
    private BigDecimal othercostBase;
    /**
     * ProposedEnd
     */
    @TableField(value = "proposedend")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "proposedend" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("proposedend")
    private Timestamp proposedend;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * CodeName
     */
    @TableField(value = "codename")
    @JSONField(name = "codename")
    @JsonProperty("codename")
    private String codename;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * ActualEnd
     */
    @TableField(value = "actualend")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "actualend" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("actualend")
    private Timestamp actualend;
    /**
     * ExpectedRevenue
     */
    @TableField(value = "expectedrevenue")
    @JSONField(name = "expectedrevenue")
    @JsonProperty("expectedrevenue")
    private BigDecimal expectedrevenue;
    /**
     * PriceListName
     */
    @TableField(value = "pricelistname")
    @JSONField(name = "pricelistname")
    @JsonProperty("pricelistname")
    private String pricelistname;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * ActualStart
     */
    @TableField(value = "actualstart")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "actualstart" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("actualstart")
    private Timestamp actualstart;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * Message
     */
    @TableField(value = "message")
    @JSONField(name = "message")
    @JsonProperty("message")
    private String message;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * ProposedStart
     */
    @TableField(value = "proposedstart")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "proposedstart" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("proposedstart")
    private Timestamp proposedstart;
    /**
     * TotalActualCost_Base
     */
    @DEField(name = "totalactualcost_base")
    @TableField(value = "totalactualcost_base")
    @JSONField(name = "totalactualcost_base")
    @JsonProperty("totalactualcost_base")
    private BigDecimal totalactualcostBase;
    /**
     * EmailAddress
     */
    @TableField(value = "emailaddress")
    @JSONField(name = "emailaddress")
    @JsonProperty("emailaddress")
    private String emailaddress;
    /**
     * PromotionCodeName
     */
    @TableField(value = "promotioncodename")
    @JSONField(name = "promotioncodename")
    @JsonProperty("promotioncodename")
    private String promotioncodename;
    /**
     * PriceListId
     */
    @TableField(value = "pricelistid")
    @JSONField(name = "pricelistid")
    @JsonProperty("pricelistid")
    private String pricelistid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.product.domain.PriceLevel pricelist;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [ExpectedResponse]
     */
    public void setExpectedresponse(Integer expectedresponse){
        this.expectedresponse = expectedresponse ;
        this.modify("expectedresponse",expectedresponse);
    }
    /**
     * 设置 [TypeCode]
     */
    public void setTypecode(String typecode){
        this.typecode = typecode ;
        this.modify("typecode",typecode);
    }
    /**
     * 设置 [BudgetedCost]
     */
    public void setBudgetedcost(BigDecimal budgetedcost){
        this.budgetedcost = budgetedcost ;
        this.modify("budgetedcost",budgetedcost);
    }
    /**
     * 设置 [TotalActualCost]
     */
    public void setTotalactualcost(BigDecimal totalactualcost){
        this.totalactualcost = totalactualcost ;
        this.modify("totalactualcost",totalactualcost);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [OtherCost]
     */
    public void setOthercost(BigDecimal othercost){
        this.othercost = othercost ;
        this.modify("othercost",othercost);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [campaignName]
     */
    public void setCampaignname(String campaignname){
        this.campaignname = campaignname ;
        this.modify("campaignname",campaignname);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [Template]
     */
    public void setTemplate(Integer template){
        this.template = template ;
        this.modify("template",template);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [Objective]
     */
    public void setObjective(String objective){
        this.objective = objective ;
        this.modify("objective",objective);
    }
    /**
     * 设置 [BudgetedCost_Base]
     */
    public void setBudgetedcostBase(BigDecimal budgetedcostBase){
        this.budgetedcostBase = budgetedcostBase ;
        this.modify("budgetedcost_base",budgetedcostBase);
    }
    /**
     * 设置 [ExpectedRevenue_Base]
     */
    public void setExpectedrevenueBase(BigDecimal expectedrevenueBase){
        this.expectedrevenueBase = expectedrevenueBase ;
        this.modify("expectedrevenue_base",expectedrevenueBase);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [OtherCost_Base]
     */
    public void setOthercostBase(BigDecimal othercostBase){
        this.othercostBase = othercostBase ;
        this.modify("othercost_base",othercostBase);
    }
    /**
     * 设置 [ProposedEnd]
     */
    public void setProposedend(Timestamp proposedend){
        this.proposedend = proposedend ;
        this.modify("proposedend",proposedend);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [CodeName]
     */
    public void setCodename(String codename){
        this.codename = codename ;
        this.modify("codename",codename);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [ActualEnd]
     */
    public void setActualend(Timestamp actualend){
        this.actualend = actualend ;
        this.modify("actualend",actualend);
    }
    /**
     * 设置 [ExpectedRevenue]
     */
    public void setExpectedrevenue(BigDecimal expectedrevenue){
        this.expectedrevenue = expectedrevenue ;
        this.modify("expectedrevenue",expectedrevenue);
    }
    /**
     * 设置 [PriceListName]
     */
    public void setPricelistname(String pricelistname){
        this.pricelistname = pricelistname ;
        this.modify("pricelistname",pricelistname);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [ActualStart]
     */
    public void setActualstart(Timestamp actualstart){
        this.actualstart = actualstart ;
        this.modify("actualstart",actualstart);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [Message]
     */
    public void setMessage(String message){
        this.message = message ;
        this.modify("message",message);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [ProposedStart]
     */
    public void setProposedstart(Timestamp proposedstart){
        this.proposedstart = proposedstart ;
        this.modify("proposedstart",proposedstart);
    }
    /**
     * 设置 [TotalActualCost_Base]
     */
    public void setTotalactualcostBase(BigDecimal totalactualcostBase){
        this.totalactualcostBase = totalactualcostBase ;
        this.modify("totalactualcost_base",totalactualcostBase);
    }
    /**
     * 设置 [EmailAddress]
     */
    public void setEmailaddress(String emailaddress){
        this.emailaddress = emailaddress ;
        this.modify("emailaddress",emailaddress);
    }
    /**
     * 设置 [PromotionCodeName]
     */
    public void setPromotioncodename(String promotioncodename){
        this.promotioncodename = promotioncodename ;
        this.modify("promotioncodename",promotioncodename);
    }
    /**
     * 设置 [PriceListId]
     */
    public void setPricelistid(String pricelistid){
        this.pricelistid = pricelistid ;
        this.modify("pricelistid",pricelistid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }

}


