package cn.ibizlab.businesscentral.core.marketing.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[市场营销列表]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "LIST",resultMap = "IBizListResultMap")
public class IBizList extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * Query
     */
    @TableField(value = "query")
    @JSONField(name = "query")
    @JsonProperty("query")
    private String query;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * LockStatus
     */
    @DEField(defaultValue = "False")
    @TableField(value = "lockstatus")
    @JSONField(name = "lockstatus")
    @JsonProperty("lockstatus")
    private Integer lockstatus;
    /**
     * Purpose
     */
    @TableField(value = "purpose")
    @JSONField(name = "purpose")
    @JsonProperty("purpose")
    private String purpose;
    /**
     * LastUsedOn
     */
    @TableField(value = "lastusedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastusedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastusedon")
    private Timestamp lastusedon;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * ListId
     */
    @DEField(isKeyField=true)
    @TableId(value= "listid",type=IdType.UUID)
    @JSONField(name = "listid")
    @JsonProperty("listid")
    private String listid;
    /**
     * MemberType
     */
    @TableField(value = "membertype")
    @JSONField(name = "membertype")
    @JsonProperty("membertype")
    private Integer membertype;
    /**
     * DoNotSendOnOptOut
     */
    @DEField(defaultValue = "True")
    @TableField(value = "donotsendonoptout")
    @JSONField(name = "donotsendonoptout")
    @JsonProperty("donotsendonoptout")
    private Integer donotsendonoptout;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * Cost
     */
    @TableField(value = "cost")
    @JSONField(name = "cost")
    @JsonProperty("cost")
    private BigDecimal cost;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * ListName
     */
    @TableField(value = "listname")
    @JSONField(name = "listname")
    @JsonProperty("listname")
    private String listname;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * Type
     */
    @DEField(defaultValue = "False")
    @TableField(value = "type")
    @JSONField(name = "type")
    @JsonProperty("type")
    private Integer type;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * Cost_Base
     */
    @DEField(name = "cost_base")
    @TableField(value = "cost_base")
    @JSONField(name = "cost_base")
    @JsonProperty("cost_base")
    private BigDecimal costBase;
    /**
     * MemberCount
     */
    @TableField(value = "membercount")
    @JSONField(name = "membercount")
    @JsonProperty("membercount")
    private Integer membercount;
    /**
     * IgnoreInactiveListMembers
     */
    @DEField(defaultValue = "True")
    @TableField(value = "ignoreinactivelistmembers")
    @JSONField(name = "ignoreinactivelistmembers")
    @JsonProperty("ignoreinactivelistmembers")
    private Integer ignoreinactivelistmembers;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * Source
     */
    @TableField(value = "source")
    @JSONField(name = "source")
    @JsonProperty("source")
    private String source;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * CreatedFromCode
     */
    @TableField(value = "createdfromcode")
    @JSONField(name = "createdfromcode")
    @JsonProperty("createdfromcode")
    private String createdfromcode;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [Query]
     */
    public void setQuery(String query){
        this.query = query ;
        this.modify("query",query);
    }
    /**
     * 设置 [LockStatus]
     */
    public void setLockstatus(Integer lockstatus){
        this.lockstatus = lockstatus ;
        this.modify("lockstatus",lockstatus);
    }
    /**
     * 设置 [Purpose]
     */
    public void setPurpose(String purpose){
        this.purpose = purpose ;
        this.modify("purpose",purpose);
    }
    /**
     * 设置 [LastUsedOn]
     */
    public void setLastusedon(Timestamp lastusedon){
        this.lastusedon = lastusedon ;
        this.modify("lastusedon",lastusedon);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [MemberType]
     */
    public void setMembertype(Integer membertype){
        this.membertype = membertype ;
        this.modify("membertype",membertype);
    }
    /**
     * 设置 [DoNotSendOnOptOut]
     */
    public void setDonotsendonoptout(Integer donotsendonoptout){
        this.donotsendonoptout = donotsendonoptout ;
        this.modify("donotsendonoptout",donotsendonoptout);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [Cost]
     */
    public void setCost(BigDecimal cost){
        this.cost = cost ;
        this.modify("cost",cost);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [ListName]
     */
    public void setListname(String listname){
        this.listname = listname ;
        this.modify("listname",listname);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [Type]
     */
    public void setType(Integer type){
        this.type = type ;
        this.modify("type",type);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [Cost_Base]
     */
    public void setCostBase(BigDecimal costBase){
        this.costBase = costBase ;
        this.modify("cost_base",costBase);
    }
    /**
     * 设置 [MemberCount]
     */
    public void setMembercount(Integer membercount){
        this.membercount = membercount ;
        this.modify("membercount",membercount);
    }
    /**
     * 设置 [IgnoreInactiveListMembers]
     */
    public void setIgnoreinactivelistmembers(Integer ignoreinactivelistmembers){
        this.ignoreinactivelistmembers = ignoreinactivelistmembers ;
        this.modify("ignoreinactivelistmembers",ignoreinactivelistmembers);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [Source]
     */
    public void setSource(String source){
        this.source = source ;
        this.modify("source",source);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [CreatedFromCode]
     */
    public void setCreatedfromcode(String createdfromcode){
        this.createdfromcode = createdfromcode ;
        this.modify("createdfromcode",createdfromcode);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }

}


