package cn.ibizlab.businesscentral.core.product.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[产品]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "PRODUCT",resultMap = "ProductResultMap")
public class Product extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * VendorID
     */
    @TableField(value = "vendorid")
    @JSONField(name = "vendorid")
    @JsonProperty("vendorid")
    private String vendorid;
    /**
     * ProductStructure
     */
    @TableField(value = "productstructure")
    @JSONField(name = "productstructure")
    @JsonProperty("productstructure")
    private String productstructure;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * StockItem
     */
    @DEField(defaultValue = "False")
    @TableField(value = "stockitem")
    @JSONField(name = "stockitem")
    @JsonProperty("stockitem")
    private Integer stockitem;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * ValidFromDate
     */
    @TableField(value = "validfromdate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "validfromdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("validfromdate")
    private Timestamp validfromdate;
    /**
     * SupplierName
     */
    @TableField(value = "suppliername")
    @JSONField(name = "suppliername")
    @JsonProperty("suppliername")
    private String suppliername;
    /**
     * ProductTypeCode
     */
    @TableField(value = "producttypecode")
    @JSONField(name = "producttypecode")
    @JsonProperty("producttypecode")
    private String producttypecode;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * ProductUrl
     */
    @TableField(value = "producturl")
    @JSONField(name = "producturl")
    @JsonProperty("producturl")
    private String producturl;
    /**
     * StandardCost
     */
    @TableField(value = "standardcost")
    @JSONField(name = "standardcost")
    @JsonProperty("standardcost")
    private BigDecimal standardcost;
    /**
     * QuantityOnHand
     */
    @TableField(value = "quantityonhand")
    @JSONField(name = "quantityonhand")
    @JsonProperty("quantityonhand")
    private BigDecimal quantityonhand;
    /**
     * CurrentCost
     */
    @TableField(value = "currentcost")
    @JSONField(name = "currentcost")
    @JsonProperty("currentcost")
    private BigDecimal currentcost;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * ProductId
     */
    @DEField(isKeyField=true)
    @TableId(value= "productid",type=IdType.UUID)
    @JSONField(name = "productid")
    @JsonProperty("productid")
    private String productid;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * VendorName
     */
    @TableField(value = "vendorname")
    @JSONField(name = "vendorname")
    @JsonProperty("vendorname")
    private String vendorname;
    /**
     * DMTImportState
     */
    @TableField(value = "dmtimportstate")
    @JSONField(name = "dmtimportstate")
    @JsonProperty("dmtimportstate")
    private Integer dmtimportstate;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * StockVolume
     */
    @TableField(value = "stockvolume")
    @JSONField(name = "stockvolume")
    @JsonProperty("stockvolume")
    private BigDecimal stockvolume;
    /**
     * QuantityDecimal
     */
    @TableField(value = "quantitydecimal")
    @JSONField(name = "quantitydecimal")
    @JsonProperty("quantitydecimal")
    private Integer quantitydecimal;
    /**
     * VendorPartNumber
     */
    @TableField(value = "vendorpartnumber")
    @JSONField(name = "vendorpartnumber")
    @JsonProperty("vendorpartnumber")
    private String vendorpartnumber;
    /**
     * ValidToDate
     */
    @TableField(value = "validtodate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "validtodate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("validtodate")
    private Timestamp validtodate;
    /**
     * Reparented
     */
    @DEField(defaultValue = "False")
    @TableField(value = "reparented")
    @JSONField(name = "reparented")
    @JsonProperty("reparented")
    private Integer reparented;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * ProductNumber
     */
    @TableField(value = "productnumber")
    @JSONField(name = "productnumber")
    @JsonProperty("productnumber")
    private String productnumber;
    /**
     * Kit
     */
    @DEField(defaultValue = "False")
    @TableField(value = "kit")
    @JSONField(name = "kit")
    @JsonProperty("kit")
    private Integer kit;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * CurrentCost_Base
     */
    @DEField(name = "currentcost_base")
    @TableField(value = "currentcost_base")
    @JSONField(name = "currentcost_base")
    @JsonProperty("currentcost_base")
    private BigDecimal currentcostBase;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * StockWeight
     */
    @TableField(value = "stockweight")
    @JSONField(name = "stockweight")
    @JsonProperty("stockweight")
    private BigDecimal stockweight;
    /**
     * Size
     */
    @TableField(value = "size")
    @JSONField(name = "size")
    @JsonProperty("size")
    private String size;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * productName
     */
    @TableField(value = "productname")
    @JSONField(name = "productname")
    @JsonProperty("productname")
    private String productname;
    /**
     * Price_Base
     */
    @DEField(name = "price_base")
    @TableField(value = "price_base")
    @JSONField(name = "price_base")
    @JsonProperty("price_base")
    private BigDecimal priceBase;
    /**
     * Price
     */
    @TableField(value = "price")
    @JSONField(name = "price")
    @JsonProperty("price")
    private BigDecimal price;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * HierarchyPath
     */
    @TableField(value = "hierarchypath")
    @JSONField(name = "hierarchypath")
    @JsonProperty("hierarchypath")
    private String hierarchypath;
    /**
     * StandardCost_Base
     */
    @DEField(name = "standardcost_base")
    @TableField(value = "standardcost_base")
    @JSONField(name = "standardcost_base")
    @JsonProperty("standardcost_base")
    private BigDecimal standardcostBase;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * ParentProductId
     */
    @TableField(value = "parentproductid")
    @JSONField(name = "parentproductid")
    @JsonProperty("parentproductid")
    private String parentproductid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;
    /**
     * PriceLevelId
     */
    @TableField(value = "pricelevelid")
    @JSONField(name = "pricelevelid")
    @JsonProperty("pricelevelid")
    private String pricelevelid;
    /**
     * DefaultUoMId
     */
    @TableField(value = "defaultuomid")
    @JSONField(name = "defaultuomid")
    @JsonProperty("defaultuomid")
    private String defaultuomid;
    /**
     * DefaultUoMScheduleId
     */
    @TableField(value = "defaultuomscheduleid")
    @JSONField(name = "defaultuomscheduleid")
    @JsonProperty("defaultuomscheduleid")
    private String defaultuomscheduleid;
    /**
     * SubjectId
     */
    @TableField(value = "subjectid")
    @JSONField(name = "subjectid")
    @JsonProperty("subjectid")
    private String subjectid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.product.domain.PriceLevel pricelevel;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.product.domain.Product parentproduct;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Subject subject;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.UomSchedule defaultuomschedule;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Uom defaultuom;



    /**
     * 设置 [VendorID]
     */
    public void setVendorid(String vendorid){
        this.vendorid = vendorid ;
        this.modify("vendorid",vendorid);
    }
    /**
     * 设置 [ProductStructure]
     */
    public void setProductstructure(String productstructure){
        this.productstructure = productstructure ;
        this.modify("productstructure",productstructure);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [StockItem]
     */
    public void setStockitem(Integer stockitem){
        this.stockitem = stockitem ;
        this.modify("stockitem",stockitem);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [ValidFromDate]
     */
    public void setValidfromdate(Timestamp validfromdate){
        this.validfromdate = validfromdate ;
        this.modify("validfromdate",validfromdate);
    }
    /**
     * 设置 [SupplierName]
     */
    public void setSuppliername(String suppliername){
        this.suppliername = suppliername ;
        this.modify("suppliername",suppliername);
    }
    /**
     * 设置 [ProductTypeCode]
     */
    public void setProducttypecode(String producttypecode){
        this.producttypecode = producttypecode ;
        this.modify("producttypecode",producttypecode);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [ProductUrl]
     */
    public void setProducturl(String producturl){
        this.producturl = producturl ;
        this.modify("producturl",producturl);
    }
    /**
     * 设置 [StandardCost]
     */
    public void setStandardcost(BigDecimal standardcost){
        this.standardcost = standardcost ;
        this.modify("standardcost",standardcost);
    }
    /**
     * 设置 [QuantityOnHand]
     */
    public void setQuantityonhand(BigDecimal quantityonhand){
        this.quantityonhand = quantityonhand ;
        this.modify("quantityonhand",quantityonhand);
    }
    /**
     * 设置 [CurrentCost]
     */
    public void setCurrentcost(BigDecimal currentcost){
        this.currentcost = currentcost ;
        this.modify("currentcost",currentcost);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [VendorName]
     */
    public void setVendorname(String vendorname){
        this.vendorname = vendorname ;
        this.modify("vendorname",vendorname);
    }
    /**
     * 设置 [DMTImportState]
     */
    public void setDmtimportstate(Integer dmtimportstate){
        this.dmtimportstate = dmtimportstate ;
        this.modify("dmtimportstate",dmtimportstate);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [StockVolume]
     */
    public void setStockvolume(BigDecimal stockvolume){
        this.stockvolume = stockvolume ;
        this.modify("stockvolume",stockvolume);
    }
    /**
     * 设置 [QuantityDecimal]
     */
    public void setQuantitydecimal(Integer quantitydecimal){
        this.quantitydecimal = quantitydecimal ;
        this.modify("quantitydecimal",quantitydecimal);
    }
    /**
     * 设置 [VendorPartNumber]
     */
    public void setVendorpartnumber(String vendorpartnumber){
        this.vendorpartnumber = vendorpartnumber ;
        this.modify("vendorpartnumber",vendorpartnumber);
    }
    /**
     * 设置 [ValidToDate]
     */
    public void setValidtodate(Timestamp validtodate){
        this.validtodate = validtodate ;
        this.modify("validtodate",validtodate);
    }
    /**
     * 设置 [Reparented]
     */
    public void setReparented(Integer reparented){
        this.reparented = reparented ;
        this.modify("reparented",reparented);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [ProductNumber]
     */
    public void setProductnumber(String productnumber){
        this.productnumber = productnumber ;
        this.modify("productnumber",productnumber);
    }
    /**
     * 设置 [Kit]
     */
    public void setKit(Integer kit){
        this.kit = kit ;
        this.modify("kit",kit);
    }
    /**
     * 设置 [CurrentCost_Base]
     */
    public void setCurrentcostBase(BigDecimal currentcostBase){
        this.currentcostBase = currentcostBase ;
        this.modify("currentcost_base",currentcostBase);
    }
    /**
     * 设置 [StockWeight]
     */
    public void setStockweight(BigDecimal stockweight){
        this.stockweight = stockweight ;
        this.modify("stockweight",stockweight);
    }
    /**
     * 设置 [Size]
     */
    public void setSize(String size){
        this.size = size ;
        this.modify("size",size);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [productName]
     */
    public void setProductname(String productname){
        this.productname = productname ;
        this.modify("productname",productname);
    }
    /**
     * 设置 [Price_Base]
     */
    public void setPriceBase(BigDecimal priceBase){
        this.priceBase = priceBase ;
        this.modify("price_base",priceBase);
    }
    /**
     * 设置 [Price]
     */
    public void setPrice(BigDecimal price){
        this.price = price ;
        this.modify("price",price);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [HierarchyPath]
     */
    public void setHierarchypath(String hierarchypath){
        this.hierarchypath = hierarchypath ;
        this.modify("hierarchypath",hierarchypath);
    }
    /**
     * 设置 [StandardCost_Base]
     */
    public void setStandardcostBase(BigDecimal standardcostBase){
        this.standardcostBase = standardcostBase ;
        this.modify("standardcost_base",standardcostBase);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [ParentProductId]
     */
    public void setParentproductid(String parentproductid){
        this.parentproductid = parentproductid ;
        this.modify("parentproductid",parentproductid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }
    /**
     * 设置 [PriceLevelId]
     */
    public void setPricelevelid(String pricelevelid){
        this.pricelevelid = pricelevelid ;
        this.modify("pricelevelid",pricelevelid);
    }
    /**
     * 设置 [DefaultUoMId]
     */
    public void setDefaultuomid(String defaultuomid){
        this.defaultuomid = defaultuomid ;
        this.modify("defaultuomid",defaultuomid);
    }
    /**
     * 设置 [DefaultUoMScheduleId]
     */
    public void setDefaultuomscheduleid(String defaultuomscheduleid){
        this.defaultuomscheduleid = defaultuomscheduleid ;
        this.modify("defaultuomscheduleid",defaultuomscheduleid);
    }
    /**
     * 设置 [SubjectId]
     */
    public void setSubjectid(String subjectid){
        this.subjectid = subjectid ;
        this.modify("subjectid",subjectid);
    }

}


