package cn.ibizlab.businesscentral.core.runtime.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[批量删除操作]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "BULKDELETEOPERATION",resultMap = "BulkDeleteOperationResultMap")
public class BulkDeleteOperation extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * BulkDeleteOperationId
     */
    @DEField(isKeyField=true)
    @TableId(value= "bulkdeleteoperationid",type=IdType.UUID)
    @JSONField(name = "bulkdeleteoperationid")
    @JsonProperty("bulkdeleteoperationid")
    private String bulkdeleteoperationid;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * OrderedQuerySetXml
     */
    @TableField(value = "orderedquerysetxml")
    @JSONField(name = "orderedquerysetxml")
    @JsonProperty("orderedquerysetxml")
    private String orderedquerysetxml;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * ProcessingQEIndex
     */
    @TableField(value = "processingqeindex")
    @JSONField(name = "processingqeindex")
    @JsonProperty("processingqeindex")
    private Integer processingqeindex;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * SuccessCount
     */
    @TableField(value = "successcount")
    @JSONField(name = "successcount")
    @JsonProperty("successcount")
    private Integer successcount;
    /**
     * bulkdeleteoperationName
     */
    @TableField(value = "bulkdeleteoperationname")
    @JSONField(name = "bulkdeleteoperationname")
    @JsonProperty("bulkdeleteoperationname")
    private String bulkdeleteoperationname;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * Recurring
     */
    @DEField(defaultValue = "False")
    @TableField(value = "recurring")
    @JSONField(name = "recurring")
    @JsonProperty("recurring")
    private Integer recurring;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * NextRun
     */
    @TableField(value = "nextrun")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "nextrun" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("nextrun")
    private Timestamp nextrun;
    /**
     * FailureCount
     */
    @TableField(value = "failurecount")
    @JSONField(name = "failurecount")
    @JsonProperty("failurecount")
    private Integer failurecount;



    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [OrderedQuerySetXml]
     */
    public void setOrderedquerysetxml(String orderedquerysetxml){
        this.orderedquerysetxml = orderedquerysetxml ;
        this.modify("orderedquerysetxml",orderedquerysetxml);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [ProcessingQEIndex]
     */
    public void setProcessingqeindex(Integer processingqeindex){
        this.processingqeindex = processingqeindex ;
        this.modify("processingqeindex",processingqeindex);
    }
    /**
     * 设置 [SuccessCount]
     */
    public void setSuccesscount(Integer successcount){
        this.successcount = successcount ;
        this.modify("successcount",successcount);
    }
    /**
     * 设置 [bulkdeleteoperationName]
     */
    public void setBulkdeleteoperationname(String bulkdeleteoperationname){
        this.bulkdeleteoperationname = bulkdeleteoperationname ;
        this.modify("bulkdeleteoperationname",bulkdeleteoperationname);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [Recurring]
     */
    public void setRecurring(Integer recurring){
        this.recurring = recurring ;
        this.modify("recurring",recurring);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [NextRun]
     */
    public void setNextrun(Timestamp nextrun){
        this.nextrun = nextrun ;
        this.modify("nextrun",nextrun);
    }
    /**
     * 设置 [FailureCount]
     */
    public void setFailurecount(Integer failurecount){
        this.failurecount = failurecount ;
        this.modify("failurecount",failurecount);
    }

}


