package cn.ibizlab.businesscentral.core.runtime.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[队列]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "QUEUE",resultMap = "QueueResultMap")
public class Queue extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * EMailAddress
     */
    @TableField(value = "emailaddress")
    @JSONField(name = "emailaddress")
    @JsonProperty("emailaddress")
    private String emailaddress;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * PrimaryUserId
     */
    @TableField(value = "primaryuserid")
    @JSONField(name = "primaryuserid")
    @JsonProperty("primaryuserid")
    private String primaryuserid;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * IncomingEmailDeliveryMethod
     */
    @TableField(value = "incomingemaildeliverymethod")
    @JSONField(name = "incomingemaildeliverymethod")
    @JsonProperty("incomingemaildeliverymethod")
    private String incomingemaildeliverymethod;
    /**
     * QueueId
     */
    @DEField(isKeyField=true)
    @TableId(value= "queueid",type=IdType.UUID)
    @JSONField(name = "queueid")
    @JsonProperty("queueid")
    private String queueid;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * FaxQueue
     */
    @DEField(defaultValue = "False")
    @TableField(value = "faxqueue")
    @JSONField(name = "faxqueue")
    @JsonProperty("faxqueue")
    private Integer faxqueue;
    /**
     * QueueTypeCode
     */
    @TableField(value = "queuetypecode")
    @JSONField(name = "queuetypecode")
    @JsonProperty("queuetypecode")
    private String queuetypecode;
    /**
     * IncomingEmailFilteringMethod
     */
    @TableField(value = "incomingemailfilteringmethod")
    @JSONField(name = "incomingemailfilteringmethod")
    @JsonProperty("incomingemailfilteringmethod")
    private String incomingemailfilteringmethod;
    /**
     * NumberOfMembers
     */
    @TableField(value = "numberofmembers")
    @JSONField(name = "numberofmembers")
    @JsonProperty("numberofmembers")
    private Integer numberofmembers;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * queueName
     */
    @TableField(value = "queuename")
    @JSONField(name = "queuename")
    @JsonProperty("queuename")
    private String queuename;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * EmailPassword
     */
    @TableField(value = "emailpassword")
    @JSONField(name = "emailpassword")
    @JsonProperty("emailpassword")
    private String emailpassword;
    /**
     * AllowEmailCredentials
     */
    @DEField(defaultValue = "False")
    @TableField(value = "allowemailcredentials")
    @JSONField(name = "allowemailcredentials")
    @JsonProperty("allowemailcredentials")
    private Integer allowemailcredentials;
    /**
     * QueueViewType
     */
    @TableField(value = "queueviewtype")
    @JSONField(name = "queueviewtype")
    @JsonProperty("queueviewtype")
    private String queueviewtype;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * EmailUsername
     */
    @TableField(value = "emailusername")
    @JSONField(name = "emailusername")
    @JsonProperty("emailusername")
    private String emailusername;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * NumberOfItems
     */
    @TableField(value = "numberofitems")
    @JSONField(name = "numberofitems")
    @JsonProperty("numberofitems")
    private Integer numberofitems;
    /**
     * PrimaryUserIdYomiName
     */
    @TableField(value = "primaryuseridyominame")
    @JSONField(name = "primaryuseridyominame")
    @JsonProperty("primaryuseridyominame")
    private String primaryuseridyominame;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * IgnoreUnsolicitedEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "ignoreunsolicitedemail")
    @JSONField(name = "ignoreunsolicitedemail")
    @JsonProperty("ignoreunsolicitedemail")
    private Integer ignoreunsolicitedemail;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * DefaultMailboxName
     */
    @TableField(value = "defaultmailboxname")
    @JSONField(name = "defaultmailboxname")
    @JsonProperty("defaultmailboxname")
    private String defaultmailboxname;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * OutgoingEmailDeliveryMethod
     */
    @TableField(value = "outgoingemaildeliverymethod")
    @JSONField(name = "outgoingemaildeliverymethod")
    @JsonProperty("outgoingemaildeliverymethod")
    private String outgoingemaildeliverymethod;
    /**
     * EmailRouterAccessApproval
     */
    @TableField(value = "emailrouteraccessapproval")
    @JSONField(name = "emailrouteraccessapproval")
    @JsonProperty("emailrouteraccessapproval")
    private String emailrouteraccessapproval;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;
    /**
     * BusinessUnitId
     */
    @TableField(value = "businessunitid")
    @JSONField(name = "businessunitid")
    @JsonProperty("businessunitid")
    private String businessunitid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.BusinessUnit businessunit;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [EMailAddress]
     */
    public void setEmailaddress(String emailaddress){
        this.emailaddress = emailaddress ;
        this.modify("emailaddress",emailaddress);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [PrimaryUserId]
     */
    public void setPrimaryuserid(String primaryuserid){
        this.primaryuserid = primaryuserid ;
        this.modify("primaryuserid",primaryuserid);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [IncomingEmailDeliveryMethod]
     */
    public void setIncomingemaildeliverymethod(String incomingemaildeliverymethod){
        this.incomingemaildeliverymethod = incomingemaildeliverymethod ;
        this.modify("incomingemaildeliverymethod",incomingemaildeliverymethod);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [FaxQueue]
     */
    public void setFaxqueue(Integer faxqueue){
        this.faxqueue = faxqueue ;
        this.modify("faxqueue",faxqueue);
    }
    /**
     * 设置 [QueueTypeCode]
     */
    public void setQueuetypecode(String queuetypecode){
        this.queuetypecode = queuetypecode ;
        this.modify("queuetypecode",queuetypecode);
    }
    /**
     * 设置 [IncomingEmailFilteringMethod]
     */
    public void setIncomingemailfilteringmethod(String incomingemailfilteringmethod){
        this.incomingemailfilteringmethod = incomingemailfilteringmethod ;
        this.modify("incomingemailfilteringmethod",incomingemailfilteringmethod);
    }
    /**
     * 设置 [NumberOfMembers]
     */
    public void setNumberofmembers(Integer numberofmembers){
        this.numberofmembers = numberofmembers ;
        this.modify("numberofmembers",numberofmembers);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [queueName]
     */
    public void setQueuename(String queuename){
        this.queuename = queuename ;
        this.modify("queuename",queuename);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [EmailPassword]
     */
    public void setEmailpassword(String emailpassword){
        this.emailpassword = emailpassword ;
        this.modify("emailpassword",emailpassword);
    }
    /**
     * 设置 [AllowEmailCredentials]
     */
    public void setAllowemailcredentials(Integer allowemailcredentials){
        this.allowemailcredentials = allowemailcredentials ;
        this.modify("allowemailcredentials",allowemailcredentials);
    }
    /**
     * 设置 [QueueViewType]
     */
    public void setQueueviewtype(String queueviewtype){
        this.queueviewtype = queueviewtype ;
        this.modify("queueviewtype",queueviewtype);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [EmailUsername]
     */
    public void setEmailusername(String emailusername){
        this.emailusername = emailusername ;
        this.modify("emailusername",emailusername);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [NumberOfItems]
     */
    public void setNumberofitems(Integer numberofitems){
        this.numberofitems = numberofitems ;
        this.modify("numberofitems",numberofitems);
    }
    /**
     * 设置 [PrimaryUserIdYomiName]
     */
    public void setPrimaryuseridyominame(String primaryuseridyominame){
        this.primaryuseridyominame = primaryuseridyominame ;
        this.modify("primaryuseridyominame",primaryuseridyominame);
    }
    /**
     * 设置 [IgnoreUnsolicitedEmail]
     */
    public void setIgnoreunsolicitedemail(Integer ignoreunsolicitedemail){
        this.ignoreunsolicitedemail = ignoreunsolicitedemail ;
        this.modify("ignoreunsolicitedemail",ignoreunsolicitedemail);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [DefaultMailboxName]
     */
    public void setDefaultmailboxname(String defaultmailboxname){
        this.defaultmailboxname = defaultmailboxname ;
        this.modify("defaultmailboxname",defaultmailboxname);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [OutgoingEmailDeliveryMethod]
     */
    public void setOutgoingemaildeliverymethod(String outgoingemaildeliverymethod){
        this.outgoingemaildeliverymethod = outgoingemaildeliverymethod ;
        this.modify("outgoingemaildeliverymethod",outgoingemaildeliverymethod);
    }
    /**
     * 设置 [EmailRouterAccessApproval]
     */
    public void setEmailrouteraccessapproval(String emailrouteraccessapproval){
        this.emailrouteraccessapproval = emailrouteraccessapproval ;
        this.modify("emailrouteraccessapproval",emailrouteraccessapproval);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }
    /**
     * 设置 [BusinessUnitId]
     */
    public void setBusinessunitid(String businessunitid){
        this.businessunitid = businessunitid ;
        this.modify("businessunitid",businessunitid);
    }

}


