package cn.ibizlab.businesscentral.core.sales.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[目标]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "GOAL",resultMap = "GoalResultMap")
public class Goal extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * InProgressDecimal
     */
    @TableField(value = "inprogressdecimal")
    @JSONField(name = "inprogressdecimal")
    @JsonProperty("inprogressdecimal")
    private BigDecimal inprogressdecimal;
    /**
     * GoalId
     */
    @DEField(isKeyField=true)
    @TableId(value= "goalid",type=IdType.UUID)
    @JSONField(name = "goalid")
    @JsonProperty("goalid")
    private String goalid;
    /**
     * StretchTargetMoney
     */
    @TableField(value = "stretchtargetmoney")
    @JSONField(name = "stretchtargetmoney")
    @JsonProperty("stretchtargetmoney")
    private BigDecimal stretchtargetmoney;
    /**
     * ActualDecimal
     */
    @TableField(value = "actualdecimal")
    @JSONField(name = "actualdecimal")
    @JsonProperty("actualdecimal")
    private BigDecimal actualdecimal;
    /**
     * ComputedTargetAsOfTodayInteger
     */
    @TableField(value = "computedtargetasoftodayinteger")
    @JSONField(name = "computedtargetasoftodayinteger")
    @JsonProperty("computedtargetasoftodayinteger")
    private Integer computedtargetasoftodayinteger;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * TargetInteger
     */
    @TableField(value = "targetinteger")
    @JSONField(name = "targetinteger")
    @JsonProperty("targetinteger")
    private Integer targetinteger;
    /**
     * CustomRollupFieldMoney_Base
     */
    @DEField(name = "customrollupfieldmoney_base")
    @TableField(value = "customrollupfieldmoney_base")
    @JSONField(name = "customrollupfieldmoney_base")
    @JsonProperty("customrollupfieldmoney_base")
    private BigDecimal customrollupfieldmoneyBase;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * ActualMoney_Base
     */
    @DEField(name = "actualmoney_base")
    @TableField(value = "actualmoney_base")
    @JSONField(name = "actualmoney_base")
    @JsonProperty("actualmoney_base")
    private BigDecimal actualmoneyBase;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * InProgressInteger
     */
    @TableField(value = "inprogressinteger")
    @JSONField(name = "inprogressinteger")
    @JsonProperty("inprogressinteger")
    private Integer inprogressinteger;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * TargetMoney_Base
     */
    @DEField(name = "targetmoney_base")
    @TableField(value = "targetmoney_base")
    @JSONField(name = "targetmoney_base")
    @JsonProperty("targetmoney_base")
    private BigDecimal targetmoneyBase;
    /**
     * InProgressString
     */
    @TableField(value = "inprogressstring")
    @JSONField(name = "inprogressstring")
    @JsonProperty("inprogressstring")
    private String inprogressstring;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * GoalStartDate
     */
    @TableField(value = "goalstartdate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "goalstartdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("goalstartdate")
    private Timestamp goalstartdate;
    /**
     * Percentage
     */
    @TableField(value = "percentage")
    @JSONField(name = "percentage")
    @JsonProperty("percentage")
    private BigDecimal percentage;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * GoalOwnerIdYomiName
     */
    @TableField(value = "goalowneridyominame")
    @JSONField(name = "goalowneridyominame")
    @JsonProperty("goalowneridyominame")
    private String goalowneridyominame;
    /**
     * TargetDecimal
     */
    @TableField(value = "targetdecimal")
    @JSONField(name = "targetdecimal")
    @JsonProperty("targetdecimal")
    private BigDecimal targetdecimal;
    /**
     * Amount
     */
    @DEField(defaultValue = "True")
    @TableField(value = "amount")
    @JSONField(name = "amount")
    @JsonProperty("amount")
    private Integer amount;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * AmountDataType
     */
    @TableField(value = "amountdatatype")
    @JSONField(name = "amountdatatype")
    @JsonProperty("amountdatatype")
    private String amountdatatype;
    /**
     * CustomRollupFieldInteger
     */
    @TableField(value = "customrollupfieldinteger")
    @JSONField(name = "customrollupfieldinteger")
    @JsonProperty("customrollupfieldinteger")
    private Integer customrollupfieldinteger;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * InProgressMoney
     */
    @TableField(value = "inprogressmoney")
    @JSONField(name = "inprogressmoney")
    @JsonProperty("inprogressmoney")
    private BigDecimal inprogressmoney;
    /**
     * FiscalYear
     */
    @TableField(value = "fiscalyear")
    @JSONField(name = "fiscalyear")
    @JsonProperty("fiscalyear")
    private String fiscalyear;
    /**
     * FiscalPeriod
     */
    @TableField(value = "fiscalperiod")
    @JSONField(name = "fiscalperiod")
    @JsonProperty("fiscalperiod")
    private String fiscalperiod;
    /**
     * Title
     */
    @TableField(value = "title")
    @JSONField(name = "title")
    @JsonProperty("title")
    private String title;
    /**
     * StretchTargetDecimal
     */
    @TableField(value = "stretchtargetdecimal")
    @JSONField(name = "stretchtargetdecimal")
    @JsonProperty("stretchtargetdecimal")
    private BigDecimal stretchtargetdecimal;
    /**
     * CustomRollupFieldDecimal
     */
    @TableField(value = "customrollupfielddecimal")
    @JSONField(name = "customrollupfielddecimal")
    @JsonProperty("customrollupfielddecimal")
    private BigDecimal customrollupfielddecimal;
    /**
     * ConsiderOnlyGoalOwnersRecords
     */
    @DEField(defaultValue = "True")
    @TableField(value = "consideronlygoalownersrecords")
    @JSONField(name = "consideronlygoalownersrecords")
    @JsonProperty("consideronlygoalownersrecords")
    private Integer consideronlygoalownersrecords;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * ActualMoney
     */
    @TableField(value = "actualmoney")
    @JSONField(name = "actualmoney")
    @JsonProperty("actualmoney")
    private BigDecimal actualmoney;
    /**
     * RollupOnlyFromChildGoals
     */
    @DEField(defaultValue = "False")
    @TableField(value = "rolluponlyfromchildgoals")
    @JSONField(name = "rolluponlyfromchildgoals")
    @JsonProperty("rolluponlyfromchildgoals")
    private Integer rolluponlyfromchildgoals;
    /**
     * GoalEndDate
     */
    @TableField(value = "goalenddate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "goalenddate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("goalenddate")
    private Timestamp goalenddate;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * CustomRollupFieldMoney
     */
    @TableField(value = "customrollupfieldmoney")
    @JSONField(name = "customrollupfieldmoney")
    @JsonProperty("customrollupfieldmoney")
    private BigDecimal customrollupfieldmoney;
    /**
     * RollupErrorCode
     */
    @TableField(value = "rolluperrorcode")
    @JSONField(name = "rolluperrorcode")
    @JsonProperty("rolluperrorcode")
    private Integer rolluperrorcode;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * StretchTargetMoney_Base
     */
    @DEField(name = "stretchtargetmoney_base")
    @TableField(value = "stretchtargetmoney_base")
    @JSONField(name = "stretchtargetmoney_base")
    @JsonProperty("stretchtargetmoney_base")
    private BigDecimal stretchtargetmoneyBase;
    /**
     * TreeId
     */
    @TableField(value = "treeid")
    @JSONField(name = "treeid")
    @JsonProperty("treeid")
    private String treeid;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * StretchTargetString
     */
    @TableField(value = "stretchtargetstring")
    @JSONField(name = "stretchtargetstring")
    @JsonProperty("stretchtargetstring")
    private String stretchtargetstring;
    /**
     * StretchTargetInteger
     */
    @TableField(value = "stretchtargetinteger")
    @JSONField(name = "stretchtargetinteger")
    @JsonProperty("stretchtargetinteger")
    private Integer stretchtargetinteger;
    /**
     * FiscalPeriodGoal
     */
    @DEField(defaultValue = "True")
    @TableField(value = "fiscalperiodgoal")
    @JSONField(name = "fiscalperiodgoal")
    @JsonProperty("fiscalperiodgoal")
    private Integer fiscalperiodgoal;
    /**
     * InProgressMoney_Base
     */
    @DEField(name = "inprogressmoney_base")
    @TableField(value = "inprogressmoney_base")
    @JSONField(name = "inprogressmoney_base")
    @JsonProperty("inprogressmoney_base")
    private BigDecimal inprogressmoneyBase;
    /**
     * Overridden
     */
    @DEField(defaultValue = "False")
    @TableField(value = "overridden")
    @JSONField(name = "overridden")
    @JsonProperty("overridden")
    private Integer overridden;
    /**
     * ActualString
     */
    @TableField(value = "actualstring")
    @JSONField(name = "actualstring")
    @JsonProperty("actualstring")
    private String actualstring;
    /**
     * ActualInteger
     */
    @TableField(value = "actualinteger")
    @JSONField(name = "actualinteger")
    @JsonProperty("actualinteger")
    private Integer actualinteger;
    /**
     * GoalOwnerIdType
     */
    @TableField(value = "goalowneridtype")
    @JSONField(name = "goalowneridtype")
    @JsonProperty("goalowneridtype")
    private String goalowneridtype;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * GoalOwnerId
     */
    @TableField(value = "goalownerid")
    @JSONField(name = "goalownerid")
    @JsonProperty("goalownerid")
    private String goalownerid;
    /**
     * ComputedTargetAsOfTodayDecimal
     */
    @TableField(value = "computedtargetasoftodaydecimal")
    @JSONField(name = "computedtargetasoftodaydecimal")
    @JsonProperty("computedtargetasoftodaydecimal")
    private BigDecimal computedtargetasoftodaydecimal;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * TargetString
     */
    @TableField(value = "targetstring")
    @JSONField(name = "targetstring")
    @JsonProperty("targetstring")
    private String targetstring;
    /**
     * CustomRollupFieldString
     */
    @TableField(value = "customrollupfieldstring")
    @JSONField(name = "customrollupfieldstring")
    @JsonProperty("customrollupfieldstring")
    private String customrollupfieldstring;
    /**
     * TargetMoney
     */
    @TableField(value = "targetmoney")
    @JSONField(name = "targetmoney")
    @JsonProperty("targetmoney")
    private BigDecimal targetmoney;
    /**
     * LastRolledupDate
     */
    @TableField(value = "lastrolledupdate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastrolledupdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastrolledupdate")
    private Timestamp lastrolledupdate;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * Override
     */
    @DEField(defaultValue = "False")
    @TableField(value = "override")
    @JSONField(name = "override")
    @JsonProperty("override")
    private Integer override;
    /**
     * ComputedTargetAsOfTodayMoney
     */
    @TableField(value = "computedtargetasoftodaymoney")
    @JSONField(name = "computedtargetasoftodaymoney")
    @JsonProperty("computedtargetasoftodaymoney")
    private BigDecimal computedtargetasoftodaymoney;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * ParentGoalId
     */
    @TableField(value = "parentgoalid")
    @JSONField(name = "parentgoalid")
    @JsonProperty("parentgoalid")
    private String parentgoalid;
    /**
     * RollUpQueryInprogressMoneyId
     */
    @TableField(value = "rollupqueryinprogressmoneyid")
    @JSONField(name = "rollupqueryinprogressmoneyid")
    @JsonProperty("rollupqueryinprogressmoneyid")
    private String rollupqueryinprogressmoneyid;
    /**
     * RollUpQueryCustomMoneyId
     */
    @TableField(value = "rollupquerycustommoneyid")
    @JSONField(name = "rollupquerycustommoneyid")
    @JsonProperty("rollupquerycustommoneyid")
    private String rollupquerycustommoneyid;
    /**
     * RollUpQueryInprogressIntegerId
     */
    @TableField(value = "rollupqueryinprogressintegerid")
    @JSONField(name = "rollupqueryinprogressintegerid")
    @JsonProperty("rollupqueryinprogressintegerid")
    private String rollupqueryinprogressintegerid;
    /**
     * RollUpQueryCustomDecimalId
     */
    @TableField(value = "rollupquerycustomdecimalid")
    @JSONField(name = "rollupquerycustomdecimalid")
    @JsonProperty("rollupquerycustomdecimalid")
    private String rollupquerycustomdecimalid;
    /**
     * RollUpQueryActualMoneyId
     */
    @TableField(value = "rollupqueryactualmoneyid")
    @JSONField(name = "rollupqueryactualmoneyid")
    @JsonProperty("rollupqueryactualmoneyid")
    private String rollupqueryactualmoneyid;
    /**
     * RollUpQueryCustomIntegerId
     */
    @TableField(value = "rollupquerycustomintegerid")
    @JSONField(name = "rollupquerycustomintegerid")
    @JsonProperty("rollupquerycustomintegerid")
    private String rollupquerycustomintegerid;
    /**
     * GoalWithErrorId
     */
    @TableField(value = "goalwitherrorid")
    @JSONField(name = "goalwitherrorid")
    @JsonProperty("goalwitherrorid")
    private String goalwitherrorid;
    /**
     * MetricId
     */
    @TableField(value = "metricid")
    @JSONField(name = "metricid")
    @JsonProperty("metricid")
    private String metricid;
    /**
     * RollUpQueryInprogressDecimalId
     */
    @TableField(value = "rollupqueryinprogressdecimalid")
    @JSONField(name = "rollupqueryinprogressdecimalid")
    @JsonProperty("rollupqueryinprogressdecimalid")
    private String rollupqueryinprogressdecimalid;
    /**
     * RollupQueryActualIntegerId
     */
    @TableField(value = "rollupqueryactualintegerid")
    @JSONField(name = "rollupqueryactualintegerid")
    @JsonProperty("rollupqueryactualintegerid")
    private String rollupqueryactualintegerid;
    /**
     * RollUpQueryActualDecimalId
     */
    @TableField(value = "rollupqueryactualdecimalid")
    @JSONField(name = "rollupqueryactualdecimalid")
    @JsonProperty("rollupqueryactualdecimalid")
    private String rollupqueryactualdecimalid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupqueryactualdecimal;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupqueryactualinteger;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupqueryactualmoney;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupquerycustomdecimal;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupquerycustominteger;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupquerycustommoney;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupqueryinprogressdecimal;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupqueryinprogressinteger;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.GoalRollupQuery rollupqueryinprogressmoney;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.Goal goalwitherror;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.Goal parentgoal;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Metric metric;



    /**
     * 设置 [InProgressDecimal]
     */
    public void setInprogressdecimal(BigDecimal inprogressdecimal){
        this.inprogressdecimal = inprogressdecimal ;
        this.modify("inprogressdecimal",inprogressdecimal);
    }
    /**
     * 设置 [StretchTargetMoney]
     */
    public void setStretchtargetmoney(BigDecimal stretchtargetmoney){
        this.stretchtargetmoney = stretchtargetmoney ;
        this.modify("stretchtargetmoney",stretchtargetmoney);
    }
    /**
     * 设置 [ActualDecimal]
     */
    public void setActualdecimal(BigDecimal actualdecimal){
        this.actualdecimal = actualdecimal ;
        this.modify("actualdecimal",actualdecimal);
    }
    /**
     * 设置 [ComputedTargetAsOfTodayInteger]
     */
    public void setComputedtargetasoftodayinteger(Integer computedtargetasoftodayinteger){
        this.computedtargetasoftodayinteger = computedtargetasoftodayinteger ;
        this.modify("computedtargetasoftodayinteger",computedtargetasoftodayinteger);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [TargetInteger]
     */
    public void setTargetinteger(Integer targetinteger){
        this.targetinteger = targetinteger ;
        this.modify("targetinteger",targetinteger);
    }
    /**
     * 设置 [CustomRollupFieldMoney_Base]
     */
    public void setCustomrollupfieldmoneyBase(BigDecimal customrollupfieldmoneyBase){
        this.customrollupfieldmoneyBase = customrollupfieldmoneyBase ;
        this.modify("customrollupfieldmoney_base",customrollupfieldmoneyBase);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [ActualMoney_Base]
     */
    public void setActualmoneyBase(BigDecimal actualmoneyBase){
        this.actualmoneyBase = actualmoneyBase ;
        this.modify("actualmoney_base",actualmoneyBase);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [InProgressInteger]
     */
    public void setInprogressinteger(Integer inprogressinteger){
        this.inprogressinteger = inprogressinteger ;
        this.modify("inprogressinteger",inprogressinteger);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [TargetMoney_Base]
     */
    public void setTargetmoneyBase(BigDecimal targetmoneyBase){
        this.targetmoneyBase = targetmoneyBase ;
        this.modify("targetmoney_base",targetmoneyBase);
    }
    /**
     * 设置 [InProgressString]
     */
    public void setInprogressstring(String inprogressstring){
        this.inprogressstring = inprogressstring ;
        this.modify("inprogressstring",inprogressstring);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [GoalStartDate]
     */
    public void setGoalstartdate(Timestamp goalstartdate){
        this.goalstartdate = goalstartdate ;
        this.modify("goalstartdate",goalstartdate);
    }
    /**
     * 设置 [Percentage]
     */
    public void setPercentage(BigDecimal percentage){
        this.percentage = percentage ;
        this.modify("percentage",percentage);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [GoalOwnerIdYomiName]
     */
    public void setGoalowneridyominame(String goalowneridyominame){
        this.goalowneridyominame = goalowneridyominame ;
        this.modify("goalowneridyominame",goalowneridyominame);
    }
    /**
     * 设置 [TargetDecimal]
     */
    public void setTargetdecimal(BigDecimal targetdecimal){
        this.targetdecimal = targetdecimal ;
        this.modify("targetdecimal",targetdecimal);
    }
    /**
     * 设置 [Amount]
     */
    public void setAmount(Integer amount){
        this.amount = amount ;
        this.modify("amount",amount);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [AmountDataType]
     */
    public void setAmountdatatype(String amountdatatype){
        this.amountdatatype = amountdatatype ;
        this.modify("amountdatatype",amountdatatype);
    }
    /**
     * 设置 [CustomRollupFieldInteger]
     */
    public void setCustomrollupfieldinteger(Integer customrollupfieldinteger){
        this.customrollupfieldinteger = customrollupfieldinteger ;
        this.modify("customrollupfieldinteger",customrollupfieldinteger);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [InProgressMoney]
     */
    public void setInprogressmoney(BigDecimal inprogressmoney){
        this.inprogressmoney = inprogressmoney ;
        this.modify("inprogressmoney",inprogressmoney);
    }
    /**
     * 设置 [FiscalYear]
     */
    public void setFiscalyear(String fiscalyear){
        this.fiscalyear = fiscalyear ;
        this.modify("fiscalyear",fiscalyear);
    }
    /**
     * 设置 [FiscalPeriod]
     */
    public void setFiscalperiod(String fiscalperiod){
        this.fiscalperiod = fiscalperiod ;
        this.modify("fiscalperiod",fiscalperiod);
    }
    /**
     * 设置 [Title]
     */
    public void setTitle(String title){
        this.title = title ;
        this.modify("title",title);
    }
    /**
     * 设置 [StretchTargetDecimal]
     */
    public void setStretchtargetdecimal(BigDecimal stretchtargetdecimal){
        this.stretchtargetdecimal = stretchtargetdecimal ;
        this.modify("stretchtargetdecimal",stretchtargetdecimal);
    }
    /**
     * 设置 [CustomRollupFieldDecimal]
     */
    public void setCustomrollupfielddecimal(BigDecimal customrollupfielddecimal){
        this.customrollupfielddecimal = customrollupfielddecimal ;
        this.modify("customrollupfielddecimal",customrollupfielddecimal);
    }
    /**
     * 设置 [ConsiderOnlyGoalOwnersRecords]
     */
    public void setConsideronlygoalownersrecords(Integer consideronlygoalownersrecords){
        this.consideronlygoalownersrecords = consideronlygoalownersrecords ;
        this.modify("consideronlygoalownersrecords",consideronlygoalownersrecords);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [ActualMoney]
     */
    public void setActualmoney(BigDecimal actualmoney){
        this.actualmoney = actualmoney ;
        this.modify("actualmoney",actualmoney);
    }
    /**
     * 设置 [RollupOnlyFromChildGoals]
     */
    public void setRolluponlyfromchildgoals(Integer rolluponlyfromchildgoals){
        this.rolluponlyfromchildgoals = rolluponlyfromchildgoals ;
        this.modify("rolluponlyfromchildgoals",rolluponlyfromchildgoals);
    }
    /**
     * 设置 [GoalEndDate]
     */
    public void setGoalenddate(Timestamp goalenddate){
        this.goalenddate = goalenddate ;
        this.modify("goalenddate",goalenddate);
    }
    /**
     * 设置 [CustomRollupFieldMoney]
     */
    public void setCustomrollupfieldmoney(BigDecimal customrollupfieldmoney){
        this.customrollupfieldmoney = customrollupfieldmoney ;
        this.modify("customrollupfieldmoney",customrollupfieldmoney);
    }
    /**
     * 设置 [RollupErrorCode]
     */
    public void setRolluperrorcode(Integer rolluperrorcode){
        this.rolluperrorcode = rolluperrorcode ;
        this.modify("rolluperrorcode",rolluperrorcode);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [StretchTargetMoney_Base]
     */
    public void setStretchtargetmoneyBase(BigDecimal stretchtargetmoneyBase){
        this.stretchtargetmoneyBase = stretchtargetmoneyBase ;
        this.modify("stretchtargetmoney_base",stretchtargetmoneyBase);
    }
    /**
     * 设置 [TreeId]
     */
    public void setTreeid(String treeid){
        this.treeid = treeid ;
        this.modify("treeid",treeid);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [StretchTargetString]
     */
    public void setStretchtargetstring(String stretchtargetstring){
        this.stretchtargetstring = stretchtargetstring ;
        this.modify("stretchtargetstring",stretchtargetstring);
    }
    /**
     * 设置 [StretchTargetInteger]
     */
    public void setStretchtargetinteger(Integer stretchtargetinteger){
        this.stretchtargetinteger = stretchtargetinteger ;
        this.modify("stretchtargetinteger",stretchtargetinteger);
    }
    /**
     * 设置 [FiscalPeriodGoal]
     */
    public void setFiscalperiodgoal(Integer fiscalperiodgoal){
        this.fiscalperiodgoal = fiscalperiodgoal ;
        this.modify("fiscalperiodgoal",fiscalperiodgoal);
    }
    /**
     * 设置 [InProgressMoney_Base]
     */
    public void setInprogressmoneyBase(BigDecimal inprogressmoneyBase){
        this.inprogressmoneyBase = inprogressmoneyBase ;
        this.modify("inprogressmoney_base",inprogressmoneyBase);
    }
    /**
     * 设置 [Overridden]
     */
    public void setOverridden(Integer overridden){
        this.overridden = overridden ;
        this.modify("overridden",overridden);
    }
    /**
     * 设置 [ActualString]
     */
    public void setActualstring(String actualstring){
        this.actualstring = actualstring ;
        this.modify("actualstring",actualstring);
    }
    /**
     * 设置 [ActualInteger]
     */
    public void setActualinteger(Integer actualinteger){
        this.actualinteger = actualinteger ;
        this.modify("actualinteger",actualinteger);
    }
    /**
     * 设置 [GoalOwnerIdType]
     */
    public void setGoalowneridtype(String goalowneridtype){
        this.goalowneridtype = goalowneridtype ;
        this.modify("goalowneridtype",goalowneridtype);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [GoalOwnerId]
     */
    public void setGoalownerid(String goalownerid){
        this.goalownerid = goalownerid ;
        this.modify("goalownerid",goalownerid);
    }
    /**
     * 设置 [ComputedTargetAsOfTodayDecimal]
     */
    public void setComputedtargetasoftodaydecimal(BigDecimal computedtargetasoftodaydecimal){
        this.computedtargetasoftodaydecimal = computedtargetasoftodaydecimal ;
        this.modify("computedtargetasoftodaydecimal",computedtargetasoftodaydecimal);
    }
    /**
     * 设置 [TargetString]
     */
    public void setTargetstring(String targetstring){
        this.targetstring = targetstring ;
        this.modify("targetstring",targetstring);
    }
    /**
     * 设置 [CustomRollupFieldString]
     */
    public void setCustomrollupfieldstring(String customrollupfieldstring){
        this.customrollupfieldstring = customrollupfieldstring ;
        this.modify("customrollupfieldstring",customrollupfieldstring);
    }
    /**
     * 设置 [TargetMoney]
     */
    public void setTargetmoney(BigDecimal targetmoney){
        this.targetmoney = targetmoney ;
        this.modify("targetmoney",targetmoney);
    }
    /**
     * 设置 [LastRolledupDate]
     */
    public void setLastrolledupdate(Timestamp lastrolledupdate){
        this.lastrolledupdate = lastrolledupdate ;
        this.modify("lastrolledupdate",lastrolledupdate);
    }
    /**
     * 设置 [Override]
     */
    public void setOverride(Integer override){
        this.override = override ;
        this.modify("override",override);
    }
    /**
     * 设置 [ComputedTargetAsOfTodayMoney]
     */
    public void setComputedtargetasoftodaymoney(BigDecimal computedtargetasoftodaymoney){
        this.computedtargetasoftodaymoney = computedtargetasoftodaymoney ;
        this.modify("computedtargetasoftodaymoney",computedtargetasoftodaymoney);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [ParentGoalId]
     */
    public void setParentgoalid(String parentgoalid){
        this.parentgoalid = parentgoalid ;
        this.modify("parentgoalid",parentgoalid);
    }
    /**
     * 设置 [RollUpQueryInprogressMoneyId]
     */
    public void setRollupqueryinprogressmoneyid(String rollupqueryinprogressmoneyid){
        this.rollupqueryinprogressmoneyid = rollupqueryinprogressmoneyid ;
        this.modify("rollupqueryinprogressmoneyid",rollupqueryinprogressmoneyid);
    }
    /**
     * 设置 [RollUpQueryCustomMoneyId]
     */
    public void setRollupquerycustommoneyid(String rollupquerycustommoneyid){
        this.rollupquerycustommoneyid = rollupquerycustommoneyid ;
        this.modify("rollupquerycustommoneyid",rollupquerycustommoneyid);
    }
    /**
     * 设置 [RollUpQueryInprogressIntegerId]
     */
    public void setRollupqueryinprogressintegerid(String rollupqueryinprogressintegerid){
        this.rollupqueryinprogressintegerid = rollupqueryinprogressintegerid ;
        this.modify("rollupqueryinprogressintegerid",rollupqueryinprogressintegerid);
    }
    /**
     * 设置 [RollUpQueryCustomDecimalId]
     */
    public void setRollupquerycustomdecimalid(String rollupquerycustomdecimalid){
        this.rollupquerycustomdecimalid = rollupquerycustomdecimalid ;
        this.modify("rollupquerycustomdecimalid",rollupquerycustomdecimalid);
    }
    /**
     * 设置 [RollUpQueryActualMoneyId]
     */
    public void setRollupqueryactualmoneyid(String rollupqueryactualmoneyid){
        this.rollupqueryactualmoneyid = rollupqueryactualmoneyid ;
        this.modify("rollupqueryactualmoneyid",rollupqueryactualmoneyid);
    }
    /**
     * 设置 [RollUpQueryCustomIntegerId]
     */
    public void setRollupquerycustomintegerid(String rollupquerycustomintegerid){
        this.rollupquerycustomintegerid = rollupquerycustomintegerid ;
        this.modify("rollupquerycustomintegerid",rollupquerycustomintegerid);
    }
    /**
     * 设置 [GoalWithErrorId]
     */
    public void setGoalwitherrorid(String goalwitherrorid){
        this.goalwitherrorid = goalwitherrorid ;
        this.modify("goalwitherrorid",goalwitherrorid);
    }
    /**
     * 设置 [MetricId]
     */
    public void setMetricid(String metricid){
        this.metricid = metricid ;
        this.modify("metricid",metricid);
    }
    /**
     * 设置 [RollUpQueryInprogressDecimalId]
     */
    public void setRollupqueryinprogressdecimalid(String rollupqueryinprogressdecimalid){
        this.rollupqueryinprogressdecimalid = rollupqueryinprogressdecimalid ;
        this.modify("rollupqueryinprogressdecimalid",rollupqueryinprogressdecimalid);
    }
    /**
     * 设置 [RollupQueryActualIntegerId]
     */
    public void setRollupqueryactualintegerid(String rollupqueryactualintegerid){
        this.rollupqueryactualintegerid = rollupqueryactualintegerid ;
        this.modify("rollupqueryactualintegerid",rollupqueryactualintegerid);
    }
    /**
     * 设置 [RollUpQueryActualDecimalId]
     */
    public void setRollupqueryactualdecimalid(String rollupqueryactualdecimalid){
        this.rollupqueryactualdecimalid = rollupqueryactualdecimalid ;
        this.modify("rollupqueryactualdecimalid",rollupqueryactualdecimalid);
    }

}


