package cn.ibizlab.businesscentral.core.sales.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[潜在客户]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "LEAD",resultMap = "LeadResultMap")
public class Lead extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * Address1_Fax
     */
    @DEField(name = "address1_fax")
    @TableField(value = "address1_fax")
    @JSONField(name = "address1_fax")
    @JsonProperty("address1_fax")
    private String address1Fax;
    /**
     * Address2_UTCOffset
     */
    @DEField(name = "address2_utcoffset")
    @TableField(value = "address2_utcoffset")
    @JSONField(name = "address2_utcoffset")
    @JsonProperty("address2_utcoffset")
    private Integer address2Utcoffset;
    /**
     * SLAName
     */
    @TableField(value = "slaname")
    @JSONField(name = "slaname")
    @JsonProperty("slaname")
    private String slaname;
    /**
     * JobTitle
     */
    @TableField(value = "jobtitle")
    @JSONField(name = "jobtitle")
    @JsonProperty("jobtitle")
    private String jobtitle;
    /**
     * Address2_Country
     */
    @DEField(name = "address2_country")
    @TableField(value = "address2_country")
    @JSONField(name = "address2_country")
    @JsonProperty("address2_country")
    private String address2Country;
    /**
     * BudgetAmount
     */
    @TableField(value = "budgetamount")
    @JSONField(name = "budgetamount")
    @JsonProperty("budgetamount")
    private BigDecimal budgetamount;
    /**
     * Address2_Fax
     */
    @DEField(name = "address2_fax")
    @TableField(value = "address2_fax")
    @JSONField(name = "address2_fax")
    @JsonProperty("address2_fax")
    private String address2Fax;
    /**
     * OnHoldTime
     */
    @TableField(value = "onholdtime")
    @JSONField(name = "onholdtime")
    @JsonProperty("onholdtime")
    private Integer onholdtime;
    /**
     * LastName
     */
    @TableField(value = "lastname")
    @JSONField(name = "lastname")
    @JsonProperty("lastname")
    private String lastname;
    /**
     * Address1_Telephone2
     */
    @DEField(name = "address1_telephone2")
    @TableField(value = "address1_telephone2")
    @JSONField(name = "address1_telephone2")
    @JsonProperty("address1_telephone2")
    private String address1Telephone2;
    /**
     * Address1_StateOrProvince
     */
    @DEField(name = "address1_stateorprovince")
    @TableField(value = "address1_stateorprovince")
    @JSONField(name = "address1_stateorprovince")
    @JsonProperty("address1_stateorprovince")
    private String address1Stateorprovince;
    /**
     * MasterLeadIdYomiName
     */
    @TableField(value = "masterleadidyominame")
    @JSONField(name = "masterleadidyominame")
    @JsonProperty("masterleadidyominame")
    private String masterleadidyominame;
    /**
     * EstimatedValue
     */
    @TableField(value = "estimatedvalue")
    @JSONField(name = "estimatedvalue")
    @JsonProperty("estimatedvalue")
    private Double estimatedvalue;
    /**
     * LeadId
     */
    @DEField(isKeyField=true)
    @TableId(value= "leadid",type=IdType.UUID)
    @JSONField(name = "leadid")
    @JsonProperty("leadid")
    private String leadid;
    /**
     * Address1_Longitude
     */
    @DEField(name = "address1_longitude")
    @TableField(value = "address1_longitude")
    @JSONField(name = "address1_longitude")
    @JsonProperty("address1_longitude")
    private Double address1Longitude;
    /**
     * Address1_Line1
     */
    @DEField(name = "address1_line1")
    @TableField(value = "address1_line1")
    @JSONField(name = "address1_line1")
    @JsonProperty("address1_line1")
    private String address1Line1;
    /**
     * LeadQualityCode
     */
    @TableField(value = "leadqualitycode")
    @JSONField(name = "leadqualitycode")
    @JsonProperty("leadqualitycode")
    private String leadqualitycode;
    /**
     * DoNotPhone
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotphone")
    @JSONField(name = "donotphone")
    @JsonProperty("donotphone")
    private Integer donotphone;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * ParentContactIdYomiName
     */
    @TableField(value = "parentcontactidyominame")
    @JSONField(name = "parentcontactidyominame")
    @JsonProperty("parentcontactidyominame")
    private String parentcontactidyominame;
    /**
     * Address2_StateOrProvince
     */
    @DEField(name = "address2_stateorprovince")
    @TableField(value = "address2_stateorprovince")
    @JSONField(name = "address2_stateorprovince")
    @JsonProperty("address2_stateorprovince")
    private String address2Stateorprovince;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * NumberOfEmployees
     */
    @TableField(value = "numberofemployees")
    @JSONField(name = "numberofemployees")
    @JsonProperty("numberofemployees")
    private Integer numberofemployees;
    /**
     * Address1_City
     */
    @DEField(name = "address1_city")
    @TableField(value = "address1_city")
    @JSONField(name = "address1_city")
    @JsonProperty("address1_city")
    private String address1City;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * Address2_Line3
     */
    @DEField(name = "address2_line3")
    @TableField(value = "address2_line3")
    @JSONField(name = "address2_line3")
    @JsonProperty("address2_line3")
    private String address2Line3;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * Address2_Line1
     */
    @DEField(name = "address2_line1")
    @TableField(value = "address2_line1")
    @JSONField(name = "address2_line1")
    @JsonProperty("address2_line1")
    private String address2Line1;
    /**
     * CustomerId
     */
    @TableField(value = "customerid")
    @JSONField(name = "customerid")
    @JsonProperty("customerid")
    private String customerid;
    /**
     * CompanyName
     */
    @TableField(value = "companyname")
    @JSONField(name = "companyname")
    @JsonProperty("companyname")
    private String companyname;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * QualificationComments
     */
    @TableField(value = "qualificationcomments")
    @JSONField(name = "qualificationcomments")
    @JsonProperty("qualificationcomments")
    private String qualificationcomments;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * ContactIdYomiName
     */
    @TableField(value = "contactidyominame")
    @JSONField(name = "contactidyominame")
    @JsonProperty("contactidyominame")
    private String contactidyominame;
    /**
     * Address2_Name
     */
    @DEField(name = "address2_name")
    @TableField(value = "address2_name")
    @JSONField(name = "address2_name")
    @JsonProperty("address2_name")
    private String address2Name;
    /**
     * EMailAddress1
     */
    @TableField(value = "emailaddress1")
    @JSONField(name = "emailaddress1")
    @JsonProperty("emailaddress1")
    private String emailaddress1;
    /**
     * FollowEmail
     */
    @DEField(defaultValue = "True")
    @TableField(value = "followemail")
    @JSONField(name = "followemail")
    @JsonProperty("followemail")
    private Integer followemail;
    /**
     * Address1_Country
     */
    @DEField(name = "address1_country")
    @TableField(value = "address1_country")
    @JSONField(name = "address1_country")
    @JsonProperty("address1_country")
    private String address1Country;
    /**
     * WebSiteUrl
     */
    @TableField(value = "websiteurl")
    @JSONField(name = "websiteurl")
    @JsonProperty("websiteurl")
    private String websiteurl;
    /**
     * YomiCompanyName
     */
    @TableField(value = "yomicompanyname")
    @JSONField(name = "yomicompanyname")
    @JsonProperty("yomicompanyname")
    private String yomicompanyname;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * Address1_Line3
     */
    @DEField(name = "address1_line3")
    @TableField(value = "address1_line3")
    @JSONField(name = "address1_line3")
    @JsonProperty("address1_line3")
    private String address1Line3;
    /**
     * Address2_AddressId
     */
    @DEField(name = "address2_addressid")
    @TableField(value = "address2_addressid")
    @JSONField(name = "address2_addressid")
    @JsonProperty("address2_addressid")
    private String address2Addressid;
    /**
     * Address1_Composite
     */
    @DEField(name = "address1_composite")
    @TableField(value = "address1_composite")
    @JSONField(name = "address1_composite")
    @JsonProperty("address1_composite")
    private String address1Composite;
    /**
     * Subject
     */
    @TableField(value = "subject")
    @JSONField(name = "subject")
    @JsonProperty("subject")
    private String subject;
    /**
     * Address1_UTCOffset
     */
    @DEField(name = "address1_utcoffset")
    @TableField(value = "address1_utcoffset")
    @JSONField(name = "address1_utcoffset")
    @JsonProperty("address1_utcoffset")
    private Integer address1Utcoffset;
    /**
     * BudgetAmount_Base
     */
    @DEField(name = "budgetamount_base")
    @TableField(value = "budgetamount_base")
    @JSONField(name = "budgetamount_base")
    @JsonProperty("budgetamount_base")
    private BigDecimal budgetamountBase;
    /**
     * Address1_AddressTypeCode
     */
    @DEField(name = "address1_addresstypecode")
    @TableField(value = "address1_addresstypecode")
    @JSONField(name = "address1_addresstypecode")
    @JsonProperty("address1_addresstypecode")
    private String address1Addresstypecode;
    /**
     * Address2_Telephone3
     */
    @DEField(name = "address2_telephone3")
    @TableField(value = "address2_telephone3")
    @JSONField(name = "address2_telephone3")
    @JsonProperty("address2_telephone3")
    private String address2Telephone3;
    /**
     * EvaluateFit
     */
    @DEField(defaultValue = "False")
    @TableField(value = "evaluatefit")
    @JSONField(name = "evaluatefit")
    @JsonProperty("evaluatefit")
    private Integer evaluatefit;
    /**
     * Address1_Latitude
     */
    @DEField(name = "address1_latitude")
    @TableField(value = "address1_latitude")
    @JSONField(name = "address1_latitude")
    @JsonProperty("address1_latitude")
    private Double address1Latitude;
    /**
     * Address1_Telephone3
     */
    @DEField(name = "address1_telephone3")
    @TableField(value = "address1_telephone3")
    @JSONField(name = "address1_telephone3")
    @JsonProperty("address1_telephone3")
    private String address1Telephone3;
    /**
     * FullName
     */
    @TableField(value = "fullname")
    @JSONField(name = "fullname")
    @JsonProperty("fullname")
    private String fullname;
    /**
     * EstimatedAmount_Base
     */
    @DEField(name = "estimatedamount_base")
    @TableField(value = "estimatedamount_base")
    @JSONField(name = "estimatedamount_base")
    @JsonProperty("estimatedamount_base")
    private BigDecimal estimatedamountBase;
    /**
     * BudgetStatus
     */
    @TableField(value = "budgetstatus")
    @JSONField(name = "budgetstatus")
    @JsonProperty("budgetstatus")
    private String budgetstatus;
    /**
     * IndustryCode
     */
    @TableField(value = "industrycode")
    @JSONField(name = "industrycode")
    @JsonProperty("industrycode")
    private String industrycode;
    /**
     * Address1_Line2
     */
    @DEField(name = "address1_line2")
    @TableField(value = "address1_line2")
    @JSONField(name = "address1_line2")
    @JsonProperty("address1_line2")
    private String address1Line2;
    /**
     * InitialCommunication
     */
    @TableField(value = "initialcommunication")
    @JSONField(name = "initialcommunication")
    @JsonProperty("initialcommunication")
    private String initialcommunication;
    /**
     * Address1_PostOfficeBox
     */
    @DEField(name = "address1_postofficebox")
    @TableField(value = "address1_postofficebox")
    @JSONField(name = "address1_postofficebox")
    @JsonProperty("address1_postofficebox")
    private String address1Postofficebox;
    /**
     * Address1_Telephone1
     */
    @DEField(name = "address1_telephone1")
    @TableField(value = "address1_telephone1")
    @JSONField(name = "address1_telephone1")
    @JsonProperty("address1_telephone1")
    private String address1Telephone1;
    /**
     * Revenue
     */
    @TableField(value = "revenue")
    @JSONField(name = "revenue")
    @JsonProperty("revenue")
    private BigDecimal revenue;
    /**
     * YomiLastName
     */
    @TableField(value = "yomilastname")
    @JSONField(name = "yomilastname")
    @JsonProperty("yomilastname")
    private String yomilastname;
    /**
     * Address2_County
     */
    @DEField(name = "address2_county")
    @TableField(value = "address2_county")
    @JSONField(name = "address2_county")
    @JsonProperty("address2_county")
    private String address2County;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * ParentAccountIdYomiName
     */
    @TableField(value = "parentaccountidyominame")
    @JSONField(name = "parentaccountidyominame")
    @JsonProperty("parentaccountidyominame")
    private String parentaccountidyominame;
    /**
     * Address1_ShippingMethodCode
     */
    @DEField(name = "address1_shippingmethodcode")
    @TableField(value = "address1_shippingmethodcode")
    @JSONField(name = "address1_shippingmethodcode")
    @JsonProperty("address1_shippingmethodcode")
    private String address1Shippingmethodcode;
    /**
     * EstimatedAmount
     */
    @TableField(value = "estimatedamount")
    @JSONField(name = "estimatedamount")
    @JsonProperty("estimatedamount")
    private BigDecimal estimatedamount;
    /**
     * Address1_County
     */
    @DEField(name = "address1_county")
    @TableField(value = "address1_county")
    @JSONField(name = "address1_county")
    @JsonProperty("address1_county")
    private String address1County;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * LastOnHoldTime
     */
    @TableField(value = "lastonholdtime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastonholdtime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastonholdtime")
    private Timestamp lastonholdtime;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * TeamsFollowed
     */
    @TableField(value = "teamsfollowed")
    @JSONField(name = "teamsfollowed")
    @JsonProperty("teamsfollowed")
    private Integer teamsfollowed;
    /**
     * Salutation
     */
    @TableField(value = "salutation")
    @JSONField(name = "salutation")
    @JsonProperty("salutation")
    private String salutation;
    /**
     * Address2_ShippingMethodCode
     */
    @DEField(name = "address2_shippingmethodcode")
    @TableField(value = "address2_shippingmethodcode")
    @JSONField(name = "address2_shippingmethodcode")
    @JsonProperty("address2_shippingmethodcode")
    private String address2Shippingmethodcode;
    /**
     * Address2_Latitude
     */
    @DEField(name = "address2_latitude")
    @TableField(value = "address2_latitude")
    @JSONField(name = "address2_latitude")
    @JsonProperty("address2_latitude")
    private Double address2Latitude;
    /**
     * ParticipatesInWorkflow
     */
    @DEField(defaultValue = "False")
    @TableField(value = "participatesinworkflow")
    @JSONField(name = "participatesinworkflow")
    @JsonProperty("participatesinworkflow")
    private Integer participatesinworkflow;
    /**
     * YomiFirstName
     */
    @TableField(value = "yomifirstname")
    @JSONField(name = "yomifirstname")
    @JsonProperty("yomifirstname")
    private String yomifirstname;
    /**
     * Address2_Composite
     */
    @DEField(name = "address2_composite")
    @TableField(value = "address2_composite")
    @JSONField(name = "address2_composite")
    @JsonProperty("address2_composite")
    private String address2Composite;
    /**
     * SalesStage
     */
    @TableField(value = "salesstage")
    @JSONField(name = "salesstage")
    @JsonProperty("salesstage")
    private String salesstage;
    /**
     * DoNotPostalMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotpostalmail")
    @JSONField(name = "donotpostalmail")
    @JsonProperty("donotpostalmail")
    private Integer donotpostalmail;
    /**
     * CustomerIdYomiName
     */
    @TableField(value = "customeridyominame")
    @JSONField(name = "customeridyominame")
    @JsonProperty("customeridyominame")
    private String customeridyominame;
    /**
     * AccountIdYomiName
     */
    @TableField(value = "accountidyominame")
    @JSONField(name = "accountidyominame")
    @JsonProperty("accountidyominame")
    private String accountidyominame;
    /**
     * Revenue_Base
     */
    @DEField(name = "revenue_base")
    @TableField(value = "revenue_base")
    @JSONField(name = "revenue_base")
    @JsonProperty("revenue_base")
    private BigDecimal revenueBase;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * ScheduleFollowUp_Prospect
     */
    @DEField(name = "schedulefollowup_prospect")
    @TableField(value = "schedulefollowup_prospect")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "schedulefollowup_prospect" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("schedulefollowup_prospect")
    private Timestamp schedulefollowupProspect;
    /**
     * Address2_City
     */
    @DEField(name = "address2_city")
    @TableField(value = "address2_city")
    @JSONField(name = "address2_city")
    @JsonProperty("address2_city")
    private String address2City;
    /**
     * Telephone1
     */
    @TableField(value = "telephone1")
    @JSONField(name = "telephone1")
    @JsonProperty("telephone1")
    private String telephone1;
    /**
     * Private
     */
    @DEField(defaultValue = "False")
    @TableField(value = "private")
    @JSONField(name = "ibizprivate")
    @JsonProperty("ibizprivate")
    private Integer ibizprivate;
    /**
     * CustomerIdType
     */
    @TableField(value = "customeridtype")
    @JSONField(name = "customeridtype")
    @JsonProperty("customeridtype")
    private String customeridtype;
    /**
     * MobilePhone
     */
    @TableField(value = "mobilephone")
    @JSONField(name = "mobilephone")
    @JsonProperty("mobilephone")
    private String mobilephone;
    /**
     * Need
     */
    @TableField(value = "need")
    @JSONField(name = "need")
    @JsonProperty("need")
    private String need;
    /**
     * PriorityCode
     */
    @TableField(value = "prioritycode")
    @JSONField(name = "prioritycode")
    @JsonProperty("prioritycode")
    private String prioritycode;
    /**
     * Address1_AddressId
     */
    @DEField(name = "address1_addressid")
    @TableField(value = "address1_addressid")
    @JSONField(name = "address1_addressid")
    @JsonProperty("address1_addressid")
    private String address1Addressid;
    /**
     * YomiFullName
     */
    @TableField(value = "yomifullname")
    @JSONField(name = "yomifullname")
    @JsonProperty("yomifullname")
    private String yomifullname;
    /**
     * SalesStageCode
     */
    @TableField(value = "salesstagecode")
    @JSONField(name = "salesstagecode")
    @JsonProperty("salesstagecode")
    private String salesstagecode;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * Address2_Telephone1
     */
    @DEField(name = "address2_telephone1")
    @TableField(value = "address2_telephone1")
    @JSONField(name = "address2_telephone1")
    @JsonProperty("address2_telephone1")
    private String address2Telephone1;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * MiddleName
     */
    @TableField(value = "middlename")
    @JSONField(name = "middlename")
    @JsonProperty("middlename")
    private String middlename;
    /**
     * Telephone2
     */
    @TableField(value = "telephone2")
    @JSONField(name = "telephone2")
    @JsonProperty("telephone2")
    private String telephone2;
    /**
     * PurchaseTimeFrame
     */
    @TableField(value = "purchasetimeframe")
    @JSONField(name = "purchasetimeframe")
    @JsonProperty("purchasetimeframe")
    private String purchasetimeframe;
    /**
     * YomiMiddleName
     */
    @TableField(value = "yomimiddlename")
    @JSONField(name = "yomimiddlename")
    @JsonProperty("yomimiddlename")
    private String yomimiddlename;
    /**
     * LeadSourceCode
     */
    @TableField(value = "leadsourcecode")
    @JSONField(name = "leadsourcecode")
    @JsonProperty("leadsourcecode")
    private String leadsourcecode;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * PreferredContactMethodCode
     */
    @TableField(value = "preferredcontactmethodcode")
    @JSONField(name = "preferredcontactmethodcode")
    @JsonProperty("preferredcontactmethodcode")
    private String preferredcontactmethodcode;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * Address2_Telephone2
     */
    @DEField(name = "address2_telephone2")
    @TableField(value = "address2_telephone2")
    @JSONField(name = "address2_telephone2")
    @JsonProperty("address2_telephone2")
    private String address2Telephone2;
    /**
     * DoNotSendMM
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotsendmm")
    @JSONField(name = "donotsendmm")
    @JsonProperty("donotsendmm")
    private Integer donotsendmm;
    /**
     * PurchaseProcess
     */
    @TableField(value = "purchaseprocess")
    @JSONField(name = "purchaseprocess")
    @JsonProperty("purchaseprocess")
    private String purchaseprocess;
    /**
     * DoNotBulkEMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotbulkemail")
    @JSONField(name = "donotbulkemail")
    @JsonProperty("donotbulkemail")
    private Integer donotbulkemail;
    /**
     * SIC
     */
    @TableField(value = "sic")
    @JSONField(name = "sic")
    @JsonProperty("sic")
    private String sic;
    /**
     * DoNotEMail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotemail")
    @JSONField(name = "donotemail")
    @JsonProperty("donotemail")
    private Integer donotemail;
    /**
     * Address2_Longitude
     */
    @DEField(name = "address2_longitude")
    @TableField(value = "address2_longitude")
    @JSONField(name = "address2_longitude")
    @JsonProperty("address2_longitude")
    private Double address2Longitude;
    /**
     * ConfirmInterest
     */
    @DEField(defaultValue = "False")
    @TableField(value = "confirminterest")
    @JSONField(name = "confirminterest")
    @JsonProperty("confirminterest")
    private Integer confirminterest;
    /**
     * Address2_PostOfficeBox
     */
    @DEField(name = "address2_postofficebox")
    @TableField(value = "address2_postofficebox")
    @JSONField(name = "address2_postofficebox")
    @JsonProperty("address2_postofficebox")
    private String address2Postofficebox;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * AutoCreate
     */
    @DEField(defaultValue = "False")
    @TableField(value = "autocreate")
    @JSONField(name = "autocreate")
    @JsonProperty("autocreate")
    private Integer autocreate;
    /**
     * Address1_Name
     */
    @DEField(name = "address1_name")
    @TableField(value = "address1_name")
    @JSONField(name = "address1_name")
    @JsonProperty("address1_name")
    private String address1Name;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * LastUsedInCampaign
     */
    @TableField(value = "lastusedincampaign")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastusedincampaign" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastusedincampaign")
    private Timestamp lastusedincampaign;
    /**
     * EstimatedCloseDate
     */
    @TableField(value = "estimatedclosedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "estimatedclosedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("estimatedclosedate")
    private Timestamp estimatedclosedate;
    /**
     * Address2_Line2
     */
    @DEField(name = "address2_line2")
    @TableField(value = "address2_line2")
    @JSONField(name = "address2_line2")
    @JsonProperty("address2_line2")
    private String address2Line2;
    /**
     * EMailAddress3
     */
    @TableField(value = "emailaddress3")
    @JSONField(name = "emailaddress3")
    @JsonProperty("emailaddress3")
    private String emailaddress3;
    /**
     * Pager
     */
    @TableField(value = "pager")
    @JSONField(name = "pager")
    @JsonProperty("pager")
    private String pager;
    /**
     * Address2_UPSZone
     */
    @DEField(name = "address2_upszone")
    @TableField(value = "address2_upszone")
    @JSONField(name = "address2_upszone")
    @JsonProperty("address2_upszone")
    private String address2Upszone;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * Fax
     */
    @TableField(value = "fax")
    @JSONField(name = "fax")
    @JsonProperty("fax")
    private String fax;
    /**
     * ScheduleFollowUp_Qualify
     */
    @DEField(name = "schedulefollowup_qualify")
    @TableField(value = "schedulefollowup_qualify")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "schedulefollowup_qualify" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("schedulefollowup_qualify")
    private Timestamp schedulefollowupQualify;
    /**
     * Telephone3
     */
    @TableField(value = "telephone3")
    @JSONField(name = "telephone3")
    @JsonProperty("telephone3")
    private String telephone3;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * EMailAddress2
     */
    @TableField(value = "emailaddress2")
    @JSONField(name = "emailaddress2")
    @JsonProperty("emailaddress2")
    private String emailaddress2;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * DecisionMaker
     */
    @DEField(defaultValue = "False")
    @TableField(value = "decisionmaker")
    @JSONField(name = "decisionmaker")
    @JsonProperty("decisionmaker")
    private Integer decisionmaker;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * Address1_PostalCode
     */
    @DEField(name = "address1_postalcode")
    @TableField(value = "address1_postalcode")
    @JSONField(name = "address1_postalcode")
    @JsonProperty("address1_postalcode")
    private String address1Postalcode;
    /**
     * Address2_PostalCode
     */
    @DEField(name = "address2_postalcode")
    @TableField(value = "address2_postalcode")
    @JSONField(name = "address2_postalcode")
    @JsonProperty("address2_postalcode")
    private String address2Postalcode;
    /**
     * DoNotFax
     */
    @DEField(defaultValue = "False")
    @TableField(value = "donotfax")
    @JSONField(name = "donotfax")
    @JsonProperty("donotfax")
    private Integer donotfax;
    /**
     * FirstName
     */
    @TableField(value = "firstname")
    @JSONField(name = "firstname")
    @JsonProperty("firstname")
    private String firstname;
    /**
     * Merged
     */
    @DEField(defaultValue = "False")
    @TableField(value = "merged")
    @JSONField(name = "merged")
    @JsonProperty("merged")
    private Integer merged;
    /**
     * Address2_AddressTypeCode
     */
    @DEField(name = "address2_addresstypecode")
    @TableField(value = "address2_addresstypecode")
    @JSONField(name = "address2_addresstypecode")
    @JsonProperty("address2_addresstypecode")
    private String address2Addresstypecode;
    /**
     * Address1_UPSZone
     */
    @DEField(name = "address1_upszone")
    @TableField(value = "address1_upszone")
    @JSONField(name = "address1_upszone")
    @JsonProperty("address1_upszone")
    private String address1Upszone;
    /**
     * QualifyingOpportunityId
     */
    @TableField(value = "qualifyingopportunityid")
    @JSONField(name = "qualifyingopportunityid")
    @JsonProperty("qualifyingopportunityid")
    private String qualifyingopportunityid;
    /**
     * SLAId
     */
    @TableField(value = "slaid")
    @JSONField(name = "slaid")
    @JsonProperty("slaid")
    private String slaid;
    /**
     * CampaignId
     */
    @TableField(value = "campaignid")
    @JSONField(name = "campaignid")
    @JsonProperty("campaignid")
    private String campaignid;
    /**
     * RelatedObjectId
     */
    @TableField(value = "relatedobjectid")
    @JSONField(name = "relatedobjectid")
    @JsonProperty("relatedobjectid")
    private String relatedobjectid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;
    /**
     * ParentAccountId
     */
    @TableField(value = "parentaccountid")
    @JSONField(name = "parentaccountid")
    @JsonProperty("parentaccountid")
    private String parentaccountid;
    /**
     * OriginatingCaseId
     */
    @TableField(value = "originatingcaseid")
    @JSONField(name = "originatingcaseid")
    @JsonProperty("originatingcaseid")
    private String originatingcaseid;
    /**
     * ParentContactId
     */
    @TableField(value = "parentcontactid")
    @JSONField(name = "parentcontactid")
    @JsonProperty("parentcontactid")
    private String parentcontactid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Account parentaccount;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.marketing.domain.CampaignResponse relatedobject;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.marketing.domain.Campaign campaign;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Contact parentcontact;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Incident originatingcase;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.Opportunity qualifyingopportunity;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Sla sla;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [Address1_Fax]
     */
    public void setAddress1Fax(String address1Fax){
        this.address1Fax = address1Fax ;
        this.modify("address1_fax",address1Fax);
    }
    /**
     * 设置 [Address2_UTCOffset]
     */
    public void setAddress2Utcoffset(Integer address2Utcoffset){
        this.address2Utcoffset = address2Utcoffset ;
        this.modify("address2_utcoffset",address2Utcoffset);
    }
    /**
     * 设置 [SLAName]
     */
    public void setSlaname(String slaname){
        this.slaname = slaname ;
        this.modify("slaname",slaname);
    }
    /**
     * 设置 [JobTitle]
     */
    public void setJobtitle(String jobtitle){
        this.jobtitle = jobtitle ;
        this.modify("jobtitle",jobtitle);
    }
    /**
     * 设置 [Address2_Country]
     */
    public void setAddress2Country(String address2Country){
        this.address2Country = address2Country ;
        this.modify("address2_country",address2Country);
    }
    /**
     * 设置 [BudgetAmount]
     */
    public void setBudgetamount(BigDecimal budgetamount){
        this.budgetamount = budgetamount ;
        this.modify("budgetamount",budgetamount);
    }
    /**
     * 设置 [Address2_Fax]
     */
    public void setAddress2Fax(String address2Fax){
        this.address2Fax = address2Fax ;
        this.modify("address2_fax",address2Fax);
    }
    /**
     * 设置 [OnHoldTime]
     */
    public void setOnholdtime(Integer onholdtime){
        this.onholdtime = onholdtime ;
        this.modify("onholdtime",onholdtime);
    }
    /**
     * 设置 [LastName]
     */
    public void setLastname(String lastname){
        this.lastname = lastname ;
        this.modify("lastname",lastname);
    }
    /**
     * 设置 [Address1_Telephone2]
     */
    public void setAddress1Telephone2(String address1Telephone2){
        this.address1Telephone2 = address1Telephone2 ;
        this.modify("address1_telephone2",address1Telephone2);
    }
    /**
     * 设置 [Address1_StateOrProvince]
     */
    public void setAddress1Stateorprovince(String address1Stateorprovince){
        this.address1Stateorprovince = address1Stateorprovince ;
        this.modify("address1_stateorprovince",address1Stateorprovince);
    }
    /**
     * 设置 [MasterLeadIdYomiName]
     */
    public void setMasterleadidyominame(String masterleadidyominame){
        this.masterleadidyominame = masterleadidyominame ;
        this.modify("masterleadidyominame",masterleadidyominame);
    }
    /**
     * 设置 [EstimatedValue]
     */
    public void setEstimatedvalue(Double estimatedvalue){
        this.estimatedvalue = estimatedvalue ;
        this.modify("estimatedvalue",estimatedvalue);
    }
    /**
     * 设置 [Address1_Longitude]
     */
    public void setAddress1Longitude(Double address1Longitude){
        this.address1Longitude = address1Longitude ;
        this.modify("address1_longitude",address1Longitude);
    }
    /**
     * 设置 [Address1_Line1]
     */
    public void setAddress1Line1(String address1Line1){
        this.address1Line1 = address1Line1 ;
        this.modify("address1_line1",address1Line1);
    }
    /**
     * 设置 [LeadQualityCode]
     */
    public void setLeadqualitycode(String leadqualitycode){
        this.leadqualitycode = leadqualitycode ;
        this.modify("leadqualitycode",leadqualitycode);
    }
    /**
     * 设置 [DoNotPhone]
     */
    public void setDonotphone(Integer donotphone){
        this.donotphone = donotphone ;
        this.modify("donotphone",donotphone);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [ParentContactIdYomiName]
     */
    public void setParentcontactidyominame(String parentcontactidyominame){
        this.parentcontactidyominame = parentcontactidyominame ;
        this.modify("parentcontactidyominame",parentcontactidyominame);
    }
    /**
     * 设置 [Address2_StateOrProvince]
     */
    public void setAddress2Stateorprovince(String address2Stateorprovince){
        this.address2Stateorprovince = address2Stateorprovince ;
        this.modify("address2_stateorprovince",address2Stateorprovince);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [NumberOfEmployees]
     */
    public void setNumberofemployees(Integer numberofemployees){
        this.numberofemployees = numberofemployees ;
        this.modify("numberofemployees",numberofemployees);
    }
    /**
     * 设置 [Address1_City]
     */
    public void setAddress1City(String address1City){
        this.address1City = address1City ;
        this.modify("address1_city",address1City);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [Address2_Line3]
     */
    public void setAddress2Line3(String address2Line3){
        this.address2Line3 = address2Line3 ;
        this.modify("address2_line3",address2Line3);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [Address2_Line1]
     */
    public void setAddress2Line1(String address2Line1){
        this.address2Line1 = address2Line1 ;
        this.modify("address2_line1",address2Line1);
    }
    /**
     * 设置 [CustomerId]
     */
    public void setCustomerid(String customerid){
        this.customerid = customerid ;
        this.modify("customerid",customerid);
    }
    /**
     * 设置 [CompanyName]
     */
    public void setCompanyname(String companyname){
        this.companyname = companyname ;
        this.modify("companyname",companyname);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [QualificationComments]
     */
    public void setQualificationcomments(String qualificationcomments){
        this.qualificationcomments = qualificationcomments ;
        this.modify("qualificationcomments",qualificationcomments);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [ContactIdYomiName]
     */
    public void setContactidyominame(String contactidyominame){
        this.contactidyominame = contactidyominame ;
        this.modify("contactidyominame",contactidyominame);
    }
    /**
     * 设置 [Address2_Name]
     */
    public void setAddress2Name(String address2Name){
        this.address2Name = address2Name ;
        this.modify("address2_name",address2Name);
    }
    /**
     * 设置 [EMailAddress1]
     */
    public void setEmailaddress1(String emailaddress1){
        this.emailaddress1 = emailaddress1 ;
        this.modify("emailaddress1",emailaddress1);
    }
    /**
     * 设置 [FollowEmail]
     */
    public void setFollowemail(Integer followemail){
        this.followemail = followemail ;
        this.modify("followemail",followemail);
    }
    /**
     * 设置 [Address1_Country]
     */
    public void setAddress1Country(String address1Country){
        this.address1Country = address1Country ;
        this.modify("address1_country",address1Country);
    }
    /**
     * 设置 [WebSiteUrl]
     */
    public void setWebsiteurl(String websiteurl){
        this.websiteurl = websiteurl ;
        this.modify("websiteurl",websiteurl);
    }
    /**
     * 设置 [YomiCompanyName]
     */
    public void setYomicompanyname(String yomicompanyname){
        this.yomicompanyname = yomicompanyname ;
        this.modify("yomicompanyname",yomicompanyname);
    }
    /**
     * 设置 [Address1_Line3]
     */
    public void setAddress1Line3(String address1Line3){
        this.address1Line3 = address1Line3 ;
        this.modify("address1_line3",address1Line3);
    }
    /**
     * 设置 [Address2_AddressId]
     */
    public void setAddress2Addressid(String address2Addressid){
        this.address2Addressid = address2Addressid ;
        this.modify("address2_addressid",address2Addressid);
    }
    /**
     * 设置 [Address1_Composite]
     */
    public void setAddress1Composite(String address1Composite){
        this.address1Composite = address1Composite ;
        this.modify("address1_composite",address1Composite);
    }
    /**
     * 设置 [Subject]
     */
    public void setSubject(String subject){
        this.subject = subject ;
        this.modify("subject",subject);
    }
    /**
     * 设置 [Address1_UTCOffset]
     */
    public void setAddress1Utcoffset(Integer address1Utcoffset){
        this.address1Utcoffset = address1Utcoffset ;
        this.modify("address1_utcoffset",address1Utcoffset);
    }
    /**
     * 设置 [BudgetAmount_Base]
     */
    public void setBudgetamountBase(BigDecimal budgetamountBase){
        this.budgetamountBase = budgetamountBase ;
        this.modify("budgetamount_base",budgetamountBase);
    }
    /**
     * 设置 [Address1_AddressTypeCode]
     */
    public void setAddress1Addresstypecode(String address1Addresstypecode){
        this.address1Addresstypecode = address1Addresstypecode ;
        this.modify("address1_addresstypecode",address1Addresstypecode);
    }
    /**
     * 设置 [Address2_Telephone3]
     */
    public void setAddress2Telephone3(String address2Telephone3){
        this.address2Telephone3 = address2Telephone3 ;
        this.modify("address2_telephone3",address2Telephone3);
    }
    /**
     * 设置 [EvaluateFit]
     */
    public void setEvaluatefit(Integer evaluatefit){
        this.evaluatefit = evaluatefit ;
        this.modify("evaluatefit",evaluatefit);
    }
    /**
     * 设置 [Address1_Latitude]
     */
    public void setAddress1Latitude(Double address1Latitude){
        this.address1Latitude = address1Latitude ;
        this.modify("address1_latitude",address1Latitude);
    }
    /**
     * 设置 [Address1_Telephone3]
     */
    public void setAddress1Telephone3(String address1Telephone3){
        this.address1Telephone3 = address1Telephone3 ;
        this.modify("address1_telephone3",address1Telephone3);
    }
    /**
     * 设置 [FullName]
     */
    public void setFullname(String fullname){
        this.fullname = fullname ;
        this.modify("fullname",fullname);
    }
    /**
     * 设置 [EstimatedAmount_Base]
     */
    public void setEstimatedamountBase(BigDecimal estimatedamountBase){
        this.estimatedamountBase = estimatedamountBase ;
        this.modify("estimatedamount_base",estimatedamountBase);
    }
    /**
     * 设置 [BudgetStatus]
     */
    public void setBudgetstatus(String budgetstatus){
        this.budgetstatus = budgetstatus ;
        this.modify("budgetstatus",budgetstatus);
    }
    /**
     * 设置 [IndustryCode]
     */
    public void setIndustrycode(String industrycode){
        this.industrycode = industrycode ;
        this.modify("industrycode",industrycode);
    }
    /**
     * 设置 [Address1_Line2]
     */
    public void setAddress1Line2(String address1Line2){
        this.address1Line2 = address1Line2 ;
        this.modify("address1_line2",address1Line2);
    }
    /**
     * 设置 [InitialCommunication]
     */
    public void setInitialcommunication(String initialcommunication){
        this.initialcommunication = initialcommunication ;
        this.modify("initialcommunication",initialcommunication);
    }
    /**
     * 设置 [Address1_PostOfficeBox]
     */
    public void setAddress1Postofficebox(String address1Postofficebox){
        this.address1Postofficebox = address1Postofficebox ;
        this.modify("address1_postofficebox",address1Postofficebox);
    }
    /**
     * 设置 [Address1_Telephone1]
     */
    public void setAddress1Telephone1(String address1Telephone1){
        this.address1Telephone1 = address1Telephone1 ;
        this.modify("address1_telephone1",address1Telephone1);
    }
    /**
     * 设置 [Revenue]
     */
    public void setRevenue(BigDecimal revenue){
        this.revenue = revenue ;
        this.modify("revenue",revenue);
    }
    /**
     * 设置 [YomiLastName]
     */
    public void setYomilastname(String yomilastname){
        this.yomilastname = yomilastname ;
        this.modify("yomilastname",yomilastname);
    }
    /**
     * 设置 [Address2_County]
     */
    public void setAddress2County(String address2County){
        this.address2County = address2County ;
        this.modify("address2_county",address2County);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [ParentAccountIdYomiName]
     */
    public void setParentaccountidyominame(String parentaccountidyominame){
        this.parentaccountidyominame = parentaccountidyominame ;
        this.modify("parentaccountidyominame",parentaccountidyominame);
    }
    /**
     * 设置 [Address1_ShippingMethodCode]
     */
    public void setAddress1Shippingmethodcode(String address1Shippingmethodcode){
        this.address1Shippingmethodcode = address1Shippingmethodcode ;
        this.modify("address1_shippingmethodcode",address1Shippingmethodcode);
    }
    /**
     * 设置 [EstimatedAmount]
     */
    public void setEstimatedamount(BigDecimal estimatedamount){
        this.estimatedamount = estimatedamount ;
        this.modify("estimatedamount",estimatedamount);
    }
    /**
     * 设置 [Address1_County]
     */
    public void setAddress1County(String address1County){
        this.address1County = address1County ;
        this.modify("address1_county",address1County);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [LastOnHoldTime]
     */
    public void setLastonholdtime(Timestamp lastonholdtime){
        this.lastonholdtime = lastonholdtime ;
        this.modify("lastonholdtime",lastonholdtime);
    }
    /**
     * 设置 [TeamsFollowed]
     */
    public void setTeamsfollowed(Integer teamsfollowed){
        this.teamsfollowed = teamsfollowed ;
        this.modify("teamsfollowed",teamsfollowed);
    }
    /**
     * 设置 [Salutation]
     */
    public void setSalutation(String salutation){
        this.salutation = salutation ;
        this.modify("salutation",salutation);
    }
    /**
     * 设置 [Address2_ShippingMethodCode]
     */
    public void setAddress2Shippingmethodcode(String address2Shippingmethodcode){
        this.address2Shippingmethodcode = address2Shippingmethodcode ;
        this.modify("address2_shippingmethodcode",address2Shippingmethodcode);
    }
    /**
     * 设置 [Address2_Latitude]
     */
    public void setAddress2Latitude(Double address2Latitude){
        this.address2Latitude = address2Latitude ;
        this.modify("address2_latitude",address2Latitude);
    }
    /**
     * 设置 [ParticipatesInWorkflow]
     */
    public void setParticipatesinworkflow(Integer participatesinworkflow){
        this.participatesinworkflow = participatesinworkflow ;
        this.modify("participatesinworkflow",participatesinworkflow);
    }
    /**
     * 设置 [YomiFirstName]
     */
    public void setYomifirstname(String yomifirstname){
        this.yomifirstname = yomifirstname ;
        this.modify("yomifirstname",yomifirstname);
    }
    /**
     * 设置 [Address2_Composite]
     */
    public void setAddress2Composite(String address2Composite){
        this.address2Composite = address2Composite ;
        this.modify("address2_composite",address2Composite);
    }
    /**
     * 设置 [SalesStage]
     */
    public void setSalesstage(String salesstage){
        this.salesstage = salesstage ;
        this.modify("salesstage",salesstage);
    }
    /**
     * 设置 [DoNotPostalMail]
     */
    public void setDonotpostalmail(Integer donotpostalmail){
        this.donotpostalmail = donotpostalmail ;
        this.modify("donotpostalmail",donotpostalmail);
    }
    /**
     * 设置 [CustomerIdYomiName]
     */
    public void setCustomeridyominame(String customeridyominame){
        this.customeridyominame = customeridyominame ;
        this.modify("customeridyominame",customeridyominame);
    }
    /**
     * 设置 [AccountIdYomiName]
     */
    public void setAccountidyominame(String accountidyominame){
        this.accountidyominame = accountidyominame ;
        this.modify("accountidyominame",accountidyominame);
    }
    /**
     * 设置 [Revenue_Base]
     */
    public void setRevenueBase(BigDecimal revenueBase){
        this.revenueBase = revenueBase ;
        this.modify("revenue_base",revenueBase);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [ScheduleFollowUp_Prospect]
     */
    public void setSchedulefollowupProspect(Timestamp schedulefollowupProspect){
        this.schedulefollowupProspect = schedulefollowupProspect ;
        this.modify("schedulefollowup_prospect",schedulefollowupProspect);
    }
    /**
     * 设置 [Address2_City]
     */
    public void setAddress2City(String address2City){
        this.address2City = address2City ;
        this.modify("address2_city",address2City);
    }
    /**
     * 设置 [Telephone1]
     */
    public void setTelephone1(String telephone1){
        this.telephone1 = telephone1 ;
        this.modify("telephone1",telephone1);
    }
    /**
     * 设置 [Private]
     */
    public void setIbizprivate(Integer ibizprivate){
        this.ibizprivate = ibizprivate ;
        this.modify("private",ibizprivate);
    }
    /**
     * 设置 [CustomerIdType]
     */
    public void setCustomeridtype(String customeridtype){
        this.customeridtype = customeridtype ;
        this.modify("customeridtype",customeridtype);
    }
    /**
     * 设置 [MobilePhone]
     */
    public void setMobilephone(String mobilephone){
        this.mobilephone = mobilephone ;
        this.modify("mobilephone",mobilephone);
    }
    /**
     * 设置 [Need]
     */
    public void setNeed(String need){
        this.need = need ;
        this.modify("need",need);
    }
    /**
     * 设置 [PriorityCode]
     */
    public void setPrioritycode(String prioritycode){
        this.prioritycode = prioritycode ;
        this.modify("prioritycode",prioritycode);
    }
    /**
     * 设置 [Address1_AddressId]
     */
    public void setAddress1Addressid(String address1Addressid){
        this.address1Addressid = address1Addressid ;
        this.modify("address1_addressid",address1Addressid);
    }
    /**
     * 设置 [YomiFullName]
     */
    public void setYomifullname(String yomifullname){
        this.yomifullname = yomifullname ;
        this.modify("yomifullname",yomifullname);
    }
    /**
     * 设置 [SalesStageCode]
     */
    public void setSalesstagecode(String salesstagecode){
        this.salesstagecode = salesstagecode ;
        this.modify("salesstagecode",salesstagecode);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [Address2_Telephone1]
     */
    public void setAddress2Telephone1(String address2Telephone1){
        this.address2Telephone1 = address2Telephone1 ;
        this.modify("address2_telephone1",address2Telephone1);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [MiddleName]
     */
    public void setMiddlename(String middlename){
        this.middlename = middlename ;
        this.modify("middlename",middlename);
    }
    /**
     * 设置 [Telephone2]
     */
    public void setTelephone2(String telephone2){
        this.telephone2 = telephone2 ;
        this.modify("telephone2",telephone2);
    }
    /**
     * 设置 [PurchaseTimeFrame]
     */
    public void setPurchasetimeframe(String purchasetimeframe){
        this.purchasetimeframe = purchasetimeframe ;
        this.modify("purchasetimeframe",purchasetimeframe);
    }
    /**
     * 设置 [YomiMiddleName]
     */
    public void setYomimiddlename(String yomimiddlename){
        this.yomimiddlename = yomimiddlename ;
        this.modify("yomimiddlename",yomimiddlename);
    }
    /**
     * 设置 [LeadSourceCode]
     */
    public void setLeadsourcecode(String leadsourcecode){
        this.leadsourcecode = leadsourcecode ;
        this.modify("leadsourcecode",leadsourcecode);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [PreferredContactMethodCode]
     */
    public void setPreferredcontactmethodcode(String preferredcontactmethodcode){
        this.preferredcontactmethodcode = preferredcontactmethodcode ;
        this.modify("preferredcontactmethodcode",preferredcontactmethodcode);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [Address2_Telephone2]
     */
    public void setAddress2Telephone2(String address2Telephone2){
        this.address2Telephone2 = address2Telephone2 ;
        this.modify("address2_telephone2",address2Telephone2);
    }
    /**
     * 设置 [DoNotSendMM]
     */
    public void setDonotsendmm(Integer donotsendmm){
        this.donotsendmm = donotsendmm ;
        this.modify("donotsendmm",donotsendmm);
    }
    /**
     * 设置 [PurchaseProcess]
     */
    public void setPurchaseprocess(String purchaseprocess){
        this.purchaseprocess = purchaseprocess ;
        this.modify("purchaseprocess",purchaseprocess);
    }
    /**
     * 设置 [DoNotBulkEMail]
     */
    public void setDonotbulkemail(Integer donotbulkemail){
        this.donotbulkemail = donotbulkemail ;
        this.modify("donotbulkemail",donotbulkemail);
    }
    /**
     * 设置 [SIC]
     */
    public void setSic(String sic){
        this.sic = sic ;
        this.modify("sic",sic);
    }
    /**
     * 设置 [DoNotEMail]
     */
    public void setDonotemail(Integer donotemail){
        this.donotemail = donotemail ;
        this.modify("donotemail",donotemail);
    }
    /**
     * 设置 [Address2_Longitude]
     */
    public void setAddress2Longitude(Double address2Longitude){
        this.address2Longitude = address2Longitude ;
        this.modify("address2_longitude",address2Longitude);
    }
    /**
     * 设置 [ConfirmInterest]
     */
    public void setConfirminterest(Integer confirminterest){
        this.confirminterest = confirminterest ;
        this.modify("confirminterest",confirminterest);
    }
    /**
     * 设置 [Address2_PostOfficeBox]
     */
    public void setAddress2Postofficebox(String address2Postofficebox){
        this.address2Postofficebox = address2Postofficebox ;
        this.modify("address2_postofficebox",address2Postofficebox);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [AutoCreate]
     */
    public void setAutocreate(Integer autocreate){
        this.autocreate = autocreate ;
        this.modify("autocreate",autocreate);
    }
    /**
     * 设置 [Address1_Name]
     */
    public void setAddress1Name(String address1Name){
        this.address1Name = address1Name ;
        this.modify("address1_name",address1Name);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [LastUsedInCampaign]
     */
    public void setLastusedincampaign(Timestamp lastusedincampaign){
        this.lastusedincampaign = lastusedincampaign ;
        this.modify("lastusedincampaign",lastusedincampaign);
    }
    /**
     * 设置 [EstimatedCloseDate]
     */
    public void setEstimatedclosedate(Timestamp estimatedclosedate){
        this.estimatedclosedate = estimatedclosedate ;
        this.modify("estimatedclosedate",estimatedclosedate);
    }
    /**
     * 设置 [Address2_Line2]
     */
    public void setAddress2Line2(String address2Line2){
        this.address2Line2 = address2Line2 ;
        this.modify("address2_line2",address2Line2);
    }
    /**
     * 设置 [EMailAddress3]
     */
    public void setEmailaddress3(String emailaddress3){
        this.emailaddress3 = emailaddress3 ;
        this.modify("emailaddress3",emailaddress3);
    }
    /**
     * 设置 [Pager]
     */
    public void setPager(String pager){
        this.pager = pager ;
        this.modify("pager",pager);
    }
    /**
     * 设置 [Address2_UPSZone]
     */
    public void setAddress2Upszone(String address2Upszone){
        this.address2Upszone = address2Upszone ;
        this.modify("address2_upszone",address2Upszone);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [Fax]
     */
    public void setFax(String fax){
        this.fax = fax ;
        this.modify("fax",fax);
    }
    /**
     * 设置 [ScheduleFollowUp_Qualify]
     */
    public void setSchedulefollowupQualify(Timestamp schedulefollowupQualify){
        this.schedulefollowupQualify = schedulefollowupQualify ;
        this.modify("schedulefollowup_qualify",schedulefollowupQualify);
    }
    /**
     * 设置 [Telephone3]
     */
    public void setTelephone3(String telephone3){
        this.telephone3 = telephone3 ;
        this.modify("telephone3",telephone3);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [EMailAddress2]
     */
    public void setEmailaddress2(String emailaddress2){
        this.emailaddress2 = emailaddress2 ;
        this.modify("emailaddress2",emailaddress2);
    }
    /**
     * 设置 [DecisionMaker]
     */
    public void setDecisionmaker(Integer decisionmaker){
        this.decisionmaker = decisionmaker ;
        this.modify("decisionmaker",decisionmaker);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [Address1_PostalCode]
     */
    public void setAddress1Postalcode(String address1Postalcode){
        this.address1Postalcode = address1Postalcode ;
        this.modify("address1_postalcode",address1Postalcode);
    }
    /**
     * 设置 [Address2_PostalCode]
     */
    public void setAddress2Postalcode(String address2Postalcode){
        this.address2Postalcode = address2Postalcode ;
        this.modify("address2_postalcode",address2Postalcode);
    }
    /**
     * 设置 [DoNotFax]
     */
    public void setDonotfax(Integer donotfax){
        this.donotfax = donotfax ;
        this.modify("donotfax",donotfax);
    }
    /**
     * 设置 [FirstName]
     */
    public void setFirstname(String firstname){
        this.firstname = firstname ;
        this.modify("firstname",firstname);
    }
    /**
     * 设置 [Merged]
     */
    public void setMerged(Integer merged){
        this.merged = merged ;
        this.modify("merged",merged);
    }
    /**
     * 设置 [Address2_AddressTypeCode]
     */
    public void setAddress2Addresstypecode(String address2Addresstypecode){
        this.address2Addresstypecode = address2Addresstypecode ;
        this.modify("address2_addresstypecode",address2Addresstypecode);
    }
    /**
     * 设置 [Address1_UPSZone]
     */
    public void setAddress1Upszone(String address1Upszone){
        this.address1Upszone = address1Upszone ;
        this.modify("address1_upszone",address1Upszone);
    }
    /**
     * 设置 [QualifyingOpportunityId]
     */
    public void setQualifyingopportunityid(String qualifyingopportunityid){
        this.qualifyingopportunityid = qualifyingopportunityid ;
        this.modify("qualifyingopportunityid",qualifyingopportunityid);
    }
    /**
     * 设置 [SLAId]
     */
    public void setSlaid(String slaid){
        this.slaid = slaid ;
        this.modify("slaid",slaid);
    }
    /**
     * 设置 [CampaignId]
     */
    public void setCampaignid(String campaignid){
        this.campaignid = campaignid ;
        this.modify("campaignid",campaignid);
    }
    /**
     * 设置 [RelatedObjectId]
     */
    public void setRelatedobjectid(String relatedobjectid){
        this.relatedobjectid = relatedobjectid ;
        this.modify("relatedobjectid",relatedobjectid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }
    /**
     * 设置 [ParentAccountId]
     */
    public void setParentaccountid(String parentaccountid){
        this.parentaccountid = parentaccountid ;
        this.modify("parentaccountid",parentaccountid);
    }
    /**
     * 设置 [OriginatingCaseId]
     */
    public void setOriginatingcaseid(String originatingcaseid){
        this.originatingcaseid = originatingcaseid ;
        this.modify("originatingcaseid",originatingcaseid);
    }
    /**
     * 设置 [ParentContactId]
     */
    public void setParentcontactid(String parentcontactid){
        this.parentcontactid = parentcontactid ;
        this.modify("parentcontactid",parentcontactid);
    }

}


