package cn.ibizlab.businesscentral.core.sales.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[商机]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "OPPORTUNITY",resultMap = "OpportunityResultMap")
public class Opportunity extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * DecisionMaker
     */
    @DEField(defaultValue = "False")
    @TableField(value = "decisionmaker")
    @JSONField(name = "decisionmaker")
    @JsonProperty("decisionmaker")
    private Integer decisionmaker;
    /**
     * TotalLineItemAmount
     */
    @TableField(value = "totallineitemamount")
    @JSONField(name = "totallineitemamount")
    @JsonProperty("totallineitemamount")
    private BigDecimal totallineitemamount;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * DiscountPercentage
     */
    @TableField(value = "discountpercentage")
    @JSONField(name = "discountpercentage")
    @JsonProperty("discountpercentage")
    private BigDecimal discountpercentage;
    /**
     * PricingErrorCode
     */
    @TableField(value = "pricingerrorcode")
    @JSONField(name = "pricingerrorcode")
    @JsonProperty("pricingerrorcode")
    private String pricingerrorcode;
    /**
     * TotalAmount
     */
    @TableField(value = "totalamount")
    @JSONField(name = "totalamount")
    @JsonProperty("totalamount")
    private BigDecimal totalamount;
    /**
     * TotalTax_Base
     */
    @DEField(name = "totaltax_base")
    @TableField(value = "totaltax_base")
    @JSONField(name = "totaltax_base")
    @JsonProperty("totaltax_base")
    private BigDecimal totaltaxBase;
    /**
     * TotalTax
     */
    @TableField(value = "totaltax")
    @JSONField(name = "totaltax")
    @JsonProperty("totaltax")
    private BigDecimal totaltax;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * EstimatedValue_Base
     */
    @DEField(name = "estimatedvalue_base")
    @TableField(value = "estimatedvalue_base")
    @JSONField(name = "estimatedvalue_base")
    @JsonProperty("estimatedvalue_base")
    private BigDecimal estimatedvalueBase;
    /**
     * ParentContactIdYomiName
     */
    @TableField(value = "parentcontactidyominame")
    @JSONField(name = "parentcontactidyominame")
    @JsonProperty("parentcontactidyominame")
    private String parentcontactidyominame;
    /**
     * PresentFinalProposal
     */
    @DEField(defaultValue = "False")
    @TableField(value = "presentfinalproposal")
    @JSONField(name = "presentfinalproposal")
    @JsonProperty("presentfinalproposal")
    private Integer presentfinalproposal;
    /**
     * DevelopProposal
     */
    @DEField(defaultValue = "False")
    @TableField(value = "developproposal")
    @JSONField(name = "developproposal")
    @JsonProperty("developproposal")
    private Integer developproposal;
    /**
     * OpportunityRatingCode
     */
    @TableField(value = "opportunityratingcode")
    @JSONField(name = "opportunityratingcode")
    @JsonProperty("opportunityratingcode")
    private String opportunityratingcode;
    /**
     * TotalAmount_Base
     */
    @DEField(name = "totalamount_base")
    @TableField(value = "totalamount_base")
    @JSONField(name = "totalamount_base")
    @JsonProperty("totalamount_base")
    private BigDecimal totalamountBase;
    /**
     * TotalAmountLessFreight
     */
    @TableField(value = "totalamountlessfreight")
    @JSONField(name = "totalamountlessfreight")
    @JsonProperty("totalamountlessfreight")
    private BigDecimal totalamountlessfreight;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * IdentifyCompetitors
     */
    @DEField(defaultValue = "False")
    @TableField(value = "identifycompetitors")
    @JSONField(name = "identifycompetitors")
    @JsonProperty("identifycompetitors")
    private Integer identifycompetitors;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * SendThankYouNote
     */
    @DEField(defaultValue = "False")
    @TableField(value = "sendthankyounote")
    @JSONField(name = "sendthankyounote")
    @JsonProperty("sendthankyounote")
    private Integer sendthankyounote;
    /**
     * TotalDiscountAmount_Base
     */
    @DEField(name = "totaldiscountamount_base")
    @TableField(value = "totaldiscountamount_base")
    @JSONField(name = "totaldiscountamount_base")
    @JsonProperty("totaldiscountamount_base")
    private BigDecimal totaldiscountamountBase;
    /**
     * TotalLineItemDiscountAmount
     */
    @TableField(value = "totallineitemdiscountamount")
    @JSONField(name = "totallineitemdiscountamount")
    @JsonProperty("totallineitemdiscountamount")
    private BigDecimal totallineitemdiscountamount;
    /**
     * PurchaseProcess
     */
    @TableField(value = "purchaseprocess")
    @JSONField(name = "purchaseprocess")
    @JsonProperty("purchaseprocess")
    private String purchaseprocess;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * CaptureProposalFeedback
     */
    @DEField(defaultValue = "False")
    @TableField(value = "captureproposalfeedback")
    @JSONField(name = "captureproposalfeedback")
    @JsonProperty("captureproposalfeedback")
    private Integer captureproposalfeedback;
    /**
     * FinalDecisionDate
     */
    @TableField(value = "finaldecisiondate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "finaldecisiondate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("finaldecisiondate")
    private Timestamp finaldecisiondate;
    /**
     * StepId
     */
    @TableField(value = "stepid")
    @JSONField(name = "stepid")
    @JsonProperty("stepid")
    private String stepid;
    /**
     * ResolveFeedback
     */
    @DEField(defaultValue = "False")
    @TableField(value = "resolvefeedback")
    @JSONField(name = "resolvefeedback")
    @JsonProperty("resolvefeedback")
    private Integer resolvefeedback;
    /**
     * BudgetAmount_Base
     */
    @DEField(name = "budgetamount_base")
    @TableField(value = "budgetamount_base")
    @JSONField(name = "budgetamount_base")
    @JsonProperty("budgetamount_base")
    private BigDecimal budgetamountBase;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * PursuitDecision
     */
    @DEField(defaultValue = "False")
    @TableField(value = "pursuitdecision")
    @JSONField(name = "pursuitdecision")
    @JsonProperty("pursuitdecision")
    private Integer pursuitdecision;
    /**
     * RevenueSystemCalculated
     */
    @DEField(defaultValue = "False")
    @TableField(value = "revenuesystemcalculated")
    @JSONField(name = "revenuesystemcalculated")
    @JsonProperty("revenuesystemcalculated")
    private Integer revenuesystemcalculated;
    /**
     * ScheduleProposalMeeting
     */
    @TableField(value = "scheduleproposalmeeting")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "scheduleproposalmeeting" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("scheduleproposalmeeting")
    private Timestamp scheduleproposalmeeting;
    /**
     * CloseProbability
     */
    @TableField(value = "closeprobability")
    @JSONField(name = "closeprobability")
    @JsonProperty("closeprobability")
    private Integer closeprobability;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * PresentProposal
     */
    @DEField(defaultValue = "False")
    @TableField(value = "presentproposal")
    @JSONField(name = "presentproposal")
    @JsonProperty("presentproposal")
    private Integer presentproposal;
    /**
     * ScheduleFollowup_Prospect
     */
    @DEField(name = "schedulefollowup_prospect")
    @TableField(value = "schedulefollowup_prospect")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "schedulefollowup_prospect" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("schedulefollowup_prospect")
    private Timestamp schedulefollowupProspect;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * ActualCloseDate
     */
    @TableField(value = "actualclosedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "actualclosedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("actualclosedate")
    private Timestamp actualclosedate;
    /**
     * ConfirmInterest
     */
    @DEField(defaultValue = "False")
    @TableField(value = "confirminterest")
    @JSONField(name = "confirminterest")
    @JsonProperty("confirminterest")
    private Integer confirminterest;
    /**
     * CustomerId
     */
    @TableField(value = "customerid")
    @JSONField(name = "customerid")
    @JsonProperty("customerid")
    private String customerid;
    /**
     * SalesStage
     */
    @TableField(value = "salesstage")
    @JSONField(name = "salesstage")
    @JsonProperty("salesstage")
    private String salesstage;
    /**
     * OpportunityId
     */
    @DEField(isKeyField=true)
    @TableId(value= "opportunityid",type=IdType.UUID)
    @JSONField(name = "opportunityid")
    @JsonProperty("opportunityid")
    private String opportunityid;
    /**
     * OnHoldTime
     */
    @TableField(value = "onholdtime")
    @JSONField(name = "onholdtime")
    @JsonProperty("onholdtime")
    private Integer onholdtime;
    /**
     * QualificationComments
     */
    @TableField(value = "qualificationcomments")
    @JSONField(name = "qualificationcomments")
    @JsonProperty("qualificationcomments")
    private String qualificationcomments;
    /**
     * AccountIdYomiName
     */
    @TableField(value = "accountidyominame")
    @JSONField(name = "accountidyominame")
    @JsonProperty("accountidyominame")
    private String accountidyominame;
    /**
     * ScheduleFollowup_Qualify
     */
    @DEField(name = "schedulefollowup_qualify")
    @TableField(value = "schedulefollowup_qualify")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "schedulefollowup_qualify" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("schedulefollowup_qualify")
    private Timestamp schedulefollowupQualify;
    /**
     * ParticipatesInWorkflow
     */
    @DEField(defaultValue = "False")
    @TableField(value = "participatesinworkflow")
    @JSONField(name = "participatesinworkflow")
    @JsonProperty("participatesinworkflow")
    private Integer participatesinworkflow;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * StepName
     */
    @TableField(value = "stepname")
    @JSONField(name = "stepname")
    @JsonProperty("stepname")
    private String stepname;
    /**
     * CustomerNeed
     */
    @TableField(value = "customerneed")
    @JSONField(name = "customerneed")
    @JsonProperty("customerneed")
    private String customerneed;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * CompleteInternalReview
     */
    @DEField(defaultValue = "False")
    @TableField(value = "completeinternalreview")
    @JSONField(name = "completeinternalreview")
    @JsonProperty("completeinternalreview")
    private Integer completeinternalreview;
    /**
     * EvaluateFit
     */
    @DEField(defaultValue = "False")
    @TableField(value = "evaluatefit")
    @JSONField(name = "evaluatefit")
    @JsonProperty("evaluatefit")
    private Integer evaluatefit;
    /**
     * SalesStageCode
     */
    @TableField(value = "salesstagecode")
    @JSONField(name = "salesstagecode")
    @JsonProperty("salesstagecode")
    private String salesstagecode;
    /**
     * IdentifyPursuitTeam
     */
    @DEField(defaultValue = "False")
    @TableField(value = "identifypursuitteam")
    @JSONField(name = "identifypursuitteam")
    @JsonProperty("identifypursuitteam")
    private Integer identifypursuitteam;
    /**
     * ContactIdYomiName
     */
    @TableField(value = "contactidyominame")
    @JSONField(name = "contactidyominame")
    @JsonProperty("contactidyominame")
    private String contactidyominame;
    /**
     * InitialCommunication
     */
    @TableField(value = "initialcommunication")
    @JSONField(name = "initialcommunication")
    @JsonProperty("initialcommunication")
    private String initialcommunication;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * FreightAmount_Base
     */
    @DEField(name = "freightamount_base")
    @TableField(value = "freightamount_base")
    @JSONField(name = "freightamount_base")
    @JsonProperty("freightamount_base")
    private BigDecimal freightamountBase;
    /**
     * TeamsFollowed
     */
    @TableField(value = "teamsfollowed")
    @JSONField(name = "teamsfollowed")
    @JsonProperty("teamsfollowed")
    private Integer teamsfollowed;
    /**
     * ProposedSolution
     */
    @TableField(value = "proposedsolution")
    @JSONField(name = "proposedsolution")
    @JsonProperty("proposedsolution")
    private String proposedsolution;
    /**
     * FileDebrief
     */
    @DEField(defaultValue = "False")
    @TableField(value = "filedebrief")
    @JSONField(name = "filedebrief")
    @JsonProperty("filedebrief")
    private Integer filedebrief;
    /**
     * BudgetAmount
     */
    @TableField(value = "budgetamount")
    @JSONField(name = "budgetamount")
    @JsonProperty("budgetamount")
    private BigDecimal budgetamount;
    /**
     * BudgetStatus
     */
    @TableField(value = "budgetstatus")
    @JSONField(name = "budgetstatus")
    @JsonProperty("budgetstatus")
    private String budgetstatus;
    /**
     * DiscountAmount_Base
     */
    @DEField(name = "discountamount_base")
    @TableField(value = "discountamount_base")
    @JSONField(name = "discountamount_base")
    @JsonProperty("discountamount_base")
    private BigDecimal discountamountBase;
    /**
     * CompleteFinalProposal
     */
    @DEField(defaultValue = "False")
    @TableField(value = "completefinalproposal")
    @JSONField(name = "completefinalproposal")
    @JsonProperty("completefinalproposal")
    private Integer completefinalproposal;
    /**
     * OriginatingLeadIdYomiName
     */
    @TableField(value = "originatingleadidyominame")
    @JSONField(name = "originatingleadidyominame")
    @JsonProperty("originatingleadidyominame")
    private String originatingleadidyominame;
    /**
     * DiscountAmount
     */
    @TableField(value = "discountamount")
    @JSONField(name = "discountamount")
    @JsonProperty("discountamount")
    private BigDecimal discountamount;
    /**
     * CustomerIdYomiName
     */
    @TableField(value = "customeridyominame")
    @JSONField(name = "customeridyominame")
    @JsonProperty("customeridyominame")
    private String customeridyominame;
    /**
     * Need
     */
    @TableField(value = "need")
    @JSONField(name = "need")
    @JsonProperty("need")
    private String need;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * FreightAmount
     */
    @TableField(value = "freightamount")
    @JSONField(name = "freightamount")
    @JsonProperty("freightamount")
    private BigDecimal freightamount;
    /**
     * ActualValue
     */
    @TableField(value = "actualvalue")
    @JSONField(name = "actualvalue")
    @JsonProperty("actualvalue")
    private BigDecimal actualvalue;
    /**
     * Private
     */
    @DEField(defaultValue = "False")
    @TableField(value = "private")
    @JSONField(name = "ibizprivate")
    @JsonProperty("ibizprivate")
    private Integer ibizprivate;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * PriorityCode
     */
    @TableField(value = "prioritycode")
    @JSONField(name = "prioritycode")
    @JsonProperty("prioritycode")
    private String prioritycode;
    /**
     * TotalLineItemAmount_Base
     */
    @DEField(name = "totallineitemamount_base")
    @TableField(value = "totallineitemamount_base")
    @JSONField(name = "totallineitemamount_base")
    @JsonProperty("totallineitemamount_base")
    private BigDecimal totallineitemamountBase;
    /**
     * EstimatedCloseDate
     */
    @TableField(value = "estimatedclosedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "estimatedclosedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("estimatedclosedate")
    private Timestamp estimatedclosedate;
    /**
     * CurrentSituation
     */
    @TableField(value = "currentsituation")
    @JSONField(name = "currentsituation")
    @JsonProperty("currentsituation")
    private String currentsituation;
    /**
     * ActualValue_Base
     */
    @DEField(name = "actualvalue_base")
    @TableField(value = "actualvalue_base")
    @JSONField(name = "actualvalue_base")
    @JsonProperty("actualvalue_base")
    private BigDecimal actualvalueBase;
    /**
     * CustomerPainPoints
     */
    @TableField(value = "customerpainpoints")
    @JSONField(name = "customerpainpoints")
    @JsonProperty("customerpainpoints")
    private String customerpainpoints;
    /**
     * TotalDiscountAmount
     */
    @TableField(value = "totaldiscountamount")
    @JSONField(name = "totaldiscountamount")
    @JsonProperty("totaldiscountamount")
    private BigDecimal totaldiscountamount;
    /**
     * opportunityName
     */
    @TableField(value = "opportunityname")
    @JSONField(name = "opportunityname")
    @JsonProperty("opportunityname")
    private String opportunityname;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * IdentifyCustomerContacts
     */
    @DEField(defaultValue = "False")
    @TableField(value = "identifycustomercontacts")
    @JSONField(name = "identifycustomercontacts")
    @JsonProperty("identifycustomercontacts")
    private Integer identifycustomercontacts;
    /**
     * TimeLine
     */
    @TableField(value = "timeline")
    @JSONField(name = "timeline")
    @JsonProperty("timeline")
    private String timeline;
    /**
     * LastOnHoldTime
     */
    @TableField(value = "lastonholdtime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastonholdtime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastonholdtime")
    private Timestamp lastonholdtime;
    /**
     * TotalAmountLessFreight_Base
     */
    @DEField(name = "totalamountlessfreight_base")
    @TableField(value = "totalamountlessfreight_base")
    @JSONField(name = "totalamountlessfreight_base")
    @JsonProperty("totalamountlessfreight_base")
    private BigDecimal totalamountlessfreightBase;
    /**
     * EstimatedValue
     */
    @TableField(value = "estimatedvalue")
    @JSONField(name = "estimatedvalue")
    @JsonProperty("estimatedvalue")
    private BigDecimal estimatedvalue;
    /**
     * EmailAddress
     */
    @TableField(value = "emailaddress")
    @JSONField(name = "emailaddress")
    @JsonProperty("emailaddress")
    private String emailaddress;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * PurchaseTimeframe
     */
    @TableField(value = "purchasetimeframe")
    @JSONField(name = "purchasetimeframe")
    @JsonProperty("purchasetimeframe")
    private String purchasetimeframe;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * QuoteComments
     */
    @TableField(value = "quotecomments")
    @JSONField(name = "quotecomments")
    @JsonProperty("quotecomments")
    private String quotecomments;
    /**
     * ParentAccountIdYomiName
     */
    @TableField(value = "parentaccountidyominame")
    @JSONField(name = "parentaccountidyominame")
    @JsonProperty("parentaccountidyominame")
    private String parentaccountidyominame;
    /**
     * CustomerIdType
     */
    @TableField(value = "customeridtype")
    @JSONField(name = "customeridtype")
    @JsonProperty("customeridtype")
    private String customeridtype;
    /**
     * SLAName
     */
    @TableField(value = "slaname")
    @JSONField(name = "slaname")
    @JsonProperty("slaname")
    private String slaname;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * ParentContactId
     */
    @TableField(value = "parentcontactid")
    @JSONField(name = "parentcontactid")
    @JsonProperty("parentcontactid")
    private String parentcontactid;
    /**
     * CampaignId
     */
    @TableField(value = "campaignid")
    @JSONField(name = "campaignid")
    @JsonProperty("campaignid")
    private String campaignid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;
    /**
     * ParentAccountId
     */
    @TableField(value = "parentaccountid")
    @JSONField(name = "parentaccountid")
    @JsonProperty("parentaccountid")
    private String parentaccountid;
    /**
     * PriceLevelId
     */
    @TableField(value = "pricelevelid")
    @JSONField(name = "pricelevelid")
    @JsonProperty("pricelevelid")
    private String pricelevelid;
    /**
     * OriginatingLeadId
     */
    @TableField(value = "originatingleadid")
    @JSONField(name = "originatingleadid")
    @JsonProperty("originatingleadid")
    private String originatingleadid;
    /**
     * SLAId
     */
    @TableField(value = "slaid")
    @JSONField(name = "slaid")
    @JsonProperty("slaid")
    private String slaid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Account parentaccount;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.marketing.domain.Campaign campaign;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Contact parentcontact;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.sales.domain.Lead originatinglead;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.product.domain.PriceLevel pricelevel;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Sla sla;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [DecisionMaker]
     */
    public void setDecisionmaker(Integer decisionmaker){
        this.decisionmaker = decisionmaker ;
        this.modify("decisionmaker",decisionmaker);
    }
    /**
     * 设置 [TotalLineItemAmount]
     */
    public void setTotallineitemamount(BigDecimal totallineitemamount){
        this.totallineitemamount = totallineitemamount ;
        this.modify("totallineitemamount",totallineitemamount);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [DiscountPercentage]
     */
    public void setDiscountpercentage(BigDecimal discountpercentage){
        this.discountpercentage = discountpercentage ;
        this.modify("discountpercentage",discountpercentage);
    }
    /**
     * 设置 [PricingErrorCode]
     */
    public void setPricingerrorcode(String pricingerrorcode){
        this.pricingerrorcode = pricingerrorcode ;
        this.modify("pricingerrorcode",pricingerrorcode);
    }
    /**
     * 设置 [TotalAmount]
     */
    public void setTotalamount(BigDecimal totalamount){
        this.totalamount = totalamount ;
        this.modify("totalamount",totalamount);
    }
    /**
     * 设置 [TotalTax_Base]
     */
    public void setTotaltaxBase(BigDecimal totaltaxBase){
        this.totaltaxBase = totaltaxBase ;
        this.modify("totaltax_base",totaltaxBase);
    }
    /**
     * 设置 [TotalTax]
     */
    public void setTotaltax(BigDecimal totaltax){
        this.totaltax = totaltax ;
        this.modify("totaltax",totaltax);
    }
    /**
     * 设置 [EstimatedValue_Base]
     */
    public void setEstimatedvalueBase(BigDecimal estimatedvalueBase){
        this.estimatedvalueBase = estimatedvalueBase ;
        this.modify("estimatedvalue_base",estimatedvalueBase);
    }
    /**
     * 设置 [ParentContactIdYomiName]
     */
    public void setParentcontactidyominame(String parentcontactidyominame){
        this.parentcontactidyominame = parentcontactidyominame ;
        this.modify("parentcontactidyominame",parentcontactidyominame);
    }
    /**
     * 设置 [PresentFinalProposal]
     */
    public void setPresentfinalproposal(Integer presentfinalproposal){
        this.presentfinalproposal = presentfinalproposal ;
        this.modify("presentfinalproposal",presentfinalproposal);
    }
    /**
     * 设置 [DevelopProposal]
     */
    public void setDevelopproposal(Integer developproposal){
        this.developproposal = developproposal ;
        this.modify("developproposal",developproposal);
    }
    /**
     * 设置 [OpportunityRatingCode]
     */
    public void setOpportunityratingcode(String opportunityratingcode){
        this.opportunityratingcode = opportunityratingcode ;
        this.modify("opportunityratingcode",opportunityratingcode);
    }
    /**
     * 设置 [TotalAmount_Base]
     */
    public void setTotalamountBase(BigDecimal totalamountBase){
        this.totalamountBase = totalamountBase ;
        this.modify("totalamount_base",totalamountBase);
    }
    /**
     * 设置 [TotalAmountLessFreight]
     */
    public void setTotalamountlessfreight(BigDecimal totalamountlessfreight){
        this.totalamountlessfreight = totalamountlessfreight ;
        this.modify("totalamountlessfreight",totalamountlessfreight);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [IdentifyCompetitors]
     */
    public void setIdentifycompetitors(Integer identifycompetitors){
        this.identifycompetitors = identifycompetitors ;
        this.modify("identifycompetitors",identifycompetitors);
    }
    /**
     * 设置 [SendThankYouNote]
     */
    public void setSendthankyounote(Integer sendthankyounote){
        this.sendthankyounote = sendthankyounote ;
        this.modify("sendthankyounote",sendthankyounote);
    }
    /**
     * 设置 [TotalDiscountAmount_Base]
     */
    public void setTotaldiscountamountBase(BigDecimal totaldiscountamountBase){
        this.totaldiscountamountBase = totaldiscountamountBase ;
        this.modify("totaldiscountamount_base",totaldiscountamountBase);
    }
    /**
     * 设置 [TotalLineItemDiscountAmount]
     */
    public void setTotallineitemdiscountamount(BigDecimal totallineitemdiscountamount){
        this.totallineitemdiscountamount = totallineitemdiscountamount ;
        this.modify("totallineitemdiscountamount",totallineitemdiscountamount);
    }
    /**
     * 设置 [PurchaseProcess]
     */
    public void setPurchaseprocess(String purchaseprocess){
        this.purchaseprocess = purchaseprocess ;
        this.modify("purchaseprocess",purchaseprocess);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [CaptureProposalFeedback]
     */
    public void setCaptureproposalfeedback(Integer captureproposalfeedback){
        this.captureproposalfeedback = captureproposalfeedback ;
        this.modify("captureproposalfeedback",captureproposalfeedback);
    }
    /**
     * 设置 [FinalDecisionDate]
     */
    public void setFinaldecisiondate(Timestamp finaldecisiondate){
        this.finaldecisiondate = finaldecisiondate ;
        this.modify("finaldecisiondate",finaldecisiondate);
    }
    /**
     * 设置 [StepId]
     */
    public void setStepid(String stepid){
        this.stepid = stepid ;
        this.modify("stepid",stepid);
    }
    /**
     * 设置 [ResolveFeedback]
     */
    public void setResolvefeedback(Integer resolvefeedback){
        this.resolvefeedback = resolvefeedback ;
        this.modify("resolvefeedback",resolvefeedback);
    }
    /**
     * 设置 [BudgetAmount_Base]
     */
    public void setBudgetamountBase(BigDecimal budgetamountBase){
        this.budgetamountBase = budgetamountBase ;
        this.modify("budgetamount_base",budgetamountBase);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [PursuitDecision]
     */
    public void setPursuitdecision(Integer pursuitdecision){
        this.pursuitdecision = pursuitdecision ;
        this.modify("pursuitdecision",pursuitdecision);
    }
    /**
     * 设置 [RevenueSystemCalculated]
     */
    public void setRevenuesystemcalculated(Integer revenuesystemcalculated){
        this.revenuesystemcalculated = revenuesystemcalculated ;
        this.modify("revenuesystemcalculated",revenuesystemcalculated);
    }
    /**
     * 设置 [ScheduleProposalMeeting]
     */
    public void setScheduleproposalmeeting(Timestamp scheduleproposalmeeting){
        this.scheduleproposalmeeting = scheduleproposalmeeting ;
        this.modify("scheduleproposalmeeting",scheduleproposalmeeting);
    }
    /**
     * 设置 [CloseProbability]
     */
    public void setCloseprobability(Integer closeprobability){
        this.closeprobability = closeprobability ;
        this.modify("closeprobability",closeprobability);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [PresentProposal]
     */
    public void setPresentproposal(Integer presentproposal){
        this.presentproposal = presentproposal ;
        this.modify("presentproposal",presentproposal);
    }
    /**
     * 设置 [ScheduleFollowup_Prospect]
     */
    public void setSchedulefollowupProspect(Timestamp schedulefollowupProspect){
        this.schedulefollowupProspect = schedulefollowupProspect ;
        this.modify("schedulefollowup_prospect",schedulefollowupProspect);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [ActualCloseDate]
     */
    public void setActualclosedate(Timestamp actualclosedate){
        this.actualclosedate = actualclosedate ;
        this.modify("actualclosedate",actualclosedate);
    }
    /**
     * 设置 [ConfirmInterest]
     */
    public void setConfirminterest(Integer confirminterest){
        this.confirminterest = confirminterest ;
        this.modify("confirminterest",confirminterest);
    }
    /**
     * 设置 [CustomerId]
     */
    public void setCustomerid(String customerid){
        this.customerid = customerid ;
        this.modify("customerid",customerid);
    }
    /**
     * 设置 [SalesStage]
     */
    public void setSalesstage(String salesstage){
        this.salesstage = salesstage ;
        this.modify("salesstage",salesstage);
    }
    /**
     * 设置 [OnHoldTime]
     */
    public void setOnholdtime(Integer onholdtime){
        this.onholdtime = onholdtime ;
        this.modify("onholdtime",onholdtime);
    }
    /**
     * 设置 [QualificationComments]
     */
    public void setQualificationcomments(String qualificationcomments){
        this.qualificationcomments = qualificationcomments ;
        this.modify("qualificationcomments",qualificationcomments);
    }
    /**
     * 设置 [AccountIdYomiName]
     */
    public void setAccountidyominame(String accountidyominame){
        this.accountidyominame = accountidyominame ;
        this.modify("accountidyominame",accountidyominame);
    }
    /**
     * 设置 [ScheduleFollowup_Qualify]
     */
    public void setSchedulefollowupQualify(Timestamp schedulefollowupQualify){
        this.schedulefollowupQualify = schedulefollowupQualify ;
        this.modify("schedulefollowup_qualify",schedulefollowupQualify);
    }
    /**
     * 设置 [ParticipatesInWorkflow]
     */
    public void setParticipatesinworkflow(Integer participatesinworkflow){
        this.participatesinworkflow = participatesinworkflow ;
        this.modify("participatesinworkflow",participatesinworkflow);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [StepName]
     */
    public void setStepname(String stepname){
        this.stepname = stepname ;
        this.modify("stepname",stepname);
    }
    /**
     * 设置 [CustomerNeed]
     */
    public void setCustomerneed(String customerneed){
        this.customerneed = customerneed ;
        this.modify("customerneed",customerneed);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [CompleteInternalReview]
     */
    public void setCompleteinternalreview(Integer completeinternalreview){
        this.completeinternalreview = completeinternalreview ;
        this.modify("completeinternalreview",completeinternalreview);
    }
    /**
     * 设置 [EvaluateFit]
     */
    public void setEvaluatefit(Integer evaluatefit){
        this.evaluatefit = evaluatefit ;
        this.modify("evaluatefit",evaluatefit);
    }
    /**
     * 设置 [SalesStageCode]
     */
    public void setSalesstagecode(String salesstagecode){
        this.salesstagecode = salesstagecode ;
        this.modify("salesstagecode",salesstagecode);
    }
    /**
     * 设置 [IdentifyPursuitTeam]
     */
    public void setIdentifypursuitteam(Integer identifypursuitteam){
        this.identifypursuitteam = identifypursuitteam ;
        this.modify("identifypursuitteam",identifypursuitteam);
    }
    /**
     * 设置 [ContactIdYomiName]
     */
    public void setContactidyominame(String contactidyominame){
        this.contactidyominame = contactidyominame ;
        this.modify("contactidyominame",contactidyominame);
    }
    /**
     * 设置 [InitialCommunication]
     */
    public void setInitialcommunication(String initialcommunication){
        this.initialcommunication = initialcommunication ;
        this.modify("initialcommunication",initialcommunication);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [FreightAmount_Base]
     */
    public void setFreightamountBase(BigDecimal freightamountBase){
        this.freightamountBase = freightamountBase ;
        this.modify("freightamount_base",freightamountBase);
    }
    /**
     * 设置 [TeamsFollowed]
     */
    public void setTeamsfollowed(Integer teamsfollowed){
        this.teamsfollowed = teamsfollowed ;
        this.modify("teamsfollowed",teamsfollowed);
    }
    /**
     * 设置 [ProposedSolution]
     */
    public void setProposedsolution(String proposedsolution){
        this.proposedsolution = proposedsolution ;
        this.modify("proposedsolution",proposedsolution);
    }
    /**
     * 设置 [FileDebrief]
     */
    public void setFiledebrief(Integer filedebrief){
        this.filedebrief = filedebrief ;
        this.modify("filedebrief",filedebrief);
    }
    /**
     * 设置 [BudgetAmount]
     */
    public void setBudgetamount(BigDecimal budgetamount){
        this.budgetamount = budgetamount ;
        this.modify("budgetamount",budgetamount);
    }
    /**
     * 设置 [BudgetStatus]
     */
    public void setBudgetstatus(String budgetstatus){
        this.budgetstatus = budgetstatus ;
        this.modify("budgetstatus",budgetstatus);
    }
    /**
     * 设置 [DiscountAmount_Base]
     */
    public void setDiscountamountBase(BigDecimal discountamountBase){
        this.discountamountBase = discountamountBase ;
        this.modify("discountamount_base",discountamountBase);
    }
    /**
     * 设置 [CompleteFinalProposal]
     */
    public void setCompletefinalproposal(Integer completefinalproposal){
        this.completefinalproposal = completefinalproposal ;
        this.modify("completefinalproposal",completefinalproposal);
    }
    /**
     * 设置 [OriginatingLeadIdYomiName]
     */
    public void setOriginatingleadidyominame(String originatingleadidyominame){
        this.originatingleadidyominame = originatingleadidyominame ;
        this.modify("originatingleadidyominame",originatingleadidyominame);
    }
    /**
     * 设置 [DiscountAmount]
     */
    public void setDiscountamount(BigDecimal discountamount){
        this.discountamount = discountamount ;
        this.modify("discountamount",discountamount);
    }
    /**
     * 设置 [CustomerIdYomiName]
     */
    public void setCustomeridyominame(String customeridyominame){
        this.customeridyominame = customeridyominame ;
        this.modify("customeridyominame",customeridyominame);
    }
    /**
     * 设置 [Need]
     */
    public void setNeed(String need){
        this.need = need ;
        this.modify("need",need);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [FreightAmount]
     */
    public void setFreightamount(BigDecimal freightamount){
        this.freightamount = freightamount ;
        this.modify("freightamount",freightamount);
    }
    /**
     * 设置 [ActualValue]
     */
    public void setActualvalue(BigDecimal actualvalue){
        this.actualvalue = actualvalue ;
        this.modify("actualvalue",actualvalue);
    }
    /**
     * 设置 [Private]
     */
    public void setIbizprivate(Integer ibizprivate){
        this.ibizprivate = ibizprivate ;
        this.modify("private",ibizprivate);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [PriorityCode]
     */
    public void setPrioritycode(String prioritycode){
        this.prioritycode = prioritycode ;
        this.modify("prioritycode",prioritycode);
    }
    /**
     * 设置 [TotalLineItemAmount_Base]
     */
    public void setTotallineitemamountBase(BigDecimal totallineitemamountBase){
        this.totallineitemamountBase = totallineitemamountBase ;
        this.modify("totallineitemamount_base",totallineitemamountBase);
    }
    /**
     * 设置 [EstimatedCloseDate]
     */
    public void setEstimatedclosedate(Timestamp estimatedclosedate){
        this.estimatedclosedate = estimatedclosedate ;
        this.modify("estimatedclosedate",estimatedclosedate);
    }
    /**
     * 设置 [CurrentSituation]
     */
    public void setCurrentsituation(String currentsituation){
        this.currentsituation = currentsituation ;
        this.modify("currentsituation",currentsituation);
    }
    /**
     * 设置 [ActualValue_Base]
     */
    public void setActualvalueBase(BigDecimal actualvalueBase){
        this.actualvalueBase = actualvalueBase ;
        this.modify("actualvalue_base",actualvalueBase);
    }
    /**
     * 设置 [CustomerPainPoints]
     */
    public void setCustomerpainpoints(String customerpainpoints){
        this.customerpainpoints = customerpainpoints ;
        this.modify("customerpainpoints",customerpainpoints);
    }
    /**
     * 设置 [TotalDiscountAmount]
     */
    public void setTotaldiscountamount(BigDecimal totaldiscountamount){
        this.totaldiscountamount = totaldiscountamount ;
        this.modify("totaldiscountamount",totaldiscountamount);
    }
    /**
     * 设置 [opportunityName]
     */
    public void setOpportunityname(String opportunityname){
        this.opportunityname = opportunityname ;
        this.modify("opportunityname",opportunityname);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [IdentifyCustomerContacts]
     */
    public void setIdentifycustomercontacts(Integer identifycustomercontacts){
        this.identifycustomercontacts = identifycustomercontacts ;
        this.modify("identifycustomercontacts",identifycustomercontacts);
    }
    /**
     * 设置 [TimeLine]
     */
    public void setTimeline(String timeline){
        this.timeline = timeline ;
        this.modify("timeline",timeline);
    }
    /**
     * 设置 [LastOnHoldTime]
     */
    public void setLastonholdtime(Timestamp lastonholdtime){
        this.lastonholdtime = lastonholdtime ;
        this.modify("lastonholdtime",lastonholdtime);
    }
    /**
     * 设置 [TotalAmountLessFreight_Base]
     */
    public void setTotalamountlessfreightBase(BigDecimal totalamountlessfreightBase){
        this.totalamountlessfreightBase = totalamountlessfreightBase ;
        this.modify("totalamountlessfreight_base",totalamountlessfreightBase);
    }
    /**
     * 设置 [EstimatedValue]
     */
    public void setEstimatedvalue(BigDecimal estimatedvalue){
        this.estimatedvalue = estimatedvalue ;
        this.modify("estimatedvalue",estimatedvalue);
    }
    /**
     * 设置 [EmailAddress]
     */
    public void setEmailaddress(String emailaddress){
        this.emailaddress = emailaddress ;
        this.modify("emailaddress",emailaddress);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [PurchaseTimeframe]
     */
    public void setPurchasetimeframe(String purchasetimeframe){
        this.purchasetimeframe = purchasetimeframe ;
        this.modify("purchasetimeframe",purchasetimeframe);
    }
    /**
     * 设置 [QuoteComments]
     */
    public void setQuotecomments(String quotecomments){
        this.quotecomments = quotecomments ;
        this.modify("quotecomments",quotecomments);
    }
    /**
     * 设置 [ParentAccountIdYomiName]
     */
    public void setParentaccountidyominame(String parentaccountidyominame){
        this.parentaccountidyominame = parentaccountidyominame ;
        this.modify("parentaccountidyominame",parentaccountidyominame);
    }
    /**
     * 设置 [CustomerIdType]
     */
    public void setCustomeridtype(String customeridtype){
        this.customeridtype = customeridtype ;
        this.modify("customeridtype",customeridtype);
    }
    /**
     * 设置 [SLAName]
     */
    public void setSlaname(String slaname){
        this.slaname = slaname ;
        this.modify("slaname",slaname);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [ParentContactId]
     */
    public void setParentcontactid(String parentcontactid){
        this.parentcontactid = parentcontactid ;
        this.modify("parentcontactid",parentcontactid);
    }
    /**
     * 设置 [CampaignId]
     */
    public void setCampaignid(String campaignid){
        this.campaignid = campaignid ;
        this.modify("campaignid",campaignid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }
    /**
     * 设置 [ParentAccountId]
     */
    public void setParentaccountid(String parentaccountid){
        this.parentaccountid = parentaccountid ;
        this.modify("parentaccountid",parentaccountid);
    }
    /**
     * 设置 [PriceLevelId]
     */
    public void setPricelevelid(String pricelevelid){
        this.pricelevelid = pricelevelid ;
        this.modify("pricelevelid",pricelevelid);
    }
    /**
     * 设置 [OriginatingLeadId]
     */
    public void setOriginatingleadid(String originatingleadid){
        this.originatingleadid = originatingleadid ;
        this.modify("originatingleadid",originatingleadid);
    }
    /**
     * 设置 [SLAId]
     */
    public void setSlaid(String slaid){
        this.slaid = slaid ;
        this.modify("slaid",slaid);
    }

}


