package cn.ibizlab.businesscentral.core.service.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[service]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "SERVICE",resultMap = "IBizServiceResultMap")
public class IBizService extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * AnchorOffset
     */
    @TableField(value = "anchoroffset")
    @JSONField(name = "anchoroffset")
    @JsonProperty("anchoroffset")
    private Integer anchoroffset;
    /**
     * InitialStatusCode
     */
    @TableField(value = "initialstatuscode")
    @JSONField(name = "initialstatuscode")
    @JsonProperty("initialstatuscode")
    private Integer initialstatuscode;
    /**
     * Granularity
     */
    @TableField(value = "granularity")
    @JSONField(name = "granularity")
    @JsonProperty("granularity")
    private String granularity;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * ShowResources
     */
    @DEField(defaultValue = "False")
    @TableField(value = "showresources")
    @JSONField(name = "showresources")
    @JsonProperty("showresources")
    private Integer showresources;
    /**
     * serviceName
     */
    @TableField(value = "servicename")
    @JSONField(name = "servicename")
    @JsonProperty("servicename")
    private String servicename;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * Visible
     */
    @DEField(defaultValue = "False")
    @TableField(value = "visible")
    @JSONField(name = "visible")
    @JsonProperty("visible")
    private Integer visible;
    /**
     * CalendarId
     */
    @TableField(value = "calendarid")
    @JSONField(name = "calendarid")
    @JsonProperty("calendarid")
    private String calendarid;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * Schedulable
     */
    @DEField(defaultValue = "True")
    @TableField(value = "schedulable")
    @JSONField(name = "schedulable")
    @JsonProperty("schedulable")
    private Integer schedulable;
    /**
     * StrategyId
     */
    @TableField(value = "strategyid")
    @JSONField(name = "strategyid")
    @JsonProperty("strategyid")
    private String strategyid;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * ServiceId
     */
    @DEField(isKeyField=true)
    @TableId(value= "serviceid",type=IdType.UUID)
    @JSONField(name = "serviceid")
    @JsonProperty("serviceid")
    private String serviceid;
    /**
     * Duration
     */
    @TableField(value = "duration")
    @JSONField(name = "duration")
    @JsonProperty("duration")
    private Integer duration;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * ResourceSpecId
     */
    @TableField(value = "resourcespecid")
    @JSONField(name = "resourcespecid")
    @JsonProperty("resourcespecid")
    private String resourcespecid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.ResourceSpec resourcespec;



    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [AnchorOffset]
     */
    public void setAnchoroffset(Integer anchoroffset){
        this.anchoroffset = anchoroffset ;
        this.modify("anchoroffset",anchoroffset);
    }
    /**
     * 设置 [InitialStatusCode]
     */
    public void setInitialstatuscode(Integer initialstatuscode){
        this.initialstatuscode = initialstatuscode ;
        this.modify("initialstatuscode",initialstatuscode);
    }
    /**
     * 设置 [Granularity]
     */
    public void setGranularity(String granularity){
        this.granularity = granularity ;
        this.modify("granularity",granularity);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [ShowResources]
     */
    public void setShowresources(Integer showresources){
        this.showresources = showresources ;
        this.modify("showresources",showresources);
    }
    /**
     * 设置 [serviceName]
     */
    public void setServicename(String servicename){
        this.servicename = servicename ;
        this.modify("servicename",servicename);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [Visible]
     */
    public void setVisible(Integer visible){
        this.visible = visible ;
        this.modify("visible",visible);
    }
    /**
     * 设置 [CalendarId]
     */
    public void setCalendarid(String calendarid){
        this.calendarid = calendarid ;
        this.modify("calendarid",calendarid);
    }
    /**
     * 设置 [Schedulable]
     */
    public void setSchedulable(Integer schedulable){
        this.schedulable = schedulable ;
        this.modify("schedulable",schedulable);
    }
    /**
     * 设置 [StrategyId]
     */
    public void setStrategyid(String strategyid){
        this.strategyid = strategyid ;
        this.modify("strategyid",strategyid);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [Duration]
     */
    public void setDuration(Integer duration){
        this.duration = duration ;
        this.modify("duration",duration);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [ResourceSpecId]
     */
    public void setResourcespecid(String resourcespecid){
        this.resourcespecid = resourcespecid ;
        this.modify("resourcespecid",resourcespecid);
    }

}


