package cn.ibizlab.businesscentral.core.service.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[案例]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "INCIDENT",resultMap = "IncidentResultMap")
public class Incident extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * LastOnHoldTime
     */
    @TableField(value = "lastonholdtime")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "lastonholdtime" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("lastonholdtime")
    private Timestamp lastonholdtime;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * CustomerIdType
     */
    @TableField(value = "customeridtype")
    @JSONField(name = "customeridtype")
    @JsonProperty("customeridtype")
    private String customeridtype;
    /**
     * FirstResponseSLAStatus
     */
    @TableField(value = "firstresponseslastatus")
    @JSONField(name = "firstresponseslastatus")
    @JsonProperty("firstresponseslastatus")
    private String firstresponseslastatus;
    /**
     * IncidentStageCode
     */
    @TableField(value = "incidentstagecode")
    @JSONField(name = "incidentstagecode")
    @JsonProperty("incidentstagecode")
    private String incidentstagecode;
    /**
     * InfluenceScore
     */
    @TableField(value = "influencescore")
    @JSONField(name = "influencescore")
    @JsonProperty("influencescore")
    private Double influencescore;
    /**
     * CustomerId
     */
    @TableField(value = "customerid")
    @JSONField(name = "customerid")
    @JsonProperty("customerid")
    private String customerid;
    /**
     * SocialProfileId
     */
    @TableField(value = "socialprofileid")
    @JSONField(name = "socialprofileid")
    @JsonProperty("socialprofileid")
    private String socialprofileid;
    /**
     * TicketNumber
     */
    @TableField(value = "ticketnumber")
    @JSONField(name = "ticketnumber")
    @JsonProperty("ticketnumber")
    private String ticketnumber;
    /**
     * Merged
     */
    @DEField(defaultValue = "False")
    @TableField(value = "merged")
    @JSONField(name = "merged")
    @JsonProperty("merged")
    private Integer merged;
    /**
     * ProductSerialNumber
     */
    @TableField(value = "productserialnumber")
    @JSONField(name = "productserialnumber")
    @JsonProperty("productserialnumber")
    private String productserialnumber;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * OwnerIdType
     */
    @TableField(value = "owneridtype")
    @JSONField(name = "owneridtype")
    @JsonProperty("owneridtype")
    private String owneridtype;
    /**
     * Escalated
     */
    @DEField(defaultValue = "False")
    @TableField(value = "escalated")
    @JSONField(name = "escalated")
    @JsonProperty("escalated")
    private Integer escalated;
    /**
     * StageId
     */
    @TableField(value = "stageid")
    @JSONField(name = "stageid")
    @JsonProperty("stageid")
    private String stageid;
    /**
     * CaseTypeCode
     */
    @TableField(value = "casetypecode")
    @JSONField(name = "casetypecode")
    @JsonProperty("casetypecode")
    private String casetypecode;
    /**
     * EmailAddress
     */
    @TableField(value = "emailaddress")
    @JSONField(name = "emailaddress")
    @JsonProperty("emailaddress")
    private String emailaddress;
    /**
     * CheckEmail
     */
    @DEField(defaultValue = "False")
    @TableField(value = "checkemail")
    @JSONField(name = "checkemail")
    @JsonProperty("checkemail")
    private Integer checkemail;
    /**
     * SeverityCode
     */
    @TableField(value = "severitycode")
    @JSONField(name = "severitycode")
    @JsonProperty("severitycode")
    private String severitycode;
    /**
     * EscalatedOn
     */
    @TableField(value = "escalatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "escalatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("escalatedon")
    private Timestamp escalatedon;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * OwnerId
     */
    @TableField(value = "ownerid")
    @JSONField(name = "ownerid")
    @JsonProperty("ownerid")
    private String ownerid;
    /**
     * BilledServiceUnits
     */
    @TableField(value = "billedserviceunits")
    @JSONField(name = "billedserviceunits")
    @JsonProperty("billedserviceunits")
    private Integer billedserviceunits;
    /**
     * PriorityCode
     */
    @TableField(value = "prioritycode")
    @JSONField(name = "prioritycode")
    @JsonProperty("prioritycode")
    private String prioritycode;
    /**
     * EntityImage
     */
    @TableField(value = "entityimage")
    @JSONField(name = "entityimage")
    @JsonProperty("entityimage")
    private String entityimage;
    /**
     * CustomerIdYomiName
     */
    @TableField(value = "customeridyominame")
    @JSONField(name = "customeridyominame")
    @JsonProperty("customeridyominame")
    private String customeridyominame;
    /**
     * OnHoldTime
     */
    @TableField(value = "onholdtime")
    @JSONField(name = "onholdtime")
    @JsonProperty("onholdtime")
    private Integer onholdtime;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * KbArticleId
     */
    @TableField(value = "kbarticleid")
    @JSONField(name = "kbarticleid")
    @JsonProperty("kbarticleid")
    private String kbarticleid;
    /**
     * ContractServiceLevelCode
     */
    @TableField(value = "contractservicelevelcode")
    @JSONField(name = "contractservicelevelcode")
    @JsonProperty("contractservicelevelcode")
    private String contractservicelevelcode;
    /**
     * ContactIdYomiName
     */
    @TableField(value = "contactidyominame")
    @JSONField(name = "contactidyominame")
    @JsonProperty("contactidyominame")
    private String contactidyominame;
    /**
     * AccountIdYomiName
     */
    @TableField(value = "accountidyominame")
    @JSONField(name = "accountidyominame")
    @JsonProperty("accountidyominame")
    private String accountidyominame;
    /**
     * EntityImage_URL
     */
    @DEField(name = "entityimage_url")
    @TableField(value = "entityimage_url")
    @JSONField(name = "entityimage_url")
    @JsonProperty("entityimage_url")
    private String entityimageUrl;
    /**
     * CustomerContacted
     */
    @DEField(defaultValue = "False")
    @TableField(value = "customercontacted")
    @JSONField(name = "customercontacted")
    @JsonProperty("customercontacted")
    private Integer customercontacted;
    /**
     * ProcessId
     */
    @TableField(value = "processid")
    @JSONField(name = "processid")
    @JsonProperty("processid")
    private String processid;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * Decrementing
     */
    @DEField(defaultValue = "False")
    @TableField(value = "decrementing")
    @JSONField(name = "decrementing")
    @JsonProperty("decrementing")
    private Integer decrementing;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * StatusCode
     */
    @TableField(value = "statuscode")
    @JSONField(name = "statuscode")
    @JsonProperty("statuscode")
    private Integer statuscode;
    /**
     * ResponsibleContactIdYomiName
     */
    @TableField(value = "responsiblecontactidyominame")
    @JSONField(name = "responsiblecontactidyominame")
    @JsonProperty("responsiblecontactidyominame")
    private String responsiblecontactidyominame;
    /**
     * ResolveBy
     */
    @TableField(value = "resolveby")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "resolveby" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("resolveby")
    private Timestamp resolveby;
    /**
     * ResponseBy
     */
    @TableField(value = "responseby")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "responseby" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("responseby")
    private Timestamp responseby;
    /**
     * PrimaryContactIdYomiName
     */
    @TableField(value = "primarycontactidyominame")
    @JSONField(name = "primarycontactidyominame")
    @JsonProperty("primarycontactidyominame")
    private String primarycontactidyominame;
    /**
     * EntityImageId
     */
    @TableField(value = "entityimageid")
    @JSONField(name = "entityimageid")
    @JsonProperty("entityimageid")
    private String entityimageid;
    /**
     * FollowUpTaskCreated
     */
    @DEField(defaultValue = "False")
    @TableField(value = "followuptaskcreated")
    @JSONField(name = "followuptaskcreated")
    @JsonProperty("followuptaskcreated")
    private Integer followuptaskcreated;
    /**
     * FirstResponseSent
     */
    @DEField(defaultValue = "False")
    @TableField(value = "firstresponsesent")
    @JSONField(name = "firstresponsesent")
    @JsonProperty("firstresponsesent")
    private Integer firstresponsesent;
    /**
     * FollowupBy
     */
    @TableField(value = "followupby")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "followupby" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("followupby")
    private Timestamp followupby;
    /**
     * IncidentId
     */
    @DEField(isKeyField=true)
    @TableId(value= "incidentid",type=IdType.UUID)
    @JSONField(name = "incidentid")
    @JsonProperty("incidentid")
    private String incidentid;
    /**
     * ServiceStage
     */
    @TableField(value = "servicestage")
    @JSONField(name = "servicestage")
    @JsonProperty("servicestage")
    private String servicestage;
    /**
     * TraversedPath
     */
    @TableField(value = "traversedpath")
    @JSONField(name = "traversedpath")
    @JsonProperty("traversedpath")
    private String traversedpath;
    /**
     * OwnerIdYomiName
     */
    @TableField(value = "owneridyominame")
    @JSONField(name = "owneridyominame")
    @JsonProperty("owneridyominame")
    private String owneridyominame;
    /**
     * NumberOfChildIncidents
     */
    @TableField(value = "numberofchildincidents")
    @JSONField(name = "numberofchildincidents")
    @JsonProperty("numberofchildincidents")
    private Integer numberofchildincidents;
    /**
     * SLAName
     */
    @TableField(value = "slaname")
    @JSONField(name = "slaname")
    @JsonProperty("slaname")
    private String slaname;
    /**
     * BlockedProfile
     */
    @DEField(defaultValue = "False")
    @TableField(value = "blockedprofile")
    @JSONField(name = "blockedprofile")
    @JsonProperty("blockedprofile")
    private Integer blockedprofile;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * ActualServiceUnits
     */
    @TableField(value = "actualserviceunits")
    @JSONField(name = "actualserviceunits")
    @JsonProperty("actualserviceunits")
    private Integer actualserviceunits;
    /**
     * MessageTypeCode
     */
    @TableField(value = "messagetypecode")
    @JSONField(name = "messagetypecode")
    @JsonProperty("messagetypecode")
    private String messagetypecode;
    /**
     * RouteCase
     */
    @DEField(defaultValue = "True")
    @TableField(value = "routecase")
    @JSONField(name = "routecase")
    @JsonProperty("routecase")
    private Integer routecase;
    /**
     * StateCode
     */
    @TableField(value = "statecode")
    @JSONField(name = "statecode")
    @JsonProperty("statecode")
    private Integer statecode;
    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * ResolveBySLAStatus
     */
    @TableField(value = "resolvebyslastatus")
    @JSONField(name = "resolvebyslastatus")
    @JsonProperty("resolvebyslastatus")
    private String resolvebyslastatus;
    /**
     * CaseOriginCode
     */
    @TableField(value = "caseorigincode")
    @JSONField(name = "caseorigincode")
    @JsonProperty("caseorigincode")
    private String caseorigincode;
    /**
     * ActivitiesComplete
     */
    @DEField(defaultValue = "False")
    @TableField(value = "activitiescomplete")
    @JSONField(name = "activitiescomplete")
    @JsonProperty("activitiescomplete")
    private Integer activitiescomplete;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * DecrementEntitlementTerm
     */
    @DEField(defaultValue = "True")
    @TableField(value = "decremententitlementterm")
    @JSONField(name = "decremententitlementterm")
    @JsonProperty("decremententitlementterm")
    private Integer decremententitlementterm;
    /**
     * CustomerSatisfactionCode
     */
    @TableField(value = "customersatisfactioncode")
    @JSONField(name = "customersatisfactioncode")
    @JsonProperty("customersatisfactioncode")
    private String customersatisfactioncode;
    /**
     * SentimentValue
     */
    @TableField(value = "sentimentvalue")
    @JSONField(name = "sentimentvalue")
    @JsonProperty("sentimentvalue")
    private Double sentimentvalue;
    /**
     * EntityImage_Timestamp
     */
    @DEField(name = "entityimage_timestamp")
    @TableField(value = "entityimage_timestamp")
    @JSONField(name = "entityimage_timestamp")
    @JsonProperty("entityimage_timestamp")
    private BigInteger entityimageTimestamp;
    /**
     * Title
     */
    @TableField(value = "title")
    @JSONField(name = "title")
    @JsonProperty("title")
    private String title;
    /**
     * ExchangeRate
     */
    @TableField(value = "exchangerate")
    @JSONField(name = "exchangerate")
    @JsonProperty("exchangerate")
    private BigDecimal exchangerate;
    /**
     * EntitlementId
     */
    @TableField(value = "entitlementid")
    @JSONField(name = "entitlementid")
    @JsonProperty("entitlementid")
    private String entitlementid;
    /**
     * FirstResponseByKPIId
     */
    @TableField(value = "firstresponsebykpiid")
    @JSONField(name = "firstresponsebykpiid")
    @JsonProperty("firstresponsebykpiid")
    private String firstresponsebykpiid;
    /**
     * SLAId
     */
    @TableField(value = "slaid")
    @JSONField(name = "slaid")
    @JsonProperty("slaid")
    private String slaid;
    /**
     * ExistingCase
     */
    @TableField(value = "existingcase")
    @JSONField(name = "existingcase")
    @JsonProperty("existingcase")
    private String existingcase;
    /**
     * ProductId
     */
    @TableField(value = "productid")
    @JSONField(name = "productid")
    @JsonProperty("productid")
    private String productid;
    /**
     * ContractId
     */
    @TableField(value = "contractid")
    @JSONField(name = "contractid")
    @JsonProperty("contractid")
    private String contractid;
    /**
     * ResponsibleContactId
     */
    @TableField(value = "responsiblecontactid")
    @JSONField(name = "responsiblecontactid")
    @JsonProperty("responsiblecontactid")
    private String responsiblecontactid;
    /**
     * ResolveByKPIId
     */
    @TableField(value = "resolvebykpiid")
    @JSONField(name = "resolvebykpiid")
    @JsonProperty("resolvebykpiid")
    private String resolvebykpiid;
    /**
     * ContractDetailId
     */
    @TableField(value = "contractdetailid")
    @JSONField(name = "contractdetailid")
    @JsonProperty("contractdetailid")
    private String contractdetailid;
    /**
     * SubjectId
     */
    @TableField(value = "subjectid")
    @JSONField(name = "subjectid")
    @JsonProperty("subjectid")
    private String subjectid;
    /**
     * MasterId
     */
    @TableField(value = "masterid")
    @JSONField(name = "masterid")
    @JsonProperty("masterid")
    private String masterid;
    /**
     * ParentCaseId
     */
    @TableField(value = "parentcaseid")
    @JSONField(name = "parentcaseid")
    @JsonProperty("parentcaseid")
    private String parentcaseid;
    /**
     * PrimaryContactId
     */
    @TableField(value = "primarycontactid")
    @JSONField(name = "primarycontactid")
    @JsonProperty("primarycontactid")
    private String primarycontactid;
    /**
     * TransactionCurrencyId
     */
    @TableField(value = "transactioncurrencyid")
    @JSONField(name = "transactioncurrencyid")
    @JsonProperty("transactioncurrencyid")
    private String transactioncurrencyid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Contact primarycontact;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Contact responsiblecontact;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.ContractDetail contractdetail;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Contract contract;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Entitlement entitlement;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Incident existingca;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Incident master;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.service.domain.Incident parentcase;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.product.domain.Product product;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.SlaKpiInstance firstresponsebykpi;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.SlaKpiInstance resolvebykpi;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Sla sla;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.Subject subject;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency transactioncurrency;



    /**
     * 设置 [LastOnHoldTime]
     */
    public void setLastonholdtime(Timestamp lastonholdtime){
        this.lastonholdtime = lastonholdtime ;
        this.modify("lastonholdtime",lastonholdtime);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [CustomerIdType]
     */
    public void setCustomeridtype(String customeridtype){
        this.customeridtype = customeridtype ;
        this.modify("customeridtype",customeridtype);
    }
    /**
     * 设置 [FirstResponseSLAStatus]
     */
    public void setFirstresponseslastatus(String firstresponseslastatus){
        this.firstresponseslastatus = firstresponseslastatus ;
        this.modify("firstresponseslastatus",firstresponseslastatus);
    }
    /**
     * 设置 [IncidentStageCode]
     */
    public void setIncidentstagecode(String incidentstagecode){
        this.incidentstagecode = incidentstagecode ;
        this.modify("incidentstagecode",incidentstagecode);
    }
    /**
     * 设置 [InfluenceScore]
     */
    public void setInfluencescore(Double influencescore){
        this.influencescore = influencescore ;
        this.modify("influencescore",influencescore);
    }
    /**
     * 设置 [CustomerId]
     */
    public void setCustomerid(String customerid){
        this.customerid = customerid ;
        this.modify("customerid",customerid);
    }
    /**
     * 设置 [SocialProfileId]
     */
    public void setSocialprofileid(String socialprofileid){
        this.socialprofileid = socialprofileid ;
        this.modify("socialprofileid",socialprofileid);
    }
    /**
     * 设置 [TicketNumber]
     */
    public void setTicketnumber(String ticketnumber){
        this.ticketnumber = ticketnumber ;
        this.modify("ticketnumber",ticketnumber);
    }
    /**
     * 设置 [Merged]
     */
    public void setMerged(Integer merged){
        this.merged = merged ;
        this.modify("merged",merged);
    }
    /**
     * 设置 [ProductSerialNumber]
     */
    public void setProductserialnumber(String productserialnumber){
        this.productserialnumber = productserialnumber ;
        this.modify("productserialnumber",productserialnumber);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [OwnerIdType]
     */
    public void setOwneridtype(String owneridtype){
        this.owneridtype = owneridtype ;
        this.modify("owneridtype",owneridtype);
    }
    /**
     * 设置 [Escalated]
     */
    public void setEscalated(Integer escalated){
        this.escalated = escalated ;
        this.modify("escalated",escalated);
    }
    /**
     * 设置 [StageId]
     */
    public void setStageid(String stageid){
        this.stageid = stageid ;
        this.modify("stageid",stageid);
    }
    /**
     * 设置 [CaseTypeCode]
     */
    public void setCasetypecode(String casetypecode){
        this.casetypecode = casetypecode ;
        this.modify("casetypecode",casetypecode);
    }
    /**
     * 设置 [EmailAddress]
     */
    public void setEmailaddress(String emailaddress){
        this.emailaddress = emailaddress ;
        this.modify("emailaddress",emailaddress);
    }
    /**
     * 设置 [CheckEmail]
     */
    public void setCheckemail(Integer checkemail){
        this.checkemail = checkemail ;
        this.modify("checkemail",checkemail);
    }
    /**
     * 设置 [SeverityCode]
     */
    public void setSeveritycode(String severitycode){
        this.severitycode = severitycode ;
        this.modify("severitycode",severitycode);
    }
    /**
     * 设置 [EscalatedOn]
     */
    public void setEscalatedon(Timestamp escalatedon){
        this.escalatedon = escalatedon ;
        this.modify("escalatedon",escalatedon);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [OwnerId]
     */
    public void setOwnerid(String ownerid){
        this.ownerid = ownerid ;
        this.modify("ownerid",ownerid);
    }
    /**
     * 设置 [BilledServiceUnits]
     */
    public void setBilledserviceunits(Integer billedserviceunits){
        this.billedserviceunits = billedserviceunits ;
        this.modify("billedserviceunits",billedserviceunits);
    }
    /**
     * 设置 [PriorityCode]
     */
    public void setPrioritycode(String prioritycode){
        this.prioritycode = prioritycode ;
        this.modify("prioritycode",prioritycode);
    }
    /**
     * 设置 [EntityImage]
     */
    public void setEntityimage(String entityimage){
        this.entityimage = entityimage ;
        this.modify("entityimage",entityimage);
    }
    /**
     * 设置 [CustomerIdYomiName]
     */
    public void setCustomeridyominame(String customeridyominame){
        this.customeridyominame = customeridyominame ;
        this.modify("customeridyominame",customeridyominame);
    }
    /**
     * 设置 [OnHoldTime]
     */
    public void setOnholdtime(Integer onholdtime){
        this.onholdtime = onholdtime ;
        this.modify("onholdtime",onholdtime);
    }
    /**
     * 设置 [KbArticleId]
     */
    public void setKbarticleid(String kbarticleid){
        this.kbarticleid = kbarticleid ;
        this.modify("kbarticleid",kbarticleid);
    }
    /**
     * 设置 [ContractServiceLevelCode]
     */
    public void setContractservicelevelcode(String contractservicelevelcode){
        this.contractservicelevelcode = contractservicelevelcode ;
        this.modify("contractservicelevelcode",contractservicelevelcode);
    }
    /**
     * 设置 [ContactIdYomiName]
     */
    public void setContactidyominame(String contactidyominame){
        this.contactidyominame = contactidyominame ;
        this.modify("contactidyominame",contactidyominame);
    }
    /**
     * 设置 [AccountIdYomiName]
     */
    public void setAccountidyominame(String accountidyominame){
        this.accountidyominame = accountidyominame ;
        this.modify("accountidyominame",accountidyominame);
    }
    /**
     * 设置 [EntityImage_URL]
     */
    public void setEntityimageUrl(String entityimageUrl){
        this.entityimageUrl = entityimageUrl ;
        this.modify("entityimage_url",entityimageUrl);
    }
    /**
     * 设置 [CustomerContacted]
     */
    public void setCustomercontacted(Integer customercontacted){
        this.customercontacted = customercontacted ;
        this.modify("customercontacted",customercontacted);
    }
    /**
     * 设置 [ProcessId]
     */
    public void setProcessid(String processid){
        this.processid = processid ;
        this.modify("processid",processid);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [Decrementing]
     */
    public void setDecrementing(Integer decrementing){
        this.decrementing = decrementing ;
        this.modify("decrementing",decrementing);
    }
    /**
     * 设置 [StatusCode]
     */
    public void setStatuscode(Integer statuscode){
        this.statuscode = statuscode ;
        this.modify("statuscode",statuscode);
    }
    /**
     * 设置 [ResponsibleContactIdYomiName]
     */
    public void setResponsiblecontactidyominame(String responsiblecontactidyominame){
        this.responsiblecontactidyominame = responsiblecontactidyominame ;
        this.modify("responsiblecontactidyominame",responsiblecontactidyominame);
    }
    /**
     * 设置 [ResolveBy]
     */
    public void setResolveby(Timestamp resolveby){
        this.resolveby = resolveby ;
        this.modify("resolveby",resolveby);
    }
    /**
     * 设置 [ResponseBy]
     */
    public void setResponseby(Timestamp responseby){
        this.responseby = responseby ;
        this.modify("responseby",responseby);
    }
    /**
     * 设置 [PrimaryContactIdYomiName]
     */
    public void setPrimarycontactidyominame(String primarycontactidyominame){
        this.primarycontactidyominame = primarycontactidyominame ;
        this.modify("primarycontactidyominame",primarycontactidyominame);
    }
    /**
     * 设置 [EntityImageId]
     */
    public void setEntityimageid(String entityimageid){
        this.entityimageid = entityimageid ;
        this.modify("entityimageid",entityimageid);
    }
    /**
     * 设置 [FollowUpTaskCreated]
     */
    public void setFollowuptaskcreated(Integer followuptaskcreated){
        this.followuptaskcreated = followuptaskcreated ;
        this.modify("followuptaskcreated",followuptaskcreated);
    }
    /**
     * 设置 [FirstResponseSent]
     */
    public void setFirstresponsesent(Integer firstresponsesent){
        this.firstresponsesent = firstresponsesent ;
        this.modify("firstresponsesent",firstresponsesent);
    }
    /**
     * 设置 [FollowupBy]
     */
    public void setFollowupby(Timestamp followupby){
        this.followupby = followupby ;
        this.modify("followupby",followupby);
    }
    /**
     * 设置 [ServiceStage]
     */
    public void setServicestage(String servicestage){
        this.servicestage = servicestage ;
        this.modify("servicestage",servicestage);
    }
    /**
     * 设置 [TraversedPath]
     */
    public void setTraversedpath(String traversedpath){
        this.traversedpath = traversedpath ;
        this.modify("traversedpath",traversedpath);
    }
    /**
     * 设置 [OwnerIdYomiName]
     */
    public void setOwneridyominame(String owneridyominame){
        this.owneridyominame = owneridyominame ;
        this.modify("owneridyominame",owneridyominame);
    }
    /**
     * 设置 [NumberOfChildIncidents]
     */
    public void setNumberofchildincidents(Integer numberofchildincidents){
        this.numberofchildincidents = numberofchildincidents ;
        this.modify("numberofchildincidents",numberofchildincidents);
    }
    /**
     * 设置 [SLAName]
     */
    public void setSlaname(String slaname){
        this.slaname = slaname ;
        this.modify("slaname",slaname);
    }
    /**
     * 设置 [BlockedProfile]
     */
    public void setBlockedprofile(Integer blockedprofile){
        this.blockedprofile = blockedprofile ;
        this.modify("blockedprofile",blockedprofile);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [ActualServiceUnits]
     */
    public void setActualserviceunits(Integer actualserviceunits){
        this.actualserviceunits = actualserviceunits ;
        this.modify("actualserviceunits",actualserviceunits);
    }
    /**
     * 设置 [MessageTypeCode]
     */
    public void setMessagetypecode(String messagetypecode){
        this.messagetypecode = messagetypecode ;
        this.modify("messagetypecode",messagetypecode);
    }
    /**
     * 设置 [RouteCase]
     */
    public void setRoutecase(Integer routecase){
        this.routecase = routecase ;
        this.modify("routecase",routecase);
    }
    /**
     * 设置 [StateCode]
     */
    public void setStatecode(Integer statecode){
        this.statecode = statecode ;
        this.modify("statecode",statecode);
    }
    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [ResolveBySLAStatus]
     */
    public void setResolvebyslastatus(String resolvebyslastatus){
        this.resolvebyslastatus = resolvebyslastatus ;
        this.modify("resolvebyslastatus",resolvebyslastatus);
    }
    /**
     * 设置 [CaseOriginCode]
     */
    public void setCaseorigincode(String caseorigincode){
        this.caseorigincode = caseorigincode ;
        this.modify("caseorigincode",caseorigincode);
    }
    /**
     * 设置 [ActivitiesComplete]
     */
    public void setActivitiescomplete(Integer activitiescomplete){
        this.activitiescomplete = activitiescomplete ;
        this.modify("activitiescomplete",activitiescomplete);
    }
    /**
     * 设置 [DecrementEntitlementTerm]
     */
    public void setDecremententitlementterm(Integer decremententitlementterm){
        this.decremententitlementterm = decremententitlementterm ;
        this.modify("decremententitlementterm",decremententitlementterm);
    }
    /**
     * 设置 [CustomerSatisfactionCode]
     */
    public void setCustomersatisfactioncode(String customersatisfactioncode){
        this.customersatisfactioncode = customersatisfactioncode ;
        this.modify("customersatisfactioncode",customersatisfactioncode);
    }
    /**
     * 设置 [SentimentValue]
     */
    public void setSentimentvalue(Double sentimentvalue){
        this.sentimentvalue = sentimentvalue ;
        this.modify("sentimentvalue",sentimentvalue);
    }
    /**
     * 设置 [EntityImage_Timestamp]
     */
    public void setEntityimageTimestamp(BigInteger entityimageTimestamp){
        this.entityimageTimestamp = entityimageTimestamp ;
        this.modify("entityimage_timestamp",entityimageTimestamp);
    }
    /**
     * 设置 [Title]
     */
    public void setTitle(String title){
        this.title = title ;
        this.modify("title",title);
    }
    /**
     * 设置 [ExchangeRate]
     */
    public void setExchangerate(BigDecimal exchangerate){
        this.exchangerate = exchangerate ;
        this.modify("exchangerate",exchangerate);
    }
    /**
     * 设置 [EntitlementId]
     */
    public void setEntitlementid(String entitlementid){
        this.entitlementid = entitlementid ;
        this.modify("entitlementid",entitlementid);
    }
    /**
     * 设置 [FirstResponseByKPIId]
     */
    public void setFirstresponsebykpiid(String firstresponsebykpiid){
        this.firstresponsebykpiid = firstresponsebykpiid ;
        this.modify("firstresponsebykpiid",firstresponsebykpiid);
    }
    /**
     * 设置 [SLAId]
     */
    public void setSlaid(String slaid){
        this.slaid = slaid ;
        this.modify("slaid",slaid);
    }
    /**
     * 设置 [ExistingCase]
     */
    public void setExistingcase(String existingcase){
        this.existingcase = existingcase ;
        this.modify("existingcase",existingcase);
    }
    /**
     * 设置 [ProductId]
     */
    public void setProductid(String productid){
        this.productid = productid ;
        this.modify("productid",productid);
    }
    /**
     * 设置 [ContractId]
     */
    public void setContractid(String contractid){
        this.contractid = contractid ;
        this.modify("contractid",contractid);
    }
    /**
     * 设置 [ResponsibleContactId]
     */
    public void setResponsiblecontactid(String responsiblecontactid){
        this.responsiblecontactid = responsiblecontactid ;
        this.modify("responsiblecontactid",responsiblecontactid);
    }
    /**
     * 设置 [ResolveByKPIId]
     */
    public void setResolvebykpiid(String resolvebykpiid){
        this.resolvebykpiid = resolvebykpiid ;
        this.modify("resolvebykpiid",resolvebykpiid);
    }
    /**
     * 设置 [ContractDetailId]
     */
    public void setContractdetailid(String contractdetailid){
        this.contractdetailid = contractdetailid ;
        this.modify("contractdetailid",contractdetailid);
    }
    /**
     * 设置 [SubjectId]
     */
    public void setSubjectid(String subjectid){
        this.subjectid = subjectid ;
        this.modify("subjectid",subjectid);
    }
    /**
     * 设置 [MasterId]
     */
    public void setMasterid(String masterid){
        this.masterid = masterid ;
        this.modify("masterid",masterid);
    }
    /**
     * 设置 [ParentCaseId]
     */
    public void setParentcaseid(String parentcaseid){
        this.parentcaseid = parentcaseid ;
        this.modify("parentcaseid",parentcaseid);
    }
    /**
     * 设置 [PrimaryContactId]
     */
    public void setPrimarycontactid(String primarycontactid){
        this.primarycontactid = primarycontactid ;
        this.modify("primarycontactid",primarycontactid);
    }
    /**
     * 设置 [TransactionCurrencyId]
     */
    public void setTransactioncurrencyid(String transactioncurrencyid){
        this.transactioncurrencyid = transactioncurrencyid ;
        this.modify("transactioncurrencyid",transactioncurrencyid);
    }

}


