package cn.ibizlab.businesscentral.core.service.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.businesscentral.util.domain.EntityMP;

/**
 * 实体[特殊资源]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "RESOURCESPEC",resultMap = "ResourceSpecResultMap")
public class ResourceSpec extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * ImportSequenceNumber
     */
    @TableField(value = "importsequencenumber")
    @JSONField(name = "importsequencenumber")
    @JsonProperty("importsequencenumber")
    private Integer importsequencenumber;
    /**
     * resourcespecName
     */
    @TableField(value = "resourcespecname")
    @JSONField(name = "resourcespecname")
    @JsonProperty("resourcespecname")
    private String resourcespecname;
    /**
     * TimeZoneRuleVersionNumber
     */
    @TableField(value = "timezoneruleversionnumber")
    @JSONField(name = "timezoneruleversionnumber")
    @JsonProperty("timezoneruleversionnumber")
    private Integer timezoneruleversionnumber;
    /**
     * ObjectTypeCode
     */
    @TableField(value = "objecttypecode")
    @JSONField(name = "objecttypecode")
    @JsonProperty("objecttypecode")
    private String objecttypecode;
    /**
     * UpdateMan
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * UTCConversionTimeZoneCode
     */
    @TableField(value = "utcconversiontimezonecode")
    @JSONField(name = "utcconversiontimezonecode")
    @JsonProperty("utcconversiontimezonecode")
    private Integer utcconversiontimezonecode;
    /**
     * Description
     */
    @TableField(value = "description")
    @JSONField(name = "description")
    @JsonProperty("description")
    private String description;
    /**
     * ObjectiveExpression
     */
    @TableField(value = "objectiveexpression")
    @JSONField(name = "objectiveexpression")
    @JsonProperty("objectiveexpression")
    private String objectiveexpression;
    /**
     * OverriddenCreatedOn
     */
    @TableField(value = "overriddencreatedon")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "overriddencreatedon" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("overriddencreatedon")
    private Timestamp overriddencreatedon;
    /**
     * CreateDate
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * CreateMan
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * UpdateDate
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * ResourceSpecId
     */
    @DEField(isKeyField=true)
    @TableId(value= "resourcespecid",type=IdType.UUID)
    @JSONField(name = "resourcespecid")
    @JsonProperty("resourcespecid")
    private String resourcespecid;
    /**
     * VersionNumber
     */
    @TableField(value = "versionnumber")
    @JSONField(name = "versionnumber")
    @JsonProperty("versionnumber")
    private BigInteger versionnumber;
    /**
     * RequiredCount
     */
    @TableField(value = "requiredcount")
    @JSONField(name = "requiredcount")
    @JsonProperty("requiredcount")
    private Integer requiredcount;
    /**
     * GroupObjectId
     */
    @TableField(value = "groupobjectid")
    @JSONField(name = "groupobjectid")
    @JsonProperty("groupobjectid")
    private String groupobjectid;
    /**
     * SameSite
     */
    @DEField(defaultValue = "False")
    @TableField(value = "samesite")
    @JSONField(name = "samesite")
    @JsonProperty("samesite")
    private Integer samesite;
    /**
     * Constraints
     */
    @TableField(value = "constraints")
    @JSONField(name = "constraints")
    @JsonProperty("constraints")
    private String constraints;
    /**
     * EffortRequired
     */
    @TableField(value = "effortrequired")
    @JSONField(name = "effortrequired")
    @JsonProperty("effortrequired")
    private Double effortrequired;
    /**
     * BusinessUnitId
     */
    @TableField(value = "businessunitid")
    @JSONField(name = "businessunitid")
    @JsonProperty("businessunitid")
    private String businessunitid;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.businesscentral.core.base.domain.BusinessUnit businessunit;



    /**
     * 设置 [ImportSequenceNumber]
     */
    public void setImportsequencenumber(Integer importsequencenumber){
        this.importsequencenumber = importsequencenumber ;
        this.modify("importsequencenumber",importsequencenumber);
    }
    /**
     * 设置 [resourcespecName]
     */
    public void setResourcespecname(String resourcespecname){
        this.resourcespecname = resourcespecname ;
        this.modify("resourcespecname",resourcespecname);
    }
    /**
     * 设置 [TimeZoneRuleVersionNumber]
     */
    public void setTimezoneruleversionnumber(Integer timezoneruleversionnumber){
        this.timezoneruleversionnumber = timezoneruleversionnumber ;
        this.modify("timezoneruleversionnumber",timezoneruleversionnumber);
    }
    /**
     * 设置 [ObjectTypeCode]
     */
    public void setObjecttypecode(String objecttypecode){
        this.objecttypecode = objecttypecode ;
        this.modify("objecttypecode",objecttypecode);
    }
    /**
     * 设置 [UTCConversionTimeZoneCode]
     */
    public void setUtcconversiontimezonecode(Integer utcconversiontimezonecode){
        this.utcconversiontimezonecode = utcconversiontimezonecode ;
        this.modify("utcconversiontimezonecode",utcconversiontimezonecode);
    }
    /**
     * 设置 [Description]
     */
    public void setDescription(String description){
        this.description = description ;
        this.modify("description",description);
    }
    /**
     * 设置 [ObjectiveExpression]
     */
    public void setObjectiveexpression(String objectiveexpression){
        this.objectiveexpression = objectiveexpression ;
        this.modify("objectiveexpression",objectiveexpression);
    }
    /**
     * 设置 [OverriddenCreatedOn]
     */
    public void setOverriddencreatedon(Timestamp overriddencreatedon){
        this.overriddencreatedon = overriddencreatedon ;
        this.modify("overriddencreatedon",overriddencreatedon);
    }
    /**
     * 设置 [VersionNumber]
     */
    public void setVersionnumber(BigInteger versionnumber){
        this.versionnumber = versionnumber ;
        this.modify("versionnumber",versionnumber);
    }
    /**
     * 设置 [RequiredCount]
     */
    public void setRequiredcount(Integer requiredcount){
        this.requiredcount = requiredcount ;
        this.modify("requiredcount",requiredcount);
    }
    /**
     * 设置 [GroupObjectId]
     */
    public void setGroupobjectid(String groupobjectid){
        this.groupobjectid = groupobjectid ;
        this.modify("groupobjectid",groupobjectid);
    }
    /**
     * 设置 [SameSite]
     */
    public void setSamesite(Integer samesite){
        this.samesite = samesite ;
        this.modify("samesite",samesite);
    }
    /**
     * 设置 [Constraints]
     */
    public void setConstraints(String constraints){
        this.constraints = constraints ;
        this.modify("constraints",constraints);
    }
    /**
     * 设置 [EffortRequired]
     */
    public void setEffortrequired(Double effortrequired){
        this.effortrequired = effortrequired ;
        this.modify("effortrequired",effortrequired);
    }
    /**
     * 设置 [BusinessUnitId]
     */
    public void setBusinessunitid(String businessunitid){
        this.businessunitid = businessunitid ;
        this.modify("businessunitid",businessunitid);
    }

}


